/* Device.c generated by valac 0.56.14, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Device.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */
/* Functions and classes for handling disk partitions */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
typedef struct _DevicePrivate DevicePrivate;

#define TYPE_MOUNT_ENTRY (mount_entry_get_type ())
#define MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_ENTRY, MountEntry))
#define MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_ENTRY, MountEntryClass))
#define IS_MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_ENTRY))
#define IS_MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_ENTRY))
#define MOUNT_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_ENTRY, MountEntryClass))

typedef struct _MountEntry MountEntry;
typedef struct _MountEntryClass MountEntryClass;
enum  {
	DEVICE_0_PROPERTY,
	DEVICE_FREE_BYTES_PROPERTY,
	DEVICE_SIZE_PROPERTY,
	DEVICE_USED_PROPERTY,
	DEVICE_FREE_PROPERTY,
	DEVICE_IS_MOUNTED_PROPERTY,
	DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_FULL_NAME_WITH_PARENT_PROPERTY,
	DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY,
	DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY,
	DEVICE_NUM_PROPERTIES
};
static GParamSpec* device_properties[DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _MountEntryPrivate MountEntryPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_TIMEOUT_COUNTER (timeout_counter_get_type ())
#define TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounter))
#define TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))
#define IS_TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMEOUT_COUNTER))
#define IS_TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMEOUT_COUNTER))
#define TIMEOUT_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))

typedef struct _TimeoutCounter TimeoutCounter;
typedef struct _TimeoutCounterClass TimeoutCounterClass;

struct _Device {
	GObject parent_instance;
	DevicePrivate * priv;
	gchar* device;
	gchar* name;
	gchar* kname;
	gchar* pkname;
	gchar* pkname_toplevel;
	gchar* mapped_name;
	gchar* uuid;
	gchar* label;
	gchar* partuuid;
	gchar* partlabel;
	gint major;
	gint minor;
	gchar* device_mapper;
	gchar* device_by_uuid;
	gchar* device_by_label;
	gchar* device_by_partuuid;
	gchar* device_by_partlabel;
	gchar* type;
	gchar* fstype;
	gint order;
	gchar* vendor;
	gchar* model;
	gchar* serial;
	gchar* revision;
	gboolean removable;
	gboolean read_only;
	guint64 size_bytes;
	guint64 used_bytes;
	guint64 available_bytes;
	gchar* used_percent;
	gchar* dist_info;
	GeeArrayList* mount_points;
	GeeArrayList* symlinks;
	Device* parent;
	GeeArrayList* children;
};

struct _DeviceClass {
	GObjectClass parent_class;
};

struct _MountEntry {
	GObject parent_instance;
	MountEntryPrivate * priv;
	Device* device;
	gchar* mount_point;
	gchar* mount_options;
};

struct _MountEntryClass {
	GObjectClass parent_class;
};

static gpointer device_parent_class = NULL;
VALA_EXTERN gdouble device_KB;
gdouble device_KB = (gdouble) 1000;
VALA_EXTERN gdouble device_MB;
gdouble device_MB = 0.0;
VALA_EXTERN gdouble device_GB;
gdouble device_GB = 0.0;
VALA_EXTERN gdouble device_KiB;
gdouble device_KiB = (gdouble) 1024;
VALA_EXTERN gdouble device_MiB;
gdouble device_MiB = 0.0;
VALA_EXTERN gdouble device_GiB;
gdouble device_GiB = 0.0;
static gchar* device_lsblk_version;
static gchar* device_lsblk_version = NULL;
static gboolean device_lsblk_is_ancient;
static gboolean device_lsblk_is_ancient = FALSE;
static GeeArrayList* device_device_list;
static GeeArrayList* device_device_list = NULL;
VALA_EXTERN gboolean tee_jee_logging_LOG_DEBUG;

VALA_EXTERN GType device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Device, g_object_unref)
VALA_EXTERN GType mount_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MountEntry, g_object_unref)
VALA_EXTERN Device* device_new (void);
VALA_EXTERN Device* device_construct (GType object_type);
VALA_EXTERN void device_test_lsblk_version (void);
VALA_EXTERN gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar** std_out,
                                       gchar** std_err);
VALA_EXTERN gboolean device_is_mounted_at_path (Device* self,
                                    const gchar* subvolname,
                                    const gchar* mount_path);
VALA_EXTERN gboolean device_type_is_raid (Device* self);
VALA_EXTERN gboolean device_has_linux_filesystem (Device* self);
VALA_EXTERN gboolean device_is_encrypted_partition (Device* self);
VALA_EXTERN gboolean device_is_on_encrypted_partition (Device* self);
VALA_EXTERN gboolean device_is_lvm_partition (Device* self);
VALA_EXTERN gboolean device_has_children (Device* self);
VALA_EXTERN Device* device_first_linux_child (Device* self);
VALA_EXTERN gboolean device_has_parent (Device* self);
VALA_EXTERN GeeArrayList* device_get_filesystems (gboolean get_space,
                                      gboolean get_mounts);
VALA_EXTERN GeeArrayList* device_get_block_devices_using_lsblk (const gchar* dev_name);
VALA_EXTERN GeeArrayList* device_get_disk_space_using_df (const gchar* dev_name_or_mount_point);
VALA_EXTERN Device* device_find_device_in_list (GeeArrayList* list,
                                    const gchar* _dev_alias);
VALA_EXTERN GeeArrayList* device_get_mounted_filesystems_using_mtab (void);
VALA_EXTERN void tee_jee_logging_log_debug (const gchar* message);
static void device_find_child_devices (GeeArrayList* list,
                                Device* parent);
static void device_find_toplevel_parent (GeeArrayList* list,
                                  Device* dev);
static void device_find_child_devices_using_dmsetup (GeeArrayList* list);
VALA_EXTERN void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
VALA_EXTERN gint device_remove_parents (GeeArrayList* list,
                            Device* dev);
VALA_EXTERN MountEntry* mount_entry_new (Device* device,
                             const gchar* mount_point,
                             const gchar* mount_options);
VALA_EXTERN MountEntry* mount_entry_construct (GType object_type,
                                   Device* device,
                                   const gchar* mount_point,
                                   const gchar* mount_options);
VALA_EXTERN gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
VALA_EXTERN gboolean tee_jee_file_system_file_exists (const gchar* file_path);
VALA_EXTERN GeeArrayList* device_get_block_devices_using_blkid (const gchar* dev_name);
VALA_EXTERN gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar** std_out,
                                              gchar** std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
VALA_EXTERN gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
VALA_EXTERN gchar* device_resolve_device_name (const gchar* dev_alias);
VALA_EXTERN gchar* device_get_device_uuid (const gchar* device);
VALA_EXTERN gchar* tee_jee_file_system_file_read (const gchar* file_path);
VALA_EXTERN Device* device_get_device_by_uuid (const gchar* uuid);
VALA_EXTERN Device* device_get_device_by_name (const gchar* file_name);
VALA_EXTERN Device* device_get_device_by_path (const gchar* path_to_check);
VALA_EXTERN GeeArrayList* device_get_device_mount_points (const gchar* dev_name_or_uuid);
VALA_EXTERN gboolean device_device_is_mounted (const gchar* dev_name_or_uuid);
VALA_EXTERN gboolean device_mount_point_in_use (const gchar* mount_point);
VALA_EXTERN gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
VALA_EXTERN gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
VALA_EXTERN void device_copy_fields_from (Device* self,
                              Device* dev2);
VALA_EXTERN Device* device_query_changes (Device* self);
VALA_EXTERN void device_query_disk_space (Device* self);
VALA_EXTERN gboolean device_automount_udisks (const gchar* dev_name_or_uuid,
                                  GtkWindow* parent_window);
VALA_EXTERN void tee_jee_gtk_helper_gtk_messagebox (const gchar* title,
                                        const gchar* message,
                                        GtkWindow* parent_win,
                                        gboolean is_error);
VALA_EXTERN gboolean device_automount_udisks_iso (const gchar* iso_file_path,
                                      gchar** loop_device,
                                      GtkWindow* parent_window);
VALA_EXTERN void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
VALA_EXTERN gboolean device_unmount_udisks (const gchar* dev_name_or_uuid,
                                GtkWindow* parent_window);
VALA_EXTERN Device* device_luks_unlock (Device* luks_device,
                            const gchar* mapped_name,
                            const gchar* passphrase,
                            GtkWindow* parent_window,
                            gchar** message,
                            gchar** details);
VALA_EXTERN GType timeout_counter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TimeoutCounter, g_object_unref)
VALA_EXTERN TimeoutCounter* timeout_counter_new (void);
VALA_EXTERN TimeoutCounter* timeout_counter_construct (GType object_type);
VALA_EXTERN void timeout_counter_kill_process_on_timeout (TimeoutCounter* self,
                                              const gchar* process_to_kill,
                                              gint seconds_to_wait,
                                              gboolean exit_app);
VALA_EXTERN void timeout_counter_stop (TimeoutCounter* self);
VALA_EXTERN gchar* tee_jee_gtk_helper_gtk_inputbox (const gchar* title,
                                        const gchar* message,
                                        GtkWindow* parent_win,
                                        gboolean mask_password);
VALA_EXTERN gboolean device_luks_lock (const gchar* kname,
                           GtkWindow* parent_window);
VALA_EXTERN gboolean device_mount (const gchar* dev_name_or_uuid,
                       const gchar* mount_point,
                       const gchar* mount_options,
                       gboolean silent);
VALA_EXTERN gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
VALA_EXTERN gboolean device_unmount (const gchar* mount_point);
VALA_EXTERN gchar* device_get_device_name_with_parent (Device* self);
VALA_EXTERN gchar* device_automount (const gchar* dev_name_or_uuid,
                         const gchar* mount_options,
                         const gchar* mount_prefix);
VALA_EXTERN gchar* device_description (Device* self);
VALA_EXTERN gchar* device_description_formatted (Device* self);
VALA_EXTERN gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
VALA_EXTERN gchar* device_get_short_name_with_parent (Device* self);
VALA_EXTERN gchar* device_description_simple (Device* self);
VALA_EXTERN gchar* device_description_simple_formatted (Device* self);
VALA_EXTERN gchar* device_description_full_free (Device* self);
VALA_EXTERN guint64 device_get_free_bytes (Device* self);
VALA_EXTERN gchar* device_description_free (Device* self);
VALA_EXTERN gchar* device_description_full (Device* self);
VALA_EXTERN gchar* device_get_used (Device* self);
VALA_EXTERN gchar* device_get_size (Device* self);
VALA_EXTERN gchar* device_description_usage (Device* self);
VALA_EXTERN gchar* device_tooltip_text (Device* self);
VALA_EXTERN void device_test_all (void);
VALA_EXTERN void device_print_device_list (GeeArrayList* list);
VALA_EXTERN void device_print_device_mounts (GeeArrayList* list);
VALA_EXTERN void device_print_device_disk_space (GeeArrayList* list);
VALA_EXTERN gchar* device_get_free (Device* self);
VALA_EXTERN gboolean device_get_is_mounted (Device* self);
VALA_EXTERN gchar* device_get_full_name_with_alias (Device* self);
VALA_EXTERN gchar* device_get_full_name_with_parent (Device* self);
VALA_EXTERN gchar* device_get_short_name_with_alias (Device* self);
static void device_finalize (GObject * obj);
static GType device_get_type_once (void);
static void _vala_device_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

Device*
device_construct (GType object_type)
{
	Device * self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 94 "../src/Utility/Device.vala"
	self = (Device*) g_object_new (object_type, NULL);
#line 95 "../src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 95 "../src/Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 95 "../src/Utility/Device.vala"
	self->mount_points = _tmp0_;
#line 96 "../src/Utility/Device.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 96 "../src/Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 96 "../src/Utility/Device.vala"
	self->symlinks = _tmp1_;
#line 97 "../src/Utility/Device.vala"
	_tmp2_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 97 "../src/Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 97 "../src/Utility/Device.vala"
	self->children = _tmp2_;
#line 99 "../src/Utility/Device.vala"
	device_test_lsblk_version ();
#line 94 "../src/Utility/Device.vala"
	return self;
#line 369 "Device.c"
}

Device*
device_new (void)
{
#line 94 "../src/Utility/Device.vala"
	return device_construct (TYPE_DEVICE);
#line 377 "Device.c"
}

void
device_test_lsblk_version (void)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
#line 104 "../src/Utility/Device.vala"
	_tmp1_ = device_lsblk_version;
#line 104 "../src/Utility/Device.vala"
	if (_tmp1_ != NULL) {
#line 395 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 104 "../src/Utility/Device.vala"
		_tmp2_ = device_lsblk_version;
#line 104 "../src/Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 104 "../src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 104 "../src/Utility/Device.vala"
		_tmp0_ = _tmp4_ > 0;
#line 407 "Device.c"
	} else {
#line 104 "../src/Utility/Device.vala"
		_tmp0_ = FALSE;
#line 411 "Device.c"
	}
#line 104 "../src/Utility/Device.vala"
	if (_tmp0_) {
#line 105 "../src/Utility/Device.vala"
		return;
#line 417 "Device.c"
	}
#line 109 "../src/Utility/Device.vala"
	_tmp7_ = tee_jee_process_helper_exec_sync ("lsblk --bytes --pairs --output HOTPLUG,PKNAME,VENDOR,SERIAL,REV", &_tmp5_, &_tmp6_);
#line 109 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 109 "../src/Utility/Device.vala"
	std_out = _tmp5_;
#line 109 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 109 "../src/Utility/Device.vala"
	std_err = _tmp6_;
#line 109 "../src/Utility/Device.vala"
	status = _tmp7_;
#line 110 "../src/Utility/Device.vala"
	if (status == 0) {
#line 433 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 111 "../src/Utility/Device.vala"
		_tmp8_ = std_out;
#line 111 "../src/Utility/Device.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 111 "../src/Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 111 "../src/Utility/Device.vala"
		device_lsblk_version = _tmp9_;
#line 112 "../src/Utility/Device.vala"
		device_lsblk_is_ancient = FALSE;
#line 446 "Device.c"
	} else {
		gchar* _tmp10_;
#line 115 "../src/Utility/Device.vala"
		_tmp10_ = g_strdup ("ancient");
#line 115 "../src/Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 115 "../src/Utility/Device.vala"
		device_lsblk_version = _tmp10_;
#line 116 "../src/Utility/Device.vala"
		device_lsblk_is_ancient = TRUE;
#line 457 "Device.c"
	}
#line 102 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 102 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 463 "Device.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 482 "Device.c"
}

gboolean
device_is_mounted_at_path (Device* self,
                           const gchar* subvolname,
                           const gchar* mount_path)
{
	gboolean result;
#line 158 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../src/Utility/Device.vala"
	g_return_val_if_fail (subvolname != NULL, FALSE);
#line 158 "../src/Utility/Device.vala"
	g_return_val_if_fail (mount_path != NULL, FALSE);
#line 497 "Device.c"
	{
		GeeArrayList* _mnt_list = NULL;
		GeeArrayList* _tmp0_;
		gint _mnt_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _mnt_index = 0;
#line 160 "../src/Utility/Device.vala"
		_tmp0_ = self->mount_points;
#line 160 "../src/Utility/Device.vala"
		_mnt_list = _tmp0_;
#line 160 "../src/Utility/Device.vala"
		_tmp1_ = _mnt_list;
#line 160 "../src/Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 160 "../src/Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 160 "../src/Utility/Device.vala"
		_mnt_size = _tmp3_;
#line 160 "../src/Utility/Device.vala"
		_mnt_index = -1;
#line 160 "../src/Utility/Device.vala"
		while (TRUE) {
#line 522 "Device.c"
			gint _tmp4_;
			gint _tmp5_;
			MountEntry* mnt = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MountEntry* _tmp8_;
			const gchar* _tmp9_;
#line 160 "../src/Utility/Device.vala"
			_mnt_index = _mnt_index + 1;
#line 160 "../src/Utility/Device.vala"
			_tmp4_ = _mnt_index;
#line 160 "../src/Utility/Device.vala"
			_tmp5_ = _mnt_size;
#line 160 "../src/Utility/Device.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 160 "../src/Utility/Device.vala"
				break;
#line 540 "Device.c"
			}
#line 160 "../src/Utility/Device.vala"
			_tmp6_ = _mnt_list;
#line 160 "../src/Utility/Device.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _mnt_index);
#line 160 "../src/Utility/Device.vala"
			mnt = (MountEntry*) _tmp7_;
#line 161 "../src/Utility/Device.vala"
			_tmp8_ = mnt;
#line 161 "../src/Utility/Device.vala"
			_tmp9_ = _tmp8_->mount_point;
#line 161 "../src/Utility/Device.vala"
			if (g_strcmp0 (_tmp9_, mount_path) == 0) {
#line 554 "Device.c"
				gint _tmp10_;
				gint _tmp11_;
#line 162 "../src/Utility/Device.vala"
				_tmp10_ = strlen (subvolname);
#line 162 "../src/Utility/Device.vala"
				_tmp11_ = _tmp10_;
#line 162 "../src/Utility/Device.vala"
				if (_tmp11_ == 0) {
#line 163 "../src/Utility/Device.vala"
					result = TRUE;
#line 163 "../src/Utility/Device.vala"
					_g_object_unref0 (mnt);
#line 163 "../src/Utility/Device.vala"
					return result;
#line 569 "Device.c"
				} else {
					gboolean _tmp12_ = FALSE;
					MountEntry* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gboolean _tmp17_;
#line 165 "../src/Utility/Device.vala"
					_tmp13_ = mnt;
#line 165 "../src/Utility/Device.vala"
					_tmp14_ = _tmp13_->mount_options;
#line 165 "../src/Utility/Device.vala"
					_tmp15_ = g_strdup_printf ("subvol=%s", subvolname);
#line 165 "../src/Utility/Device.vala"
					_tmp16_ = _tmp15_;
#line 165 "../src/Utility/Device.vala"
					_tmp17_ = string_contains (_tmp14_, _tmp16_);
#line 165 "../src/Utility/Device.vala"
					_g_free0 (_tmp16_);
#line 165 "../src/Utility/Device.vala"
					if (_tmp17_) {
#line 165 "../src/Utility/Device.vala"
						_tmp12_ = TRUE;
#line 593 "Device.c"
					} else {
						MountEntry* _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
#line 166 "../src/Utility/Device.vala"
						_tmp18_ = mnt;
#line 166 "../src/Utility/Device.vala"
						_tmp19_ = _tmp18_->mount_options;
#line 166 "../src/Utility/Device.vala"
						_tmp20_ = g_strdup_printf ("subvol=/%s", subvolname);
#line 166 "../src/Utility/Device.vala"
						_tmp21_ = _tmp20_;
#line 166 "../src/Utility/Device.vala"
						_tmp12_ = string_contains (_tmp19_, _tmp21_);
#line 166 "../src/Utility/Device.vala"
						_g_free0 (_tmp21_);
#line 611 "Device.c"
					}
#line 165 "../src/Utility/Device.vala"
					if (_tmp12_) {
#line 168 "../src/Utility/Device.vala"
						result = TRUE;
#line 168 "../src/Utility/Device.vala"
						_g_object_unref0 (mnt);
#line 168 "../src/Utility/Device.vala"
						return result;
#line 621 "Device.c"
					}
				}
			}
#line 160 "../src/Utility/Device.vala"
			_g_object_unref0 (mnt);
#line 627 "Device.c"
		}
	}
#line 173 "../src/Utility/Device.vala"
	result = FALSE;
#line 173 "../src/Utility/Device.vala"
	return result;
#line 634 "Device.c"
}

gboolean
device_type_is_raid (Device* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 178 "../src/Utility/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 178 "../src/Utility/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 178 "../src/Utility/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 178 "../src/Utility/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 178 "../src/Utility/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 178 "../src/Utility/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 655 "Device.c"
	gboolean result;
#line 176 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 178 "../src/Utility/Device.vala"
	_tmp0_ = self->type;
#line 178 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 178 "../src/Utility/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 178 "../src/Utility/Device.vala"
	if ((((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("raid0")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("raid1"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("raid4"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("raid5"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("raid6"))))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("raid10"))))) {
#line 178 "../src/Utility/Device.vala"
		switch (0) {
#line 669 "Device.c"
			default:
			{
#line 185 "../src/Utility/Device.vala"
				result = TRUE;
#line 185 "../src/Utility/Device.vala"
				return result;
#line 676 "Device.c"
			}
		}
	} else {
#line 178 "../src/Utility/Device.vala"
		switch (0) {
#line 682 "Device.c"
			default:
			{
#line 187 "../src/Utility/Device.vala"
				result = FALSE;
#line 187 "../src/Utility/Device.vala"
				return result;
#line 689 "Device.c"
			}
		}
	}
}

gboolean
device_has_linux_filesystem (Device* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label6 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label7 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label8 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label9 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label10 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label11 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label12 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label13 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label14 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label15 = 0;
#line 192 "../src/Utility/Device.vala"
	static GQuark _tmp2_label16 = 0;
#line 735 "Device.c"
	gboolean result;
#line 191 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 192 "../src/Utility/Device.vala"
	_tmp0_ = self->fstype;
#line 192 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 192 "../src/Utility/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 192 "../src/Utility/Device.vala"
	if (((((((((((((((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("ext2")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("ext3"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("ext4"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("f2fs"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("reiserfs"))))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("reiser4"))))) || (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("xfs"))))) || (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("jfs"))))) || (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("zfs"))))) || (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("zfs_member"))))) || (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("btrfs"))))) || (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("lvm"))))) || (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("lvm2"))))) || (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("lvm2_member"))))) || (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("luks"))))) || (_tmp3_ == ((0 != _tmp2_label15) ? _tmp2_label15 : (_tmp2_label15 = g_quark_from_static_string ("crypt"))))) || (_tmp3_ == ((0 != _tmp2_label16) ? _tmp2_label16 : (_tmp2_label16 = g_quark_from_static_string ("crypto_luks"))))) {
#line 192 "../src/Utility/Device.vala"
		switch (0) {
#line 749 "Device.c"
			default:
			{
#line 210 "../src/Utility/Device.vala"
				result = TRUE;
#line 210 "../src/Utility/Device.vala"
				return result;
#line 756 "Device.c"
			}
		}
	} else {
#line 192 "../src/Utility/Device.vala"
		switch (0) {
#line 762 "Device.c"
			default:
			{
#line 212 "../src/Utility/Device.vala"
				result = FALSE;
#line 212 "../src/Utility/Device.vala"
				return result;
#line 769 "Device.c"
			}
		}
	}
}

gboolean
device_is_encrypted_partition (Device* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean result;
#line 216 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 217 "../src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 217 "../src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 787 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 217 "../src/Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 217 "../src/Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 217 "../src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 217 "../src/Utility/Device.vala"
		_tmp0_ = string_contains (_tmp4_, "luks");
#line 217 "../src/Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 801 "Device.c"
	} else {
#line 217 "../src/Utility/Device.vala"
		_tmp0_ = FALSE;
#line 805 "Device.c"
	}
#line 217 "../src/Utility/Device.vala"
	result = _tmp0_;
#line 217 "../src/Utility/Device.vala"
	return result;
#line 811 "Device.c"
}

gboolean
device_is_on_encrypted_partition (Device* self)
{
	const gchar* _tmp0_;
	gboolean result;
#line 220 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 221 "../src/Utility/Device.vala"
	_tmp0_ = self->type;
#line 221 "../src/Utility/Device.vala"
	result = g_strcmp0 (_tmp0_, "crypt") == 0;
#line 221 "../src/Utility/Device.vala"
	return result;
#line 827 "Device.c"
}

gboolean
device_is_lvm_partition (Device* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean result;
#line 224 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 225 "../src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 225 "../src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 842 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 225 "../src/Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 225 "../src/Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 225 "../src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 225 "../src/Utility/Device.vala"
		_tmp0_ = string_contains (_tmp4_, "lvm2_member");
#line 225 "../src/Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 856 "Device.c"
	} else {
#line 225 "../src/Utility/Device.vala"
		_tmp0_ = FALSE;
#line 860 "Device.c"
	}
#line 225 "../src/Utility/Device.vala"
	result = _tmp0_;
#line 225 "../src/Utility/Device.vala"
	return result;
#line 866 "Device.c"
}

gboolean
device_has_children (Device* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 228 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 229 "../src/Utility/Device.vala"
	_tmp0_ = self->children;
#line 229 "../src/Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 229 "../src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 229 "../src/Utility/Device.vala"
	result = _tmp2_ > 0;
#line 229 "../src/Utility/Device.vala"
	return result;
#line 888 "Device.c"
}

Device*
device_first_linux_child (Device* self)
{
	Device* result;
#line 232 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 897 "Device.c"
	{
		GeeArrayList* _child_list = NULL;
		GeeArrayList* _tmp0_;
		gint _child_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _child_index = 0;
#line 234 "../src/Utility/Device.vala"
		_tmp0_ = self->children;
#line 234 "../src/Utility/Device.vala"
		_child_list = _tmp0_;
#line 234 "../src/Utility/Device.vala"
		_tmp1_ = _child_list;
#line 234 "../src/Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 234 "../src/Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 234 "../src/Utility/Device.vala"
		_child_size = _tmp3_;
#line 234 "../src/Utility/Device.vala"
		_child_index = -1;
#line 234 "../src/Utility/Device.vala"
		while (TRUE) {
#line 922 "Device.c"
			gint _tmp4_;
			gint _tmp5_;
			Device* child = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			Device* _tmp8_;
#line 234 "../src/Utility/Device.vala"
			_child_index = _child_index + 1;
#line 234 "../src/Utility/Device.vala"
			_tmp4_ = _child_index;
#line 234 "../src/Utility/Device.vala"
			_tmp5_ = _child_size;
#line 234 "../src/Utility/Device.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 234 "../src/Utility/Device.vala"
				break;
#line 939 "Device.c"
			}
#line 234 "../src/Utility/Device.vala"
			_tmp6_ = _child_list;
#line 234 "../src/Utility/Device.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _child_index);
#line 234 "../src/Utility/Device.vala"
			child = (Device*) _tmp7_;
#line 235 "../src/Utility/Device.vala"
			_tmp8_ = child;
#line 235 "../src/Utility/Device.vala"
			if (device_has_linux_filesystem (_tmp8_)) {
#line 236 "../src/Utility/Device.vala"
				result = child;
#line 236 "../src/Utility/Device.vala"
				return result;
#line 955 "Device.c"
			}
#line 234 "../src/Utility/Device.vala"
			_g_object_unref0 (child);
#line 959 "Device.c"
		}
	}
#line 240 "../src/Utility/Device.vala"
	result = NULL;
#line 240 "../src/Utility/Device.vala"
	return result;
#line 966 "Device.c"
}

gboolean
device_has_parent (Device* self)
{
	Device* _tmp0_;
	gboolean result;
#line 243 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 244 "../src/Utility/Device.vala"
	_tmp0_ = self->parent;
#line 244 "../src/Utility/Device.vala"
	result = _tmp0_ != NULL;
#line 244 "../src/Utility/Device.vala"
	return result;
#line 982 "Device.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 276 "../src/Utility/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 990 "Device.c"
}

GeeArrayList*
device_get_filesystems (gboolean get_space,
                        gboolean get_mounts)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	GeeArrayList* result;
#line 254 "../src/Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 254 "../src/Utility/Device.vala"
	list = _tmp0_;
#line 256 "../src/Utility/Device.vala"
	if (get_space) {
#line 1011 "Device.c"
		GeeArrayList* list_df = NULL;
		GeeArrayList* _tmp1_;
#line 258 "../src/Utility/Device.vala"
		_tmp1_ = device_get_disk_space_using_df ("");
#line 258 "../src/Utility/Device.vala"
		list_df = _tmp1_;
#line 1018 "Device.c"
		{
			GeeArrayList* _dev_df_list = NULL;
			GeeArrayList* _tmp2_;
			gint _dev_df_size = 0;
			GeeArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _dev_df_index = 0;
#line 259 "../src/Utility/Device.vala"
			_tmp2_ = list_df;
#line 259 "../src/Utility/Device.vala"
			_dev_df_list = _tmp2_;
#line 259 "../src/Utility/Device.vala"
			_tmp3_ = _dev_df_list;
#line 259 "../src/Utility/Device.vala"
			_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 259 "../src/Utility/Device.vala"
			_tmp5_ = _tmp4_;
#line 259 "../src/Utility/Device.vala"
			_dev_df_size = _tmp5_;
#line 259 "../src/Utility/Device.vala"
			_dev_df_index = -1;
#line 259 "../src/Utility/Device.vala"
			while (TRUE) {
#line 1043 "Device.c"
				gint _tmp6_;
				gint _tmp7_;
				Device* dev_df = NULL;
				GeeArrayList* _tmp8_;
				gpointer _tmp9_;
				Device* dev = NULL;
				GeeArrayList* _tmp10_;
				Device* _tmp11_;
				const gchar* _tmp12_;
				Device* _tmp13_;
				Device* _tmp14_;
#line 259 "../src/Utility/Device.vala"
				_dev_df_index = _dev_df_index + 1;
#line 259 "../src/Utility/Device.vala"
				_tmp6_ = _dev_df_index;
#line 259 "../src/Utility/Device.vala"
				_tmp7_ = _dev_df_size;
#line 259 "../src/Utility/Device.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 259 "../src/Utility/Device.vala"
					break;
#line 1065 "Device.c"
				}
#line 259 "../src/Utility/Device.vala"
				_tmp8_ = _dev_df_list;
#line 259 "../src/Utility/Device.vala"
				_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_df_index);
#line 259 "../src/Utility/Device.vala"
				dev_df = (Device*) _tmp9_;
#line 260 "../src/Utility/Device.vala"
				_tmp10_ = list;
#line 260 "../src/Utility/Device.vala"
				_tmp11_ = dev_df;
#line 260 "../src/Utility/Device.vala"
				_tmp12_ = _tmp11_->uuid;
#line 260 "../src/Utility/Device.vala"
				_tmp13_ = device_find_device_in_list (_tmp10_, _tmp12_);
#line 260 "../src/Utility/Device.vala"
				dev = _tmp13_;
#line 261 "../src/Utility/Device.vala"
				_tmp14_ = dev;
#line 261 "../src/Utility/Device.vala"
				if (_tmp14_ != NULL) {
#line 1087 "Device.c"
					Device* _tmp15_;
					Device* _tmp16_;
					Device* _tmp17_;
					Device* _tmp18_;
					Device* _tmp19_;
					Device* _tmp20_;
					Device* _tmp21_;
					Device* _tmp22_;
					const gchar* _tmp23_;
					gchar* _tmp24_;
#line 262 "../src/Utility/Device.vala"
					_tmp15_ = dev;
#line 262 "../src/Utility/Device.vala"
					_tmp16_ = dev_df;
#line 262 "../src/Utility/Device.vala"
					_tmp15_->size_bytes = _tmp16_->size_bytes;
#line 263 "../src/Utility/Device.vala"
					_tmp17_ = dev;
#line 263 "../src/Utility/Device.vala"
					_tmp18_ = dev_df;
#line 263 "../src/Utility/Device.vala"
					_tmp17_->used_bytes = _tmp18_->used_bytes;
#line 264 "../src/Utility/Device.vala"
					_tmp19_ = dev;
#line 264 "../src/Utility/Device.vala"
					_tmp20_ = dev_df;
#line 264 "../src/Utility/Device.vala"
					_tmp19_->available_bytes = _tmp20_->available_bytes;
#line 265 "../src/Utility/Device.vala"
					_tmp21_ = dev;
#line 265 "../src/Utility/Device.vala"
					_tmp22_ = dev_df;
#line 265 "../src/Utility/Device.vala"
					_tmp23_ = _tmp22_->used_percent;
#line 265 "../src/Utility/Device.vala"
					_tmp24_ = g_strdup (_tmp23_);
#line 265 "../src/Utility/Device.vala"
					_g_free0 (_tmp21_->used_percent);
#line 265 "../src/Utility/Device.vala"
					_tmp21_->used_percent = _tmp24_;
#line 1128 "Device.c"
				}
#line 259 "../src/Utility/Device.vala"
				_g_object_unref0 (dev);
#line 259 "../src/Utility/Device.vala"
				_g_object_unref0 (dev_df);
#line 1134 "Device.c"
			}
		}
#line 256 "../src/Utility/Device.vala"
		_g_object_unref0 (list_df);
#line 1139 "Device.c"
	}
#line 270 "../src/Utility/Device.vala"
	if (get_mounts) {
#line 1143 "Device.c"
		GeeArrayList* list_mtab = NULL;
		GeeArrayList* _tmp25_;
#line 272 "../src/Utility/Device.vala"
		_tmp25_ = device_get_mounted_filesystems_using_mtab ();
#line 272 "../src/Utility/Device.vala"
		list_mtab = _tmp25_;
#line 1150 "Device.c"
		{
			GeeArrayList* _dev_mtab_list = NULL;
			GeeArrayList* _tmp26_;
			gint _dev_mtab_size = 0;
			GeeArrayList* _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
			gint _dev_mtab_index = 0;
#line 273 "../src/Utility/Device.vala"
			_tmp26_ = list_mtab;
#line 273 "../src/Utility/Device.vala"
			_dev_mtab_list = _tmp26_;
#line 273 "../src/Utility/Device.vala"
			_tmp27_ = _dev_mtab_list;
#line 273 "../src/Utility/Device.vala"
			_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
#line 273 "../src/Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 273 "../src/Utility/Device.vala"
			_dev_mtab_size = _tmp29_;
#line 273 "../src/Utility/Device.vala"
			_dev_mtab_index = -1;
#line 273 "../src/Utility/Device.vala"
			while (TRUE) {
#line 1175 "Device.c"
				gint _tmp30_;
				gint _tmp31_;
				Device* dev_mtab = NULL;
				GeeArrayList* _tmp32_;
				gpointer _tmp33_;
				Device* dev = NULL;
				GeeArrayList* _tmp34_;
				Device* _tmp35_;
				const gchar* _tmp36_;
				Device* _tmp37_;
				Device* _tmp38_;
#line 273 "../src/Utility/Device.vala"
				_dev_mtab_index = _dev_mtab_index + 1;
#line 273 "../src/Utility/Device.vala"
				_tmp30_ = _dev_mtab_index;
#line 273 "../src/Utility/Device.vala"
				_tmp31_ = _dev_mtab_size;
#line 273 "../src/Utility/Device.vala"
				if (!(_tmp30_ < _tmp31_)) {
#line 273 "../src/Utility/Device.vala"
					break;
#line 1197 "Device.c"
				}
#line 273 "../src/Utility/Device.vala"
				_tmp32_ = _dev_mtab_list;
#line 273 "../src/Utility/Device.vala"
				_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _dev_mtab_index);
#line 273 "../src/Utility/Device.vala"
				dev_mtab = (Device*) _tmp33_;
#line 274 "../src/Utility/Device.vala"
				_tmp34_ = list;
#line 274 "../src/Utility/Device.vala"
				_tmp35_ = dev_mtab;
#line 274 "../src/Utility/Device.vala"
				_tmp36_ = _tmp35_->uuid;
#line 274 "../src/Utility/Device.vala"
				_tmp37_ = device_find_device_in_list (_tmp34_, _tmp36_);
#line 274 "../src/Utility/Device.vala"
				dev = _tmp37_;
#line 275 "../src/Utility/Device.vala"
				_tmp38_ = dev;
#line 275 "../src/Utility/Device.vala"
				if (_tmp38_ != NULL) {
#line 1219 "Device.c"
					Device* _tmp39_;
					Device* _tmp40_;
					GeeArrayList* _tmp41_;
					GeeArrayList* _tmp42_;
#line 276 "../src/Utility/Device.vala"
					_tmp39_ = dev;
#line 276 "../src/Utility/Device.vala"
					_tmp40_ = dev_mtab;
#line 276 "../src/Utility/Device.vala"
					_tmp41_ = _tmp40_->mount_points;
#line 276 "../src/Utility/Device.vala"
					_tmp42_ = _g_object_ref0 (_tmp41_);
#line 276 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp39_->mount_points);
#line 276 "../src/Utility/Device.vala"
					_tmp39_->mount_points = _tmp42_;
#line 1236 "Device.c"
				}
#line 273 "../src/Utility/Device.vala"
				_g_object_unref0 (dev);
#line 273 "../src/Utility/Device.vala"
				_g_object_unref0 (dev_mtab);
#line 1242 "Device.c"
			}
		}
#line 270 "../src/Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1247 "Device.c"
	}
#line 285 "../src/Utility/Device.vala"
	_tmp43_ = list;
#line 285 "../src/Utility/Device.vala"
	_tmp44_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp43_);
#line 285 "../src/Utility/Device.vala"
	_tmp45_ = _tmp44_;
#line 285 "../src/Utility/Device.vala"
	_tmp46_ = g_strdup_printf ("Device: get_filesystems(): %d", _tmp45_);
#line 285 "../src/Utility/Device.vala"
	_tmp47_ = _tmp46_;
#line 285 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp47_);
#line 285 "../src/Utility/Device.vala"
	_g_free0 (_tmp47_);
#line 287 "../src/Utility/Device.vala"
	result = list;
#line 287 "../src/Utility/Device.vala"
	return result;
#line 1267 "Device.c"
}

static void
device_find_child_devices (GeeArrayList* list,
                           Device* parent)
{
	gboolean _tmp0_ = FALSE;
#line 290 "../src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 290 "../src/Utility/Device.vala"
	g_return_if_fail (parent != NULL);
#line 291 "../src/Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 1281 "Device.c"
		const gchar* _tmp1_;
#line 291 "../src/Utility/Device.vala"
		_tmp1_ = parent->type;
#line 291 "../src/Utility/Device.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, "disk") == 0;
#line 1287 "Device.c"
	} else {
#line 291 "../src/Utility/Device.vala"
		_tmp0_ = FALSE;
#line 1291 "Device.c"
	}
#line 291 "../src/Utility/Device.vala"
	if (_tmp0_) {
#line 1295 "Device.c"
		{
			GeeArrayList* _part_list = NULL;
			gint _part_size = 0;
			GeeArrayList* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _part_index = 0;
#line 292 "../src/Utility/Device.vala"
			_part_list = list;
#line 292 "../src/Utility/Device.vala"
			_tmp2_ = _part_list;
#line 292 "../src/Utility/Device.vala"
			_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 292 "../src/Utility/Device.vala"
			_tmp4_ = _tmp3_;
#line 292 "../src/Utility/Device.vala"
			_part_size = _tmp4_;
#line 292 "../src/Utility/Device.vala"
			_part_index = -1;
#line 292 "../src/Utility/Device.vala"
			while (TRUE) {
#line 1317 "Device.c"
				gint _tmp5_;
				gint _tmp6_;
				Device* part = NULL;
				GeeArrayList* _tmp7_;
				gpointer _tmp8_;
				gboolean _tmp9_ = FALSE;
				Device* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
#line 292 "../src/Utility/Device.vala"
				_part_index = _part_index + 1;
#line 292 "../src/Utility/Device.vala"
				_tmp5_ = _part_index;
#line 292 "../src/Utility/Device.vala"
				_tmp6_ = _part_size;
#line 292 "../src/Utility/Device.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 292 "../src/Utility/Device.vala"
					break;
#line 1337 "Device.c"
				}
#line 292 "../src/Utility/Device.vala"
				_tmp7_ = _part_list;
#line 292 "../src/Utility/Device.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _part_index);
#line 292 "../src/Utility/Device.vala"
				part = (Device*) _tmp8_;
#line 293 "../src/Utility/Device.vala"
				_tmp10_ = part;
#line 293 "../src/Utility/Device.vala"
				_tmp11_ = _tmp10_->kname;
#line 293 "../src/Utility/Device.vala"
				_tmp12_ = parent->kname;
#line 293 "../src/Utility/Device.vala"
				if (g_strcmp0 (_tmp11_, _tmp12_) != 0) {
#line 1353 "Device.c"
					Device* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 293 "../src/Utility/Device.vala"
					_tmp13_ = part;
#line 293 "../src/Utility/Device.vala"
					_tmp14_ = _tmp13_->kname;
#line 293 "../src/Utility/Device.vala"
					_tmp15_ = parent->kname;
#line 293 "../src/Utility/Device.vala"
					_tmp9_ = g_str_has_prefix (_tmp14_, _tmp15_);
#line 1365 "Device.c"
				} else {
#line 293 "../src/Utility/Device.vala"
					_tmp9_ = FALSE;
#line 1369 "Device.c"
				}
#line 293 "../src/Utility/Device.vala"
				if (_tmp9_) {
#line 1373 "Device.c"
					GeeArrayList* _tmp16_;
					Device* _tmp17_;
					Device* _tmp18_;
					Device* _tmp19_;
					Device* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					const gchar* _tmp23_;
					Device* _tmp24_;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
#line 294 "../src/Utility/Device.vala"
					_tmp16_ = parent->children;
#line 294 "../src/Utility/Device.vala"
					_tmp17_ = part;
#line 294 "../src/Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 295 "../src/Utility/Device.vala"
					_tmp18_ = part;
#line 295 "../src/Utility/Device.vala"
					_tmp19_ = _g_object_ref0 (parent);
#line 295 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp18_->parent);
#line 295 "../src/Utility/Device.vala"
					_tmp18_->parent = _tmp19_;
#line 296 "../src/Utility/Device.vala"
					_tmp20_ = part;
#line 296 "../src/Utility/Device.vala"
					_tmp21_ = parent->kname;
#line 296 "../src/Utility/Device.vala"
					_tmp22_ = g_strdup (_tmp21_);
#line 296 "../src/Utility/Device.vala"
					_g_free0 (_tmp20_->pkname);
#line 296 "../src/Utility/Device.vala"
					_tmp20_->pkname = _tmp22_;
#line 297 "../src/Utility/Device.vala"
					_tmp23_ = parent->kname;
#line 297 "../src/Utility/Device.vala"
					_tmp24_ = part;
#line 297 "../src/Utility/Device.vala"
					_tmp25_ = _tmp24_->kname;
#line 297 "../src/Utility/Device.vala"
					_tmp26_ = g_strdup_printf ("%s -> %s", _tmp23_, _tmp25_);
#line 297 "../src/Utility/Device.vala"
					_tmp27_ = _tmp26_;
#line 297 "../src/Utility/Device.vala"
					tee_jee_logging_log_debug (_tmp27_);
#line 297 "../src/Utility/Device.vala"
					_g_free0 (_tmp27_);
#line 1424 "Device.c"
				}
#line 292 "../src/Utility/Device.vala"
				_g_object_unref0 (part);
#line 1428 "Device.c"
			}
		}
	} else {
		{
			GeeArrayList* _part_list = NULL;
			gint _part_size = 0;
			GeeArrayList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _part_index = 0;
#line 302 "../src/Utility/Device.vala"
			_part_list = list;
#line 302 "../src/Utility/Device.vala"
			_tmp28_ = _part_list;
#line 302 "../src/Utility/Device.vala"
			_tmp29_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp28_);
#line 302 "../src/Utility/Device.vala"
			_tmp30_ = _tmp29_;
#line 302 "../src/Utility/Device.vala"
			_part_size = _tmp30_;
#line 302 "../src/Utility/Device.vala"
			_part_index = -1;
#line 302 "../src/Utility/Device.vala"
			while (TRUE) {
#line 1453 "Device.c"
				gint _tmp31_;
				gint _tmp32_;
				Device* part = NULL;
				GeeArrayList* _tmp33_;
				gpointer _tmp34_;
				Device* _tmp35_;
				const gchar* _tmp36_;
				const gchar* _tmp37_;
#line 302 "../src/Utility/Device.vala"
				_part_index = _part_index + 1;
#line 302 "../src/Utility/Device.vala"
				_tmp31_ = _part_index;
#line 302 "../src/Utility/Device.vala"
				_tmp32_ = _part_size;
#line 302 "../src/Utility/Device.vala"
				if (!(_tmp31_ < _tmp32_)) {
#line 302 "../src/Utility/Device.vala"
					break;
#line 1472 "Device.c"
				}
#line 302 "../src/Utility/Device.vala"
				_tmp33_ = _part_list;
#line 302 "../src/Utility/Device.vala"
				_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _part_index);
#line 302 "../src/Utility/Device.vala"
				part = (Device*) _tmp34_;
#line 303 "../src/Utility/Device.vala"
				_tmp35_ = part;
#line 303 "../src/Utility/Device.vala"
				_tmp36_ = _tmp35_->pkname;
#line 303 "../src/Utility/Device.vala"
				_tmp37_ = parent->kname;
#line 303 "../src/Utility/Device.vala"
				if (g_strcmp0 (_tmp36_, _tmp37_) == 0) {
#line 1488 "Device.c"
					GeeArrayList* _tmp38_;
					Device* _tmp39_;
					Device* _tmp40_;
					Device* _tmp41_;
#line 304 "../src/Utility/Device.vala"
					_tmp38_ = parent->children;
#line 304 "../src/Utility/Device.vala"
					_tmp39_ = part;
#line 304 "../src/Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp39_);
#line 305 "../src/Utility/Device.vala"
					_tmp40_ = part;
#line 305 "../src/Utility/Device.vala"
					_tmp41_ = _g_object_ref0 (parent);
#line 305 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp40_->parent);
#line 305 "../src/Utility/Device.vala"
					_tmp40_->parent = _tmp41_;
#line 1507 "Device.c"
				}
#line 302 "../src/Utility/Device.vala"
				_g_object_unref0 (part);
#line 1511 "Device.c"
			}
		}
	}
}

static void
device_find_toplevel_parent (GeeArrayList* list,
                             Device* dev)
{
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* top_kname = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
#line 311 "../src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 311 "../src/Utility/Device.vala"
	g_return_if_fail (dev != NULL);
#line 313 "../src/Utility/Device.vala"
	_tmp0_ = dev->pkname;
#line 313 "../src/Utility/Device.vala"
	_tmp1_ = strlen (_tmp0_);
#line 313 "../src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 313 "../src/Utility/Device.vala"
	if (_tmp2_ == 0) {
#line 313 "../src/Utility/Device.vala"
		return;
#line 1543 "Device.c"
	}
#line 315 "../src/Utility/Device.vala"
	_tmp3_ = dev->pkname;
#line 315 "../src/Utility/Device.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 315 "../src/Utility/Device.vala"
	top_kname = _tmp4_;
#line 1551 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		gint _part_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _part_index = 0;
#line 317 "../src/Utility/Device.vala"
		_part_list = list;
#line 317 "../src/Utility/Device.vala"
		_tmp5_ = _part_list;
#line 317 "../src/Utility/Device.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 317 "../src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 317 "../src/Utility/Device.vala"
		_part_size = _tmp7_;
#line 317 "../src/Utility/Device.vala"
		_part_index = -1;
#line 317 "../src/Utility/Device.vala"
		while (TRUE) {
#line 1573 "Device.c"
			gint _tmp8_;
			gint _tmp9_;
			Device* part = NULL;
			GeeArrayList* _tmp10_;
			gpointer _tmp11_;
			Device* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 317 "../src/Utility/Device.vala"
			_part_index = _part_index + 1;
#line 317 "../src/Utility/Device.vala"
			_tmp8_ = _part_index;
#line 317 "../src/Utility/Device.vala"
			_tmp9_ = _part_size;
#line 317 "../src/Utility/Device.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 317 "../src/Utility/Device.vala"
				break;
#line 1592 "Device.c"
			}
#line 317 "../src/Utility/Device.vala"
			_tmp10_ = _part_list;
#line 317 "../src/Utility/Device.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _part_index);
#line 317 "../src/Utility/Device.vala"
			part = (Device*) _tmp11_;
#line 318 "../src/Utility/Device.vala"
			_tmp12_ = part;
#line 318 "../src/Utility/Device.vala"
			_tmp13_ = _tmp12_->kname;
#line 318 "../src/Utility/Device.vala"
			_tmp14_ = top_kname;
#line 318 "../src/Utility/Device.vala"
			if (g_strcmp0 (_tmp13_, _tmp14_) == 0) {
#line 1608 "Device.c"
				Device* _tmp15_;
				const gchar* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 319 "../src/Utility/Device.vala"
				_tmp15_ = part;
#line 319 "../src/Utility/Device.vala"
				_tmp16_ = _tmp15_->pkname;
#line 319 "../src/Utility/Device.vala"
				_tmp17_ = strlen (_tmp16_);
#line 319 "../src/Utility/Device.vala"
				_tmp18_ = _tmp17_;
#line 319 "../src/Utility/Device.vala"
				if (_tmp18_ > 0) {
#line 1623 "Device.c"
					Device* _tmp19_;
					const gchar* _tmp20_;
					gchar* _tmp21_;
#line 320 "../src/Utility/Device.vala"
					_tmp19_ = part;
#line 320 "../src/Utility/Device.vala"
					_tmp20_ = _tmp19_->pkname;
#line 320 "../src/Utility/Device.vala"
					_tmp21_ = g_strdup (_tmp20_);
#line 320 "../src/Utility/Device.vala"
					_g_free0 (top_kname);
#line 320 "../src/Utility/Device.vala"
					top_kname = _tmp21_;
#line 1637 "Device.c"
				}
			}
#line 317 "../src/Utility/Device.vala"
			_g_object_unref0 (part);
#line 1642 "Device.c"
		}
	}
#line 325 "../src/Utility/Device.vala"
	_tmp22_ = top_kname;
#line 325 "../src/Utility/Device.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 325 "../src/Utility/Device.vala"
	_g_free0 (dev->pkname_toplevel);
#line 325 "../src/Utility/Device.vala"
	dev->pkname_toplevel = _tmp23_;
#line 311 "../src/Utility/Device.vala"
	_g_free0 (top_kname);
#line 1655 "Device.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 1676 "Device.c"
}

static void
device_find_child_devices_using_dmsetup (GeeArrayList* list)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	GError* _inner_error0_ = NULL;
#line 330 "../src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 333 "../src/Utility/Device.vala"
	tee_jee_process_helper_exec_sync ("dmsetup deps -o blkdevname", &_tmp0_, &_tmp1_);
#line 333 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 333 "../src/Utility/Device.vala"
	std_out = _tmp0_;
#line 333 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 333 "../src/Utility/Device.vala"
	std_err = _tmp1_;
#line 344 "../src/Utility/Device.vala"
	_tmp2_ = std_out;
#line 344 "../src/Utility/Device.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 1708 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 344 "../src/Utility/Device.vala"
		line_collection = _tmp4_;
#line 344 "../src/Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp3_);
#line 344 "../src/Utility/Device.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1720 "Device.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 344 "../src/Utility/Device.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 344 "../src/Utility/Device.vala"
			line = _tmp5_;
#line 1727 "Device.c"
			{
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gboolean _tmp11_;
#line 345 "../src/Utility/Device.vala"
				_tmp6_ = line;
#line 345 "../src/Utility/Device.vala"
				_tmp7_ = string_strip (_tmp6_);
#line 345 "../src/Utility/Device.vala"
				_tmp8_ = _tmp7_;
#line 345 "../src/Utility/Device.vala"
				_tmp9_ = strlen (_tmp8_);
#line 345 "../src/Utility/Device.vala"
				_tmp10_ = _tmp9_;
#line 345 "../src/Utility/Device.vala"
				_tmp11_ = _tmp10_ == 0;
#line 345 "../src/Utility/Device.vala"
				_g_free0 (_tmp8_);
#line 345 "../src/Utility/Device.vala"
				if (_tmp11_) {
#line 345 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 345 "../src/Utility/Device.vala"
					continue;
#line 1755 "Device.c"
				}
				{
					GRegex* _tmp12_ = NULL;
					GRegex* _tmp13_;
					GRegex* _tmp14_;
					GRegex* _tmp15_;
					const gchar* _tmp16_;
					GMatchInfo* _tmp17_ = NULL;
					gboolean _tmp18_;
#line 349 "../src/Utility/Device.vala"
					_tmp13_ = g_regex_new ("([^:]*)\\:.*\\((.*)\\)", 0, 0, &_inner_error0_);
#line 349 "../src/Utility/Device.vala"
					_tmp12_ = _tmp13_;
#line 349 "../src/Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1771 "Device.c"
						goto __catch0_g_error;
					}
#line 349 "../src/Utility/Device.vala"
					_tmp14_ = _tmp12_;
#line 349 "../src/Utility/Device.vala"
					_tmp12_ = NULL;
#line 349 "../src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 349 "../src/Utility/Device.vala"
					rex = _tmp14_;
#line 351 "../src/Utility/Device.vala"
					_tmp15_ = rex;
#line 351 "../src/Utility/Device.vala"
					_tmp16_ = line;
#line 351 "../src/Utility/Device.vala"
					_tmp18_ = g_regex_match (_tmp15_, _tmp16_, 0, &_tmp17_);
#line 351 "../src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 351 "../src/Utility/Device.vala"
					match = _tmp17_;
#line 351 "../src/Utility/Device.vala"
					if (_tmp18_) {
#line 1794 "Device.c"
						gchar* child_name = NULL;
						GMatchInfo* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* parent_kname = NULL;
						GMatchInfo* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						Device* parent = NULL;
						Device* child = NULL;
						gboolean _tmp53_ = FALSE;
						Device* _tmp54_;
#line 353 "../src/Utility/Device.vala"
						_tmp19_ = match;
#line 353 "../src/Utility/Device.vala"
						_tmp20_ = g_match_info_fetch (_tmp19_, 1);
#line 353 "../src/Utility/Device.vala"
						_tmp21_ = _tmp20_;
#line 353 "../src/Utility/Device.vala"
						_tmp22_ = string_strip (_tmp21_);
#line 353 "../src/Utility/Device.vala"
						_tmp23_ = _tmp22_;
#line 353 "../src/Utility/Device.vala"
						_g_free0 (_tmp21_);
#line 353 "../src/Utility/Device.vala"
						child_name = _tmp23_;
#line 354 "../src/Utility/Device.vala"
						_tmp24_ = match;
#line 354 "../src/Utility/Device.vala"
						_tmp25_ = g_match_info_fetch (_tmp24_, 2);
#line 354 "../src/Utility/Device.vala"
						_tmp26_ = _tmp25_;
#line 354 "../src/Utility/Device.vala"
						_tmp27_ = string_strip (_tmp26_);
#line 354 "../src/Utility/Device.vala"
						_tmp28_ = _tmp27_;
#line 354 "../src/Utility/Device.vala"
						_g_free0 (_tmp26_);
#line 354 "../src/Utility/Device.vala"
						parent_kname = _tmp28_;
#line 356 "../src/Utility/Device.vala"
						parent = NULL;
#line 1841 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							gint _dev_size = 0;
							GeeArrayList* _tmp29_;
							gint _tmp30_;
							gint _tmp31_;
							gint _dev_index = 0;
#line 357 "../src/Utility/Device.vala"
							_dev_list = list;
#line 357 "../src/Utility/Device.vala"
							_tmp29_ = _dev_list;
#line 357 "../src/Utility/Device.vala"
							_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
#line 357 "../src/Utility/Device.vala"
							_tmp31_ = _tmp30_;
#line 357 "../src/Utility/Device.vala"
							_dev_size = _tmp31_;
#line 357 "../src/Utility/Device.vala"
							_dev_index = -1;
#line 357 "../src/Utility/Device.vala"
							while (TRUE) {
#line 1863 "Device.c"
								gint _tmp32_;
								gint _tmp33_;
								Device* dev = NULL;
								GeeArrayList* _tmp34_;
								gpointer _tmp35_;
								Device* _tmp36_;
								const gchar* _tmp37_;
								const gchar* _tmp38_;
#line 357 "../src/Utility/Device.vala"
								_dev_index = _dev_index + 1;
#line 357 "../src/Utility/Device.vala"
								_tmp32_ = _dev_index;
#line 357 "../src/Utility/Device.vala"
								_tmp33_ = _dev_size;
#line 357 "../src/Utility/Device.vala"
								if (!(_tmp32_ < _tmp33_)) {
#line 357 "../src/Utility/Device.vala"
									break;
#line 1882 "Device.c"
								}
#line 357 "../src/Utility/Device.vala"
								_tmp34_ = _dev_list;
#line 357 "../src/Utility/Device.vala"
								_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _tmp34_, _dev_index);
#line 357 "../src/Utility/Device.vala"
								dev = (Device*) _tmp35_;
#line 358 "../src/Utility/Device.vala"
								_tmp36_ = dev;
#line 358 "../src/Utility/Device.vala"
								_tmp37_ = _tmp36_->kname;
#line 358 "../src/Utility/Device.vala"
								_tmp38_ = parent_kname;
#line 358 "../src/Utility/Device.vala"
								if (g_strcmp0 (_tmp37_, _tmp38_) == 0) {
#line 1898 "Device.c"
									Device* _tmp39_;
									Device* _tmp40_;
#line 359 "../src/Utility/Device.vala"
									_tmp39_ = dev;
#line 359 "../src/Utility/Device.vala"
									_tmp40_ = _g_object_ref0 (_tmp39_);
#line 359 "../src/Utility/Device.vala"
									_g_object_unref0 (parent);
#line 359 "../src/Utility/Device.vala"
									parent = _tmp40_;
#line 360 "../src/Utility/Device.vala"
									_g_object_unref0 (dev);
#line 360 "../src/Utility/Device.vala"
									break;
#line 1913 "Device.c"
								}
#line 357 "../src/Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1917 "Device.c"
							}
						}
#line 364 "../src/Utility/Device.vala"
						child = NULL;
#line 1922 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							gint _dev_size = 0;
							GeeArrayList* _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
							gint _dev_index = 0;
#line 365 "../src/Utility/Device.vala"
							_dev_list = list;
#line 365 "../src/Utility/Device.vala"
							_tmp41_ = _dev_list;
#line 365 "../src/Utility/Device.vala"
							_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 365 "../src/Utility/Device.vala"
							_tmp43_ = _tmp42_;
#line 365 "../src/Utility/Device.vala"
							_dev_size = _tmp43_;
#line 365 "../src/Utility/Device.vala"
							_dev_index = -1;
#line 365 "../src/Utility/Device.vala"
							while (TRUE) {
#line 1944 "Device.c"
								gint _tmp44_;
								gint _tmp45_;
								Device* dev = NULL;
								GeeArrayList* _tmp46_;
								gpointer _tmp47_;
								Device* _tmp48_;
								const gchar* _tmp49_;
								const gchar* _tmp50_;
#line 365 "../src/Utility/Device.vala"
								_dev_index = _dev_index + 1;
#line 365 "../src/Utility/Device.vala"
								_tmp44_ = _dev_index;
#line 365 "../src/Utility/Device.vala"
								_tmp45_ = _dev_size;
#line 365 "../src/Utility/Device.vala"
								if (!(_tmp44_ < _tmp45_)) {
#line 365 "../src/Utility/Device.vala"
									break;
#line 1963 "Device.c"
								}
#line 365 "../src/Utility/Device.vala"
								_tmp46_ = _dev_list;
#line 365 "../src/Utility/Device.vala"
								_tmp47_ = gee_abstract_list_get ((GeeAbstractList*) _tmp46_, _dev_index);
#line 365 "../src/Utility/Device.vala"
								dev = (Device*) _tmp47_;
#line 366 "../src/Utility/Device.vala"
								_tmp48_ = dev;
#line 366 "../src/Utility/Device.vala"
								_tmp49_ = _tmp48_->mapped_name;
#line 366 "../src/Utility/Device.vala"
								_tmp50_ = child_name;
#line 366 "../src/Utility/Device.vala"
								if (g_strcmp0 (_tmp49_, _tmp50_) == 0) {
#line 1979 "Device.c"
									Device* _tmp51_;
									Device* _tmp52_;
#line 367 "../src/Utility/Device.vala"
									_tmp51_ = dev;
#line 367 "../src/Utility/Device.vala"
									_tmp52_ = _g_object_ref0 (_tmp51_);
#line 367 "../src/Utility/Device.vala"
									_g_object_unref0 (child);
#line 367 "../src/Utility/Device.vala"
									child = _tmp52_;
#line 368 "../src/Utility/Device.vala"
									_g_object_unref0 (dev);
#line 368 "../src/Utility/Device.vala"
									break;
#line 1994 "Device.c"
								}
#line 365 "../src/Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1998 "Device.c"
							}
						}
#line 372 "../src/Utility/Device.vala"
						_tmp54_ = parent;
#line 372 "../src/Utility/Device.vala"
						if (_tmp54_ != NULL) {
#line 2005 "Device.c"
							Device* _tmp55_;
#line 372 "../src/Utility/Device.vala"
							_tmp55_ = child;
#line 372 "../src/Utility/Device.vala"
							_tmp53_ = _tmp55_ != NULL;
#line 2011 "Device.c"
						} else {
#line 372 "../src/Utility/Device.vala"
							_tmp53_ = FALSE;
#line 2015 "Device.c"
						}
#line 372 "../src/Utility/Device.vala"
						if (_tmp53_) {
#line 2019 "Device.c"
							Device* _tmp56_;
							Device* _tmp57_;
							const gchar* _tmp58_;
							gchar* _tmp59_;
#line 373 "../src/Utility/Device.vala"
							_tmp56_ = child;
#line 373 "../src/Utility/Device.vala"
							_tmp57_ = parent;
#line 373 "../src/Utility/Device.vala"
							_tmp58_ = _tmp57_->kname;
#line 373 "../src/Utility/Device.vala"
							_tmp59_ = g_strdup (_tmp58_);
#line 373 "../src/Utility/Device.vala"
							_g_free0 (_tmp56_->pkname);
#line 373 "../src/Utility/Device.vala"
							_tmp56_->pkname = _tmp59_;
#line 2036 "Device.c"
						}
#line 351 "../src/Utility/Device.vala"
						_g_object_unref0 (child);
#line 351 "../src/Utility/Device.vala"
						_g_object_unref0 (parent);
#line 351 "../src/Utility/Device.vala"
						_g_free0 (parent_kname);
#line 351 "../src/Utility/Device.vala"
						_g_free0 (child_name);
#line 2046 "Device.c"
					} else {
						const gchar* _tmp60_;
						gchar* _tmp61_;
						gchar* _tmp62_;
#line 379 "../src/Utility/Device.vala"
						_tmp60_ = line;
#line 379 "../src/Utility/Device.vala"
						_tmp61_ = g_strdup_printf ("no-match: %s", _tmp60_);
#line 379 "../src/Utility/Device.vala"
						_tmp62_ = _tmp61_;
#line 379 "../src/Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp62_);
#line 379 "../src/Utility/Device.vala"
						_g_free0 (_tmp62_);
#line 2061 "Device.c"
					}
#line 347 "../src/Utility/Device.vala"
					_g_regex_unref0 (_tmp12_);
#line 2065 "Device.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp63_;
					const gchar* _tmp64_;
#line 347 "../src/Utility/Device.vala"
					e = _inner_error0_;
#line 347 "../src/Utility/Device.vala"
					_inner_error0_ = NULL;
#line 383 "../src/Utility/Device.vala"
					_tmp63_ = e;
#line 383 "../src/Utility/Device.vala"
					_tmp64_ = _tmp63_->message;
#line 383 "../src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp64_, FALSE, FALSE);
#line 347 "../src/Utility/Device.vala"
					_g_error_free0 (e);
#line 2085 "Device.c"
				}
				__finally0:
#line 347 "../src/Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 347 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 347 "../src/Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 347 "../src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 347 "../src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 347 "../src/Utility/Device.vala"
					_g_free0 (std_err);
#line 347 "../src/Utility/Device.vala"
					_g_free0 (std_out);
#line 347 "../src/Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 347 "../src/Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 347 "../src/Utility/Device.vala"
					return;
#line 2108 "Device.c"
				}
#line 344 "../src/Utility/Device.vala"
				_g_free0 (line);
#line 2112 "Device.c"
			}
		}
#line 344 "../src/Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2117 "Device.c"
	}
#line 330 "../src/Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 330 "../src/Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 330 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 330 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 2127 "Device.c"
}

gint
device_remove_parents (GeeArrayList* list,
                       Device* dev)
{
	gint removed = 0;
	const gchar* _tmp0_;
	gint result;
#line 392 "../src/Utility/Device.vala"
	g_return_val_if_fail (list != NULL, 0);
#line 392 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev != NULL, 0);
#line 394 "../src/Utility/Device.vala"
	removed = 0;
#line 396 "../src/Utility/Device.vala"
	_tmp0_ = dev->pkname;
#line 396 "../src/Utility/Device.vala"
	if (g_strcmp0 (_tmp0_, "") != 0) {
#line 2147 "Device.c"
		const gchar* _tmp21_;
		{
			gint i = 0;
			gint _tmp1_;
			gint _tmp2_;
#line 397 "../src/Utility/Device.vala"
			_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) list);
#line 397 "../src/Utility/Device.vala"
			_tmp2_ = _tmp1_;
#line 397 "../src/Utility/Device.vala"
			i = _tmp2_ - 1;
#line 2159 "Device.c"
			{
				gboolean _tmp3_ = FALSE;
#line 397 "../src/Utility/Device.vala"
				_tmp3_ = TRUE;
#line 397 "../src/Utility/Device.vala"
				while (TRUE) {
#line 2166 "Device.c"
					gpointer _tmp5_;
					Device* _tmp6_;
					const gchar* _tmp7_;
					const gchar* _tmp8_;
					gboolean _tmp9_;
#line 397 "../src/Utility/Device.vala"
					if (!_tmp3_) {
#line 2174 "Device.c"
						gint _tmp4_;
#line 397 "../src/Utility/Device.vala"
						i = i - 1;
#line 397 "../src/Utility/Device.vala"
						_tmp4_ = i;
#line 2180 "Device.c"
					}
#line 397 "../src/Utility/Device.vala"
					_tmp3_ = FALSE;
#line 397 "../src/Utility/Device.vala"
					if (!(i >= 0)) {
#line 397 "../src/Utility/Device.vala"
						break;
#line 2188 "Device.c"
					}
#line 398 "../src/Utility/Device.vala"
					_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) list, i);
#line 398 "../src/Utility/Device.vala"
					_tmp6_ = (Device*) _tmp5_;
#line 398 "../src/Utility/Device.vala"
					_tmp7_ = _tmp6_->kname;
#line 398 "../src/Utility/Device.vala"
					_tmp8_ = dev->pkname;
#line 398 "../src/Utility/Device.vala"
					_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) == 0;
#line 398 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp6_);
#line 398 "../src/Utility/Device.vala"
					if (_tmp9_) {
#line 2204 "Device.c"
						gpointer _tmp10_;
						Device* _tmp11_;
						const gchar* _tmp12_;
						gboolean _tmp13_;
						gpointer _tmp16_;
						Device* _tmp17_;
						gint _tmp18_;
						gchar* _tmp19_;
						gint _tmp20_;
#line 399 "../src/Utility/Device.vala"
						_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) list, i);
#line 399 "../src/Utility/Device.vala"
						_tmp11_ = (Device*) _tmp10_;
#line 399 "../src/Utility/Device.vala"
						_tmp12_ = _tmp11_->pkname;
#line 399 "../src/Utility/Device.vala"
						_tmp13_ = g_strcmp0 (_tmp12_, "") != 0;
#line 399 "../src/Utility/Device.vala"
						_g_object_unref0 (_tmp11_);
#line 399 "../src/Utility/Device.vala"
						if (_tmp13_) {
#line 2226 "Device.c"
							gpointer _tmp14_;
							Device* _tmp15_;
#line 400 "../src/Utility/Device.vala"
							_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) list, i);
#line 400 "../src/Utility/Device.vala"
							_tmp15_ = (Device*) _tmp14_;
#line 400 "../src/Utility/Device.vala"
							removed = device_remove_parents (list, _tmp15_);
#line 400 "../src/Utility/Device.vala"
							_g_object_unref0 (_tmp15_);
#line 401 "../src/Utility/Device.vala"
							i -= removed;
#line 2239 "Device.c"
						}
#line 403 "../src/Utility/Device.vala"
						_tmp16_ = gee_abstract_list_remove_at ((GeeAbstractList*) list, i);
#line 403 "../src/Utility/Device.vala"
						_tmp17_ = (Device*) _tmp16_;
#line 403 "../src/Utility/Device.vala"
						_g_object_unref0 (_tmp17_);
#line 404 "../src/Utility/Device.vala"
						i = i - 1;
#line 404 "../src/Utility/Device.vala"
						_tmp18_ = i;
#line 405 "../src/Utility/Device.vala"
						_tmp19_ = g_strdup ("");
#line 405 "../src/Utility/Device.vala"
						_g_free0 (dev->pkname);
#line 405 "../src/Utility/Device.vala"
						dev->pkname = _tmp19_;
#line 406 "../src/Utility/Device.vala"
						removed = removed + 1;
#line 406 "../src/Utility/Device.vala"
						_tmp20_ = removed;
#line 2261 "Device.c"
					}
				}
			}
		}
#line 412 "../src/Utility/Device.vala"
		_tmp21_ = dev->pkname;
#line 412 "../src/Utility/Device.vala"
		if (g_strcmp0 (_tmp21_, "") != 0) {
#line 2270 "Device.c"
			gchar* _tmp22_;
#line 413 "../src/Utility/Device.vala"
			_tmp22_ = g_strdup ("");
#line 413 "../src/Utility/Device.vala"
			_g_free0 (dev->pkname);
#line 413 "../src/Utility/Device.vala"
			dev->pkname = _tmp22_;
#line 2278 "Device.c"
		}
	}
#line 417 "../src/Utility/Device.vala"
	result = removed;
#line 417 "../src/Utility/Device.vala"
	return result;
#line 2285 "Device.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 2299 "Device.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2321 "Device.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2325 "Device.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2331 "Device.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2335 "Device.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2339 "Device.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 2347 "Device.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2375 "Device.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 2384 "Device.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2398 "Device.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 2407 "Device.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 2421 "Device.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2430 "Device.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 2439 "Device.c"
}

GeeArrayList*
device_get_block_devices_using_lsblk (const gchar* dev_name)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gint _tmp3_;
	gint _tmp4_;
	const gchar* _tmp9_;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gint _tmp12_;
	gint index = 0;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	GeeArrayList* _tmp284_;
	GeeArrayList* _tmp285_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 420 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 427 "../src/Utility/Device.vala"
	device_test_lsblk_version ();
#line 429 "../src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 429 "../src/Utility/Device.vala"
	list = _tmp0_;
#line 438 "../src/Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 2477 "Device.c"
		gchar* _tmp1_;
#line 439 "../src/Utility/Device.vala"
		_tmp1_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,RM,MAJ:MIN");
#line 439 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 439 "../src/Utility/Device.vala"
		cmd = _tmp1_;
#line 2485 "Device.c"
	} else {
		gchar* _tmp2_;
#line 442 "../src/Utility/Device.vala"
		_tmp2_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,HOTPLUG,MAJ:MIN,PARTLABEL,PARTUUID,PKNAME,VENDOR,S" \
"ERIAL,REV");
#line 442 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 442 "../src/Utility/Device.vala"
		cmd = _tmp2_;
#line 2494 "Device.c"
	}
#line 445 "../src/Utility/Device.vala"
	_tmp3_ = strlen (dev_name);
#line 445 "../src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 445 "../src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 2502 "Device.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 446 "../src/Utility/Device.vala"
		_tmp5_ = cmd;
#line 446 "../src/Utility/Device.vala"
		_tmp6_ = g_strdup_printf (" %s", dev_name);
#line 446 "../src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 446 "../src/Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 446 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 446 "../src/Utility/Device.vala"
		cmd = _tmp8_;
#line 446 "../src/Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 2521 "Device.c"
	}
#line 449 "../src/Utility/Device.vala"
	_tmp9_ = cmd;
#line 449 "../src/Utility/Device.vala"
	_tmp12_ = tee_jee_process_helper_exec_sync (_tmp9_, &_tmp10_, &_tmp11_);
#line 449 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 449 "../src/Utility/Device.vala"
	std_out = _tmp10_;
#line 449 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 449 "../src/Utility/Device.vala"
	std_err = _tmp11_;
#line 449 "../src/Utility/Device.vala"
	ret_val = _tmp12_;
#line 470 "../src/Utility/Device.vala"
	index = -1;
#line 472 "../src/Utility/Device.vala"
	_tmp13_ = std_out;
#line 472 "../src/Utility/Device.vala"
	_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "\n", 0);
#line 2543 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 472 "../src/Utility/Device.vala"
		line_collection = _tmp15_;
#line 472 "../src/Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp14_);
#line 472 "../src/Utility/Device.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 2555 "Device.c"
			gchar* _tmp16_;
			gchar* line = NULL;
#line 472 "../src/Utility/Device.vala"
			_tmp16_ = g_strdup (line_collection[line_it]);
#line 472 "../src/Utility/Device.vala"
			line = _tmp16_;
#line 2562 "Device.c"
			{
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gboolean _tmp22_;
#line 473 "../src/Utility/Device.vala"
				_tmp17_ = line;
#line 473 "../src/Utility/Device.vala"
				_tmp18_ = string_strip (_tmp17_);
#line 473 "../src/Utility/Device.vala"
				_tmp19_ = _tmp18_;
#line 473 "../src/Utility/Device.vala"
				_tmp20_ = strlen (_tmp19_);
#line 473 "../src/Utility/Device.vala"
				_tmp21_ = _tmp20_;
#line 473 "../src/Utility/Device.vala"
				_tmp22_ = _tmp21_ == 0;
#line 473 "../src/Utility/Device.vala"
				_g_free0 (_tmp19_);
#line 473 "../src/Utility/Device.vala"
				if (_tmp22_) {
#line 473 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 473 "../src/Utility/Device.vala"
					continue;
#line 2590 "Device.c"
				}
				{
					GRegex* _tmp29_;
					const gchar* _tmp30_;
					GMatchInfo* _tmp31_ = NULL;
					gboolean _tmp32_;
#line 476 "../src/Utility/Device.vala"
					if (device_lsblk_is_ancient) {
#line 2599 "Device.c"
						GRegex* _tmp23_ = NULL;
						GRegex* _tmp24_;
						GRegex* _tmp25_;
#line 477 "../src/Utility/Device.vala"
						_tmp24_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" RM=\"([0-9]+)\" MAJ[_:]MIN=\"([0-9:]+)\"", 0, 0, &_inner_error0_);
#line 477 "../src/Utility/Device.vala"
						_tmp23_ = _tmp24_;
#line 477 "../src/Utility/Device.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2609 "Device.c"
							goto __catch0_g_error;
						}
#line 477 "../src/Utility/Device.vala"
						_tmp25_ = _tmp23_;
#line 477 "../src/Utility/Device.vala"
						_tmp23_ = NULL;
#line 477 "../src/Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 477 "../src/Utility/Device.vala"
						rex = _tmp25_;
#line 476 "../src/Utility/Device.vala"
						_g_regex_unref0 (_tmp23_);
#line 2622 "Device.c"
					} else {
						GRegex* _tmp26_ = NULL;
						GRegex* _tmp27_;
						GRegex* _tmp28_;
#line 480 "../src/Utility/Device.vala"
						_tmp27_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" HOTPLUG=\"([0-9]+)\" MAJ[_:]MIN=\"([0-9:]+)\" PARTLABEL=\"(" \
".*)\" PARTUUID=\"(.*)\" PKNAME=\"(.*)\" VENDOR=\"(.*)\" SERIAL=\"(.*)\"" \
" REV=\"(.*)\"", 0, 0, &_inner_error0_);
#line 480 "../src/Utility/Device.vala"
						_tmp26_ = _tmp27_;
#line 480 "../src/Utility/Device.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2633 "Device.c"
							goto __catch0_g_error;
						}
#line 480 "../src/Utility/Device.vala"
						_tmp28_ = _tmp26_;
#line 480 "../src/Utility/Device.vala"
						_tmp26_ = NULL;
#line 480 "../src/Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 480 "../src/Utility/Device.vala"
						rex = _tmp28_;
#line 476 "../src/Utility/Device.vala"
						_g_regex_unref0 (_tmp26_);
#line 2646 "Device.c"
					}
#line 483 "../src/Utility/Device.vala"
					_tmp29_ = rex;
#line 483 "../src/Utility/Device.vala"
					_tmp30_ = line;
#line 483 "../src/Utility/Device.vala"
					_tmp32_ = g_regex_match (_tmp29_, _tmp30_, 0, &_tmp31_);
#line 483 "../src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 483 "../src/Utility/Device.vala"
					match = _tmp31_;
#line 483 "../src/Utility/Device.vala"
					if (_tmp32_) {
#line 2660 "Device.c"
						Device* pi = NULL;
						Device* _tmp33_;
						gint pos = 0;
						Device* _tmp34_;
						GMatchInfo* _tmp35_;
						gint _tmp36_;
						gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						Device* _tmp40_;
						GMatchInfo* _tmp41_;
						gint _tmp42_;
						gchar* _tmp43_;
						gchar* _tmp44_;
						gchar* _tmp45_;
						Device* _tmp46_;
						GMatchInfo* _tmp47_;
						gint _tmp48_;
						gchar* _tmp49_;
						Device* _tmp50_;
						GMatchInfo* _tmp51_;
						gint _tmp52_;
						gchar* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						Device* _tmp56_;
						GMatchInfo* _tmp57_;
						gint _tmp58_;
						gchar* _tmp59_;
						gchar* _tmp60_;
						gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						Device* _tmp64_;
						GMatchInfo* _tmp65_;
						gint _tmp66_;
						gchar* _tmp67_;
						gchar* _tmp68_;
						gchar* _tmp69_;
						gchar* _tmp70_;
						gchar* _tmp71_;
						const gchar* _tmp72_ = NULL;
						Device* _tmp73_;
						const gchar* _tmp74_;
						Device* _tmp77_;
						gchar* _tmp78_;
						const gchar* _tmp79_ = NULL;
						Device* _tmp80_;
						const gchar* _tmp81_;
						Device* _tmp84_;
						gchar* _tmp85_;
						Device* _tmp86_;
						GMatchInfo* _tmp87_;
						gint _tmp88_;
						gchar* _tmp89_;
						gchar* _tmp90_;
						gchar* _tmp91_;
						gchar* _tmp92_;
						gchar* mp = NULL;
						GMatchInfo* _tmp93_;
						gint _tmp94_;
						gchar* _tmp95_;
						gchar* _tmp96_;
						gchar* _tmp97_;
						gchar* _tmp98_;
						const gchar* _tmp99_;
						gint _tmp100_;
						gint _tmp101_;
						Device* _tmp108_;
						GMatchInfo* _tmp109_;
						gint _tmp110_;
						gchar* _tmp111_;
						gchar* _tmp112_;
						gchar* _tmp113_;
						Device* _tmp114_;
						GMatchInfo* _tmp115_;
						gint _tmp116_;
						gchar* _tmp117_;
						gchar* _tmp118_;
						gchar* _tmp119_;
						gchar* _tmp120_;
						Device* _tmp121_;
						GMatchInfo* _tmp122_;
						gint _tmp123_;
						gchar* _tmp124_;
						gchar* _tmp125_;
						gchar* _tmp126_;
						gchar* _tmp127_;
						gchar* txt = NULL;
						GMatchInfo* _tmp128_;
						gint _tmp129_;
						gchar* _tmp130_;
						gchar* _tmp131_;
						gchar* _tmp132_;
						gchar* _tmp133_;
						const gchar* _tmp134_;
						Device* _tmp181_;
						gint _tmp182_;
						Device* _tmp183_;
						Device* _tmp184_;
						const gchar* _tmp185_;
						gchar* _tmp186_;
						Device* _tmp187_;
						const gchar* _tmp188_;
						gint _tmp189_;
						gint _tmp190_;
						Device* _tmp195_;
						const gchar* _tmp196_;
						gint _tmp197_;
						gint _tmp198_;
						Device* _tmp203_;
						const gchar* _tmp204_;
						gint _tmp205_;
						gint _tmp206_;
						Device* _tmp211_;
						const gchar* _tmp212_;
						gint _tmp213_;
						gint _tmp214_;
						GeeArrayList* _tmp219_;
						Device* _tmp220_;
#line 485 "../src/Utility/Device.vala"
						_tmp33_ = device_new ();
#line 485 "../src/Utility/Device.vala"
						pi = _tmp33_;
#line 487 "../src/Utility/Device.vala"
						pos = 0;
#line 489 "../src/Utility/Device.vala"
						_tmp34_ = pi;
#line 489 "../src/Utility/Device.vala"
						_tmp35_ = match;
#line 489 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 489 "../src/Utility/Device.vala"
						_tmp36_ = pos;
#line 489 "../src/Utility/Device.vala"
						_tmp37_ = g_match_info_fetch (_tmp35_, _tmp36_);
#line 489 "../src/Utility/Device.vala"
						_tmp38_ = _tmp37_;
#line 489 "../src/Utility/Device.vala"
						_tmp39_ = string_strip (_tmp38_);
#line 489 "../src/Utility/Device.vala"
						_g_free0 (_tmp34_->name);
#line 489 "../src/Utility/Device.vala"
						_tmp34_->name = _tmp39_;
#line 489 "../src/Utility/Device.vala"
						_g_free0 (_tmp38_);
#line 490 "../src/Utility/Device.vala"
						_tmp40_ = pi;
#line 490 "../src/Utility/Device.vala"
						_tmp41_ = match;
#line 490 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 490 "../src/Utility/Device.vala"
						_tmp42_ = pos;
#line 490 "../src/Utility/Device.vala"
						_tmp43_ = g_match_info_fetch (_tmp41_, _tmp42_);
#line 490 "../src/Utility/Device.vala"
						_tmp44_ = _tmp43_;
#line 490 "../src/Utility/Device.vala"
						_tmp45_ = string_strip (_tmp44_);
#line 490 "../src/Utility/Device.vala"
						_g_free0 (_tmp40_->kname);
#line 490 "../src/Utility/Device.vala"
						_tmp40_->kname = _tmp45_;
#line 490 "../src/Utility/Device.vala"
						_g_free0 (_tmp44_);
#line 492 "../src/Utility/Device.vala"
						_tmp46_ = pi;
#line 492 "../src/Utility/Device.vala"
						_tmp47_ = match;
#line 492 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 492 "../src/Utility/Device.vala"
						_tmp48_ = pos;
#line 492 "../src/Utility/Device.vala"
						_tmp49_ = g_match_info_fetch (_tmp47_, _tmp48_);
#line 492 "../src/Utility/Device.vala"
						_g_free0 (_tmp46_->label);
#line 492 "../src/Utility/Device.vala"
						_tmp46_->label = _tmp49_;
#line 493 "../src/Utility/Device.vala"
						_tmp50_ = pi;
#line 493 "../src/Utility/Device.vala"
						_tmp51_ = match;
#line 493 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 493 "../src/Utility/Device.vala"
						_tmp52_ = pos;
#line 493 "../src/Utility/Device.vala"
						_tmp53_ = g_match_info_fetch (_tmp51_, _tmp52_);
#line 493 "../src/Utility/Device.vala"
						_tmp54_ = _tmp53_;
#line 493 "../src/Utility/Device.vala"
						_tmp55_ = string_strip (_tmp54_);
#line 493 "../src/Utility/Device.vala"
						_g_free0 (_tmp50_->uuid);
#line 493 "../src/Utility/Device.vala"
						_tmp50_->uuid = _tmp55_;
#line 493 "../src/Utility/Device.vala"
						_g_free0 (_tmp54_);
#line 495 "../src/Utility/Device.vala"
						_tmp56_ = pi;
#line 495 "../src/Utility/Device.vala"
						_tmp57_ = match;
#line 495 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 495 "../src/Utility/Device.vala"
						_tmp58_ = pos;
#line 495 "../src/Utility/Device.vala"
						_tmp59_ = g_match_info_fetch (_tmp57_, _tmp58_);
#line 495 "../src/Utility/Device.vala"
						_tmp60_ = _tmp59_;
#line 495 "../src/Utility/Device.vala"
						_tmp61_ = string_strip (_tmp60_);
#line 495 "../src/Utility/Device.vala"
						_tmp62_ = _tmp61_;
#line 495 "../src/Utility/Device.vala"
						_tmp63_ = g_utf8_strdown (_tmp62_, (gssize) -1);
#line 495 "../src/Utility/Device.vala"
						_g_free0 (_tmp56_->type);
#line 495 "../src/Utility/Device.vala"
						_tmp56_->type = _tmp63_;
#line 495 "../src/Utility/Device.vala"
						_g_free0 (_tmp62_);
#line 495 "../src/Utility/Device.vala"
						_g_free0 (_tmp60_);
#line 497 "../src/Utility/Device.vala"
						_tmp64_ = pi;
#line 497 "../src/Utility/Device.vala"
						_tmp65_ = match;
#line 497 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 497 "../src/Utility/Device.vala"
						_tmp66_ = pos;
#line 497 "../src/Utility/Device.vala"
						_tmp67_ = g_match_info_fetch (_tmp65_, _tmp66_);
#line 497 "../src/Utility/Device.vala"
						_tmp68_ = _tmp67_;
#line 497 "../src/Utility/Device.vala"
						_tmp69_ = string_strip (_tmp68_);
#line 497 "../src/Utility/Device.vala"
						_tmp70_ = _tmp69_;
#line 497 "../src/Utility/Device.vala"
						_tmp71_ = g_utf8_strdown (_tmp70_, (gssize) -1);
#line 497 "../src/Utility/Device.vala"
						_g_free0 (_tmp64_->fstype);
#line 497 "../src/Utility/Device.vala"
						_tmp64_->fstype = _tmp71_;
#line 497 "../src/Utility/Device.vala"
						_g_free0 (_tmp70_);
#line 497 "../src/Utility/Device.vala"
						_g_free0 (_tmp68_);
#line 498 "../src/Utility/Device.vala"
						_tmp73_ = pi;
#line 498 "../src/Utility/Device.vala"
						_tmp74_ = _tmp73_->fstype;
#line 498 "../src/Utility/Device.vala"
						if (g_strcmp0 (_tmp74_, "crypto_luks") == 0) {
#line 498 "../src/Utility/Device.vala"
							_tmp72_ = "luks";
#line 2921 "Device.c"
						} else {
							Device* _tmp75_;
							const gchar* _tmp76_;
#line 498 "../src/Utility/Device.vala"
							_tmp75_ = pi;
#line 498 "../src/Utility/Device.vala"
							_tmp76_ = _tmp75_->fstype;
#line 498 "../src/Utility/Device.vala"
							_tmp72_ = _tmp76_;
#line 2931 "Device.c"
						}
#line 498 "../src/Utility/Device.vala"
						_tmp77_ = pi;
#line 498 "../src/Utility/Device.vala"
						_tmp78_ = g_strdup (_tmp72_);
#line 498 "../src/Utility/Device.vala"
						_g_free0 (_tmp77_->fstype);
#line 498 "../src/Utility/Device.vala"
						_tmp77_->fstype = _tmp78_;
#line 499 "../src/Utility/Device.vala"
						_tmp80_ = pi;
#line 499 "../src/Utility/Device.vala"
						_tmp81_ = _tmp80_->fstype;
#line 499 "../src/Utility/Device.vala"
						if (g_strcmp0 (_tmp81_, "lvm2_member") == 0) {
#line 499 "../src/Utility/Device.vala"
							_tmp79_ = "lvm2";
#line 2949 "Device.c"
						} else {
							Device* _tmp82_;
							const gchar* _tmp83_;
#line 499 "../src/Utility/Device.vala"
							_tmp82_ = pi;
#line 499 "../src/Utility/Device.vala"
							_tmp83_ = _tmp82_->fstype;
#line 499 "../src/Utility/Device.vala"
							_tmp79_ = _tmp83_;
#line 2959 "Device.c"
						}
#line 499 "../src/Utility/Device.vala"
						_tmp84_ = pi;
#line 499 "../src/Utility/Device.vala"
						_tmp85_ = g_strdup (_tmp79_);
#line 499 "../src/Utility/Device.vala"
						_g_free0 (_tmp84_->fstype);
#line 499 "../src/Utility/Device.vala"
						_tmp84_->fstype = _tmp85_;
#line 501 "../src/Utility/Device.vala"
						_tmp86_ = pi;
#line 501 "../src/Utility/Device.vala"
						_tmp87_ = match;
#line 501 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 501 "../src/Utility/Device.vala"
						_tmp88_ = pos;
#line 501 "../src/Utility/Device.vala"
						_tmp89_ = g_match_info_fetch (_tmp87_, _tmp88_);
#line 501 "../src/Utility/Device.vala"
						_tmp90_ = _tmp89_;
#line 501 "../src/Utility/Device.vala"
						_tmp91_ = string_strip (_tmp90_);
#line 501 "../src/Utility/Device.vala"
						_tmp92_ = _tmp91_;
#line 501 "../src/Utility/Device.vala"
						_tmp86_->size_bytes = (guint64) int64_parse (_tmp92_, (guint) 0);
#line 501 "../src/Utility/Device.vala"
						_g_free0 (_tmp92_);
#line 501 "../src/Utility/Device.vala"
						_g_free0 (_tmp90_);
#line 503 "../src/Utility/Device.vala"
						_tmp93_ = match;
#line 503 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 503 "../src/Utility/Device.vala"
						_tmp94_ = pos;
#line 503 "../src/Utility/Device.vala"
						_tmp95_ = g_match_info_fetch (_tmp93_, _tmp94_);
#line 503 "../src/Utility/Device.vala"
						_tmp96_ = _tmp95_;
#line 503 "../src/Utility/Device.vala"
						_tmp97_ = string_strip (_tmp96_);
#line 503 "../src/Utility/Device.vala"
						_tmp98_ = _tmp97_;
#line 503 "../src/Utility/Device.vala"
						_g_free0 (_tmp96_);
#line 503 "../src/Utility/Device.vala"
						mp = _tmp98_;
#line 504 "../src/Utility/Device.vala"
						_tmp99_ = mp;
#line 504 "../src/Utility/Device.vala"
						_tmp100_ = strlen (_tmp99_);
#line 504 "../src/Utility/Device.vala"
						_tmp101_ = _tmp100_;
#line 504 "../src/Utility/Device.vala"
						if (_tmp101_ > 0) {
#line 3017 "Device.c"
							Device* _tmp102_;
							GeeArrayList* _tmp103_;
							Device* _tmp104_;
							const gchar* _tmp105_;
							MountEntry* _tmp106_;
							MountEntry* _tmp107_;
#line 505 "../src/Utility/Device.vala"
							_tmp102_ = pi;
#line 505 "../src/Utility/Device.vala"
							_tmp103_ = _tmp102_->mount_points;
#line 505 "../src/Utility/Device.vala"
							_tmp104_ = pi;
#line 505 "../src/Utility/Device.vala"
							_tmp105_ = mp;
#line 505 "../src/Utility/Device.vala"
							_tmp106_ = mount_entry_new (_tmp104_, _tmp105_, "");
#line 505 "../src/Utility/Device.vala"
							_tmp107_ = _tmp106_;
#line 505 "../src/Utility/Device.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp103_, _tmp107_);
#line 505 "../src/Utility/Device.vala"
							_g_object_unref0 (_tmp107_);
#line 3040 "Device.c"
						}
#line 508 "../src/Utility/Device.vala"
						_tmp108_ = pi;
#line 508 "../src/Utility/Device.vala"
						_tmp109_ = match;
#line 508 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 508 "../src/Utility/Device.vala"
						_tmp110_ = pos;
#line 508 "../src/Utility/Device.vala"
						_tmp111_ = g_match_info_fetch (_tmp109_, _tmp110_);
#line 508 "../src/Utility/Device.vala"
						_tmp112_ = _tmp111_;
#line 508 "../src/Utility/Device.vala"
						_tmp113_ = string_strip (_tmp112_);
#line 508 "../src/Utility/Device.vala"
						_g_free0 (_tmp108_->model);
#line 508 "../src/Utility/Device.vala"
						_tmp108_->model = _tmp113_;
#line 508 "../src/Utility/Device.vala"
						_g_free0 (_tmp112_);
#line 510 "../src/Utility/Device.vala"
						_tmp114_ = pi;
#line 510 "../src/Utility/Device.vala"
						_tmp115_ = match;
#line 510 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 510 "../src/Utility/Device.vala"
						_tmp116_ = pos;
#line 510 "../src/Utility/Device.vala"
						_tmp117_ = g_match_info_fetch (_tmp115_, _tmp116_);
#line 510 "../src/Utility/Device.vala"
						_tmp118_ = _tmp117_;
#line 510 "../src/Utility/Device.vala"
						_tmp119_ = string_strip (_tmp118_);
#line 510 "../src/Utility/Device.vala"
						_tmp120_ = _tmp119_;
#line 510 "../src/Utility/Device.vala"
						_tmp114_->read_only = g_strcmp0 (_tmp120_, "1") == 0;
#line 510 "../src/Utility/Device.vala"
						_g_free0 (_tmp120_);
#line 510 "../src/Utility/Device.vala"
						_g_free0 (_tmp118_);
#line 512 "../src/Utility/Device.vala"
						_tmp121_ = pi;
#line 512 "../src/Utility/Device.vala"
						_tmp122_ = match;
#line 512 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 512 "../src/Utility/Device.vala"
						_tmp123_ = pos;
#line 512 "../src/Utility/Device.vala"
						_tmp124_ = g_match_info_fetch (_tmp122_, _tmp123_);
#line 512 "../src/Utility/Device.vala"
						_tmp125_ = _tmp124_;
#line 512 "../src/Utility/Device.vala"
						_tmp126_ = string_strip (_tmp125_);
#line 512 "../src/Utility/Device.vala"
						_tmp127_ = _tmp126_;
#line 512 "../src/Utility/Device.vala"
						_tmp121_->removable = g_strcmp0 (_tmp127_, "1") == 0;
#line 512 "../src/Utility/Device.vala"
						_g_free0 (_tmp127_);
#line 512 "../src/Utility/Device.vala"
						_g_free0 (_tmp125_);
#line 514 "../src/Utility/Device.vala"
						_tmp128_ = match;
#line 514 "../src/Utility/Device.vala"
						pos = pos + 1;
#line 514 "../src/Utility/Device.vala"
						_tmp129_ = pos;
#line 514 "../src/Utility/Device.vala"
						_tmp130_ = g_match_info_fetch (_tmp128_, _tmp129_);
#line 514 "../src/Utility/Device.vala"
						_tmp131_ = _tmp130_;
#line 514 "../src/Utility/Device.vala"
						_tmp132_ = string_strip (_tmp131_);
#line 514 "../src/Utility/Device.vala"
						_tmp133_ = _tmp132_;
#line 514 "../src/Utility/Device.vala"
						_g_free0 (_tmp131_);
#line 514 "../src/Utility/Device.vala"
						txt = _tmp133_;
#line 515 "../src/Utility/Device.vala"
						_tmp134_ = txt;
#line 515 "../src/Utility/Device.vala"
						if (string_contains (_tmp134_, ":")) {
#line 3128 "Device.c"
							Device* _tmp135_;
							const gchar* _tmp136_;
							gchar** _tmp137_;
							gchar** _tmp138_;
							gchar** _tmp139_;
							gint _tmp139__length1;
							const gchar* _tmp140_;
							Device* _tmp141_;
							const gchar* _tmp142_;
							gchar** _tmp143_;
							gchar** _tmp144_;
							gchar** _tmp145_;
							gint _tmp145__length1;
							const gchar* _tmp146_;
#line 516 "../src/Utility/Device.vala"
							_tmp135_ = pi;
#line 516 "../src/Utility/Device.vala"
							_tmp136_ = txt;
#line 516 "../src/Utility/Device.vala"
							_tmp138_ = _tmp137_ = g_strsplit (_tmp136_, ":", 0);
#line 516 "../src/Utility/Device.vala"
							_tmp139_ = _tmp138_;
#line 516 "../src/Utility/Device.vala"
							_tmp139__length1 = _vala_array_length (_tmp137_);
#line 516 "../src/Utility/Device.vala"
							_tmp140_ = _tmp139_[0];
#line 516 "../src/Utility/Device.vala"
							_tmp135_->major = atoi (_tmp140_);
#line 516 "../src/Utility/Device.vala"
							_tmp139_ = (_vala_array_free (_tmp139_, _tmp139__length1, (GDestroyNotify) g_free), NULL);
#line 517 "../src/Utility/Device.vala"
							_tmp141_ = pi;
#line 517 "../src/Utility/Device.vala"
							_tmp142_ = txt;
#line 517 "../src/Utility/Device.vala"
							_tmp144_ = _tmp143_ = g_strsplit (_tmp142_, ":", 0);
#line 517 "../src/Utility/Device.vala"
							_tmp145_ = _tmp144_;
#line 517 "../src/Utility/Device.vala"
							_tmp145__length1 = _vala_array_length (_tmp143_);
#line 517 "../src/Utility/Device.vala"
							_tmp146_ = _tmp145_[1];
#line 517 "../src/Utility/Device.vala"
							_tmp141_->minor = atoi (_tmp146_);
#line 517 "../src/Utility/Device.vala"
							_tmp145_ = (_vala_array_free (_tmp145_, _tmp145__length1, (GDestroyNotify) g_free), NULL);
#line 3175 "Device.c"
						}
#line 520 "../src/Utility/Device.vala"
						if (!device_lsblk_is_ancient) {
#line 3179 "Device.c"
							Device* _tmp147_;
							GMatchInfo* _tmp148_;
							gint _tmp149_;
							gchar* _tmp150_;
							Device* _tmp151_;
							GMatchInfo* _tmp152_;
							gint _tmp153_;
							gchar* _tmp154_;
							gchar* _tmp155_;
							gchar* _tmp156_;
							Device* _tmp157_;
							GMatchInfo* _tmp158_;
							gint _tmp159_;
							gchar* _tmp160_;
							gchar* _tmp161_;
							gchar* _tmp162_;
							Device* _tmp163_;
							GMatchInfo* _tmp164_;
							gint _tmp165_;
							gchar* _tmp166_;
							gchar* _tmp167_;
							gchar* _tmp168_;
							Device* _tmp169_;
							GMatchInfo* _tmp170_;
							gint _tmp171_;
							gchar* _tmp172_;
							gchar* _tmp173_;
							gchar* _tmp174_;
							Device* _tmp175_;
							GMatchInfo* _tmp176_;
							gint _tmp177_;
							gchar* _tmp178_;
							gchar* _tmp179_;
							gchar* _tmp180_;
#line 522 "../src/Utility/Device.vala"
							_tmp147_ = pi;
#line 522 "../src/Utility/Device.vala"
							_tmp148_ = match;
#line 522 "../src/Utility/Device.vala"
							pos = pos + 1;
#line 522 "../src/Utility/Device.vala"
							_tmp149_ = pos;
#line 522 "../src/Utility/Device.vala"
							_tmp150_ = g_match_info_fetch (_tmp148_, _tmp149_);
#line 522 "../src/Utility/Device.vala"
							_g_free0 (_tmp147_->partlabel);
#line 522 "../src/Utility/Device.vala"
							_tmp147_->partlabel = _tmp150_;
#line 523 "../src/Utility/Device.vala"
							_tmp151_ = pi;
#line 523 "../src/Utility/Device.vala"
							_tmp152_ = match;
#line 523 "../src/Utility/Device.vala"
							pos = pos + 1;
#line 523 "../src/Utility/Device.vala"
							_tmp153_ = pos;
#line 523 "../src/Utility/Device.vala"
							_tmp154_ = g_match_info_fetch (_tmp152_, _tmp153_);
#line 523 "../src/Utility/Device.vala"
							_tmp155_ = _tmp154_;
#line 523 "../src/Utility/Device.vala"
							_tmp156_ = string_strip (_tmp155_);
#line 523 "../src/Utility/Device.vala"
							_g_free0 (_tmp151_->partuuid);
#line 523 "../src/Utility/Device.vala"
							_tmp151_->partuuid = _tmp156_;
#line 523 "../src/Utility/Device.vala"
							_g_free0 (_tmp155_);
#line 525 "../src/Utility/Device.vala"
							_tmp157_ = pi;
#line 525 "../src/Utility/Device.vala"
							_tmp158_ = match;
#line 525 "../src/Utility/Device.vala"
							pos = pos + 1;
#line 525 "../src/Utility/Device.vala"
							_tmp159_ = pos;
#line 525 "../src/Utility/Device.vala"
							_tmp160_ = g_match_info_fetch (_tmp158_, _tmp159_);
#line 525 "../src/Utility/Device.vala"
							_tmp161_ = _tmp160_;
#line 525 "../src/Utility/Device.vala"
							_tmp162_ = string_strip (_tmp161_);
#line 525 "../src/Utility/Device.vala"
							_g_free0 (_tmp157_->pkname);
#line 525 "../src/Utility/Device.vala"
							_tmp157_->pkname = _tmp162_;
#line 525 "../src/Utility/Device.vala"
							_g_free0 (_tmp161_);
#line 526 "../src/Utility/Device.vala"
							_tmp163_ = pi;
#line 526 "../src/Utility/Device.vala"
							_tmp164_ = match;
#line 526 "../src/Utility/Device.vala"
							pos = pos + 1;
#line 526 "../src/Utility/Device.vala"
							_tmp165_ = pos;
#line 526 "../src/Utility/Device.vala"
							_tmp166_ = g_match_info_fetch (_tmp164_, _tmp165_);
#line 526 "../src/Utility/Device.vala"
							_tmp167_ = _tmp166_;
#line 526 "../src/Utility/Device.vala"
							_tmp168_ = string_strip (_tmp167_);
#line 526 "../src/Utility/Device.vala"
							_g_free0 (_tmp163_->vendor);
#line 526 "../src/Utility/Device.vala"
							_tmp163_->vendor = _tmp168_;
#line 526 "../src/Utility/Device.vala"
							_g_free0 (_tmp167_);
#line 527 "../src/Utility/Device.vala"
							_tmp169_ = pi;
#line 527 "../src/Utility/Device.vala"
							_tmp170_ = match;
#line 527 "../src/Utility/Device.vala"
							pos = pos + 1;
#line 527 "../src/Utility/Device.vala"
							_tmp171_ = pos;
#line 527 "../src/Utility/Device.vala"
							_tmp172_ = g_match_info_fetch (_tmp170_, _tmp171_);
#line 527 "../src/Utility/Device.vala"
							_tmp173_ = _tmp172_;
#line 527 "../src/Utility/Device.vala"
							_tmp174_ = string_strip (_tmp173_);
#line 527 "../src/Utility/Device.vala"
							_g_free0 (_tmp169_->serial);
#line 527 "../src/Utility/Device.vala"
							_tmp169_->serial = _tmp174_;
#line 527 "../src/Utility/Device.vala"
							_g_free0 (_tmp173_);
#line 528 "../src/Utility/Device.vala"
							_tmp175_ = pi;
#line 528 "../src/Utility/Device.vala"
							_tmp176_ = match;
#line 528 "../src/Utility/Device.vala"
							pos = pos + 1;
#line 528 "../src/Utility/Device.vala"
							_tmp177_ = pos;
#line 528 "../src/Utility/Device.vala"
							_tmp178_ = g_match_info_fetch (_tmp176_, _tmp177_);
#line 528 "../src/Utility/Device.vala"
							_tmp179_ = _tmp178_;
#line 528 "../src/Utility/Device.vala"
							_tmp180_ = string_strip (_tmp179_);
#line 528 "../src/Utility/Device.vala"
							_g_free0 (_tmp175_->revision);
#line 528 "../src/Utility/Device.vala"
							_tmp175_->revision = _tmp180_;
#line 528 "../src/Utility/Device.vala"
							_g_free0 (_tmp179_);
#line 3328 "Device.c"
						}
#line 531 "../src/Utility/Device.vala"
						_tmp181_ = pi;
#line 531 "../src/Utility/Device.vala"
						index = index + 1;
#line 531 "../src/Utility/Device.vala"
						_tmp182_ = index;
#line 531 "../src/Utility/Device.vala"
						_tmp181_->order = _tmp182_;
#line 532 "../src/Utility/Device.vala"
						_tmp183_ = pi;
#line 532 "../src/Utility/Device.vala"
						_tmp184_ = pi;
#line 532 "../src/Utility/Device.vala"
						_tmp185_ = _tmp184_->kname;
#line 532 "../src/Utility/Device.vala"
						_tmp186_ = g_strdup_printf ("/dev/%s", _tmp185_);
#line 532 "../src/Utility/Device.vala"
						_g_free0 (_tmp183_->device);
#line 532 "../src/Utility/Device.vala"
						_tmp183_->device = _tmp186_;
#line 534 "../src/Utility/Device.vala"
						_tmp187_ = pi;
#line 534 "../src/Utility/Device.vala"
						_tmp188_ = _tmp187_->uuid;
#line 534 "../src/Utility/Device.vala"
						_tmp189_ = strlen (_tmp188_);
#line 534 "../src/Utility/Device.vala"
						_tmp190_ = _tmp189_;
#line 534 "../src/Utility/Device.vala"
						if (_tmp190_ > 0) {
#line 3360 "Device.c"
							Device* _tmp191_;
							Device* _tmp192_;
							const gchar* _tmp193_;
							gchar* _tmp194_;
#line 535 "../src/Utility/Device.vala"
							_tmp191_ = pi;
#line 535 "../src/Utility/Device.vala"
							_tmp192_ = pi;
#line 535 "../src/Utility/Device.vala"
							_tmp193_ = _tmp192_->uuid;
#line 535 "../src/Utility/Device.vala"
							_tmp194_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp193_);
#line 535 "../src/Utility/Device.vala"
							_g_free0 (_tmp191_->device_by_uuid);
#line 535 "../src/Utility/Device.vala"
							_tmp191_->device_by_uuid = _tmp194_;
#line 3377 "Device.c"
						}
#line 538 "../src/Utility/Device.vala"
						_tmp195_ = pi;
#line 538 "../src/Utility/Device.vala"
						_tmp196_ = _tmp195_->label;
#line 538 "../src/Utility/Device.vala"
						_tmp197_ = strlen (_tmp196_);
#line 538 "../src/Utility/Device.vala"
						_tmp198_ = _tmp197_;
#line 538 "../src/Utility/Device.vala"
						if (_tmp198_ > 0) {
#line 3389 "Device.c"
							Device* _tmp199_;
							Device* _tmp200_;
							const gchar* _tmp201_;
							gchar* _tmp202_;
#line 539 "../src/Utility/Device.vala"
							_tmp199_ = pi;
#line 539 "../src/Utility/Device.vala"
							_tmp200_ = pi;
#line 539 "../src/Utility/Device.vala"
							_tmp201_ = _tmp200_->label;
#line 539 "../src/Utility/Device.vala"
							_tmp202_ = g_strdup_printf ("/dev/disk/by-label/%s", _tmp201_);
#line 539 "../src/Utility/Device.vala"
							_g_free0 (_tmp199_->device_by_label);
#line 539 "../src/Utility/Device.vala"
							_tmp199_->device_by_label = _tmp202_;
#line 3406 "Device.c"
						}
#line 542 "../src/Utility/Device.vala"
						_tmp203_ = pi;
#line 542 "../src/Utility/Device.vala"
						_tmp204_ = _tmp203_->partuuid;
#line 542 "../src/Utility/Device.vala"
						_tmp205_ = strlen (_tmp204_);
#line 542 "../src/Utility/Device.vala"
						_tmp206_ = _tmp205_;
#line 542 "../src/Utility/Device.vala"
						if (_tmp206_ > 0) {
#line 3418 "Device.c"
							Device* _tmp207_;
							Device* _tmp208_;
							const gchar* _tmp209_;
							gchar* _tmp210_;
#line 543 "../src/Utility/Device.vala"
							_tmp207_ = pi;
#line 543 "../src/Utility/Device.vala"
							_tmp208_ = pi;
#line 543 "../src/Utility/Device.vala"
							_tmp209_ = _tmp208_->partuuid;
#line 543 "../src/Utility/Device.vala"
							_tmp210_ = g_strdup_printf ("/dev/disk/by-partuuid/%s", _tmp209_);
#line 543 "../src/Utility/Device.vala"
							_g_free0 (_tmp207_->device_by_partuuid);
#line 543 "../src/Utility/Device.vala"
							_tmp207_->device_by_partuuid = _tmp210_;
#line 3435 "Device.c"
						}
#line 546 "../src/Utility/Device.vala"
						_tmp211_ = pi;
#line 546 "../src/Utility/Device.vala"
						_tmp212_ = _tmp211_->partlabel;
#line 546 "../src/Utility/Device.vala"
						_tmp213_ = strlen (_tmp212_);
#line 546 "../src/Utility/Device.vala"
						_tmp214_ = _tmp213_;
#line 546 "../src/Utility/Device.vala"
						if (_tmp214_ > 0) {
#line 3447 "Device.c"
							Device* _tmp215_;
							Device* _tmp216_;
							const gchar* _tmp217_;
							gchar* _tmp218_;
#line 547 "../src/Utility/Device.vala"
							_tmp215_ = pi;
#line 547 "../src/Utility/Device.vala"
							_tmp216_ = pi;
#line 547 "../src/Utility/Device.vala"
							_tmp217_ = _tmp216_->partlabel;
#line 547 "../src/Utility/Device.vala"
							_tmp218_ = g_strdup_printf ("/dev/disk/by-partlabel/%s", _tmp217_);
#line 547 "../src/Utility/Device.vala"
							_g_free0 (_tmp215_->device_by_partlabel);
#line 547 "../src/Utility/Device.vala"
							_tmp215_->device_by_partlabel = _tmp218_;
#line 3464 "Device.c"
						}
#line 555 "../src/Utility/Device.vala"
						_tmp219_ = list;
#line 555 "../src/Utility/Device.vala"
						_tmp220_ = pi;
#line 555 "../src/Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp219_, _tmp220_);
#line 483 "../src/Utility/Device.vala"
						_g_free0 (txt);
#line 483 "../src/Utility/Device.vala"
						_g_free0 (mp);
#line 483 "../src/Utility/Device.vala"
						_g_object_unref0 (pi);
#line 3478 "Device.c"
					} else {
						const gchar* _tmp221_;
						gchar* _tmp222_;
						gchar* _tmp223_;
#line 559 "../src/Utility/Device.vala"
						_tmp221_ = line;
#line 559 "../src/Utility/Device.vala"
						_tmp222_ = g_strdup_printf ("no-match: %s", _tmp221_);
#line 559 "../src/Utility/Device.vala"
						_tmp223_ = _tmp222_;
#line 559 "../src/Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp223_);
#line 559 "../src/Utility/Device.vala"
						_g_free0 (_tmp223_);
#line 3493 "Device.c"
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp224_;
					const gchar* _tmp225_;
#line 475 "../src/Utility/Device.vala"
					e = _inner_error0_;
#line 475 "../src/Utility/Device.vala"
					_inner_error0_ = NULL;
#line 563 "../src/Utility/Device.vala"
					_tmp224_ = e;
#line 563 "../src/Utility/Device.vala"
					_tmp225_ = _tmp224_->message;
#line 563 "../src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp225_, FALSE, FALSE);
#line 475 "../src/Utility/Device.vala"
					_g_error_free0 (e);
#line 3514 "Device.c"
				}
				__finally0:
#line 475 "../src/Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 475 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 475 "../src/Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 475 "../src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 475 "../src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 475 "../src/Utility/Device.vala"
					_g_free0 (cmd);
#line 475 "../src/Utility/Device.vala"
					_g_free0 (std_err);
#line 475 "../src/Utility/Device.vala"
					_g_free0 (std_out);
#line 475 "../src/Utility/Device.vala"
					_g_object_unref0 (list);
#line 475 "../src/Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 475 "../src/Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 475 "../src/Utility/Device.vala"
					return NULL;
#line 3541 "Device.c"
				}
#line 472 "../src/Utility/Device.vala"
				_g_free0 (line);
#line 3545 "Device.c"
			}
		}
#line 472 "../src/Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3550 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp226_;
		gint _dev_size = 0;
		GeeArrayList* _tmp227_;
		gint _tmp228_;
		gint _tmp229_;
		gint _dev_index = 0;
#line 574 "../src/Utility/Device.vala"
		_tmp226_ = list;
#line 574 "../src/Utility/Device.vala"
		_dev_list = _tmp226_;
#line 574 "../src/Utility/Device.vala"
		_tmp227_ = _dev_list;
#line 574 "../src/Utility/Device.vala"
		_tmp228_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp227_);
#line 574 "../src/Utility/Device.vala"
		_tmp229_ = _tmp228_;
#line 574 "../src/Utility/Device.vala"
		_dev_size = _tmp229_;
#line 574 "../src/Utility/Device.vala"
		_dev_index = -1;
#line 574 "../src/Utility/Device.vala"
		while (TRUE) {
#line 3576 "Device.c"
			gint _tmp230_;
			gint _tmp231_;
			Device* dev = NULL;
			GeeArrayList* _tmp232_;
			gpointer _tmp233_;
			gchar* dev_by_uuid = NULL;
			Device* _tmp234_;
			const gchar* _tmp235_;
			gchar* _tmp236_;
			const gchar* _tmp237_;
#line 574 "../src/Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 574 "../src/Utility/Device.vala"
			_tmp230_ = _dev_index;
#line 574 "../src/Utility/Device.vala"
			_tmp231_ = _dev_size;
#line 574 "../src/Utility/Device.vala"
			if (!(_tmp230_ < _tmp231_)) {
#line 574 "../src/Utility/Device.vala"
				break;
#line 3597 "Device.c"
			}
#line 574 "../src/Utility/Device.vala"
			_tmp232_ = _dev_list;
#line 574 "../src/Utility/Device.vala"
			_tmp233_ = gee_abstract_list_get ((GeeAbstractList*) _tmp232_, _dev_index);
#line 574 "../src/Utility/Device.vala"
			dev = (Device*) _tmp233_;
#line 575 "../src/Utility/Device.vala"
			_tmp234_ = dev;
#line 575 "../src/Utility/Device.vala"
			_tmp235_ = _tmp234_->uuid;
#line 575 "../src/Utility/Device.vala"
			_tmp236_ = tee_jee_file_system_path_combine ("/dev/disk/by-uuid/", _tmp235_);
#line 575 "../src/Utility/Device.vala"
			dev_by_uuid = _tmp236_;
#line 576 "../src/Utility/Device.vala"
			_tmp237_ = dev_by_uuid;
#line 576 "../src/Utility/Device.vala"
			if (tee_jee_file_system_file_exists (_tmp237_)) {
#line 3617 "Device.c"
				Device* _tmp238_;
				GeeArrayList* _tmp239_;
				const gchar* _tmp240_;
#line 577 "../src/Utility/Device.vala"
				_tmp238_ = dev;
#line 577 "../src/Utility/Device.vala"
				_tmp239_ = _tmp238_->symlinks;
#line 577 "../src/Utility/Device.vala"
				_tmp240_ = dev_by_uuid;
#line 577 "../src/Utility/Device.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp239_, _tmp240_);
#line 3629 "Device.c"
			}
#line 574 "../src/Utility/Device.vala"
			_g_free0 (dev_by_uuid);
#line 574 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 3635 "Device.c"
		}
	}
	{
		GFile* f_dev_mapper = NULL;
		GFile* _tmp241_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp242_;
		gchar* _tmp243_;
		gchar* _tmp244_;
		GFileEnumerator* _tmp245_;
		GFileEnumerator* _tmp246_;
		GFileInfo* info = NULL;
#line 585 "../src/Utility/Device.vala"
		_tmp241_ = g_file_new_for_path ("/dev/mapper");
#line 585 "../src/Utility/Device.vala"
		f_dev_mapper = _tmp241_;
#line 587 "../src/Utility/Device.vala"
		_tmp242_ = f_dev_mapper;
#line 587 "../src/Utility/Device.vala"
		_tmp243_ = g_strdup_printf ("%s,%s", G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 587 "../src/Utility/Device.vala"
		_tmp244_ = _tmp243_;
#line 587 "../src/Utility/Device.vala"
		_tmp245_ = g_file_enumerate_children (_tmp242_, _tmp244_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 587 "../src/Utility/Device.vala"
		_tmp246_ = _tmp245_;
#line 587 "../src/Utility/Device.vala"
		_g_free0 (_tmp244_);
#line 587 "../src/Utility/Device.vala"
		enumerator = _tmp246_;
#line 587 "../src/Utility/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 587 "../src/Utility/Device.vala"
			_g_object_unref0 (f_dev_mapper);
#line 3670 "Device.c"
			goto __catch1_g_error;
		}
#line 593 "../src/Utility/Device.vala"
		while (TRUE) {
#line 3675 "Device.c"
			GFileInfo* _tmp247_ = NULL;
			GFileEnumerator* _tmp248_;
			GFileInfo* _tmp249_;
			GFileInfo* _tmp250_;
			GFileInfo* _tmp251_;
			GFileInfo* _tmp252_;
			const gchar* _tmp253_;
			GFile* f_mapped = NULL;
			GFile* _tmp254_;
			GFileInfo* _tmp255_;
			const gchar* _tmp256_;
			GFile* _tmp257_;
			gchar* mapped_file = NULL;
			GFile* _tmp258_;
			gchar* _tmp259_;
			gchar* mapped_device = NULL;
			GFileInfo* _tmp260_;
			const gchar* _tmp261_;
			gchar* _tmp262_;
			const gchar* _tmp263_;
			gchar* _tmp264_;
#line 593 "../src/Utility/Device.vala"
			_tmp248_ = enumerator;
#line 593 "../src/Utility/Device.vala"
			_tmp249_ = g_file_enumerator_next_file (_tmp248_, NULL, &_inner_error0_);
#line 593 "../src/Utility/Device.vala"
			_tmp247_ = _tmp249_;
#line 593 "../src/Utility/Device.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 593 "../src/Utility/Device.vala"
				_g_object_unref0 (info);
#line 593 "../src/Utility/Device.vala"
				_g_object_unref0 (enumerator);
#line 593 "../src/Utility/Device.vala"
				_g_object_unref0 (f_dev_mapper);
#line 3711 "Device.c"
				goto __catch1_g_error;
			}
#line 593 "../src/Utility/Device.vala"
			_tmp250_ = _tmp247_;
#line 593 "../src/Utility/Device.vala"
			_tmp247_ = NULL;
#line 593 "../src/Utility/Device.vala"
			_g_object_unref0 (info);
#line 593 "../src/Utility/Device.vala"
			info = _tmp250_;
#line 593 "../src/Utility/Device.vala"
			_tmp251_ = info;
#line 593 "../src/Utility/Device.vala"
			if (!(_tmp251_ != NULL)) {
#line 593 "../src/Utility/Device.vala"
				_g_object_unref0 (_tmp247_);
#line 593 "../src/Utility/Device.vala"
				break;
#line 3730 "Device.c"
			}
#line 595 "../src/Utility/Device.vala"
			_tmp252_ = info;
#line 595 "../src/Utility/Device.vala"
			_tmp253_ = g_file_info_get_name (_tmp252_);
#line 595 "../src/Utility/Device.vala"
			if (g_strcmp0 (_tmp253_, "control") == 0) {
#line 595 "../src/Utility/Device.vala"
				_g_object_unref0 (_tmp247_);
#line 595 "../src/Utility/Device.vala"
				continue;
#line 3742 "Device.c"
			}
#line 597 "../src/Utility/Device.vala"
			_tmp254_ = f_dev_mapper;
#line 597 "../src/Utility/Device.vala"
			_tmp255_ = info;
#line 597 "../src/Utility/Device.vala"
			_tmp256_ = g_file_info_get_name (_tmp255_);
#line 597 "../src/Utility/Device.vala"
			_tmp257_ = g_file_resolve_relative_path (_tmp254_, _tmp256_);
#line 597 "../src/Utility/Device.vala"
			f_mapped = _tmp257_;
#line 599 "../src/Utility/Device.vala"
			_tmp258_ = f_mapped;
#line 599 "../src/Utility/Device.vala"
			_tmp259_ = g_file_get_path (_tmp258_);
#line 599 "../src/Utility/Device.vala"
			mapped_file = _tmp259_;
#line 600 "../src/Utility/Device.vala"
			_tmp260_ = info;
#line 600 "../src/Utility/Device.vala"
			_tmp261_ = g_file_info_get_symlink_target (_tmp260_);
#line 600 "../src/Utility/Device.vala"
			_tmp262_ = g_strdup (_tmp261_);
#line 600 "../src/Utility/Device.vala"
			mapped_device = _tmp262_;
#line 601 "../src/Utility/Device.vala"
			_tmp263_ = mapped_device;
#line 601 "../src/Utility/Device.vala"
			_tmp264_ = string_replace (_tmp263_, "..", "/dev");
#line 601 "../src/Utility/Device.vala"
			_g_free0 (mapped_device);
#line 601 "../src/Utility/Device.vala"
			mapped_device = _tmp264_;
#line 3776 "Device.c"
			{
				GeeArrayList* _dev_list = NULL;
				GeeArrayList* _tmp265_;
				gint _dev_size = 0;
				GeeArrayList* _tmp266_;
				gint _tmp267_;
				gint _tmp268_;
				gint _dev_index = 0;
#line 607 "../src/Utility/Device.vala"
				_tmp265_ = list;
#line 607 "../src/Utility/Device.vala"
				_dev_list = _tmp265_;
#line 607 "../src/Utility/Device.vala"
				_tmp266_ = _dev_list;
#line 607 "../src/Utility/Device.vala"
				_tmp267_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp266_);
#line 607 "../src/Utility/Device.vala"
				_tmp268_ = _tmp267_;
#line 607 "../src/Utility/Device.vala"
				_dev_size = _tmp268_;
#line 607 "../src/Utility/Device.vala"
				_dev_index = -1;
#line 607 "../src/Utility/Device.vala"
				while (TRUE) {
#line 3801 "Device.c"
					gint _tmp269_;
					gint _tmp270_;
					Device* dev = NULL;
					GeeArrayList* _tmp271_;
					gpointer _tmp272_;
					Device* _tmp273_;
					const gchar* _tmp274_;
					const gchar* _tmp275_;
#line 607 "../src/Utility/Device.vala"
					_dev_index = _dev_index + 1;
#line 607 "../src/Utility/Device.vala"
					_tmp269_ = _dev_index;
#line 607 "../src/Utility/Device.vala"
					_tmp270_ = _dev_size;
#line 607 "../src/Utility/Device.vala"
					if (!(_tmp269_ < _tmp270_)) {
#line 607 "../src/Utility/Device.vala"
						break;
#line 3820 "Device.c"
					}
#line 607 "../src/Utility/Device.vala"
					_tmp271_ = _dev_list;
#line 607 "../src/Utility/Device.vala"
					_tmp272_ = gee_abstract_list_get ((GeeAbstractList*) _tmp271_, _dev_index);
#line 607 "../src/Utility/Device.vala"
					dev = (Device*) _tmp272_;
#line 608 "../src/Utility/Device.vala"
					_tmp273_ = dev;
#line 608 "../src/Utility/Device.vala"
					_tmp274_ = _tmp273_->device;
#line 608 "../src/Utility/Device.vala"
					_tmp275_ = mapped_device;
#line 608 "../src/Utility/Device.vala"
					if (g_strcmp0 (_tmp274_, _tmp275_) == 0) {
#line 3836 "Device.c"
						Device* _tmp276_;
						const gchar* _tmp277_;
						gchar* _tmp278_;
						Device* _tmp279_;
						GeeArrayList* _tmp280_;
						const gchar* _tmp281_;
#line 609 "../src/Utility/Device.vala"
						_tmp276_ = dev;
#line 609 "../src/Utility/Device.vala"
						_tmp277_ = mapped_file;
#line 609 "../src/Utility/Device.vala"
						_tmp278_ = string_replace (_tmp277_, "/dev/mapper/", "");
#line 609 "../src/Utility/Device.vala"
						_g_free0 (_tmp276_->mapped_name);
#line 609 "../src/Utility/Device.vala"
						_tmp276_->mapped_name = _tmp278_;
#line 610 "../src/Utility/Device.vala"
						_tmp279_ = dev;
#line 610 "../src/Utility/Device.vala"
						_tmp280_ = _tmp279_->symlinks;
#line 610 "../src/Utility/Device.vala"
						_tmp281_ = mapped_file;
#line 610 "../src/Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp280_, _tmp281_);
#line 612 "../src/Utility/Device.vala"
						_g_object_unref0 (dev);
#line 612 "../src/Utility/Device.vala"
						break;
#line 3865 "Device.c"
					}
#line 607 "../src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 3869 "Device.c"
				}
			}
#line 593 "../src/Utility/Device.vala"
			_g_free0 (mapped_device);
#line 593 "../src/Utility/Device.vala"
			_g_free0 (mapped_file);
#line 593 "../src/Utility/Device.vala"
			_g_object_unref0 (f_mapped);
#line 593 "../src/Utility/Device.vala"
			_g_object_unref0 (_tmp247_);
#line 3880 "Device.c"
		}
#line 583 "../src/Utility/Device.vala"
		_g_object_unref0 (info);
#line 583 "../src/Utility/Device.vala"
		_g_object_unref0 (enumerator);
#line 583 "../src/Utility/Device.vala"
		_g_object_unref0 (f_dev_mapper);
#line 3888 "Device.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp282_;
		const gchar* _tmp283_;
#line 583 "../src/Utility/Device.vala"
		e = _inner_error0_;
#line 583 "../src/Utility/Device.vala"
		_inner_error0_ = NULL;
#line 618 "../src/Utility/Device.vala"
		_tmp282_ = e;
#line 618 "../src/Utility/Device.vala"
		_tmp283_ = _tmp282_->message;
#line 618 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp283_, FALSE, FALSE);
#line 583 "../src/Utility/Device.vala"
		_g_error_free0 (e);
#line 3908 "Device.c"
	}
	__finally1:
#line 583 "../src/Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 583 "../src/Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 583 "../src/Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 583 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 583 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 583 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 583 "../src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 583 "../src/Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 583 "../src/Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 583 "../src/Utility/Device.vala"
		return NULL;
#line 3931 "Device.c"
	}
#line 621 "../src/Utility/Device.vala"
	_tmp284_ = list;
#line 621 "../src/Utility/Device.vala"
	_tmp285_ = _g_object_ref0 (_tmp284_);
#line 621 "../src/Utility/Device.vala"
	_g_object_unref0 (device_device_list);
#line 621 "../src/Utility/Device.vala"
	device_device_list = _tmp285_;
#line 3941 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp286_;
		gint _part_size = 0;
		GeeArrayList* _tmp287_;
		gint _tmp288_;
		gint _tmp289_;
		gint _part_index = 0;
#line 623 "../src/Utility/Device.vala"
		_tmp286_ = list;
#line 623 "../src/Utility/Device.vala"
		_part_list = _tmp286_;
#line 623 "../src/Utility/Device.vala"
		_tmp287_ = _part_list;
#line 623 "../src/Utility/Device.vala"
		_tmp288_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp287_);
#line 623 "../src/Utility/Device.vala"
		_tmp289_ = _tmp288_;
#line 623 "../src/Utility/Device.vala"
		_part_size = _tmp289_;
#line 623 "../src/Utility/Device.vala"
		_part_index = -1;
#line 623 "../src/Utility/Device.vala"
		while (TRUE) {
#line 3966 "Device.c"
			gint _tmp290_;
			gint _tmp291_;
			Device* part = NULL;
			GeeArrayList* _tmp292_;
			gpointer _tmp293_;
			GeeArrayList* _tmp294_;
			Device* _tmp295_;
			GeeArrayList* _tmp296_;
			Device* _tmp297_;
#line 623 "../src/Utility/Device.vala"
			_part_index = _part_index + 1;
#line 623 "../src/Utility/Device.vala"
			_tmp290_ = _part_index;
#line 623 "../src/Utility/Device.vala"
			_tmp291_ = _part_size;
#line 623 "../src/Utility/Device.vala"
			if (!(_tmp290_ < _tmp291_)) {
#line 623 "../src/Utility/Device.vala"
				break;
#line 3986 "Device.c"
			}
#line 623 "../src/Utility/Device.vala"
			_tmp292_ = _part_list;
#line 623 "../src/Utility/Device.vala"
			_tmp293_ = gee_abstract_list_get ((GeeAbstractList*) _tmp292_, _part_index);
#line 623 "../src/Utility/Device.vala"
			part = (Device*) _tmp293_;
#line 624 "../src/Utility/Device.vala"
			_tmp294_ = list;
#line 624 "../src/Utility/Device.vala"
			_tmp295_ = part;
#line 624 "../src/Utility/Device.vala"
			device_find_child_devices (_tmp294_, _tmp295_);
#line 625 "../src/Utility/Device.vala"
			_tmp296_ = list;
#line 625 "../src/Utility/Device.vala"
			_tmp297_ = part;
#line 625 "../src/Utility/Device.vala"
			device_find_toplevel_parent (_tmp296_, _tmp297_);
#line 623 "../src/Utility/Device.vala"
			_g_object_unref0 (part);
#line 4008 "Device.c"
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp298_;
		gint _tmp299_;
		gint _tmp300_;
#line 631 "../src/Utility/Device.vala"
		_tmp298_ = list;
#line 631 "../src/Utility/Device.vala"
		_tmp299_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp298_);
#line 631 "../src/Utility/Device.vala"
		_tmp300_ = _tmp299_;
#line 631 "../src/Utility/Device.vala"
		i = _tmp300_ - 1;
#line 4024 "Device.c"
		{
			gboolean _tmp301_ = FALSE;
#line 631 "../src/Utility/Device.vala"
			_tmp301_ = TRUE;
#line 631 "../src/Utility/Device.vala"
			while (TRUE) {
#line 4031 "Device.c"
				GeeArrayList* _tmp303_;
				gpointer _tmp304_;
				Device* _tmp305_;
				gboolean _tmp306_;
#line 631 "../src/Utility/Device.vala"
				if (!_tmp301_) {
#line 4038 "Device.c"
					gint _tmp302_;
#line 631 "../src/Utility/Device.vala"
					i = i - 1;
#line 631 "../src/Utility/Device.vala"
					_tmp302_ = i;
#line 4044 "Device.c"
				}
#line 631 "../src/Utility/Device.vala"
				_tmp301_ = FALSE;
#line 631 "../src/Utility/Device.vala"
				if (!(i >= 0)) {
#line 631 "../src/Utility/Device.vala"
					break;
#line 4052 "Device.c"
				}
#line 632 "../src/Utility/Device.vala"
				_tmp303_ = list;
#line 632 "../src/Utility/Device.vala"
				_tmp304_ = gee_abstract_list_get ((GeeAbstractList*) _tmp303_, i);
#line 632 "../src/Utility/Device.vala"
				_tmp305_ = (Device*) _tmp304_;
#line 632 "../src/Utility/Device.vala"
				_tmp306_ = device_type_is_raid (_tmp305_);
#line 632 "../src/Utility/Device.vala"
				_g_object_unref0 (_tmp305_);
#line 632 "../src/Utility/Device.vala"
				if (_tmp306_) {
#line 4066 "Device.c"
					GeeArrayList* _tmp307_;
					GeeArrayList* _tmp308_;
					gpointer _tmp309_;
					Device* _tmp310_;
#line 633 "../src/Utility/Device.vala"
					_tmp307_ = list;
#line 633 "../src/Utility/Device.vala"
					_tmp308_ = list;
#line 633 "../src/Utility/Device.vala"
					_tmp309_ = gee_abstract_list_get ((GeeAbstractList*) _tmp308_, i);
#line 633 "../src/Utility/Device.vala"
					_tmp310_ = (Device*) _tmp309_;
#line 633 "../src/Utility/Device.vala"
					i -= device_remove_parents (_tmp307_, _tmp310_);
#line 633 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp310_);
#line 4083 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp311_;
						gint _tmp312_;
						gint _tmp313_;
#line 637 "../src/Utility/Device.vala"
						_tmp311_ = list;
#line 637 "../src/Utility/Device.vala"
						_tmp312_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp311_);
#line 637 "../src/Utility/Device.vala"
						_tmp313_ = _tmp312_;
#line 637 "../src/Utility/Device.vala"
						j = _tmp313_ - 1;
#line 4097 "Device.c"
						{
							gboolean _tmp314_ = FALSE;
#line 637 "../src/Utility/Device.vala"
							_tmp314_ = TRUE;
#line 637 "../src/Utility/Device.vala"
							while (TRUE) {
#line 4104 "Device.c"
								GeeArrayList* _tmp316_;
								gpointer _tmp317_;
								Device* _tmp318_;
								const gchar* _tmp319_;
								GeeArrayList* _tmp320_;
								gpointer _tmp321_;
								Device* _tmp322_;
								const gchar* _tmp323_;
								gboolean _tmp324_;
#line 637 "../src/Utility/Device.vala"
								if (!_tmp314_) {
#line 4116 "Device.c"
									gint _tmp315_;
#line 637 "../src/Utility/Device.vala"
									j = j - 1;
#line 637 "../src/Utility/Device.vala"
									_tmp315_ = j;
#line 4122 "Device.c"
								}
#line 637 "../src/Utility/Device.vala"
								_tmp314_ = FALSE;
#line 637 "../src/Utility/Device.vala"
								if (!(j > i)) {
#line 637 "../src/Utility/Device.vala"
									break;
#line 4130 "Device.c"
								}
#line 638 "../src/Utility/Device.vala"
								_tmp316_ = list;
#line 638 "../src/Utility/Device.vala"
								_tmp317_ = gee_abstract_list_get ((GeeAbstractList*) _tmp316_, j);
#line 638 "../src/Utility/Device.vala"
								_tmp318_ = (Device*) _tmp317_;
#line 638 "../src/Utility/Device.vala"
								_tmp319_ = _tmp318_->pkname;
#line 638 "../src/Utility/Device.vala"
								_tmp320_ = list;
#line 638 "../src/Utility/Device.vala"
								_tmp321_ = gee_abstract_list_get ((GeeAbstractList*) _tmp320_, i);
#line 638 "../src/Utility/Device.vala"
								_tmp322_ = (Device*) _tmp321_;
#line 638 "../src/Utility/Device.vala"
								_tmp323_ = _tmp322_->kname;
#line 638 "../src/Utility/Device.vala"
								_tmp324_ = g_strcmp0 (_tmp319_, _tmp323_) == 0;
#line 638 "../src/Utility/Device.vala"
								_g_object_unref0 (_tmp322_);
#line 638 "../src/Utility/Device.vala"
								_g_object_unref0 (_tmp318_);
#line 638 "../src/Utility/Device.vala"
								if (_tmp324_) {
#line 4156 "Device.c"
									{
										gint k = 0;
#line 639 "../src/Utility/Device.vala"
										k = j - 1;
#line 4161 "Device.c"
										{
											gboolean _tmp325_ = FALSE;
#line 639 "../src/Utility/Device.vala"
											_tmp325_ = TRUE;
#line 639 "../src/Utility/Device.vala"
											while (TRUE) {
#line 4168 "Device.c"
												GeeArrayList* _tmp327_;
												gpointer _tmp328_;
												Device* _tmp329_;
												const gchar* _tmp330_;
												GeeArrayList* _tmp331_;
												gpointer _tmp332_;
												Device* _tmp333_;
												const gchar* _tmp334_;
												gboolean _tmp335_;
#line 639 "../src/Utility/Device.vala"
												if (!_tmp325_) {
#line 4180 "Device.c"
													gint _tmp326_;
#line 639 "../src/Utility/Device.vala"
													k = k - 1;
#line 639 "../src/Utility/Device.vala"
													_tmp326_ = k;
#line 4186 "Device.c"
												}
#line 639 "../src/Utility/Device.vala"
												_tmp325_ = FALSE;
#line 639 "../src/Utility/Device.vala"
												if (!(k >= 0)) {
#line 639 "../src/Utility/Device.vala"
													break;
#line 4194 "Device.c"
												}
#line 640 "../src/Utility/Device.vala"
												_tmp327_ = list;
#line 640 "../src/Utility/Device.vala"
												_tmp328_ = gee_abstract_list_get ((GeeAbstractList*) _tmp327_, k);
#line 640 "../src/Utility/Device.vala"
												_tmp329_ = (Device*) _tmp328_;
#line 640 "../src/Utility/Device.vala"
												_tmp330_ = _tmp329_->kname;
#line 640 "../src/Utility/Device.vala"
												_tmp331_ = list;
#line 640 "../src/Utility/Device.vala"
												_tmp332_ = gee_abstract_list_get ((GeeAbstractList*) _tmp331_, j);
#line 640 "../src/Utility/Device.vala"
												_tmp333_ = (Device*) _tmp332_;
#line 640 "../src/Utility/Device.vala"
												_tmp334_ = _tmp333_->kname;
#line 640 "../src/Utility/Device.vala"
												_tmp335_ = g_strcmp0 (_tmp330_, _tmp334_) == 0;
#line 640 "../src/Utility/Device.vala"
												_g_object_unref0 (_tmp333_);
#line 640 "../src/Utility/Device.vala"
												_g_object_unref0 (_tmp329_);
#line 640 "../src/Utility/Device.vala"
												if (_tmp335_) {
#line 4220 "Device.c"
													GeeArrayList* _tmp336_;
													gpointer _tmp337_;
													Device* _tmp338_;
													gint _tmp339_;
													gint _tmp340_;
#line 641 "../src/Utility/Device.vala"
													_tmp336_ = list;
#line 641 "../src/Utility/Device.vala"
													_tmp337_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp336_, k);
#line 641 "../src/Utility/Device.vala"
													_tmp338_ = (Device*) _tmp337_;
#line 641 "../src/Utility/Device.vala"
													_g_object_unref0 (_tmp338_);
#line 642 "../src/Utility/Device.vala"
													i = i - 1;
#line 642 "../src/Utility/Device.vala"
													_tmp339_ = i;
#line 643 "../src/Utility/Device.vala"
													j = j - 1;
#line 643 "../src/Utility/Device.vala"
													_tmp340_ = j;
#line 4242 "Device.c"
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp341_;
		gint _tmp342_;
		gint _tmp343_;
#line 652 "../src/Utility/Device.vala"
		_tmp341_ = list;
#line 652 "../src/Utility/Device.vala"
		_tmp342_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp341_);
#line 652 "../src/Utility/Device.vala"
		_tmp343_ = _tmp342_;
#line 652 "../src/Utility/Device.vala"
		i = _tmp343_ - 1;
#line 4268 "Device.c"
		{
			gboolean _tmp344_ = FALSE;
#line 652 "../src/Utility/Device.vala"
			_tmp344_ = TRUE;
#line 652 "../src/Utility/Device.vala"
			while (TRUE) {
#line 4275 "Device.c"
				GeeArrayList* _tmp346_;
				gpointer _tmp347_;
				Device* _tmp348_;
				gboolean _tmp349_;
#line 652 "../src/Utility/Device.vala"
				if (!_tmp344_) {
#line 4282 "Device.c"
					gint _tmp345_;
#line 652 "../src/Utility/Device.vala"
					i = i - 1;
#line 652 "../src/Utility/Device.vala"
					_tmp345_ = i;
#line 4288 "Device.c"
				}
#line 652 "../src/Utility/Device.vala"
				_tmp344_ = FALSE;
#line 652 "../src/Utility/Device.vala"
				if (!(i >= 0)) {
#line 652 "../src/Utility/Device.vala"
					break;
#line 4296 "Device.c"
				}
#line 653 "../src/Utility/Device.vala"
				_tmp346_ = list;
#line 653 "../src/Utility/Device.vala"
				_tmp347_ = gee_abstract_list_get ((GeeAbstractList*) _tmp346_, i);
#line 653 "../src/Utility/Device.vala"
				_tmp348_ = (Device*) _tmp347_;
#line 653 "../src/Utility/Device.vala"
				_tmp349_ = device_type_is_raid (_tmp348_);
#line 653 "../src/Utility/Device.vala"
				_g_object_unref0 (_tmp348_);
#line 653 "../src/Utility/Device.vala"
				if (_tmp349_) {
#line 4310 "Device.c"
					GeeArrayList* _tmp350_;
					gpointer _tmp351_;
					Device* _tmp352_;
					gchar* _tmp353_;
					GeeArrayList* _tmp354_;
					gpointer _tmp355_;
					Device* _tmp356_;
					GeeArrayList* _tmp357_;
					gpointer _tmp358_;
					Device* _tmp359_;
					const gchar* _tmp360_;
					gchar* _tmp361_;
#line 655 "../src/Utility/Device.vala"
					_tmp350_ = list;
#line 655 "../src/Utility/Device.vala"
					_tmp351_ = gee_abstract_list_get ((GeeAbstractList*) _tmp350_, i);
#line 655 "../src/Utility/Device.vala"
					_tmp352_ = (Device*) _tmp351_;
#line 655 "../src/Utility/Device.vala"
					_tmp353_ = g_strdup ("disk");
#line 655 "../src/Utility/Device.vala"
					_g_free0 (_tmp352_->type);
#line 655 "../src/Utility/Device.vala"
					_tmp352_->type = _tmp353_;
#line 655 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp352_);
#line 656 "../src/Utility/Device.vala"
					_tmp354_ = list;
#line 656 "../src/Utility/Device.vala"
					_tmp355_ = gee_abstract_list_get ((GeeAbstractList*) _tmp354_, i);
#line 656 "../src/Utility/Device.vala"
					_tmp356_ = (Device*) _tmp355_;
#line 656 "../src/Utility/Device.vala"
					_tmp357_ = list;
#line 656 "../src/Utility/Device.vala"
					_tmp358_ = gee_abstract_list_get ((GeeAbstractList*) _tmp357_, i);
#line 656 "../src/Utility/Device.vala"
					_tmp359_ = (Device*) _tmp358_;
#line 656 "../src/Utility/Device.vala"
					_tmp360_ = _tmp359_->name;
#line 656 "../src/Utility/Device.vala"
					_tmp361_ = g_strdup (_tmp360_);
#line 656 "../src/Utility/Device.vala"
					_g_free0 (_tmp356_->model);
#line 656 "../src/Utility/Device.vala"
					_tmp356_->model = _tmp361_;
#line 656 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp359_);
#line 656 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp356_);
#line 4361 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp362_;
						gint _tmp363_;
						gint _tmp364_;
#line 659 "../src/Utility/Device.vala"
						_tmp362_ = list;
#line 659 "../src/Utility/Device.vala"
						_tmp363_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp362_);
#line 659 "../src/Utility/Device.vala"
						_tmp364_ = _tmp363_;
#line 659 "../src/Utility/Device.vala"
						j = _tmp364_ - 1;
#line 4375 "Device.c"
						{
							gboolean _tmp365_ = FALSE;
#line 659 "../src/Utility/Device.vala"
							_tmp365_ = TRUE;
#line 659 "../src/Utility/Device.vala"
							while (TRUE) {
#line 4382 "Device.c"
								gboolean _tmp367_ = FALSE;
								gboolean _tmp368_ = FALSE;
#line 659 "../src/Utility/Device.vala"
								if (!_tmp365_) {
#line 4387 "Device.c"
									gint _tmp366_;
#line 659 "../src/Utility/Device.vala"
									j = j - 1;
#line 659 "../src/Utility/Device.vala"
									_tmp366_ = j;
#line 4393 "Device.c"
								}
#line 659 "../src/Utility/Device.vala"
								_tmp365_ = FALSE;
#line 659 "../src/Utility/Device.vala"
								if (!(j >= 0)) {
#line 659 "../src/Utility/Device.vala"
									break;
#line 4401 "Device.c"
								}
#line 660 "../src/Utility/Device.vala"
								if (i != j) {
#line 4405 "Device.c"
									GeeArrayList* _tmp369_;
									gpointer _tmp370_;
									Device* _tmp371_;
									const gchar* _tmp372_;
									GeeArrayList* _tmp373_;
									gpointer _tmp374_;
									Device* _tmp375_;
									const gchar* _tmp376_;
#line 660 "../src/Utility/Device.vala"
									_tmp369_ = list;
#line 660 "../src/Utility/Device.vala"
									_tmp370_ = gee_abstract_list_get ((GeeAbstractList*) _tmp369_, j);
#line 660 "../src/Utility/Device.vala"
									_tmp371_ = (Device*) _tmp370_;
#line 660 "../src/Utility/Device.vala"
									_tmp372_ = _tmp371_->type;
#line 660 "../src/Utility/Device.vala"
									_tmp373_ = list;
#line 660 "../src/Utility/Device.vala"
									_tmp374_ = gee_abstract_list_get ((GeeAbstractList*) _tmp373_, i);
#line 660 "../src/Utility/Device.vala"
									_tmp375_ = (Device*) _tmp374_;
#line 660 "../src/Utility/Device.vala"
									_tmp376_ = _tmp375_->type;
#line 660 "../src/Utility/Device.vala"
									_tmp368_ = g_strcmp0 (_tmp372_, _tmp376_) == 0;
#line 660 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp375_);
#line 660 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp371_);
#line 4436 "Device.c"
								} else {
#line 660 "../src/Utility/Device.vala"
									_tmp368_ = FALSE;
#line 4440 "Device.c"
								}
#line 660 "../src/Utility/Device.vala"
								if (_tmp368_) {
#line 4444 "Device.c"
									GeeArrayList* _tmp377_;
									gpointer _tmp378_;
									Device* _tmp379_;
									const gchar* _tmp380_;
									GeeArrayList* _tmp381_;
									gpointer _tmp382_;
									Device* _tmp383_;
									const gchar* _tmp384_;
#line 660 "../src/Utility/Device.vala"
									_tmp377_ = list;
#line 660 "../src/Utility/Device.vala"
									_tmp378_ = gee_abstract_list_get ((GeeAbstractList*) _tmp377_, j);
#line 660 "../src/Utility/Device.vala"
									_tmp379_ = (Device*) _tmp378_;
#line 660 "../src/Utility/Device.vala"
									_tmp380_ = _tmp379_->kname;
#line 660 "../src/Utility/Device.vala"
									_tmp381_ = list;
#line 660 "../src/Utility/Device.vala"
									_tmp382_ = gee_abstract_list_get ((GeeAbstractList*) _tmp381_, i);
#line 660 "../src/Utility/Device.vala"
									_tmp383_ = (Device*) _tmp382_;
#line 660 "../src/Utility/Device.vala"
									_tmp384_ = _tmp383_->kname;
#line 660 "../src/Utility/Device.vala"
									_tmp367_ = g_strcmp0 (_tmp380_, _tmp384_) == 0;
#line 660 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp383_);
#line 660 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp379_);
#line 4475 "Device.c"
								} else {
#line 660 "../src/Utility/Device.vala"
									_tmp367_ = FALSE;
#line 4479 "Device.c"
								}
#line 660 "../src/Utility/Device.vala"
								if (_tmp367_) {
#line 4483 "Device.c"
									GeeArrayList* _tmp385_;
									gpointer _tmp386_;
									Device* _tmp387_;
#line 661 "../src/Utility/Device.vala"
									_tmp385_ = list;
#line 661 "../src/Utility/Device.vala"
									_tmp386_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp385_, j);
#line 661 "../src/Utility/Device.vala"
									_tmp387_ = (Device*) _tmp386_;
#line 661 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp387_);
#line 662 "../src/Utility/Device.vala"
									if (j < i) {
#line 4497 "Device.c"
										gint _tmp388_;
#line 663 "../src/Utility/Device.vala"
										i = i - 1;
#line 663 "../src/Utility/Device.vala"
										_tmp388_ = i;
#line 4503 "Device.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp389_;
		gint _tmp390_;
		gint _tmp391_;
#line 672 "../src/Utility/Device.vala"
		_tmp389_ = list;
#line 672 "../src/Utility/Device.vala"
		_tmp390_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp389_);
#line 672 "../src/Utility/Device.vala"
		_tmp391_ = _tmp390_;
#line 672 "../src/Utility/Device.vala"
		i = _tmp391_ - 1;
#line 4526 "Device.c"
		{
			gboolean _tmp392_ = FALSE;
#line 672 "../src/Utility/Device.vala"
			_tmp392_ = TRUE;
#line 672 "../src/Utility/Device.vala"
			while (TRUE) {
#line 4533 "Device.c"
				GeeArrayList* _tmp394_;
				gpointer _tmp395_;
				Device* _tmp396_;
				const gchar* _tmp397_;
				gboolean _tmp398_;
#line 672 "../src/Utility/Device.vala"
				if (!_tmp392_) {
#line 4541 "Device.c"
					gint _tmp393_;
#line 672 "../src/Utility/Device.vala"
					i = i - 1;
#line 672 "../src/Utility/Device.vala"
					_tmp393_ = i;
#line 4547 "Device.c"
				}
#line 672 "../src/Utility/Device.vala"
				_tmp392_ = FALSE;
#line 672 "../src/Utility/Device.vala"
				if (!(i >= 0)) {
#line 672 "../src/Utility/Device.vala"
					break;
#line 4555 "Device.c"
				}
#line 673 "../src/Utility/Device.vala"
				_tmp394_ = list;
#line 673 "../src/Utility/Device.vala"
				_tmp395_ = gee_abstract_list_get ((GeeAbstractList*) _tmp394_, i);
#line 673 "../src/Utility/Device.vala"
				_tmp396_ = (Device*) _tmp395_;
#line 673 "../src/Utility/Device.vala"
				_tmp397_ = _tmp396_->type;
#line 673 "../src/Utility/Device.vala"
				_tmp398_ = g_strcmp0 (_tmp397_, "dmraid") == 0;
#line 673 "../src/Utility/Device.vala"
				_g_object_unref0 (_tmp396_);
#line 673 "../src/Utility/Device.vala"
				if (_tmp398_) {
#line 4571 "Device.c"
					GeeArrayList* _tmp399_;
					GeeArrayList* _tmp400_;
					gpointer _tmp401_;
					Device* _tmp402_;
#line 674 "../src/Utility/Device.vala"
					_tmp399_ = list;
#line 674 "../src/Utility/Device.vala"
					_tmp400_ = list;
#line 674 "../src/Utility/Device.vala"
					_tmp401_ = gee_abstract_list_get ((GeeAbstractList*) _tmp400_, i);
#line 674 "../src/Utility/Device.vala"
					_tmp402_ = (Device*) _tmp401_;
#line 674 "../src/Utility/Device.vala"
					i -= device_remove_parents (_tmp399_, _tmp402_);
#line 674 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp402_);
#line 4588 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp403_;
						gint _tmp404_;
						gint _tmp405_;
#line 678 "../src/Utility/Device.vala"
						_tmp403_ = list;
#line 678 "../src/Utility/Device.vala"
						_tmp404_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp403_);
#line 678 "../src/Utility/Device.vala"
						_tmp405_ = _tmp404_;
#line 678 "../src/Utility/Device.vala"
						j = _tmp405_ - 1;
#line 4602 "Device.c"
						{
							gboolean _tmp406_ = FALSE;
#line 678 "../src/Utility/Device.vala"
							_tmp406_ = TRUE;
#line 678 "../src/Utility/Device.vala"
							while (TRUE) {
#line 4609 "Device.c"
								GeeArrayList* _tmp408_;
								gpointer _tmp409_;
								Device* _tmp410_;
								const gchar* _tmp411_;
								GeeArrayList* _tmp412_;
								gpointer _tmp413_;
								Device* _tmp414_;
								const gchar* _tmp415_;
								gboolean _tmp416_;
#line 678 "../src/Utility/Device.vala"
								if (!_tmp406_) {
#line 4621 "Device.c"
									gint _tmp407_;
#line 678 "../src/Utility/Device.vala"
									j = j - 1;
#line 678 "../src/Utility/Device.vala"
									_tmp407_ = j;
#line 4627 "Device.c"
								}
#line 678 "../src/Utility/Device.vala"
								_tmp406_ = FALSE;
#line 678 "../src/Utility/Device.vala"
								if (!(j > i)) {
#line 678 "../src/Utility/Device.vala"
									break;
#line 4635 "Device.c"
								}
#line 679 "../src/Utility/Device.vala"
								_tmp408_ = list;
#line 679 "../src/Utility/Device.vala"
								_tmp409_ = gee_abstract_list_get ((GeeAbstractList*) _tmp408_, j);
#line 679 "../src/Utility/Device.vala"
								_tmp410_ = (Device*) _tmp409_;
#line 679 "../src/Utility/Device.vala"
								_tmp411_ = _tmp410_->pkname;
#line 679 "../src/Utility/Device.vala"
								_tmp412_ = list;
#line 679 "../src/Utility/Device.vala"
								_tmp413_ = gee_abstract_list_get ((GeeAbstractList*) _tmp412_, i);
#line 679 "../src/Utility/Device.vala"
								_tmp414_ = (Device*) _tmp413_;
#line 679 "../src/Utility/Device.vala"
								_tmp415_ = _tmp414_->kname;
#line 679 "../src/Utility/Device.vala"
								_tmp416_ = g_strcmp0 (_tmp411_, _tmp415_) == 0;
#line 679 "../src/Utility/Device.vala"
								_g_object_unref0 (_tmp414_);
#line 679 "../src/Utility/Device.vala"
								_g_object_unref0 (_tmp410_);
#line 679 "../src/Utility/Device.vala"
								if (_tmp416_) {
#line 4661 "Device.c"
									{
										gint k = 0;
#line 680 "../src/Utility/Device.vala"
										k = j - 1;
#line 4666 "Device.c"
										{
											gboolean _tmp417_ = FALSE;
#line 680 "../src/Utility/Device.vala"
											_tmp417_ = TRUE;
#line 680 "../src/Utility/Device.vala"
											while (TRUE) {
#line 4673 "Device.c"
												GeeArrayList* _tmp419_;
												gpointer _tmp420_;
												Device* _tmp421_;
												const gchar* _tmp422_;
												GeeArrayList* _tmp423_;
												gpointer _tmp424_;
												Device* _tmp425_;
												const gchar* _tmp426_;
												gboolean _tmp427_;
#line 680 "../src/Utility/Device.vala"
												if (!_tmp417_) {
#line 4685 "Device.c"
													gint _tmp418_;
#line 680 "../src/Utility/Device.vala"
													k = k - 1;
#line 680 "../src/Utility/Device.vala"
													_tmp418_ = k;
#line 4691 "Device.c"
												}
#line 680 "../src/Utility/Device.vala"
												_tmp417_ = FALSE;
#line 680 "../src/Utility/Device.vala"
												if (!(k >= 0)) {
#line 680 "../src/Utility/Device.vala"
													break;
#line 4699 "Device.c"
												}
#line 681 "../src/Utility/Device.vala"
												_tmp419_ = list;
#line 681 "../src/Utility/Device.vala"
												_tmp420_ = gee_abstract_list_get ((GeeAbstractList*) _tmp419_, k);
#line 681 "../src/Utility/Device.vala"
												_tmp421_ = (Device*) _tmp420_;
#line 681 "../src/Utility/Device.vala"
												_tmp422_ = _tmp421_->kname;
#line 681 "../src/Utility/Device.vala"
												_tmp423_ = list;
#line 681 "../src/Utility/Device.vala"
												_tmp424_ = gee_abstract_list_get ((GeeAbstractList*) _tmp423_, j);
#line 681 "../src/Utility/Device.vala"
												_tmp425_ = (Device*) _tmp424_;
#line 681 "../src/Utility/Device.vala"
												_tmp426_ = _tmp425_->kname;
#line 681 "../src/Utility/Device.vala"
												_tmp427_ = g_strcmp0 (_tmp422_, _tmp426_) == 0;
#line 681 "../src/Utility/Device.vala"
												_g_object_unref0 (_tmp425_);
#line 681 "../src/Utility/Device.vala"
												_g_object_unref0 (_tmp421_);
#line 681 "../src/Utility/Device.vala"
												if (_tmp427_) {
#line 4725 "Device.c"
													GeeArrayList* _tmp428_;
													gpointer _tmp429_;
													Device* _tmp430_;
													gint _tmp431_;
#line 682 "../src/Utility/Device.vala"
													_tmp428_ = list;
#line 682 "../src/Utility/Device.vala"
													_tmp429_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp428_, k);
#line 682 "../src/Utility/Device.vala"
													_tmp430_ = (Device*) _tmp429_;
#line 682 "../src/Utility/Device.vala"
													_g_object_unref0 (_tmp430_);
#line 683 "../src/Utility/Device.vala"
													j = j - 1;
#line 683 "../src/Utility/Device.vala"
													_tmp431_ = j;
#line 4742 "Device.c"
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp432_;
		gint _tmp433_;
		gint _tmp434_;
#line 692 "../src/Utility/Device.vala"
		_tmp432_ = list;
#line 692 "../src/Utility/Device.vala"
		_tmp433_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp432_);
#line 692 "../src/Utility/Device.vala"
		_tmp434_ = _tmp433_;
#line 692 "../src/Utility/Device.vala"
		i = _tmp434_ - 1;
#line 4768 "Device.c"
		{
			gboolean _tmp435_ = FALSE;
#line 692 "../src/Utility/Device.vala"
			_tmp435_ = TRUE;
#line 692 "../src/Utility/Device.vala"
			while (TRUE) {
#line 4775 "Device.c"
				GeeArrayList* _tmp437_;
				gpointer _tmp438_;
				Device* _tmp439_;
				const gchar* _tmp440_;
				gboolean _tmp441_;
#line 692 "../src/Utility/Device.vala"
				if (!_tmp435_) {
#line 4783 "Device.c"
					gint _tmp436_;
#line 692 "../src/Utility/Device.vala"
					i = i - 1;
#line 692 "../src/Utility/Device.vala"
					_tmp436_ = i;
#line 4789 "Device.c"
				}
#line 692 "../src/Utility/Device.vala"
				_tmp435_ = FALSE;
#line 692 "../src/Utility/Device.vala"
				if (!(i >= 0)) {
#line 692 "../src/Utility/Device.vala"
					break;
#line 4797 "Device.c"
				}
#line 693 "../src/Utility/Device.vala"
				_tmp437_ = list;
#line 693 "../src/Utility/Device.vala"
				_tmp438_ = gee_abstract_list_get ((GeeAbstractList*) _tmp437_, i);
#line 693 "../src/Utility/Device.vala"
				_tmp439_ = (Device*) _tmp438_;
#line 693 "../src/Utility/Device.vala"
				_tmp440_ = _tmp439_->type;
#line 693 "../src/Utility/Device.vala"
				_tmp441_ = g_strcmp0 (_tmp440_, "dmraid") == 0;
#line 693 "../src/Utility/Device.vala"
				_g_object_unref0 (_tmp439_);
#line 693 "../src/Utility/Device.vala"
				if (_tmp441_) {
#line 4813 "Device.c"
					GeeArrayList* _tmp442_;
					gpointer _tmp443_;
					Device* _tmp444_;
					gchar* _tmp445_;
					GeeArrayList* _tmp446_;
					gpointer _tmp447_;
					Device* _tmp448_;
					GeeArrayList* _tmp449_;
					gpointer _tmp450_;
					Device* _tmp451_;
					const gchar* _tmp452_;
					gchar* _tmp453_;
#line 695 "../src/Utility/Device.vala"
					_tmp442_ = list;
#line 695 "../src/Utility/Device.vala"
					_tmp443_ = gee_abstract_list_get ((GeeAbstractList*) _tmp442_, i);
#line 695 "../src/Utility/Device.vala"
					_tmp444_ = (Device*) _tmp443_;
#line 695 "../src/Utility/Device.vala"
					_tmp445_ = g_strdup ("disk");
#line 695 "../src/Utility/Device.vala"
					_g_free0 (_tmp444_->type);
#line 695 "../src/Utility/Device.vala"
					_tmp444_->type = _tmp445_;
#line 695 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp444_);
#line 696 "../src/Utility/Device.vala"
					_tmp446_ = list;
#line 696 "../src/Utility/Device.vala"
					_tmp447_ = gee_abstract_list_get ((GeeAbstractList*) _tmp446_, i);
#line 696 "../src/Utility/Device.vala"
					_tmp448_ = (Device*) _tmp447_;
#line 696 "../src/Utility/Device.vala"
					_tmp449_ = list;
#line 696 "../src/Utility/Device.vala"
					_tmp450_ = gee_abstract_list_get ((GeeAbstractList*) _tmp449_, i);
#line 696 "../src/Utility/Device.vala"
					_tmp451_ = (Device*) _tmp450_;
#line 696 "../src/Utility/Device.vala"
					_tmp452_ = _tmp451_->name;
#line 696 "../src/Utility/Device.vala"
					_tmp453_ = g_strdup (_tmp452_);
#line 696 "../src/Utility/Device.vala"
					_g_free0 (_tmp448_->model);
#line 696 "../src/Utility/Device.vala"
					_tmp448_->model = _tmp453_;
#line 696 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp451_);
#line 696 "../src/Utility/Device.vala"
					_g_object_unref0 (_tmp448_);
#line 4864 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp454_;
						gint _tmp455_;
						gint _tmp456_;
#line 699 "../src/Utility/Device.vala"
						_tmp454_ = list;
#line 699 "../src/Utility/Device.vala"
						_tmp455_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp454_);
#line 699 "../src/Utility/Device.vala"
						_tmp456_ = _tmp455_;
#line 699 "../src/Utility/Device.vala"
						j = _tmp456_ - 1;
#line 4878 "Device.c"
						{
							gboolean _tmp457_ = FALSE;
#line 699 "../src/Utility/Device.vala"
							_tmp457_ = TRUE;
#line 699 "../src/Utility/Device.vala"
							while (TRUE) {
#line 4885 "Device.c"
								gboolean _tmp459_ = FALSE;
								gboolean _tmp460_ = FALSE;
#line 699 "../src/Utility/Device.vala"
								if (!_tmp457_) {
#line 4890 "Device.c"
									gint _tmp458_;
#line 699 "../src/Utility/Device.vala"
									j = j - 1;
#line 699 "../src/Utility/Device.vala"
									_tmp458_ = j;
#line 4896 "Device.c"
								}
#line 699 "../src/Utility/Device.vala"
								_tmp457_ = FALSE;
#line 699 "../src/Utility/Device.vala"
								if (!(j >= 0)) {
#line 699 "../src/Utility/Device.vala"
									break;
#line 4904 "Device.c"
								}
#line 700 "../src/Utility/Device.vala"
								if (i != j) {
#line 4908 "Device.c"
									GeeArrayList* _tmp461_;
									gpointer _tmp462_;
									Device* _tmp463_;
									const gchar* _tmp464_;
#line 700 "../src/Utility/Device.vala"
									_tmp461_ = list;
#line 700 "../src/Utility/Device.vala"
									_tmp462_ = gee_abstract_list_get ((GeeAbstractList*) _tmp461_, j);
#line 700 "../src/Utility/Device.vala"
									_tmp463_ = (Device*) _tmp462_;
#line 700 "../src/Utility/Device.vala"
									_tmp464_ = _tmp463_->type;
#line 700 "../src/Utility/Device.vala"
									_tmp460_ = g_strcmp0 (_tmp464_, "dmraid") == 0;
#line 700 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp463_);
#line 4925 "Device.c"
								} else {
#line 700 "../src/Utility/Device.vala"
									_tmp460_ = FALSE;
#line 4929 "Device.c"
								}
#line 700 "../src/Utility/Device.vala"
								if (_tmp460_) {
#line 4933 "Device.c"
									GeeArrayList* _tmp465_;
									gpointer _tmp466_;
									Device* _tmp467_;
									const gchar* _tmp468_;
									GeeArrayList* _tmp469_;
									gpointer _tmp470_;
									Device* _tmp471_;
									const gchar* _tmp472_;
#line 700 "../src/Utility/Device.vala"
									_tmp465_ = list;
#line 700 "../src/Utility/Device.vala"
									_tmp466_ = gee_abstract_list_get ((GeeAbstractList*) _tmp465_, j);
#line 700 "../src/Utility/Device.vala"
									_tmp467_ = (Device*) _tmp466_;
#line 700 "../src/Utility/Device.vala"
									_tmp468_ = _tmp467_->kname;
#line 700 "../src/Utility/Device.vala"
									_tmp469_ = list;
#line 700 "../src/Utility/Device.vala"
									_tmp470_ = gee_abstract_list_get ((GeeAbstractList*) _tmp469_, i);
#line 700 "../src/Utility/Device.vala"
									_tmp471_ = (Device*) _tmp470_;
#line 700 "../src/Utility/Device.vala"
									_tmp472_ = _tmp471_->kname;
#line 700 "../src/Utility/Device.vala"
									_tmp459_ = g_strcmp0 (_tmp468_, _tmp472_) == 0;
#line 700 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp471_);
#line 700 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp467_);
#line 4964 "Device.c"
								} else {
#line 700 "../src/Utility/Device.vala"
									_tmp459_ = FALSE;
#line 4968 "Device.c"
								}
#line 700 "../src/Utility/Device.vala"
								if (_tmp459_) {
#line 4972 "Device.c"
									GeeArrayList* _tmp473_;
									gpointer _tmp474_;
									Device* _tmp475_;
#line 701 "../src/Utility/Device.vala"
									_tmp473_ = list;
#line 701 "../src/Utility/Device.vala"
									_tmp474_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp473_, j);
#line 701 "../src/Utility/Device.vala"
									_tmp475_ = (Device*) _tmp474_;
#line 701 "../src/Utility/Device.vala"
									_g_object_unref0 (_tmp475_);
#line 702 "../src/Utility/Device.vala"
									if (j < i) {
#line 4986 "Device.c"
										gint _tmp476_;
#line 703 "../src/Utility/Device.vala"
										i = i - 1;
#line 703 "../src/Utility/Device.vala"
										_tmp476_ = i;
#line 4992 "Device.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 712 "../src/Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 5004 "Device.c"
		GeeArrayList* _tmp477_;
#line 713 "../src/Utility/Device.vala"
		_tmp477_ = list;
#line 713 "../src/Utility/Device.vala"
		device_find_child_devices_using_dmsetup (_tmp477_);
#line 5010 "Device.c"
	}
#line 720 "../src/Utility/Device.vala"
	result = list;
#line 720 "../src/Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 720 "../src/Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 720 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 720 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 720 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 720 "../src/Utility/Device.vala"
	return result;
#line 5026 "Device.c"
}

GeeArrayList*
device_get_block_devices_using_blkid (const gchar* dev_name)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp6_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_;
	const gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	GeeArrayList* _tmp104_;
	gint _tmp105_;
	gint _tmp106_;
	gchar* _tmp107_;
	gchar* _tmp108_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 724 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 729 "../src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 729 "../src/Utility/Device.vala"
	list = _tmp0_;
#line 738 "../src/Utility/Device.vala"
	_tmp2_ = strlen (dev_name);
#line 738 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 738 "../src/Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 5070 "Device.c"
		gchar* _tmp4_;
#line 738 "../src/Utility/Device.vala"
		_tmp4_ = g_strconcat (" ", dev_name, NULL);
#line 738 "../src/Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 738 "../src/Utility/Device.vala"
		_tmp1_ = _tmp4_;
#line 5078 "Device.c"
	} else {
		gchar* _tmp5_;
#line 738 "../src/Utility/Device.vala"
		_tmp5_ = g_strdup ("");
#line 738 "../src/Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 738 "../src/Utility/Device.vala"
		_tmp1_ = _tmp5_;
#line 5087 "Device.c"
	}
#line 738 "../src/Utility/Device.vala"
	_tmp6_ = g_strconcat ("/sbin/blkid", _tmp1_, NULL);
#line 738 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 738 "../src/Utility/Device.vala"
	cmd = _tmp6_;
#line 740 "../src/Utility/Device.vala"
	if (tee_jee_logging_LOG_DEBUG) {
#line 5097 "Device.c"
		const gchar* _tmp7_;
#line 741 "../src/Utility/Device.vala"
		_tmp7_ = cmd;
#line 741 "../src/Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp7_);
#line 5103 "Device.c"
	}
#line 744 "../src/Utility/Device.vala"
	_tmp8_ = cmd;
#line 744 "../src/Utility/Device.vala"
	_tmp11_ = tee_jee_process_helper_exec_script_sync (_tmp8_, &_tmp9_, &_tmp10_, FALSE, FALSE, TRUE, FALSE);
#line 744 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 744 "../src/Utility/Device.vala"
	std_out = _tmp9_;
#line 744 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 744 "../src/Utility/Device.vala"
	std_err = _tmp10_;
#line 744 "../src/Utility/Device.vala"
	ret_val = _tmp11_;
#line 745 "../src/Utility/Device.vala"
	if (ret_val != 0) {
#line 5121 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gint _tmp14_;
		gint _tmp15_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
#line 746 "../src/Utility/Device.vala"
		_tmp12_ = g_strconcat ("blkid: ", _ ("Failed to get partition list"), NULL);
#line 746 "../src/Utility/Device.vala"
		msg = _tmp12_;
#line 747 "../src/Utility/Device.vala"
		_tmp14_ = strlen (dev_name);
#line 747 "../src/Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 747 "../src/Utility/Device.vala"
		if (_tmp15_ > 0) {
#line 5140 "Device.c"
			gchar* _tmp16_;
#line 747 "../src/Utility/Device.vala"
			_tmp16_ = g_strconcat (": ", dev_name, NULL);
#line 747 "../src/Utility/Device.vala"
			_g_free0 (_tmp13_);
#line 747 "../src/Utility/Device.vala"
			_tmp13_ = _tmp16_;
#line 5148 "Device.c"
		} else {
			gchar* _tmp17_;
#line 747 "../src/Utility/Device.vala"
			_tmp17_ = g_strdup ("");
#line 747 "../src/Utility/Device.vala"
			_g_free0 (_tmp13_);
#line 747 "../src/Utility/Device.vala"
			_tmp13_ = _tmp17_;
#line 5157 "Device.c"
		}
#line 747 "../src/Utility/Device.vala"
		_tmp18_ = msg;
#line 747 "../src/Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp18_, _tmp13_, NULL);
#line 747 "../src/Utility/Device.vala"
		_g_free0 (msg);
#line 747 "../src/Utility/Device.vala"
		msg = _tmp19_;
#line 748 "../src/Utility/Device.vala"
		_tmp20_ = msg;
#line 748 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp20_, FALSE, FALSE);
#line 749 "../src/Utility/Device.vala"
		result = list;
#line 749 "../src/Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 749 "../src/Utility/Device.vala"
		_g_free0 (msg);
#line 749 "../src/Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 749 "../src/Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 749 "../src/Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 749 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 749 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 749 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 749 "../src/Utility/Device.vala"
		return result;
#line 5191 "Device.c"
	}
#line 762 "../src/Utility/Device.vala"
	_tmp21_ = std_out;
#line 762 "../src/Utility/Device.vala"
	_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, "\n", 0);
#line 5197 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 762 "../src/Utility/Device.vala"
		line_collection = _tmp23_;
#line 762 "../src/Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp22_);
#line 762 "../src/Utility/Device.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 5209 "Device.c"
			gchar* _tmp24_;
			gchar* line = NULL;
#line 762 "../src/Utility/Device.vala"
			_tmp24_ = g_strdup (line_collection[line_it]);
#line 762 "../src/Utility/Device.vala"
			line = _tmp24_;
#line 5216 "Device.c"
			{
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gboolean _tmp30_;
				Device* pi = NULL;
				Device* _tmp31_;
				Device* _tmp32_;
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gchar** _tmp35_;
				gchar** _tmp36_;
				gint _tmp36__length1;
				const gchar* _tmp37_;
				gchar* _tmp38_;
				Device* _tmp39_;
				const gchar* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				Device* _tmp43_;
				const gchar* _tmp44_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_ = FALSE;
				Device* _tmp48_;
				const gchar* _tmp49_;
				Device* _tmp98_;
				const gchar* _tmp99_;
				gint _tmp100_;
				gint _tmp101_;
#line 763 "../src/Utility/Device.vala"
				_tmp25_ = line;
#line 763 "../src/Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 763 "../src/Utility/Device.vala"
				_tmp27_ = _tmp26_;
#line 763 "../src/Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 763 "../src/Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 763 "../src/Utility/Device.vala"
				_tmp30_ = _tmp29_ == 0;
#line 763 "../src/Utility/Device.vala"
				_g_free0 (_tmp27_);
#line 763 "../src/Utility/Device.vala"
				if (_tmp30_) {
#line 763 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 763 "../src/Utility/Device.vala"
					continue;
#line 5269 "Device.c"
				}
#line 765 "../src/Utility/Device.vala"
				_tmp31_ = device_new ();
#line 765 "../src/Utility/Device.vala"
				pi = _tmp31_;
#line 767 "../src/Utility/Device.vala"
				_tmp32_ = pi;
#line 767 "../src/Utility/Device.vala"
				_tmp33_ = line;
#line 767 "../src/Utility/Device.vala"
				_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, ":", 0);
#line 767 "../src/Utility/Device.vala"
				_tmp36_ = _tmp35_;
#line 767 "../src/Utility/Device.vala"
				_tmp36__length1 = _vala_array_length (_tmp34_);
#line 767 "../src/Utility/Device.vala"
				_tmp37_ = _tmp36_[0];
#line 767 "../src/Utility/Device.vala"
				_tmp38_ = string_strip (_tmp37_);
#line 767 "../src/Utility/Device.vala"
				_g_free0 (_tmp32_->device);
#line 767 "../src/Utility/Device.vala"
				_tmp32_->device = _tmp38_;
#line 767 "../src/Utility/Device.vala"
				_tmp36_ = (_vala_array_free (_tmp36_, _tmp36__length1, (GDestroyNotify) g_free), NULL);
#line 769 "../src/Utility/Device.vala"
				_tmp39_ = pi;
#line 769 "../src/Utility/Device.vala"
				_tmp40_ = _tmp39_->device;
#line 769 "../src/Utility/Device.vala"
				_tmp41_ = strlen (_tmp40_);
#line 769 "../src/Utility/Device.vala"
				_tmp42_ = _tmp41_;
#line 769 "../src/Utility/Device.vala"
				if (_tmp42_ == 0) {
#line 769 "../src/Utility/Device.vala"
					_g_object_unref0 (pi);
#line 769 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 769 "../src/Utility/Device.vala"
					continue;
#line 5311 "Device.c"
				}
#line 773 "../src/Utility/Device.vala"
				_tmp43_ = pi;
#line 773 "../src/Utility/Device.vala"
				_tmp44_ = _tmp43_->device;
#line 773 "../src/Utility/Device.vala"
				if (!g_str_has_prefix (_tmp44_, "/dev/")) {
#line 774 "../src/Utility/Device.vala"
					_g_object_unref0 (pi);
#line 774 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 774 "../src/Utility/Device.vala"
					continue;
#line 5325 "Device.c"
				}
#line 777 "../src/Utility/Device.vala"
				_tmp48_ = pi;
#line 777 "../src/Utility/Device.vala"
				_tmp49_ = _tmp48_->device;
#line 777 "../src/Utility/Device.vala"
				if (g_str_has_prefix (_tmp49_, "/dev/sd")) {
#line 777 "../src/Utility/Device.vala"
					_tmp47_ = TRUE;
#line 5335 "Device.c"
				} else {
					Device* _tmp50_;
					const gchar* _tmp51_;
#line 777 "../src/Utility/Device.vala"
					_tmp50_ = pi;
#line 777 "../src/Utility/Device.vala"
					_tmp51_ = _tmp50_->device;
#line 777 "../src/Utility/Device.vala"
					_tmp47_ = g_str_has_prefix (_tmp51_, "/dev/hd");
#line 5345 "Device.c"
				}
#line 777 "../src/Utility/Device.vala"
				if (_tmp47_) {
#line 777 "../src/Utility/Device.vala"
					_tmp46_ = TRUE;
#line 5351 "Device.c"
				} else {
					Device* _tmp52_;
					const gchar* _tmp53_;
#line 777 "../src/Utility/Device.vala"
					_tmp52_ = pi;
#line 777 "../src/Utility/Device.vala"
					_tmp53_ = _tmp52_->device;
#line 777 "../src/Utility/Device.vala"
					_tmp46_ = g_str_has_prefix (_tmp53_, "/dev/mapper/");
#line 5361 "Device.c"
				}
#line 777 "../src/Utility/Device.vala"
				if (_tmp46_) {
#line 777 "../src/Utility/Device.vala"
					_tmp45_ = TRUE;
#line 5367 "Device.c"
				} else {
					Device* _tmp54_;
					const gchar* _tmp55_;
#line 777 "../src/Utility/Device.vala"
					_tmp54_ = pi;
#line 777 "../src/Utility/Device.vala"
					_tmp55_ = _tmp54_->device;
#line 777 "../src/Utility/Device.vala"
					_tmp45_ = g_str_has_prefix (_tmp55_, "/dev/dm");
#line 5377 "Device.c"
				}
#line 777 "../src/Utility/Device.vala"
				if (_tmp45_) {
#line 5381 "Device.c"
				} else {
					Device* _tmp56_;
					const gchar* _tmp57_;
#line 780 "../src/Utility/Device.vala"
					_tmp56_ = pi;
#line 780 "../src/Utility/Device.vala"
					_tmp57_ = _tmp56_->device;
#line 780 "../src/Utility/Device.vala"
					if (g_str_has_prefix (_tmp57_, "/dev/disk/by-uuid/")) {
#line 5391 "Device.c"
						Device* _tmp58_;
						Device* _tmp59_;
						const gchar* _tmp60_;
						gchar* _tmp61_;
#line 782 "../src/Utility/Device.vala"
						_tmp58_ = pi;
#line 782 "../src/Utility/Device.vala"
						_tmp59_ = pi;
#line 782 "../src/Utility/Device.vala"
						_tmp60_ = _tmp59_->device;
#line 782 "../src/Utility/Device.vala"
						_tmp61_ = string_replace (_tmp60_, "/dev/disk/by-uuid/", "");
#line 782 "../src/Utility/Device.vala"
						_g_free0 (_tmp58_->uuid);
#line 782 "../src/Utility/Device.vala"
						_tmp58_->uuid = _tmp61_;
#line 5408 "Device.c"
					} else {
#line 785 "../src/Utility/Device.vala"
						_g_object_unref0 (pi);
#line 785 "../src/Utility/Device.vala"
						_g_free0 (line);
#line 785 "../src/Utility/Device.vala"
						continue;
#line 5416 "Device.c"
					}
				}
				{
					GRegex* _tmp62_ = NULL;
					GRegex* _tmp63_;
					GRegex* _tmp64_;
					GRegex* _tmp65_;
					const gchar* _tmp66_;
					GMatchInfo* _tmp67_ = NULL;
					gboolean _tmp68_;
					GRegex* _tmp72_ = NULL;
					GRegex* _tmp73_;
					GRegex* _tmp74_;
					GRegex* _tmp75_;
					const gchar* _tmp76_;
					GMatchInfo* _tmp77_ = NULL;
					gboolean _tmp78_;
					GRegex* _tmp84_ = NULL;
					GRegex* _tmp85_;
					GRegex* _tmp86_;
					GRegex* _tmp87_;
					const gchar* _tmp88_;
					GMatchInfo* _tmp89_ = NULL;
					gboolean _tmp90_;
#line 791 "../src/Utility/Device.vala"
					_tmp63_ = g_regex_new ("LABEL=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 791 "../src/Utility/Device.vala"
					_tmp62_ = _tmp63_;
#line 791 "../src/Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5447 "Device.c"
						goto __catch0_g_error;
					}
#line 791 "../src/Utility/Device.vala"
					_tmp64_ = _tmp62_;
#line 791 "../src/Utility/Device.vala"
					_tmp62_ = NULL;
#line 791 "../src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 791 "../src/Utility/Device.vala"
					rex = _tmp64_;
#line 792 "../src/Utility/Device.vala"
					_tmp65_ = rex;
#line 792 "../src/Utility/Device.vala"
					_tmp66_ = line;
#line 792 "../src/Utility/Device.vala"
					_tmp68_ = g_regex_match (_tmp65_, _tmp66_, 0, &_tmp67_);
#line 792 "../src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 792 "../src/Utility/Device.vala"
					match = _tmp67_;
#line 792 "../src/Utility/Device.vala"
					if (_tmp68_) {
#line 5470 "Device.c"
						Device* _tmp69_;
						GMatchInfo* _tmp70_;
						gchar* _tmp71_;
#line 793 "../src/Utility/Device.vala"
						_tmp69_ = pi;
#line 793 "../src/Utility/Device.vala"
						_tmp70_ = match;
#line 793 "../src/Utility/Device.vala"
						_tmp71_ = g_match_info_fetch (_tmp70_, 1);
#line 793 "../src/Utility/Device.vala"
						_g_free0 (_tmp69_->label);
#line 793 "../src/Utility/Device.vala"
						_tmp69_->label = _tmp71_;
#line 5484 "Device.c"
					}
#line 796 "../src/Utility/Device.vala"
					_tmp73_ = g_regex_new ("UUID=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 796 "../src/Utility/Device.vala"
					_tmp72_ = _tmp73_;
#line 796 "../src/Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 796 "../src/Utility/Device.vala"
						_g_regex_unref0 (_tmp62_);
#line 5494 "Device.c"
						goto __catch0_g_error;
					}
#line 796 "../src/Utility/Device.vala"
					_tmp74_ = _tmp72_;
#line 796 "../src/Utility/Device.vala"
					_tmp72_ = NULL;
#line 796 "../src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 796 "../src/Utility/Device.vala"
					rex = _tmp74_;
#line 797 "../src/Utility/Device.vala"
					_tmp75_ = rex;
#line 797 "../src/Utility/Device.vala"
					_tmp76_ = line;
#line 797 "../src/Utility/Device.vala"
					_tmp78_ = g_regex_match (_tmp75_, _tmp76_, 0, &_tmp77_);
#line 797 "../src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 797 "../src/Utility/Device.vala"
					match = _tmp77_;
#line 797 "../src/Utility/Device.vala"
					if (_tmp78_) {
#line 5517 "Device.c"
						Device* _tmp79_;
						GMatchInfo* _tmp80_;
						gchar* _tmp81_;
						gchar* _tmp82_;
						gchar* _tmp83_;
#line 798 "../src/Utility/Device.vala"
						_tmp79_ = pi;
#line 798 "../src/Utility/Device.vala"
						_tmp80_ = match;
#line 798 "../src/Utility/Device.vala"
						_tmp81_ = g_match_info_fetch (_tmp80_, 1);
#line 798 "../src/Utility/Device.vala"
						_tmp82_ = _tmp81_;
#line 798 "../src/Utility/Device.vala"
						_tmp83_ = string_strip (_tmp82_);
#line 798 "../src/Utility/Device.vala"
						_g_free0 (_tmp79_->uuid);
#line 798 "../src/Utility/Device.vala"
						_tmp79_->uuid = _tmp83_;
#line 798 "../src/Utility/Device.vala"
						_g_free0 (_tmp82_);
#line 5539 "Device.c"
					}
#line 801 "../src/Utility/Device.vala"
					_tmp85_ = g_regex_new ("TYPE=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 801 "../src/Utility/Device.vala"
					_tmp84_ = _tmp85_;
#line 801 "../src/Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 801 "../src/Utility/Device.vala"
						_g_regex_unref0 (_tmp72_);
#line 801 "../src/Utility/Device.vala"
						_g_regex_unref0 (_tmp62_);
#line 5551 "Device.c"
						goto __catch0_g_error;
					}
#line 801 "../src/Utility/Device.vala"
					_tmp86_ = _tmp84_;
#line 801 "../src/Utility/Device.vala"
					_tmp84_ = NULL;
#line 801 "../src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 801 "../src/Utility/Device.vala"
					rex = _tmp86_;
#line 802 "../src/Utility/Device.vala"
					_tmp87_ = rex;
#line 802 "../src/Utility/Device.vala"
					_tmp88_ = line;
#line 802 "../src/Utility/Device.vala"
					_tmp90_ = g_regex_match (_tmp87_, _tmp88_, 0, &_tmp89_);
#line 802 "../src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 802 "../src/Utility/Device.vala"
					match = _tmp89_;
#line 802 "../src/Utility/Device.vala"
					if (_tmp90_) {
#line 5574 "Device.c"
						Device* _tmp91_;
						GMatchInfo* _tmp92_;
						gchar* _tmp93_;
						gchar* _tmp94_;
						gchar* _tmp95_;
#line 803 "../src/Utility/Device.vala"
						_tmp91_ = pi;
#line 803 "../src/Utility/Device.vala"
						_tmp92_ = match;
#line 803 "../src/Utility/Device.vala"
						_tmp93_ = g_match_info_fetch (_tmp92_, 1);
#line 803 "../src/Utility/Device.vala"
						_tmp94_ = _tmp93_;
#line 803 "../src/Utility/Device.vala"
						_tmp95_ = string_strip (_tmp94_);
#line 803 "../src/Utility/Device.vala"
						_g_free0 (_tmp91_->fstype);
#line 803 "../src/Utility/Device.vala"
						_tmp91_->fstype = _tmp95_;
#line 803 "../src/Utility/Device.vala"
						_g_free0 (_tmp94_);
#line 5596 "Device.c"
					}
#line 790 "../src/Utility/Device.vala"
					_g_regex_unref0 (_tmp84_);
#line 790 "../src/Utility/Device.vala"
					_g_regex_unref0 (_tmp72_);
#line 790 "../src/Utility/Device.vala"
					_g_regex_unref0 (_tmp62_);
#line 5604 "Device.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp96_;
					const gchar* _tmp97_;
#line 790 "../src/Utility/Device.vala"
					e = _inner_error0_;
#line 790 "../src/Utility/Device.vala"
					_inner_error0_ = NULL;
#line 807 "../src/Utility/Device.vala"
					_tmp96_ = e;
#line 807 "../src/Utility/Device.vala"
					_tmp97_ = _tmp96_->message;
#line 807 "../src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp97_, FALSE, FALSE);
#line 790 "../src/Utility/Device.vala"
					_g_error_free0 (e);
#line 5624 "Device.c"
				}
				__finally0:
#line 790 "../src/Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 790 "../src/Utility/Device.vala"
					_g_object_unref0 (pi);
#line 790 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 790 "../src/Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 790 "../src/Utility/Device.vala"
					_g_free0 (_tmp1_);
#line 790 "../src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 790 "../src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 790 "../src/Utility/Device.vala"
					_g_free0 (cmd);
#line 790 "../src/Utility/Device.vala"
					_g_free0 (std_err);
#line 790 "../src/Utility/Device.vala"
					_g_free0 (std_out);
#line 790 "../src/Utility/Device.vala"
					_g_object_unref0 (list);
#line 790 "../src/Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 790 "../src/Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 790 "../src/Utility/Device.vala"
					return NULL;
#line 5655 "Device.c"
				}
#line 812 "../src/Utility/Device.vala"
				_tmp98_ = pi;
#line 812 "../src/Utility/Device.vala"
				_tmp99_ = _tmp98_->uuid;
#line 812 "../src/Utility/Device.vala"
				_tmp100_ = strlen (_tmp99_);
#line 812 "../src/Utility/Device.vala"
				_tmp101_ = _tmp100_;
#line 812 "../src/Utility/Device.vala"
				if (_tmp101_ > 0) {
#line 5667 "Device.c"
					GeeArrayList* _tmp102_;
					Device* _tmp103_;
#line 813 "../src/Utility/Device.vala"
					_tmp102_ = list;
#line 813 "../src/Utility/Device.vala"
					_tmp103_ = pi;
#line 813 "../src/Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp102_, _tmp103_);
#line 5676 "Device.c"
				}
#line 762 "../src/Utility/Device.vala"
				_g_object_unref0 (pi);
#line 762 "../src/Utility/Device.vala"
				_g_free0 (line);
#line 5682 "Device.c"
			}
		}
#line 762 "../src/Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5687 "Device.c"
	}
#line 817 "../src/Utility/Device.vala"
	_tmp104_ = list;
#line 817 "../src/Utility/Device.vala"
	_tmp105_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp104_);
#line 817 "../src/Utility/Device.vala"
	_tmp106_ = _tmp105_;
#line 817 "../src/Utility/Device.vala"
	_tmp107_ = g_strdup_printf ("Device: get_block_devices_using_blkid(): %d", _tmp106_);
#line 817 "../src/Utility/Device.vala"
	_tmp108_ = _tmp107_;
#line 817 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp108_);
#line 817 "../src/Utility/Device.vala"
	_g_free0 (_tmp108_);
#line 819 "../src/Utility/Device.vala"
	result = list;
#line 819 "../src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 819 "../src/Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 819 "../src/Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 819 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 819 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 819 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 819 "../src/Utility/Device.vala"
	return result;
#line 5719 "Device.c"
}

static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result;
#line 839 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 840 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, _base);
#line 840 "glib-2.0.vapi"
	return result;
#line 5733 "Device.c"
}

GeeArrayList*
device_get_disk_space_using_df (const gchar* dev_name_or_mount_point)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gint _tmp14_;
	gchar** lines = NULL;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint lines_length1;
	gint _lines_size_;
	gint line_num = 0;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GeeArrayList* _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	GeeArrayList* result;
#line 822 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_mount_point != NULL, NULL);
#line 829 "../src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 829 "../src/Utility/Device.vala"
	list = _tmp0_;
#line 836 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup ("df -T -B1");
#line 836 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 836 "../src/Utility/Device.vala"
	cmd = _tmp1_;
#line 838 "../src/Utility/Device.vala"
	_tmp2_ = strlen (dev_name_or_mount_point);
#line 838 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 838 "../src/Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 5785 "Device.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 839 "../src/Utility/Device.vala"
		_tmp4_ = cmd;
#line 839 "../src/Utility/Device.vala"
		_tmp5_ = tee_jee_file_system_escape_single_quote (dev_name_or_mount_point);
#line 839 "../src/Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 839 "../src/Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" '%s'", _tmp6_);
#line 839 "../src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 839 "../src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp4_, _tmp8_, NULL);
#line 839 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 839 "../src/Utility/Device.vala"
		cmd = _tmp9_;
#line 839 "../src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 839 "../src/Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 5812 "Device.c"
	}
#line 842 "../src/Utility/Device.vala"
	if (tee_jee_logging_LOG_DEBUG) {
#line 5816 "Device.c"
		const gchar* _tmp10_;
#line 843 "../src/Utility/Device.vala"
		_tmp10_ = cmd;
#line 843 "../src/Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp10_);
#line 5822 "Device.c"
	}
#line 846 "../src/Utility/Device.vala"
	_tmp11_ = cmd;
#line 846 "../src/Utility/Device.vala"
	_tmp14_ = tee_jee_process_helper_exec_sync (_tmp11_, &_tmp12_, &_tmp13_);
#line 846 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 846 "../src/Utility/Device.vala"
	std_out = _tmp12_;
#line 846 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 846 "../src/Utility/Device.vala"
	std_err = _tmp13_;
#line 846 "../src/Utility/Device.vala"
	ret_val = _tmp14_;
#line 861 "../src/Utility/Device.vala"
	_tmp15_ = std_out;
#line 861 "../src/Utility/Device.vala"
	_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, "\n", 0);
#line 861 "../src/Utility/Device.vala"
	lines = _tmp17_;
#line 861 "../src/Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp16_);
#line 861 "../src/Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 863 "../src/Utility/Device.vala"
	line_num = 0;
#line 864 "../src/Utility/Device.vala"
	_tmp18_ = lines;
#line 864 "../src/Utility/Device.vala"
	_tmp18__length1 = lines_length1;
#line 5854 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 864 "../src/Utility/Device.vala"
		line_collection = _tmp18_;
#line 864 "../src/Utility/Device.vala"
		line_collection_length1 = _tmp18__length1;
#line 864 "../src/Utility/Device.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 5866 "Device.c"
			gchar* _tmp19_;
			gchar* line = NULL;
#line 864 "../src/Utility/Device.vala"
			_tmp19_ = g_strdup (line_collection[line_it]);
#line 864 "../src/Utility/Device.vala"
			line = _tmp19_;
#line 5873 "Device.c"
			{
				gint _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gboolean _tmp26_;
				Device* pi = NULL;
				Device* _tmp27_;
				gint k = 0;
				const gchar* _tmp28_;
				gchar** _tmp29_;
				gchar** _tmp30_;
				Device* _tmp60_;
				Device* _tmp61_;
				const gchar* _tmp62_;
				gchar* _tmp63_;
				Device* _tmp64_;
				Device* _tmp65_;
				const gchar* _tmp66_;
				gchar* _tmp67_;
				Device* _tmp68_;
				const gchar* _tmp69_;
				gint _tmp70_;
				gint _tmp71_;
#line 866 "../src/Utility/Device.vala"
				line_num = line_num + 1;
#line 866 "../src/Utility/Device.vala"
				_tmp20_ = line_num;
#line 866 "../src/Utility/Device.vala"
				if (_tmp20_ == 1) {
#line 866 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 866 "../src/Utility/Device.vala"
					continue;
#line 5910 "Device.c"
				}
#line 867 "../src/Utility/Device.vala"
				_tmp21_ = line;
#line 867 "../src/Utility/Device.vala"
				_tmp22_ = string_strip (_tmp21_);
#line 867 "../src/Utility/Device.vala"
				_tmp23_ = _tmp22_;
#line 867 "../src/Utility/Device.vala"
				_tmp24_ = strlen (_tmp23_);
#line 867 "../src/Utility/Device.vala"
				_tmp25_ = _tmp24_;
#line 867 "../src/Utility/Device.vala"
				_tmp26_ = _tmp25_ == 0;
#line 867 "../src/Utility/Device.vala"
				_g_free0 (_tmp23_);
#line 867 "../src/Utility/Device.vala"
				if (_tmp26_) {
#line 867 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 867 "../src/Utility/Device.vala"
					continue;
#line 5932 "Device.c"
				}
#line 869 "../src/Utility/Device.vala"
				_tmp27_ = device_new ();
#line 869 "../src/Utility/Device.vala"
				pi = _tmp27_;
#line 873 "../src/Utility/Device.vala"
				k = 1;
#line 874 "../src/Utility/Device.vala"
				_tmp28_ = line;
#line 874 "../src/Utility/Device.vala"
				_tmp30_ = _tmp29_ = g_strsplit (_tmp28_, " ", 0);
#line 5944 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 874 "../src/Utility/Device.vala"
					val_collection = _tmp30_;
#line 874 "../src/Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp29_);
#line 874 "../src/Utility/Device.vala"
					for (val_it = 0; val_it < val_collection_length1; val_it = val_it + 1) {
#line 5956 "Device.c"
						gchar* _tmp31_;
						gchar* val = NULL;
#line 874 "../src/Utility/Device.vala"
						_tmp31_ = g_strdup (val_collection[val_it]);
#line 874 "../src/Utility/Device.vala"
						val = _tmp31_;
#line 5963 "Device.c"
						{
							const gchar* _tmp32_;
							gchar* _tmp33_;
							gchar* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gboolean _tmp37_;
							gint _tmp38_;
#line 876 "../src/Utility/Device.vala"
							_tmp32_ = val;
#line 876 "../src/Utility/Device.vala"
							_tmp33_ = string_strip (_tmp32_);
#line 876 "../src/Utility/Device.vala"
							_tmp34_ = _tmp33_;
#line 876 "../src/Utility/Device.vala"
							_tmp35_ = strlen (_tmp34_);
#line 876 "../src/Utility/Device.vala"
							_tmp36_ = _tmp35_;
#line 876 "../src/Utility/Device.vala"
							_tmp37_ = _tmp36_ == 0;
#line 876 "../src/Utility/Device.vala"
							_g_free0 (_tmp34_);
#line 876 "../src/Utility/Device.vala"
							if (_tmp37_) {
#line 876 "../src/Utility/Device.vala"
								_g_free0 (val);
#line 876 "../src/Utility/Device.vala"
								continue;
#line 5992 "Device.c"
							}
#line 878 "../src/Utility/Device.vala"
							_tmp38_ = k;
#line 878 "../src/Utility/Device.vala"
							k = _tmp38_ + 1;
#line 878 "../src/Utility/Device.vala"
							switch (_tmp38_) {
#line 878 "../src/Utility/Device.vala"
								case 1:
#line 6002 "Device.c"
								{
									Device* _tmp39_;
									const gchar* _tmp40_;
									gchar* _tmp41_;
#line 880 "../src/Utility/Device.vala"
									_tmp39_ = pi;
#line 880 "../src/Utility/Device.vala"
									_tmp40_ = val;
#line 880 "../src/Utility/Device.vala"
									_tmp41_ = string_strip (_tmp40_);
#line 880 "../src/Utility/Device.vala"
									_g_free0 (_tmp39_->device);
#line 880 "../src/Utility/Device.vala"
									_tmp39_->device = _tmp41_;
#line 881 "../src/Utility/Device.vala"
									break;
#line 6019 "Device.c"
								}
#line 878 "../src/Utility/Device.vala"
								case 2:
#line 6023 "Device.c"
								{
									Device* _tmp42_;
									const gchar* _tmp43_;
									gchar* _tmp44_;
#line 883 "../src/Utility/Device.vala"
									_tmp42_ = pi;
#line 883 "../src/Utility/Device.vala"
									_tmp43_ = val;
#line 883 "../src/Utility/Device.vala"
									_tmp44_ = string_strip (_tmp43_);
#line 883 "../src/Utility/Device.vala"
									_g_free0 (_tmp42_->fstype);
#line 883 "../src/Utility/Device.vala"
									_tmp42_->fstype = _tmp44_;
#line 884 "../src/Utility/Device.vala"
									break;
#line 6040 "Device.c"
								}
#line 878 "../src/Utility/Device.vala"
								case 3:
#line 6044 "Device.c"
								{
									Device* _tmp45_;
									const gchar* _tmp46_;
									gchar* _tmp47_;
									gchar* _tmp48_;
#line 886 "../src/Utility/Device.vala"
									_tmp45_ = pi;
#line 886 "../src/Utility/Device.vala"
									_tmp46_ = val;
#line 886 "../src/Utility/Device.vala"
									_tmp47_ = string_strip (_tmp46_);
#line 886 "../src/Utility/Device.vala"
									_tmp48_ = _tmp47_;
#line 886 "../src/Utility/Device.vala"
									_tmp45_->size_bytes = uint64_parse (_tmp48_, (guint) 0);
#line 886 "../src/Utility/Device.vala"
									_g_free0 (_tmp48_);
#line 887 "../src/Utility/Device.vala"
									break;
#line 6064 "Device.c"
								}
#line 878 "../src/Utility/Device.vala"
								case 4:
#line 6068 "Device.c"
								{
									Device* _tmp49_;
									const gchar* _tmp50_;
									gchar* _tmp51_;
									gchar* _tmp52_;
#line 889 "../src/Utility/Device.vala"
									_tmp49_ = pi;
#line 889 "../src/Utility/Device.vala"
									_tmp50_ = val;
#line 889 "../src/Utility/Device.vala"
									_tmp51_ = string_strip (_tmp50_);
#line 889 "../src/Utility/Device.vala"
									_tmp52_ = _tmp51_;
#line 889 "../src/Utility/Device.vala"
									_tmp49_->used_bytes = uint64_parse (_tmp52_, (guint) 0);
#line 889 "../src/Utility/Device.vala"
									_g_free0 (_tmp52_);
#line 890 "../src/Utility/Device.vala"
									break;
#line 6088 "Device.c"
								}
#line 878 "../src/Utility/Device.vala"
								case 5:
#line 6092 "Device.c"
								{
									Device* _tmp53_;
									const gchar* _tmp54_;
									gchar* _tmp55_;
									gchar* _tmp56_;
#line 892 "../src/Utility/Device.vala"
									_tmp53_ = pi;
#line 892 "../src/Utility/Device.vala"
									_tmp54_ = val;
#line 892 "../src/Utility/Device.vala"
									_tmp55_ = string_strip (_tmp54_);
#line 892 "../src/Utility/Device.vala"
									_tmp56_ = _tmp55_;
#line 892 "../src/Utility/Device.vala"
									_tmp53_->available_bytes = uint64_parse (_tmp56_, (guint) 0);
#line 892 "../src/Utility/Device.vala"
									_g_free0 (_tmp56_);
#line 893 "../src/Utility/Device.vala"
									break;
#line 6112 "Device.c"
								}
#line 878 "../src/Utility/Device.vala"
								case 6:
#line 6116 "Device.c"
								{
									Device* _tmp57_;
									const gchar* _tmp58_;
									gchar* _tmp59_;
#line 895 "../src/Utility/Device.vala"
									_tmp57_ = pi;
#line 895 "../src/Utility/Device.vala"
									_tmp58_ = val;
#line 895 "../src/Utility/Device.vala"
									_tmp59_ = string_strip (_tmp58_);
#line 895 "../src/Utility/Device.vala"
									_g_free0 (_tmp57_->used_percent);
#line 895 "../src/Utility/Device.vala"
									_tmp57_->used_percent = _tmp59_;
#line 896 "../src/Utility/Device.vala"
									break;
#line 6133 "Device.c"
								}
#line 878 "../src/Utility/Device.vala"
								case 7:
#line 6137 "Device.c"
								{
#line 902 "../src/Utility/Device.vala"
									break;
#line 6141 "Device.c"
								}
								default:
#line 878 "../src/Utility/Device.vala"
								break;
#line 6146 "Device.c"
							}
#line 874 "../src/Utility/Device.vala"
							_g_free0 (val);
#line 6150 "Device.c"
						}
					}
#line 874 "../src/Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 6155 "Device.c"
				}
#line 915 "../src/Utility/Device.vala"
				_tmp60_ = pi;
#line 915 "../src/Utility/Device.vala"
				_tmp61_ = pi;
#line 915 "../src/Utility/Device.vala"
				_tmp62_ = _tmp61_->device;
#line 915 "../src/Utility/Device.vala"
				_tmp63_ = device_resolve_device_name (_tmp62_);
#line 915 "../src/Utility/Device.vala"
				_g_free0 (_tmp60_->device);
#line 915 "../src/Utility/Device.vala"
				_tmp60_->device = _tmp63_;
#line 919 "../src/Utility/Device.vala"
				_tmp64_ = pi;
#line 919 "../src/Utility/Device.vala"
				_tmp65_ = pi;
#line 919 "../src/Utility/Device.vala"
				_tmp66_ = _tmp65_->device;
#line 919 "../src/Utility/Device.vala"
				_tmp67_ = device_get_device_uuid (_tmp66_);
#line 919 "../src/Utility/Device.vala"
				_g_free0 (_tmp64_->uuid);
#line 919 "../src/Utility/Device.vala"
				_tmp64_->uuid = _tmp67_;
#line 923 "../src/Utility/Device.vala"
				_tmp68_ = pi;
#line 923 "../src/Utility/Device.vala"
				_tmp69_ = _tmp68_->uuid;
#line 923 "../src/Utility/Device.vala"
				_tmp70_ = strlen (_tmp69_);
#line 923 "../src/Utility/Device.vala"
				_tmp71_ = _tmp70_;
#line 923 "../src/Utility/Device.vala"
				if (_tmp71_ > 0) {
#line 6191 "Device.c"
					GeeArrayList* _tmp72_;
					Device* _tmp73_;
#line 924 "../src/Utility/Device.vala"
					_tmp72_ = list;
#line 924 "../src/Utility/Device.vala"
					_tmp73_ = pi;
#line 924 "../src/Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp72_, _tmp73_);
#line 6200 "Device.c"
				}
#line 864 "../src/Utility/Device.vala"
				_g_object_unref0 (pi);
#line 864 "../src/Utility/Device.vala"
				_g_free0 (line);
#line 6206 "Device.c"
			}
		}
	}
#line 928 "../src/Utility/Device.vala"
	_tmp74_ = list;
#line 928 "../src/Utility/Device.vala"
	_tmp75_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp74_);
#line 928 "../src/Utility/Device.vala"
	_tmp76_ = _tmp75_;
#line 928 "../src/Utility/Device.vala"
	_tmp77_ = g_strdup_printf ("Device: get_disk_space_using_df(): %d", _tmp76_);
#line 928 "../src/Utility/Device.vala"
	_tmp78_ = _tmp77_;
#line 928 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp78_);
#line 928 "../src/Utility/Device.vala"
	_g_free0 (_tmp78_);
#line 930 "../src/Utility/Device.vala"
	result = list;
#line 930 "../src/Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 930 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 930 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 930 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 930 "../src/Utility/Device.vala"
	return result;
#line 6236 "Device.c"
}

GeeArrayList*
device_get_mounted_filesystems_using_mtab (void)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* mtab_path = NULL;
	gchar* _tmp1_;
	gchar* mtab_lines = NULL;
	gchar* _tmp2_;
	GFile* f = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar** lines = NULL;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint lines_length1;
	gint _lines_size_;
	GeeArrayList* mount_list = NULL;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp100_;
	gint _tmp101_;
	gint _tmp102_;
	gchar* _tmp103_;
	gchar* _tmp104_;
	GeeArrayList* result;
#line 938 "../src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 938 "../src/Utility/Device.vala"
	list = _tmp0_;
#line 940 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup ("/etc/mtab");
#line 940 "../src/Utility/Device.vala"
	mtab_path = _tmp1_;
#line 941 "../src/Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 941 "../src/Utility/Device.vala"
	mtab_lines = _tmp2_;
#line 947 "../src/Utility/Device.vala"
	_tmp3_ = g_strdup ("/proc/mounts");
#line 947 "../src/Utility/Device.vala"
	_g_free0 (mtab_path);
#line 947 "../src/Utility/Device.vala"
	mtab_path = _tmp3_;
#line 948 "../src/Utility/Device.vala"
	_tmp4_ = mtab_path;
#line 948 "../src/Utility/Device.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 948 "../src/Utility/Device.vala"
	_g_object_unref0 (f);
#line 948 "../src/Utility/Device.vala"
	f = _tmp5_;
#line 949 "../src/Utility/Device.vala"
	_tmp6_ = f;
#line 949 "../src/Utility/Device.vala"
	if (!g_file_query_exists (_tmp6_, NULL)) {
#line 6299 "Device.c"
		gchar* _tmp7_;
		const gchar* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
#line 950 "../src/Utility/Device.vala"
		_tmp7_ = g_strdup ("/proc/self/mounts");
#line 950 "../src/Utility/Device.vala"
		_g_free0 (mtab_path);
#line 950 "../src/Utility/Device.vala"
		mtab_path = _tmp7_;
#line 951 "../src/Utility/Device.vala"
		_tmp8_ = mtab_path;
#line 951 "../src/Utility/Device.vala"
		_tmp9_ = g_file_new_for_path (_tmp8_);
#line 951 "../src/Utility/Device.vala"
		_g_object_unref0 (f);
#line 951 "../src/Utility/Device.vala"
		f = _tmp9_;
#line 952 "../src/Utility/Device.vala"
		_tmp10_ = f;
#line 952 "../src/Utility/Device.vala"
		if (!g_file_query_exists (_tmp10_, NULL)) {
#line 6322 "Device.c"
			gchar* _tmp11_;
			const gchar* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
#line 953 "../src/Utility/Device.vala"
			_tmp11_ = g_strdup ("/etc/mtab");
#line 953 "../src/Utility/Device.vala"
			_g_free0 (mtab_path);
#line 953 "../src/Utility/Device.vala"
			mtab_path = _tmp11_;
#line 954 "../src/Utility/Device.vala"
			_tmp12_ = mtab_path;
#line 954 "../src/Utility/Device.vala"
			_tmp13_ = g_file_new_for_path (_tmp12_);
#line 954 "../src/Utility/Device.vala"
			_g_object_unref0 (f);
#line 954 "../src/Utility/Device.vala"
			f = _tmp13_;
#line 955 "../src/Utility/Device.vala"
			_tmp14_ = f;
#line 955 "../src/Utility/Device.vala"
			if (!g_file_query_exists (_tmp14_, NULL)) {
#line 956 "../src/Utility/Device.vala"
				result = list;
#line 956 "../src/Utility/Device.vala"
				_g_object_unref0 (f);
#line 956 "../src/Utility/Device.vala"
				_g_free0 (mtab_lines);
#line 956 "../src/Utility/Device.vala"
				_g_free0 (mtab_path);
#line 956 "../src/Utility/Device.vala"
				return result;
#line 6355 "Device.c"
			}
		}
	}
#line 969 "../src/Utility/Device.vala"
	_tmp15_ = mtab_path;
#line 969 "../src/Utility/Device.vala"
	_tmp16_ = tee_jee_file_system_file_read (_tmp15_);
#line 969 "../src/Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 969 "../src/Utility/Device.vala"
	mtab_lines = _tmp16_;
#line 998 "../src/Utility/Device.vala"
	_tmp17_ = mtab_lines;
#line 998 "../src/Utility/Device.vala"
	_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "\n", 0);
#line 998 "../src/Utility/Device.vala"
	lines = _tmp19_;
#line 998 "../src/Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp18_);
#line 998 "../src/Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 999 "../src/Utility/Device.vala"
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 999 "../src/Utility/Device.vala"
	mount_list = _tmp20_;
#line 6381 "Device.c"
	{
		gint i = 0;
		gchar** _tmp21_;
		gint _tmp21__length1;
#line 1001 "../src/Utility/Device.vala"
		_tmp21_ = lines;
#line 1001 "../src/Utility/Device.vala"
		_tmp21__length1 = lines_length1;
#line 1001 "../src/Utility/Device.vala"
		i = _tmp21__length1 - 1;
#line 6392 "Device.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1001 "../src/Utility/Device.vala"
			_tmp22_ = TRUE;
#line 1001 "../src/Utility/Device.vala"
			while (TRUE) {
#line 6399 "Device.c"
				gboolean ignoreEntry = FALSE;
				gchar* line = NULL;
				gchar** _tmp24_;
				gint _tmp24__length1;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				Device* pi = NULL;
				Device* _tmp30_;
				MountEntry* mp = NULL;
				Device* _tmp31_;
				MountEntry* _tmp32_;
				gint k = 0;
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gchar** _tmp35_;
				Device* _tmp69_;
				Device* _tmp70_;
				const gchar* _tmp71_;
				gchar* _tmp72_;
				Device* _tmp73_;
				Device* _tmp74_;
				const gchar* _tmp75_;
				gchar* _tmp76_;
				Device* _tmp77_;
				const gchar* _tmp78_;
				gint _tmp79_;
				gint _tmp80_;
#line 1001 "../src/Utility/Device.vala"
				if (!_tmp22_) {
#line 6432 "Device.c"
					gint _tmp23_;
#line 1001 "../src/Utility/Device.vala"
					_tmp23_ = i;
#line 1001 "../src/Utility/Device.vala"
					i = _tmp23_ - 1;
#line 6438 "Device.c"
				}
#line 1001 "../src/Utility/Device.vala"
				_tmp22_ = FALSE;
#line 1001 "../src/Utility/Device.vala"
				if (!(i >= 0)) {
#line 1001 "../src/Utility/Device.vala"
					break;
#line 6446 "Device.c"
				}
#line 1003 "../src/Utility/Device.vala"
				ignoreEntry = FALSE;
#line 1005 "../src/Utility/Device.vala"
				_tmp24_ = lines;
#line 1005 "../src/Utility/Device.vala"
				_tmp24__length1 = lines_length1;
#line 1005 "../src/Utility/Device.vala"
				_tmp25_ = _tmp24_[i];
#line 1005 "../src/Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 1005 "../src/Utility/Device.vala"
				line = _tmp26_;
#line 1006 "../src/Utility/Device.vala"
				_tmp27_ = line;
#line 1006 "../src/Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 1006 "../src/Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 1006 "../src/Utility/Device.vala"
				if (_tmp29_ == 0) {
#line 1006 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 1006 "../src/Utility/Device.vala"
					continue;
#line 6472 "Device.c"
				}
#line 1008 "../src/Utility/Device.vala"
				_tmp30_ = device_new ();
#line 1008 "../src/Utility/Device.vala"
				pi = _tmp30_;
#line 1010 "../src/Utility/Device.vala"
				_tmp31_ = pi;
#line 1010 "../src/Utility/Device.vala"
				_tmp32_ = mount_entry_new (_tmp31_, "", "");
#line 1010 "../src/Utility/Device.vala"
				mp = _tmp32_;
#line 1014 "../src/Utility/Device.vala"
				k = 1;
#line 1015 "../src/Utility/Device.vala"
				_tmp33_ = line;
#line 1015 "../src/Utility/Device.vala"
				_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, " ", 0);
#line 6490 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 1015 "../src/Utility/Device.vala"
					val_collection = _tmp35_;
#line 1015 "../src/Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp34_);
#line 1015 "../src/Utility/Device.vala"
					for (val_it = 0; val_it < val_collection_length1; val_it = val_it + 1) {
#line 6502 "Device.c"
						gchar* _tmp36_;
						gchar* val = NULL;
#line 1015 "../src/Utility/Device.vala"
						_tmp36_ = g_strdup (val_collection[val_it]);
#line 1015 "../src/Utility/Device.vala"
						val = _tmp36_;
#line 6509 "Device.c"
						{
							const gchar* _tmp37_;
							gchar* _tmp38_;
							gchar* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							gboolean _tmp42_;
							gint _tmp43_;
#line 1016 "../src/Utility/Device.vala"
							_tmp37_ = val;
#line 1016 "../src/Utility/Device.vala"
							_tmp38_ = string_strip (_tmp37_);
#line 1016 "../src/Utility/Device.vala"
							_tmp39_ = _tmp38_;
#line 1016 "../src/Utility/Device.vala"
							_tmp40_ = strlen (_tmp39_);
#line 1016 "../src/Utility/Device.vala"
							_tmp41_ = _tmp40_;
#line 1016 "../src/Utility/Device.vala"
							_tmp42_ = _tmp41_ == 0;
#line 1016 "../src/Utility/Device.vala"
							_g_free0 (_tmp39_);
#line 1016 "../src/Utility/Device.vala"
							if (_tmp42_) {
#line 1016 "../src/Utility/Device.vala"
								_g_free0 (val);
#line 1016 "../src/Utility/Device.vala"
								continue;
#line 6538 "Device.c"
							}
#line 1017 "../src/Utility/Device.vala"
							if (ignoreEntry) {
#line 1017 "../src/Utility/Device.vala"
								_g_free0 (val);
#line 1017 "../src/Utility/Device.vala"
								break;
#line 6546 "Device.c"
							}
#line 1018 "../src/Utility/Device.vala"
							_tmp43_ = k;
#line 1018 "../src/Utility/Device.vala"
							k = _tmp43_ + 1;
#line 1018 "../src/Utility/Device.vala"
							switch (_tmp43_) {
#line 1018 "../src/Utility/Device.vala"
								case 1:
#line 6556 "Device.c"
								{
									Device* _tmp44_;
									const gchar* _tmp45_;
									gchar* _tmp46_;
#line 1020 "../src/Utility/Device.vala"
									_tmp44_ = pi;
#line 1020 "../src/Utility/Device.vala"
									_tmp45_ = val;
#line 1020 "../src/Utility/Device.vala"
									_tmp46_ = string_strip (_tmp45_);
#line 1020 "../src/Utility/Device.vala"
									_g_free0 (_tmp44_->device);
#line 1020 "../src/Utility/Device.vala"
									_tmp44_->device = _tmp46_;
#line 1021 "../src/Utility/Device.vala"
									break;
#line 6573 "Device.c"
								}
#line 1018 "../src/Utility/Device.vala"
								case 2:
#line 6577 "Device.c"
								{
									MountEntry* _tmp47_;
									const gchar* _tmp48_;
									gchar* _tmp49_;
									gchar* _tmp50_;
									gchar* _tmp51_;
									MountEntry* _tmp52_;
									const gchar* _tmp53_;
									GeeArrayList* _tmp54_;
									MountEntry* _tmp55_;
									const gchar* _tmp56_;
#line 1023 "../src/Utility/Device.vala"
									_tmp47_ = mp;
#line 1023 "../src/Utility/Device.vala"
									_tmp48_ = val;
#line 1023 "../src/Utility/Device.vala"
									_tmp49_ = string_strip (_tmp48_);
#line 1023 "../src/Utility/Device.vala"
									_tmp50_ = _tmp49_;
#line 1023 "../src/Utility/Device.vala"
									_tmp51_ = string_replace (_tmp50_, "\\040", " ");
#line 1023 "../src/Utility/Device.vala"
									_g_free0 (_tmp47_->mount_point);
#line 1023 "../src/Utility/Device.vala"
									_tmp47_->mount_point = _tmp51_;
#line 1023 "../src/Utility/Device.vala"
									_g_free0 (_tmp50_);
#line 1026 "../src/Utility/Device.vala"
									_tmp52_ = mp;
#line 1026 "../src/Utility/Device.vala"
									_tmp53_ = _tmp52_->mount_point;
#line 1026 "../src/Utility/Device.vala"
									if (string_contains (_tmp53_, "/docker")) {
#line 1027 "../src/Utility/Device.vala"
										ignoreEntry = TRUE;
#line 1028 "../src/Utility/Device.vala"
										break;
#line 6615 "Device.c"
									}
#line 1031 "../src/Utility/Device.vala"
									_tmp54_ = mount_list;
#line 1031 "../src/Utility/Device.vala"
									_tmp55_ = mp;
#line 1031 "../src/Utility/Device.vala"
									_tmp56_ = _tmp55_->mount_point;
#line 1031 "../src/Utility/Device.vala"
									if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp54_, _tmp56_)) {
#line 6625 "Device.c"
										GeeArrayList* _tmp57_;
										MountEntry* _tmp58_;
										const gchar* _tmp59_;
										Device* _tmp60_;
										GeeArrayList* _tmp61_;
										MountEntry* _tmp62_;
#line 1032 "../src/Utility/Device.vala"
										_tmp57_ = mount_list;
#line 1032 "../src/Utility/Device.vala"
										_tmp58_ = mp;
#line 1032 "../src/Utility/Device.vala"
										_tmp59_ = _tmp58_->mount_point;
#line 1032 "../src/Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp57_, _tmp59_);
#line 1033 "../src/Utility/Device.vala"
										_tmp60_ = pi;
#line 1033 "../src/Utility/Device.vala"
										_tmp61_ = _tmp60_->mount_points;
#line 1033 "../src/Utility/Device.vala"
										_tmp62_ = mp;
#line 1033 "../src/Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, _tmp62_);
#line 6648 "Device.c"
									}
#line 1035 "../src/Utility/Device.vala"
									break;
#line 6652 "Device.c"
								}
#line 1018 "../src/Utility/Device.vala"
								case 3:
#line 6656 "Device.c"
								{
									Device* _tmp63_;
									const gchar* _tmp64_;
									gchar* _tmp65_;
#line 1037 "../src/Utility/Device.vala"
									_tmp63_ = pi;
#line 1037 "../src/Utility/Device.vala"
									_tmp64_ = val;
#line 1037 "../src/Utility/Device.vala"
									_tmp65_ = string_strip (_tmp64_);
#line 1037 "../src/Utility/Device.vala"
									_g_free0 (_tmp63_->fstype);
#line 1037 "../src/Utility/Device.vala"
									_tmp63_->fstype = _tmp65_;
#line 1038 "../src/Utility/Device.vala"
									break;
#line 6673 "Device.c"
								}
#line 1018 "../src/Utility/Device.vala"
								case 4:
#line 6677 "Device.c"
								{
									MountEntry* _tmp66_;
									const gchar* _tmp67_;
									gchar* _tmp68_;
#line 1040 "../src/Utility/Device.vala"
									_tmp66_ = mp;
#line 1040 "../src/Utility/Device.vala"
									_tmp67_ = val;
#line 1040 "../src/Utility/Device.vala"
									_tmp68_ = string_strip (_tmp67_);
#line 1040 "../src/Utility/Device.vala"
									_g_free0 (_tmp66_->mount_options);
#line 1040 "../src/Utility/Device.vala"
									_tmp66_->mount_options = _tmp68_;
#line 1041 "../src/Utility/Device.vala"
									break;
#line 6694 "Device.c"
								}
								default:
								{
#line 1044 "../src/Utility/Device.vala"
									break;
#line 6700 "Device.c"
								}
							}
#line 1015 "../src/Utility/Device.vala"
							_g_free0 (val);
#line 6705 "Device.c"
						}
					}
#line 1015 "../src/Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 6710 "Device.c"
				}
#line 1048 "../src/Utility/Device.vala"
				if (ignoreEntry) {
#line 1048 "../src/Utility/Device.vala"
					_g_object_unref0 (mp);
#line 1048 "../src/Utility/Device.vala"
					_g_object_unref0 (pi);
#line 1048 "../src/Utility/Device.vala"
					_g_free0 (line);
#line 1048 "../src/Utility/Device.vala"
					continue;
#line 6722 "Device.c"
				}
#line 1052 "../src/Utility/Device.vala"
				_tmp69_ = pi;
#line 1052 "../src/Utility/Device.vala"
				_tmp70_ = pi;
#line 1052 "../src/Utility/Device.vala"
				_tmp71_ = _tmp70_->device;
#line 1052 "../src/Utility/Device.vala"
				_tmp72_ = device_resolve_device_name (_tmp71_);
#line 1052 "../src/Utility/Device.vala"
				_g_free0 (_tmp69_->device);
#line 1052 "../src/Utility/Device.vala"
				_tmp69_->device = _tmp72_;
#line 1056 "../src/Utility/Device.vala"
				_tmp73_ = pi;
#line 1056 "../src/Utility/Device.vala"
				_tmp74_ = pi;
#line 1056 "../src/Utility/Device.vala"
				_tmp75_ = _tmp74_->device;
#line 1056 "../src/Utility/Device.vala"
				_tmp76_ = device_get_device_uuid (_tmp75_);
#line 1056 "../src/Utility/Device.vala"
				_g_free0 (_tmp73_->uuid);
#line 1056 "../src/Utility/Device.vala"
				_tmp73_->uuid = _tmp76_;
#line 1060 "../src/Utility/Device.vala"
				_tmp77_ = pi;
#line 1060 "../src/Utility/Device.vala"
				_tmp78_ = _tmp77_->uuid;
#line 1060 "../src/Utility/Device.vala"
				_tmp79_ = strlen (_tmp78_);
#line 1060 "../src/Utility/Device.vala"
				_tmp80_ = _tmp79_;
#line 1060 "../src/Utility/Device.vala"
				if (_tmp80_ > 0) {
#line 6758 "Device.c"
					Device* dev = NULL;
					GeeArrayList* _tmp81_;
					Device* _tmp82_;
					const gchar* _tmp83_;
					Device* _tmp84_;
					Device* _tmp85_;
#line 1061 "../src/Utility/Device.vala"
					_tmp81_ = list;
#line 1061 "../src/Utility/Device.vala"
					_tmp82_ = pi;
#line 1061 "../src/Utility/Device.vala"
					_tmp83_ = _tmp82_->uuid;
#line 1061 "../src/Utility/Device.vala"
					_tmp84_ = device_find_device_in_list (_tmp81_, _tmp83_);
#line 1061 "../src/Utility/Device.vala"
					dev = _tmp84_;
#line 1062 "../src/Utility/Device.vala"
					_tmp85_ = dev;
#line 1062 "../src/Utility/Device.vala"
					if (_tmp85_ == NULL) {
#line 6779 "Device.c"
						GeeArrayList* _tmp86_;
						Device* _tmp87_;
#line 1063 "../src/Utility/Device.vala"
						_tmp86_ = list;
#line 1063 "../src/Utility/Device.vala"
						_tmp87_ = pi;
#line 1063 "../src/Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp86_, _tmp87_);
#line 6788 "Device.c"
					} else {
						{
							GeeArrayList* _item_list = NULL;
							Device* _tmp88_;
							GeeArrayList* _tmp89_;
							gint _item_size = 0;
							GeeArrayList* _tmp90_;
							gint _tmp91_;
							gint _tmp92_;
							gint _item_index = 0;
#line 1067 "../src/Utility/Device.vala"
							_tmp88_ = pi;
#line 1067 "../src/Utility/Device.vala"
							_tmp89_ = _tmp88_->mount_points;
#line 1067 "../src/Utility/Device.vala"
							_item_list = _tmp89_;
#line 1067 "../src/Utility/Device.vala"
							_tmp90_ = _item_list;
#line 1067 "../src/Utility/Device.vala"
							_tmp91_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp90_);
#line 1067 "../src/Utility/Device.vala"
							_tmp92_ = _tmp91_;
#line 1067 "../src/Utility/Device.vala"
							_item_size = _tmp92_;
#line 1067 "../src/Utility/Device.vala"
							_item_index = -1;
#line 1067 "../src/Utility/Device.vala"
							while (TRUE) {
#line 6817 "Device.c"
								gint _tmp93_;
								gint _tmp94_;
								MountEntry* item = NULL;
								GeeArrayList* _tmp95_;
								gpointer _tmp96_;
								Device* _tmp97_;
								GeeArrayList* _tmp98_;
								MountEntry* _tmp99_;
#line 1067 "../src/Utility/Device.vala"
								_item_index = _item_index + 1;
#line 1067 "../src/Utility/Device.vala"
								_tmp93_ = _item_index;
#line 1067 "../src/Utility/Device.vala"
								_tmp94_ = _item_size;
#line 1067 "../src/Utility/Device.vala"
								if (!(_tmp93_ < _tmp94_)) {
#line 1067 "../src/Utility/Device.vala"
									break;
#line 6836 "Device.c"
								}
#line 1067 "../src/Utility/Device.vala"
								_tmp95_ = _item_list;
#line 1067 "../src/Utility/Device.vala"
								_tmp96_ = gee_abstract_list_get ((GeeAbstractList*) _tmp95_, _item_index);
#line 1067 "../src/Utility/Device.vala"
								item = (MountEntry*) _tmp96_;
#line 1068 "../src/Utility/Device.vala"
								_tmp97_ = dev;
#line 1068 "../src/Utility/Device.vala"
								_tmp98_ = _tmp97_->mount_points;
#line 1068 "../src/Utility/Device.vala"
								_tmp99_ = item;
#line 1068 "../src/Utility/Device.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp98_, _tmp99_);
#line 1067 "../src/Utility/Device.vala"
								_g_object_unref0 (item);
#line 6854 "Device.c"
							}
						}
					}
#line 1060 "../src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 6860 "Device.c"
				}
#line 1001 "../src/Utility/Device.vala"
				_g_object_unref0 (mp);
#line 1001 "../src/Utility/Device.vala"
				_g_object_unref0 (pi);
#line 1001 "../src/Utility/Device.vala"
				_g_free0 (line);
#line 6868 "Device.c"
			}
		}
	}
#line 1074 "../src/Utility/Device.vala"
	_tmp100_ = list;
#line 1074 "../src/Utility/Device.vala"
	_tmp101_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp100_);
#line 1074 "../src/Utility/Device.vala"
	_tmp102_ = _tmp101_;
#line 1074 "../src/Utility/Device.vala"
	_tmp103_ = g_strdup_printf ("Device: get_mounted_filesystems_using_mtab(): %d", _tmp102_);
#line 1074 "../src/Utility/Device.vala"
	_tmp104_ = _tmp103_;
#line 1074 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp104_);
#line 1074 "../src/Utility/Device.vala"
	_g_free0 (_tmp104_);
#line 1076 "../src/Utility/Device.vala"
	result = list;
#line 1076 "../src/Utility/Device.vala"
	_g_object_unref0 (mount_list);
#line 1076 "../src/Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 1076 "../src/Utility/Device.vala"
	_g_object_unref0 (f);
#line 1076 "../src/Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 1076 "../src/Utility/Device.vala"
	_g_free0 (mtab_path);
#line 1076 "../src/Utility/Device.vala"
	return result;
#line 6900 "Device.c"
}

Device*
device_get_device_by_uuid (const gchar* uuid)
{
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
	Device* result;
#line 1081 "../src/Utility/Device.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 1083 "../src/Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1083 "../src/Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, uuid);
#line 1083 "../src/Utility/Device.vala"
	result = _tmp1_;
#line 1083 "../src/Utility/Device.vala"
	return result;
#line 6919 "Device.c"
}

Device*
device_get_device_by_name (const gchar* file_name)
{
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
	Device* result;
#line 1086 "../src/Utility/Device.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 1088 "../src/Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1088 "../src/Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, file_name);
#line 1088 "../src/Utility/Device.vala"
	result = _tmp1_;
#line 1088 "../src/Utility/Device.vala"
	return result;
#line 6938 "Device.c"
}

Device*
device_get_device_by_path (const gchar* path_to_check)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Device* result;
#line 1091 "../src/Utility/Device.vala"
	g_return_val_if_fail (path_to_check != NULL, NULL);
#line 1093 "../src/Utility/Device.vala"
	_tmp0_ = device_get_disk_space_using_df (path_to_check);
#line 1093 "../src/Utility/Device.vala"
	list = _tmp0_;
#line 1095 "../src/Utility/Device.vala"
	_tmp1_ = list;
#line 1095 "../src/Utility/Device.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1095 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1095 "../src/Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 6964 "Device.c"
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
#line 1096 "../src/Utility/Device.vala"
		_tmp4_ = list;
#line 1096 "../src/Utility/Device.vala"
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, 0);
#line 1096 "../src/Utility/Device.vala"
		result = (Device*) _tmp5_;
#line 1096 "../src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1096 "../src/Utility/Device.vala"
		return result;
#line 6977 "Device.c"
	}
#line 1099 "../src/Utility/Device.vala"
	result = NULL;
#line 1099 "../src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1099 "../src/Utility/Device.vala"
	return result;
#line 6985 "Device.c"
}

gchar*
device_get_device_uuid (const gchar* device)
{
	GeeArrayList* _tmp0_;
	gchar* _tmp15_;
	gchar* result;
#line 1102 "../src/Utility/Device.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 1104 "../src/Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1104 "../src/Utility/Device.vala"
	if (_tmp0_ == NULL) {
#line 7000 "Device.c"
		GeeArrayList* _tmp1_;
#line 1105 "../src/Utility/Device.vala"
		_tmp1_ = device_get_block_devices_using_lsblk ("");
#line 1105 "../src/Utility/Device.vala"
		_g_object_unref0 (device_device_list);
#line 1105 "../src/Utility/Device.vala"
		device_device_list = _tmp1_;
#line 7008 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
#line 1107 "../src/Utility/Device.vala"
		_tmp2_ = device_device_list;
#line 1107 "../src/Utility/Device.vala"
		_dev_list = _tmp2_;
#line 1107 "../src/Utility/Device.vala"
		_tmp3_ = _dev_list;
#line 1107 "../src/Utility/Device.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1107 "../src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1107 "../src/Utility/Device.vala"
		_dev_size = _tmp5_;
#line 1107 "../src/Utility/Device.vala"
		_dev_index = -1;
#line 1107 "../src/Utility/Device.vala"
		while (TRUE) {
#line 7034 "Device.c"
			gint _tmp6_;
			gint _tmp7_;
			Device* dev = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			Device* _tmp10_;
			const gchar* _tmp11_;
#line 1107 "../src/Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1107 "../src/Utility/Device.vala"
			_tmp6_ = _dev_index;
#line 1107 "../src/Utility/Device.vala"
			_tmp7_ = _dev_size;
#line 1107 "../src/Utility/Device.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 1107 "../src/Utility/Device.vala"
				break;
#line 7052 "Device.c"
			}
#line 1107 "../src/Utility/Device.vala"
			_tmp8_ = _dev_list;
#line 1107 "../src/Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_index);
#line 1107 "../src/Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 1108 "../src/Utility/Device.vala"
			_tmp10_ = dev;
#line 1108 "../src/Utility/Device.vala"
			_tmp11_ = _tmp10_->device;
#line 1108 "../src/Utility/Device.vala"
			if (g_strcmp0 (_tmp11_, device) == 0) {
#line 7066 "Device.c"
				Device* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 1109 "../src/Utility/Device.vala"
				_tmp12_ = dev;
#line 1109 "../src/Utility/Device.vala"
				_tmp13_ = _tmp12_->uuid;
#line 1109 "../src/Utility/Device.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 1109 "../src/Utility/Device.vala"
				result = _tmp14_;
#line 1109 "../src/Utility/Device.vala"
				_g_object_unref0 (dev);
#line 1109 "../src/Utility/Device.vala"
				return result;
#line 7082 "Device.c"
			}
#line 1107 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7086 "Device.c"
		}
	}
#line 1113 "../src/Utility/Device.vala"
	_tmp15_ = g_strdup ("");
#line 1113 "../src/Utility/Device.vala"
	result = _tmp15_;
#line 1113 "../src/Utility/Device.vala"
	return result;
#line 7095 "Device.c"
}

GeeArrayList*
device_get_device_mount_points (const gchar* dev_name_or_uuid)
{
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	GeeArrayList* list_mtab = NULL;
	GeeArrayList* _tmp9_;
	Device* dev = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	Device* _tmp12_;
	Device* _tmp13_;
	GeeArrayList* result;
#line 1116 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 1117 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1117 "../src/Utility/Device.vala"
	device = _tmp0_;
#line 1118 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1118 "../src/Utility/Device.vala"
	uuid = _tmp1_;
#line 1120 "../src/Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 7125 "Device.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1121 "../src/Utility/Device.vala"
		_tmp2_ = g_strdup (dev_name_or_uuid);
#line 1121 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1121 "../src/Utility/Device.vala"
		device = _tmp2_;
#line 1122 "../src/Utility/Device.vala"
		_tmp3_ = device_get_device_uuid (dev_name_or_uuid);
#line 1122 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1122 "../src/Utility/Device.vala"
		uuid = _tmp3_;
#line 7140 "Device.c"
	} else {
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1125 "../src/Utility/Device.vala"
		_tmp4_ = g_strdup (dev_name_or_uuid);
#line 1125 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1125 "../src/Utility/Device.vala"
		uuid = _tmp4_;
#line 1126 "../src/Utility/Device.vala"
		_tmp5_ = uuid;
#line 1126 "../src/Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp5_);
#line 1126 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1126 "../src/Utility/Device.vala"
		device = _tmp6_;
#line 1127 "../src/Utility/Device.vala"
		_tmp7_ = device;
#line 1127 "../src/Utility/Device.vala"
		_tmp8_ = device_resolve_device_name (_tmp7_);
#line 1127 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1127 "../src/Utility/Device.vala"
		device = _tmp8_;
#line 7169 "Device.c"
	}
#line 1130 "../src/Utility/Device.vala"
	_tmp9_ = device_get_mounted_filesystems_using_mtab ();
#line 1130 "../src/Utility/Device.vala"
	list_mtab = _tmp9_;
#line 1132 "../src/Utility/Device.vala"
	_tmp10_ = list_mtab;
#line 1132 "../src/Utility/Device.vala"
	_tmp11_ = uuid;
#line 1132 "../src/Utility/Device.vala"
	_tmp12_ = device_find_device_in_list (_tmp10_, _tmp11_);
#line 1132 "../src/Utility/Device.vala"
	dev = _tmp12_;
#line 1134 "../src/Utility/Device.vala"
	_tmp13_ = dev;
#line 1134 "../src/Utility/Device.vala"
	if (_tmp13_ != NULL) {
#line 7187 "Device.c"
		Device* _tmp14_;
		GeeArrayList* _tmp15_;
		GeeArrayList* _tmp16_;
#line 1135 "../src/Utility/Device.vala"
		_tmp14_ = dev;
#line 1135 "../src/Utility/Device.vala"
		_tmp15_ = _tmp14_->mount_points;
#line 1135 "../src/Utility/Device.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 1135 "../src/Utility/Device.vala"
		result = _tmp16_;
#line 1135 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1135 "../src/Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1135 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1135 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1135 "../src/Utility/Device.vala"
		return result;
#line 7209 "Device.c"
	} else {
		GeeArrayList* _tmp17_;
#line 1138 "../src/Utility/Device.vala"
		_tmp17_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1138 "../src/Utility/Device.vala"
		result = _tmp17_;
#line 1138 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1138 "../src/Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1138 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1138 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1138 "../src/Utility/Device.vala"
		return result;
#line 7226 "Device.c"
	}
}

gboolean
device_device_is_mounted (const gchar* dev_name_or_uuid)
{
	GeeArrayList* mps = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean result;
#line 1142 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1144 "../src/Utility/Device.vala"
	_tmp0_ = device_get_device_mount_points (dev_name_or_uuid);
#line 1144 "../src/Utility/Device.vala"
	mps = _tmp0_;
#line 1145 "../src/Utility/Device.vala"
	_tmp1_ = mps;
#line 1145 "../src/Utility/Device.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1145 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1145 "../src/Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 1146 "../src/Utility/Device.vala"
		result = TRUE;
#line 1146 "../src/Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1146 "../src/Utility/Device.vala"
		return result;
#line 7259 "Device.c"
	}
#line 1149 "../src/Utility/Device.vala"
	result = FALSE;
#line 1149 "../src/Utility/Device.vala"
	_g_object_unref0 (mps);
#line 1149 "../src/Utility/Device.vala"
	return result;
#line 7267 "Device.c"
}

gboolean
device_mount_point_in_use (const gchar* mount_point)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gboolean result;
#line 1152 "../src/Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1153 "../src/Utility/Device.vala"
	_tmp0_ = device_get_mounted_filesystems_using_mtab ();
#line 1153 "../src/Utility/Device.vala"
	list = _tmp0_;
#line 7282 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		gint _dev_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _dev_index = 0;
#line 1154 "../src/Utility/Device.vala"
		_tmp1_ = list;
#line 1154 "../src/Utility/Device.vala"
		_dev_list = _tmp1_;
#line 1154 "../src/Utility/Device.vala"
		_tmp2_ = _dev_list;
#line 1154 "../src/Utility/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 1154 "../src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 1154 "../src/Utility/Device.vala"
		_dev_size = _tmp4_;
#line 1154 "../src/Utility/Device.vala"
		_dev_index = -1;
#line 1154 "../src/Utility/Device.vala"
		while (TRUE) {
#line 7307 "Device.c"
			gint _tmp5_;
			gint _tmp6_;
			Device* dev = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
#line 1154 "../src/Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1154 "../src/Utility/Device.vala"
			_tmp5_ = _dev_index;
#line 1154 "../src/Utility/Device.vala"
			_tmp6_ = _dev_size;
#line 1154 "../src/Utility/Device.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1154 "../src/Utility/Device.vala"
				break;
#line 7323 "Device.c"
			}
#line 1154 "../src/Utility/Device.vala"
			_tmp7_ = _dev_list;
#line 1154 "../src/Utility/Device.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_index);
#line 1154 "../src/Utility/Device.vala"
			dev = (Device*) _tmp8_;
#line 7331 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp9_;
				GeeArrayList* _tmp10_;
				gint _mp_size = 0;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _mp_index = 0;
#line 1155 "../src/Utility/Device.vala"
				_tmp9_ = dev;
#line 1155 "../src/Utility/Device.vala"
				_tmp10_ = _tmp9_->mount_points;
#line 1155 "../src/Utility/Device.vala"
				_mp_list = _tmp10_;
#line 1155 "../src/Utility/Device.vala"
				_tmp11_ = _mp_list;
#line 1155 "../src/Utility/Device.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 1155 "../src/Utility/Device.vala"
				_tmp13_ = _tmp12_;
#line 1155 "../src/Utility/Device.vala"
				_mp_size = _tmp13_;
#line 1155 "../src/Utility/Device.vala"
				_mp_index = -1;
#line 1155 "../src/Utility/Device.vala"
				while (TRUE) {
#line 7359 "Device.c"
					gint _tmp14_;
					gint _tmp15_;
					MountEntry* mp = NULL;
					GeeArrayList* _tmp16_;
					gpointer _tmp17_;
					MountEntry* _tmp18_;
					const gchar* _tmp19_;
#line 1155 "../src/Utility/Device.vala"
					_mp_index = _mp_index + 1;
#line 1155 "../src/Utility/Device.vala"
					_tmp14_ = _mp_index;
#line 1155 "../src/Utility/Device.vala"
					_tmp15_ = _mp_size;
#line 1155 "../src/Utility/Device.vala"
					if (!(_tmp14_ < _tmp15_)) {
#line 1155 "../src/Utility/Device.vala"
						break;
#line 7377 "Device.c"
					}
#line 1155 "../src/Utility/Device.vala"
					_tmp16_ = _mp_list;
#line 1155 "../src/Utility/Device.vala"
					_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _mp_index);
#line 1155 "../src/Utility/Device.vala"
					mp = (MountEntry*) _tmp17_;
#line 1156 "../src/Utility/Device.vala"
					_tmp18_ = mp;
#line 1156 "../src/Utility/Device.vala"
					_tmp19_ = _tmp18_->mount_point;
#line 1156 "../src/Utility/Device.vala"
					if (g_str_has_prefix (_tmp19_, mount_point)) {
#line 1158 "../src/Utility/Device.vala"
						result = TRUE;
#line 1158 "../src/Utility/Device.vala"
						_g_object_unref0 (mp);
#line 1158 "../src/Utility/Device.vala"
						_g_object_unref0 (dev);
#line 1158 "../src/Utility/Device.vala"
						_g_object_unref0 (list);
#line 1158 "../src/Utility/Device.vala"
						return result;
#line 7401 "Device.c"
					}
#line 1155 "../src/Utility/Device.vala"
					_g_object_unref0 (mp);
#line 7405 "Device.c"
				}
			}
#line 1154 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7410 "Device.c"
		}
	}
#line 1162 "../src/Utility/Device.vala"
	result = FALSE;
#line 1162 "../src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1162 "../src/Utility/Device.vala"
	return result;
#line 7419 "Device.c"
}

gchar*
device_resolve_device_name (const gchar* dev_alias)
{
	Device* dev = NULL;
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
	Device* _tmp2_;
	gchar* result;
#line 1165 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_alias != NULL, NULL);
#line 1167 "../src/Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1167 "../src/Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, dev_alias);
#line 1167 "../src/Utility/Device.vala"
	dev = _tmp1_;
#line 1169 "../src/Utility/Device.vala"
	_tmp2_ = dev;
#line 1169 "../src/Utility/Device.vala"
	if (_tmp2_ != NULL) {
#line 7442 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 1170 "../src/Utility/Device.vala"
		_tmp3_ = dev;
#line 1170 "../src/Utility/Device.vala"
		_tmp4_ = _tmp3_->device;
#line 1170 "../src/Utility/Device.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 1170 "../src/Utility/Device.vala"
		result = _tmp5_;
#line 1170 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1170 "../src/Utility/Device.vala"
		return result;
#line 7458 "Device.c"
	} else {
		gchar* _tmp6_;
#line 1173 "../src/Utility/Device.vala"
		_tmp6_ = g_strdup (dev_alias);
#line 1173 "../src/Utility/Device.vala"
		result = _tmp6_;
#line 1173 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1173 "../src/Utility/Device.vala"
		return result;
#line 7469 "Device.c"
	}
}

Device*
device_find_device_in_list (GeeArrayList* list,
                            const gchar* _dev_alias)
{
	gchar* dev_alias = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	Device* result;
#line 1177 "../src/Utility/Device.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 1177 "../src/Utility/Device.vala"
	g_return_val_if_fail (_dev_alias != NULL, NULL);
#line 1179 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup (_dev_alias);
#line 1179 "../src/Utility/Device.vala"
	dev_alias = _tmp0_;
#line 1181 "../src/Utility/Device.vala"
	_tmp1_ = dev_alias;
#line 1181 "../src/Utility/Device.vala"
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) -1);
#line 1181 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1181 "../src/Utility/Device.vala"
	_tmp4_ = g_str_has_prefix (_tmp3_, "uuid=");
#line 1181 "../src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1181 "../src/Utility/Device.vala"
	if (_tmp4_) {
#line 7504 "Device.c"
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 1183 "../src/Utility/Device.vala"
		_tmp5_ = dev_alias;
#line 1183 "../src/Utility/Device.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "=", 2);
#line 1183 "../src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1183 "../src/Utility/Device.vala"
		_tmp8__length1 = _vala_array_length (_tmp6_);
#line 1183 "../src/Utility/Device.vala"
		_tmp9_ = _tmp8_[1];
#line 1183 "../src/Utility/Device.vala"
		_tmp10_ = string_strip (_tmp9_);
#line 1183 "../src/Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1183 "../src/Utility/Device.vala"
		_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 1183 "../src/Utility/Device.vala"
		_g_free0 (dev_alias);
#line 1183 "../src/Utility/Device.vala"
		dev_alias = _tmp12_;
#line 1183 "../src/Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1183 "../src/Utility/Device.vala"
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 7538 "Device.c"
	} else {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 1185 "../src/Utility/Device.vala"
		_tmp14_ = dev_alias;
#line 1185 "../src/Utility/Device.vala"
		if (tee_jee_file_system_file_exists (_tmp14_)) {
#line 7546 "Device.c"
			const gchar* _tmp15_;
#line 1185 "../src/Utility/Device.vala"
			_tmp15_ = dev_alias;
#line 1185 "../src/Utility/Device.vala"
			_tmp13_ = tee_jee_file_system_file_is_symlink (_tmp15_);
#line 7552 "Device.c"
		} else {
#line 1185 "../src/Utility/Device.vala"
			_tmp13_ = FALSE;
#line 7556 "Device.c"
		}
#line 1185 "../src/Utility/Device.vala"
		if (_tmp13_) {
#line 7560 "Device.c"
			gchar* link_path = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 1187 "../src/Utility/Device.vala"
			_tmp16_ = dev_alias;
#line 1187 "../src/Utility/Device.vala"
			_tmp17_ = tee_jee_file_system_file_get_symlink_target (_tmp16_);
#line 1187 "../src/Utility/Device.vala"
			link_path = _tmp17_;
#line 1189 "../src/Utility/Device.vala"
			_tmp18_ = link_path;
#line 1189 "../src/Utility/Device.vala"
			_tmp19_ = string_replace (_tmp18_, "../../../", "/dev/");
#line 1189 "../src/Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1189 "../src/Utility/Device.vala"
			_tmp21_ = string_replace (_tmp20_, "../../", "/dev/");
#line 1189 "../src/Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1189 "../src/Utility/Device.vala"
			_tmp23_ = string_replace (_tmp22_, "../", "/dev/");
#line 1189 "../src/Utility/Device.vala"
			_g_free0 (dev_alias);
#line 1189 "../src/Utility/Device.vala"
			dev_alias = _tmp23_;
#line 1189 "../src/Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 1189 "../src/Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1185 "../src/Utility/Device.vala"
			_g_free0 (link_path);
#line 7598 "Device.c"
		}
	}
	{
		GeeArrayList* _dev_list = NULL;
		gint _dev_size = 0;
		GeeArrayList* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _dev_index = 0;
#line 1192 "../src/Utility/Device.vala"
		_dev_list = list;
#line 1192 "../src/Utility/Device.vala"
		_tmp24_ = _dev_list;
#line 1192 "../src/Utility/Device.vala"
		_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
#line 1192 "../src/Utility/Device.vala"
		_tmp26_ = _tmp25_;
#line 1192 "../src/Utility/Device.vala"
		_dev_size = _tmp26_;
#line 1192 "../src/Utility/Device.vala"
		_dev_index = -1;
#line 1192 "../src/Utility/Device.vala"
		while (TRUE) {
#line 7622 "Device.c"
			gint _tmp27_;
			gint _tmp28_;
			Device* dev = NULL;
			GeeArrayList* _tmp29_;
			gpointer _tmp30_;
			Device* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
#line 1192 "../src/Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1192 "../src/Utility/Device.vala"
			_tmp27_ = _dev_index;
#line 1192 "../src/Utility/Device.vala"
			_tmp28_ = _dev_size;
#line 1192 "../src/Utility/Device.vala"
			if (!(_tmp27_ < _tmp28_)) {
#line 1192 "../src/Utility/Device.vala"
				break;
#line 7641 "Device.c"
			}
#line 1192 "../src/Utility/Device.vala"
			_tmp29_ = _dev_list;
#line 1192 "../src/Utility/Device.vala"
			_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, _dev_index);
#line 1192 "../src/Utility/Device.vala"
			dev = (Device*) _tmp30_;
#line 1194 "../src/Utility/Device.vala"
			_tmp31_ = dev;
#line 1194 "../src/Utility/Device.vala"
			_tmp32_ = _tmp31_->device;
#line 1194 "../src/Utility/Device.vala"
			_tmp33_ = dev_alias;
#line 1194 "../src/Utility/Device.vala"
			if (g_strcmp0 (_tmp32_, _tmp33_) == 0) {
#line 1195 "../src/Utility/Device.vala"
				result = dev;
#line 1195 "../src/Utility/Device.vala"
				_g_free0 (dev_alias);
#line 1195 "../src/Utility/Device.vala"
				return result;
#line 7663 "Device.c"
			} else {
				Device* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
#line 1197 "../src/Utility/Device.vala"
				_tmp34_ = dev;
#line 1197 "../src/Utility/Device.vala"
				_tmp35_ = _tmp34_->uuid;
#line 1197 "../src/Utility/Device.vala"
				_tmp36_ = dev_alias;
#line 1197 "../src/Utility/Device.vala"
				if (g_strcmp0 (_tmp35_, _tmp36_) == 0) {
#line 1198 "../src/Utility/Device.vala"
					result = dev;
#line 1198 "../src/Utility/Device.vala"
					_g_free0 (dev_alias);
#line 1198 "../src/Utility/Device.vala"
					return result;
#line 7682 "Device.c"
				} else {
					Device* _tmp37_;
					const gchar* _tmp38_;
					const gchar* _tmp39_;
#line 1200 "../src/Utility/Device.vala"
					_tmp37_ = dev;
#line 1200 "../src/Utility/Device.vala"
					_tmp38_ = _tmp37_->label;
#line 1200 "../src/Utility/Device.vala"
					_tmp39_ = dev_alias;
#line 1200 "../src/Utility/Device.vala"
					if (g_strcmp0 (_tmp38_, _tmp39_) == 0) {
#line 1201 "../src/Utility/Device.vala"
						result = dev;
#line 1201 "../src/Utility/Device.vala"
						_g_free0 (dev_alias);
#line 1201 "../src/Utility/Device.vala"
						return result;
#line 7701 "Device.c"
					} else {
						Device* _tmp40_;
						const gchar* _tmp41_;
						const gchar* _tmp42_;
#line 1203 "../src/Utility/Device.vala"
						_tmp40_ = dev;
#line 1203 "../src/Utility/Device.vala"
						_tmp41_ = _tmp40_->partuuid;
#line 1203 "../src/Utility/Device.vala"
						_tmp42_ = dev_alias;
#line 1203 "../src/Utility/Device.vala"
						if (g_strcmp0 (_tmp41_, _tmp42_) == 0) {
#line 1204 "../src/Utility/Device.vala"
							result = dev;
#line 1204 "../src/Utility/Device.vala"
							_g_free0 (dev_alias);
#line 1204 "../src/Utility/Device.vala"
							return result;
#line 7720 "Device.c"
						} else {
							Device* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
#line 1206 "../src/Utility/Device.vala"
							_tmp43_ = dev;
#line 1206 "../src/Utility/Device.vala"
							_tmp44_ = _tmp43_->partlabel;
#line 1206 "../src/Utility/Device.vala"
							_tmp45_ = dev_alias;
#line 1206 "../src/Utility/Device.vala"
							if (g_strcmp0 (_tmp44_, _tmp45_) == 0) {
#line 1207 "../src/Utility/Device.vala"
								result = dev;
#line 1207 "../src/Utility/Device.vala"
								_g_free0 (dev_alias);
#line 1207 "../src/Utility/Device.vala"
								return result;
#line 7739 "Device.c"
							} else {
								Device* _tmp46_;
								const gchar* _tmp47_;
								const gchar* _tmp48_;
#line 1209 "../src/Utility/Device.vala"
								_tmp46_ = dev;
#line 1209 "../src/Utility/Device.vala"
								_tmp47_ = _tmp46_->device_by_uuid;
#line 1209 "../src/Utility/Device.vala"
								_tmp48_ = dev_alias;
#line 1209 "../src/Utility/Device.vala"
								if (g_strcmp0 (_tmp47_, _tmp48_) == 0) {
#line 1210 "../src/Utility/Device.vala"
									result = dev;
#line 1210 "../src/Utility/Device.vala"
									_g_free0 (dev_alias);
#line 1210 "../src/Utility/Device.vala"
									return result;
#line 7758 "Device.c"
								} else {
									Device* _tmp49_;
									const gchar* _tmp50_;
									const gchar* _tmp51_;
#line 1212 "../src/Utility/Device.vala"
									_tmp49_ = dev;
#line 1212 "../src/Utility/Device.vala"
									_tmp50_ = _tmp49_->device_by_label;
#line 1212 "../src/Utility/Device.vala"
									_tmp51_ = dev_alias;
#line 1212 "../src/Utility/Device.vala"
									if (g_strcmp0 (_tmp50_, _tmp51_) == 0) {
#line 1213 "../src/Utility/Device.vala"
										result = dev;
#line 1213 "../src/Utility/Device.vala"
										_g_free0 (dev_alias);
#line 1213 "../src/Utility/Device.vala"
										return result;
#line 7777 "Device.c"
									} else {
										Device* _tmp52_;
										const gchar* _tmp53_;
										const gchar* _tmp54_;
#line 1215 "../src/Utility/Device.vala"
										_tmp52_ = dev;
#line 1215 "../src/Utility/Device.vala"
										_tmp53_ = _tmp52_->device_by_partuuid;
#line 1215 "../src/Utility/Device.vala"
										_tmp54_ = dev_alias;
#line 1215 "../src/Utility/Device.vala"
										if (g_strcmp0 (_tmp53_, _tmp54_) == 0) {
#line 1216 "../src/Utility/Device.vala"
											result = dev;
#line 1216 "../src/Utility/Device.vala"
											_g_free0 (dev_alias);
#line 1216 "../src/Utility/Device.vala"
											return result;
#line 7796 "Device.c"
										} else {
											Device* _tmp55_;
											const gchar* _tmp56_;
											const gchar* _tmp57_;
#line 1218 "../src/Utility/Device.vala"
											_tmp55_ = dev;
#line 1218 "../src/Utility/Device.vala"
											_tmp56_ = _tmp55_->device_by_partlabel;
#line 1218 "../src/Utility/Device.vala"
											_tmp57_ = dev_alias;
#line 1218 "../src/Utility/Device.vala"
											if (g_strcmp0 (_tmp56_, _tmp57_) == 0) {
#line 1219 "../src/Utility/Device.vala"
												result = dev;
#line 1219 "../src/Utility/Device.vala"
												_g_free0 (dev_alias);
#line 1219 "../src/Utility/Device.vala"
												return result;
#line 7815 "Device.c"
											} else {
												Device* _tmp58_;
												const gchar* _tmp59_;
												const gchar* _tmp60_;
#line 1221 "../src/Utility/Device.vala"
												_tmp58_ = dev;
#line 1221 "../src/Utility/Device.vala"
												_tmp59_ = _tmp58_->device_mapper;
#line 1221 "../src/Utility/Device.vala"
												_tmp60_ = dev_alias;
#line 1221 "../src/Utility/Device.vala"
												if (g_strcmp0 (_tmp59_, _tmp60_) == 0) {
#line 1222 "../src/Utility/Device.vala"
													result = dev;
#line 1222 "../src/Utility/Device.vala"
													_g_free0 (dev_alias);
#line 1222 "../src/Utility/Device.vala"
													return result;
#line 7834 "Device.c"
												} else {
													Device* _tmp61_;
													const gchar* _tmp62_;
													const gchar* _tmp63_;
#line 1224 "../src/Utility/Device.vala"
													_tmp61_ = dev;
#line 1224 "../src/Utility/Device.vala"
													_tmp62_ = _tmp61_->mapped_name;
#line 1224 "../src/Utility/Device.vala"
													_tmp63_ = dev_alias;
#line 1224 "../src/Utility/Device.vala"
													if (g_strcmp0 (_tmp62_, _tmp63_) == 0) {
#line 1225 "../src/Utility/Device.vala"
														result = dev;
#line 1225 "../src/Utility/Device.vala"
														_g_free0 (dev_alias);
#line 1225 "../src/Utility/Device.vala"
														return result;
#line 7853 "Device.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 1192 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7867 "Device.c"
		}
	}
#line 1229 "../src/Utility/Device.vala"
	result = NULL;
#line 1229 "../src/Utility/Device.vala"
	_g_free0 (dev_alias);
#line 1229 "../src/Utility/Device.vala"
	return result;
#line 7876 "Device.c"
}

void
device_copy_fields_from (Device* self,
                         Device* dev2)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GeeArrayList* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	Device* _tmp22_;
	Device* _tmp23_;
	GeeArrayList* _tmp24_;
	GeeArrayList* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
#line 1232 "../src/Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1232 "../src/Utility/Device.vala"
	g_return_if_fail (dev2 != NULL);
#line 1234 "../src/Utility/Device.vala"
	_tmp0_ = dev2->device;
#line 1234 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1234 "../src/Utility/Device.vala"
	_g_free0 (self->device);
#line 1234 "../src/Utility/Device.vala"
	self->device = _tmp1_;
#line 1235 "../src/Utility/Device.vala"
	_tmp2_ = dev2->name;
#line 1235 "../src/Utility/Device.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1235 "../src/Utility/Device.vala"
	_g_free0 (self->name);
#line 1235 "../src/Utility/Device.vala"
	self->name = _tmp3_;
#line 1236 "../src/Utility/Device.vala"
	_tmp4_ = dev2->kname;
#line 1236 "../src/Utility/Device.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 1236 "../src/Utility/Device.vala"
	_g_free0 (self->kname);
#line 1236 "../src/Utility/Device.vala"
	self->kname = _tmp5_;
#line 1237 "../src/Utility/Device.vala"
	_tmp6_ = dev2->pkname;
#line 1237 "../src/Utility/Device.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 1237 "../src/Utility/Device.vala"
	_g_free0 (self->pkname);
#line 1237 "../src/Utility/Device.vala"
	self->pkname = _tmp7_;
#line 1238 "../src/Utility/Device.vala"
	_tmp8_ = dev2->label;
#line 1238 "../src/Utility/Device.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 1238 "../src/Utility/Device.vala"
	_g_free0 (self->label);
#line 1238 "../src/Utility/Device.vala"
	self->label = _tmp9_;
#line 1239 "../src/Utility/Device.vala"
	_tmp10_ = dev2->uuid;
#line 1239 "../src/Utility/Device.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 1239 "../src/Utility/Device.vala"
	_g_free0 (self->uuid);
#line 1239 "../src/Utility/Device.vala"
	self->uuid = _tmp11_;
#line 1240 "../src/Utility/Device.vala"
	_tmp12_ = dev2->mapped_name;
#line 1240 "../src/Utility/Device.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 1240 "../src/Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 1240 "../src/Utility/Device.vala"
	self->mapped_name = _tmp13_;
#line 1242 "../src/Utility/Device.vala"
	_tmp14_ = dev2->type;
#line 1242 "../src/Utility/Device.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 1242 "../src/Utility/Device.vala"
	_g_free0 (self->type);
#line 1242 "../src/Utility/Device.vala"
	self->type = _tmp15_;
#line 1243 "../src/Utility/Device.vala"
	_tmp16_ = dev2->fstype;
#line 1243 "../src/Utility/Device.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 1243 "../src/Utility/Device.vala"
	_g_free0 (self->fstype);
#line 1243 "../src/Utility/Device.vala"
	self->fstype = _tmp17_;
#line 1245 "../src/Utility/Device.vala"
	self->size_bytes = dev2->size_bytes;
#line 1246 "../src/Utility/Device.vala"
	self->used_bytes = dev2->used_bytes;
#line 1247 "../src/Utility/Device.vala"
	self->available_bytes = dev2->available_bytes;
#line 1249 "../src/Utility/Device.vala"
	_tmp18_ = dev2->mount_points;
#line 1249 "../src/Utility/Device.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1249 "../src/Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 1249 "../src/Utility/Device.vala"
	self->mount_points = _tmp19_;
#line 1250 "../src/Utility/Device.vala"
	_tmp20_ = dev2->symlinks;
#line 1250 "../src/Utility/Device.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1250 "../src/Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 1250 "../src/Utility/Device.vala"
	self->symlinks = _tmp21_;
#line 1251 "../src/Utility/Device.vala"
	_tmp22_ = dev2->parent;
#line 1251 "../src/Utility/Device.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 1251 "../src/Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 1251 "../src/Utility/Device.vala"
	self->parent = _tmp23_;
#line 1252 "../src/Utility/Device.vala"
	_tmp24_ = dev2->children;
#line 1252 "../src/Utility/Device.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 1252 "../src/Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 1252 "../src/Utility/Device.vala"
	self->children = _tmp25_;
#line 1254 "../src/Utility/Device.vala"
	_tmp26_ = dev2->vendor;
#line 1254 "../src/Utility/Device.vala"
	_tmp27_ = g_strdup (_tmp26_);
#line 1254 "../src/Utility/Device.vala"
	_g_free0 (self->vendor);
#line 1254 "../src/Utility/Device.vala"
	self->vendor = _tmp27_;
#line 1255 "../src/Utility/Device.vala"
	_tmp28_ = dev2->model;
#line 1255 "../src/Utility/Device.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 1255 "../src/Utility/Device.vala"
	_g_free0 (self->model);
#line 1255 "../src/Utility/Device.vala"
	self->model = _tmp29_;
#line 1256 "../src/Utility/Device.vala"
	_tmp30_ = dev2->serial;
#line 1256 "../src/Utility/Device.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 1256 "../src/Utility/Device.vala"
	_g_free0 (self->serial);
#line 1256 "../src/Utility/Device.vala"
	self->serial = _tmp31_;
#line 1257 "../src/Utility/Device.vala"
	_tmp32_ = dev2->revision;
#line 1257 "../src/Utility/Device.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 1257 "../src/Utility/Device.vala"
	_g_free0 (self->revision);
#line 1257 "../src/Utility/Device.vala"
	self->revision = _tmp33_;
#line 1259 "../src/Utility/Device.vala"
	self->removable = dev2->removable;
#line 1260 "../src/Utility/Device.vala"
	self->read_only = dev2->read_only;
#line 8067 "Device.c"
}

Device*
device_query_changes (Device* self)
{
	Device* dev_new = NULL;
	Device* result;
#line 1263 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1265 "../src/Utility/Device.vala"
	dev_new = NULL;
#line 8079 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 1267 "../src/Utility/Device.vala"
		_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 1267 "../src/Utility/Device.vala"
		_dev_list = _tmp0_;
#line 1267 "../src/Utility/Device.vala"
		_tmp1_ = _dev_list;
#line 1267 "../src/Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1267 "../src/Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1267 "../src/Utility/Device.vala"
		_dev_size = _tmp3_;
#line 1267 "../src/Utility/Device.vala"
		_dev_index = -1;
#line 1267 "../src/Utility/Device.vala"
		while (TRUE) {
#line 8104 "Device.c"
			gint _tmp4_;
			gint _tmp5_;
			Device* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 1267 "../src/Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1267 "../src/Utility/Device.vala"
			_tmp4_ = _dev_index;
#line 1267 "../src/Utility/Device.vala"
			_tmp5_ = _dev_size;
#line 1267 "../src/Utility/Device.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 1267 "../src/Utility/Device.vala"
				break;
#line 8123 "Device.c"
			}
#line 1267 "../src/Utility/Device.vala"
			_tmp6_ = _dev_list;
#line 1267 "../src/Utility/Device.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
#line 1267 "../src/Utility/Device.vala"
			dev = (Device*) _tmp7_;
#line 1268 "../src/Utility/Device.vala"
			_tmp8_ = self->uuid;
#line 1268 "../src/Utility/Device.vala"
			_tmp9_ = strlen (_tmp8_);
#line 1268 "../src/Utility/Device.vala"
			_tmp10_ = _tmp9_;
#line 1268 "../src/Utility/Device.vala"
			if (_tmp10_ > 0) {
#line 8139 "Device.c"
				Device* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
#line 1269 "../src/Utility/Device.vala"
				_tmp11_ = dev;
#line 1269 "../src/Utility/Device.vala"
				_tmp12_ = _tmp11_->uuid;
#line 1269 "../src/Utility/Device.vala"
				_tmp13_ = self->uuid;
#line 1269 "../src/Utility/Device.vala"
				if (g_strcmp0 (_tmp12_, _tmp13_) == 0) {
#line 8151 "Device.c"
					Device* _tmp14_;
					Device* _tmp15_;
#line 1270 "../src/Utility/Device.vala"
					_tmp14_ = dev;
#line 1270 "../src/Utility/Device.vala"
					_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1270 "../src/Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1270 "../src/Utility/Device.vala"
					dev_new = _tmp15_;
#line 1271 "../src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1271 "../src/Utility/Device.vala"
					break;
#line 8166 "Device.c"
				}
			} else {
				Device* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
#line 1275 "../src/Utility/Device.vala"
				_tmp16_ = dev;
#line 1275 "../src/Utility/Device.vala"
				_tmp17_ = _tmp16_->device;
#line 1275 "../src/Utility/Device.vala"
				_tmp18_ = self->device;
#line 1275 "../src/Utility/Device.vala"
				if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 8180 "Device.c"
					Device* _tmp19_;
					Device* _tmp20_;
#line 1276 "../src/Utility/Device.vala"
					_tmp19_ = dev;
#line 1276 "../src/Utility/Device.vala"
					_tmp20_ = _g_object_ref0 (_tmp19_);
#line 1276 "../src/Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1276 "../src/Utility/Device.vala"
					dev_new = _tmp20_;
#line 1277 "../src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1277 "../src/Utility/Device.vala"
					break;
#line 8195 "Device.c"
				}
			}
#line 1267 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 8200 "Device.c"
		}
#line 1267 "../src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 8204 "Device.c"
	}
#line 1282 "../src/Utility/Device.vala"
	result = dev_new;
#line 1282 "../src/Utility/Device.vala"
	return result;
#line 8210 "Device.c"
}

void
device_query_disk_space (Device* self)
{
	GeeArrayList* list_df = NULL;
	const gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	Device* dev_df = NULL;
	GeeArrayList* _tmp2_;
	const gchar* _tmp3_;
	Device* _tmp4_;
	Device* _tmp5_;
#line 1285 "../src/Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1289 "../src/Utility/Device.vala"
	_tmp0_ = self->device;
#line 1289 "../src/Utility/Device.vala"
	_tmp1_ = device_get_disk_space_using_df (_tmp0_);
#line 1289 "../src/Utility/Device.vala"
	list_df = _tmp1_;
#line 1291 "../src/Utility/Device.vala"
	_tmp2_ = list_df;
#line 1291 "../src/Utility/Device.vala"
	_tmp3_ = self->uuid;
#line 1291 "../src/Utility/Device.vala"
	_tmp4_ = device_find_device_in_list (_tmp2_, _tmp3_);
#line 1291 "../src/Utility/Device.vala"
	dev_df = _tmp4_;
#line 1293 "../src/Utility/Device.vala"
	_tmp5_ = dev_df;
#line 1293 "../src/Utility/Device.vala"
	if (_tmp5_ != NULL) {
#line 8244 "Device.c"
		Device* _tmp6_;
		Device* _tmp7_;
		Device* _tmp8_;
		Device* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 1295 "../src/Utility/Device.vala"
		_tmp6_ = dev_df;
#line 1295 "../src/Utility/Device.vala"
		self->size_bytes = _tmp6_->size_bytes;
#line 1296 "../src/Utility/Device.vala"
		_tmp7_ = dev_df;
#line 1296 "../src/Utility/Device.vala"
		self->used_bytes = _tmp7_->used_bytes;
#line 1297 "../src/Utility/Device.vala"
		_tmp8_ = dev_df;
#line 1297 "../src/Utility/Device.vala"
		self->available_bytes = _tmp8_->available_bytes;
#line 1298 "../src/Utility/Device.vala"
		_tmp9_ = dev_df;
#line 1298 "../src/Utility/Device.vala"
		_tmp10_ = _tmp9_->used_percent;
#line 1298 "../src/Utility/Device.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 1298 "../src/Utility/Device.vala"
		_g_free0 (self->used_percent);
#line 1298 "../src/Utility/Device.vala"
		self->used_percent = _tmp11_;
#line 8273 "Device.c"
	}
#line 1285 "../src/Utility/Device.vala"
	_g_object_unref0 (dev_df);
#line 1285 "../src/Utility/Device.vala"
	_g_object_unref0 (list_df);
#line 8279 "Device.c"
}

gboolean
device_automount_udisks (const gchar* dev_name_or_uuid,
                         GtkWindow* parent_window)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
	gboolean result;
#line 1304 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1306 "../src/Utility/Device.vala"
	_tmp0_ = strlen (dev_name_or_uuid);
#line 1306 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1306 "../src/Utility/Device.vala"
	if (_tmp1_ == 0) {
#line 1307 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1308 "../src/Utility/Device.vala"
		result = FALSE;
#line 1308 "../src/Utility/Device.vala"
		return result;
#line 8308 "Device.c"
	}
#line 1311 "../src/Utility/Device.vala"
	_tmp2_ = g_strdup_printf ("udisksctl mount -b '%s'", dev_name_or_uuid);
#line 1311 "../src/Utility/Device.vala"
	cmd = _tmp2_;
#line 1312 "../src/Utility/Device.vala"
	_tmp3_ = cmd;
#line 1312 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1313 "../src/Utility/Device.vala"
	_tmp4_ = cmd;
#line 1313 "../src/Utility/Device.vala"
	status = system (_tmp4_);
#line 1315 "../src/Utility/Device.vala"
	if (status != 0) {
#line 1316 "../src/Utility/Device.vala"
		if (parent_window != NULL) {
#line 8326 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 1317 "../src/Utility/Device.vala"
			_tmp5_ = g_strdup_printf ("Failed to mount: %s", dev_name_or_uuid);
#line 1317 "../src/Utility/Device.vala"
			msg = _tmp5_;
#line 1318 "../src/Utility/Device.vala"
			_tmp6_ = msg;
#line 1318 "../src/Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp6_, parent_window, TRUE);
#line 1316 "../src/Utility/Device.vala"
			_g_free0 (msg);
#line 8340 "Device.c"
		}
	}
#line 1322 "../src/Utility/Device.vala"
	result = status == 0;
#line 1322 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 1322 "../src/Utility/Device.vala"
	return result;
#line 8349 "Device.c"
}

gboolean
device_automount_udisks_iso (const gchar* iso_file_path,
                             gchar** loop_device,
                             GtkWindow* parent_window)
{
	gchar* _vala_loop_device = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint exit_code = 0;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_;
	gboolean result;
#line 1325 "../src/Utility/Device.vala"
	g_return_val_if_fail (iso_file_path != NULL, FALSE);
#line 1327 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1327 "../src/Utility/Device.vala"
	_g_free0 (_vala_loop_device);
#line 1327 "../src/Utility/Device.vala"
	_vala_loop_device = _tmp0_;
#line 1329 "../src/Utility/Device.vala"
	if (!tee_jee_file_system_file_exists (iso_file_path)) {
#line 8383 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 1330 "../src/Utility/Device.vala"
		_tmp1_ = g_strdup_printf ("%s: %s", _ ("Could not find file"), iso_file_path);
#line 1330 "../src/Utility/Device.vala"
		msg = _tmp1_;
#line 1331 "../src/Utility/Device.vala"
		_tmp2_ = msg;
#line 1331 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp2_, FALSE, FALSE);
#line 1332 "../src/Utility/Device.vala"
		result = FALSE;
#line 1332 "../src/Utility/Device.vala"
		_g_free0 (msg);
#line 1332 "../src/Utility/Device.vala"
		if (loop_device) {
#line 1332 "../src/Utility/Device.vala"
			*loop_device = _vala_loop_device;
#line 8403 "Device.c"
		} else {
#line 1332 "../src/Utility/Device.vala"
			_g_free0 (_vala_loop_device);
#line 8407 "Device.c"
		}
#line 1332 "../src/Utility/Device.vala"
		return result;
#line 8411 "Device.c"
	}
#line 1335 "../src/Utility/Device.vala"
	_tmp3_ = tee_jee_file_system_escape_single_quote (iso_file_path);
#line 1335 "../src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1335 "../src/Utility/Device.vala"
	_tmp5_ = g_strdup_printf ("udisksctl loop-setup -r -f '%s'", _tmp4_);
#line 1335 "../src/Utility/Device.vala"
	_tmp6_ = _tmp5_;
#line 1335 "../src/Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1335 "../src/Utility/Device.vala"
	cmd = _tmp6_;
#line 1338 "../src/Utility/Device.vala"
	_tmp7_ = cmd;
#line 1338 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp7_);
#line 1340 "../src/Utility/Device.vala"
	_tmp8_ = cmd;
#line 1340 "../src/Utility/Device.vala"
	_tmp11_ = tee_jee_process_helper_exec_sync (_tmp8_, &_tmp9_, &_tmp10_);
#line 1340 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1340 "../src/Utility/Device.vala"
	std_out = _tmp9_;
#line 1340 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1340 "../src/Utility/Device.vala"
	std_err = _tmp10_;
#line 1340 "../src/Utility/Device.vala"
	exit_code = _tmp11_;
#line 1342 "../src/Utility/Device.vala"
	if (exit_code == 0) {
#line 8445 "Device.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar** _tmp17_;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp27_;
#line 1343 "../src/Utility/Device.vala"
		_tmp12_ = std_out;
#line 1343 "../src/Utility/Device.vala"
		_tmp13_ = g_strdup_printf ("%s", _tmp12_);
#line 1343 "../src/Utility/Device.vala"
		_tmp14_ = _tmp13_;
#line 1343 "../src/Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp14_, FALSE);
#line 1343 "../src/Utility/Device.vala"
		_g_free0 (_tmp14_);
#line 1346 "../src/Utility/Device.vala"
		_tmp15_ = std_out;
#line 1346 "../src/Utility/Device.vala"
		if (!string_contains (_tmp15_, " as ")) {
#line 1347 "../src/Utility/Device.vala"
			tee_jee_logging_log_error ("Could not determine loop device", FALSE, FALSE);
#line 1348 "../src/Utility/Device.vala"
			result = FALSE;
#line 1348 "../src/Utility/Device.vala"
			_g_free0 (std_err);
#line 1348 "../src/Utility/Device.vala"
			_g_free0 (std_out);
#line 1348 "../src/Utility/Device.vala"
			_g_free0 (cmd);
#line 1348 "../src/Utility/Device.vala"
			if (loop_device) {
#line 1348 "../src/Utility/Device.vala"
				*loop_device = _vala_loop_device;
#line 8492 "Device.c"
			} else {
#line 1348 "../src/Utility/Device.vala"
				_g_free0 (_vala_loop_device);
#line 8496 "Device.c"
			}
#line 1348 "../src/Utility/Device.vala"
			return result;
#line 8500 "Device.c"
		}
#line 1351 "../src/Utility/Device.vala"
		_tmp16_ = std_out;
#line 1351 "../src/Utility/Device.vala"
		_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, " as ", 0);
#line 1351 "../src/Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1351 "../src/Utility/Device.vala"
		_tmp19__length1 = _vala_array_length (_tmp17_);
#line 1351 "../src/Utility/Device.vala"
		_tmp20_ = _tmp19_[1];
#line 1351 "../src/Utility/Device.vala"
		_tmp21_ = string_replace (_tmp20_, ".", "");
#line 1351 "../src/Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1351 "../src/Utility/Device.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 1351 "../src/Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 1351 "../src/Utility/Device.vala"
		_vala_loop_device = _tmp23_;
#line 1351 "../src/Utility/Device.vala"
		_g_free0 (_tmp22_);
#line 1351 "../src/Utility/Device.vala"
		_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 1352 "../src/Utility/Device.vala"
		_tmp24_ = _vala_loop_device;
#line 1352 "../src/Utility/Device.vala"
		_tmp25_ = g_strdup_printf ("loop_device: %s", _tmp24_);
#line 1352 "../src/Utility/Device.vala"
		_tmp26_ = _tmp25_;
#line 1352 "../src/Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp26_, FALSE);
#line 1352 "../src/Utility/Device.vala"
		_g_free0 (_tmp26_);
#line 1354 "../src/Utility/Device.vala"
		_tmp27_ = device_get_block_devices_using_lsblk ("");
#line 1354 "../src/Utility/Device.vala"
		list = _tmp27_;
#line 8540 "Device.c"
		{
			GeeArrayList* _dev_list = NULL;
			GeeArrayList* _tmp28_;
			gint _dev_size = 0;
			GeeArrayList* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			gint _dev_index = 0;
#line 1355 "../src/Utility/Device.vala"
			_tmp28_ = list;
#line 1355 "../src/Utility/Device.vala"
			_dev_list = _tmp28_;
#line 1355 "../src/Utility/Device.vala"
			_tmp29_ = _dev_list;
#line 1355 "../src/Utility/Device.vala"
			_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
#line 1355 "../src/Utility/Device.vala"
			_tmp31_ = _tmp30_;
#line 1355 "../src/Utility/Device.vala"
			_dev_size = _tmp31_;
#line 1355 "../src/Utility/Device.vala"
			_dev_index = -1;
#line 1355 "../src/Utility/Device.vala"
			while (TRUE) {
#line 8565 "Device.c"
				gint _tmp32_;
				gint _tmp33_;
				Device* dev = NULL;
				GeeArrayList* _tmp34_;
				gpointer _tmp35_;
				gboolean _tmp36_ = FALSE;
				Device* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				gboolean _tmp42_;
#line 1355 "../src/Utility/Device.vala"
				_dev_index = _dev_index + 1;
#line 1355 "../src/Utility/Device.vala"
				_tmp32_ = _dev_index;
#line 1355 "../src/Utility/Device.vala"
				_tmp33_ = _dev_size;
#line 1355 "../src/Utility/Device.vala"
				if (!(_tmp32_ < _tmp33_)) {
#line 1355 "../src/Utility/Device.vala"
					break;
#line 8588 "Device.c"
				}
#line 1355 "../src/Utility/Device.vala"
				_tmp34_ = _dev_list;
#line 1355 "../src/Utility/Device.vala"
				_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _tmp34_, _dev_index);
#line 1355 "../src/Utility/Device.vala"
				dev = (Device*) _tmp35_;
#line 1356 "../src/Utility/Device.vala"
				_tmp37_ = dev;
#line 1356 "../src/Utility/Device.vala"
				_tmp38_ = _tmp37_->pkname;
#line 1356 "../src/Utility/Device.vala"
				_tmp39_ = _vala_loop_device;
#line 1356 "../src/Utility/Device.vala"
				_tmp40_ = string_replace (_tmp39_, "/dev/", "");
#line 1356 "../src/Utility/Device.vala"
				_tmp41_ = _tmp40_;
#line 1356 "../src/Utility/Device.vala"
				_tmp42_ = g_strcmp0 (_tmp38_, _tmp41_) == 0;
#line 1356 "../src/Utility/Device.vala"
				_g_free0 (_tmp41_);
#line 1356 "../src/Utility/Device.vala"
				if (_tmp42_) {
#line 8612 "Device.c"
					Device* _tmp43_;
					const gchar* _tmp44_;
#line 1356 "../src/Utility/Device.vala"
					_tmp43_ = dev;
#line 1356 "../src/Utility/Device.vala"
					_tmp44_ = _tmp43_->fstype;
#line 1356 "../src/Utility/Device.vala"
					_tmp36_ = g_strcmp0 (_tmp44_, "iso9660") == 0;
#line 8621 "Device.c"
				} else {
#line 1356 "../src/Utility/Device.vala"
					_tmp36_ = FALSE;
#line 8625 "Device.c"
				}
#line 1356 "../src/Utility/Device.vala"
				if (_tmp36_) {
#line 8629 "Device.c"
					Device* _tmp45_;
					const gchar* _tmp46_;
					gchar* _tmp47_;
					Device* _tmp48_;
					const gchar* _tmp49_;
#line 1357 "../src/Utility/Device.vala"
					_tmp45_ = dev;
#line 1357 "../src/Utility/Device.vala"
					_tmp46_ = _tmp45_->device;
#line 1357 "../src/Utility/Device.vala"
					_tmp47_ = g_strdup (_tmp46_);
#line 1357 "../src/Utility/Device.vala"
					_g_free0 (_vala_loop_device);
#line 1357 "../src/Utility/Device.vala"
					_vala_loop_device = _tmp47_;
#line 1358 "../src/Utility/Device.vala"
					_tmp48_ = dev;
#line 1358 "../src/Utility/Device.vala"
					_tmp49_ = _tmp48_->device;
#line 1358 "../src/Utility/Device.vala"
					result = device_automount_udisks (_tmp49_, parent_window);
#line 1358 "../src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1358 "../src/Utility/Device.vala"
					_g_object_unref0 (list);
#line 1358 "../src/Utility/Device.vala"
					_g_free0 (std_err);
#line 1358 "../src/Utility/Device.vala"
					_g_free0 (std_out);
#line 1358 "../src/Utility/Device.vala"
					_g_free0 (cmd);
#line 1358 "../src/Utility/Device.vala"
					if (loop_device) {
#line 1358 "../src/Utility/Device.vala"
						*loop_device = _vala_loop_device;
#line 8665 "Device.c"
					} else {
#line 1358 "../src/Utility/Device.vala"
						_g_free0 (_vala_loop_device);
#line 8669 "Device.c"
					}
#line 1358 "../src/Utility/Device.vala"
					return result;
#line 8673 "Device.c"
				}
#line 1355 "../src/Utility/Device.vala"
				_g_object_unref0 (dev);
#line 8677 "Device.c"
			}
		}
#line 1342 "../src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 8682 "Device.c"
	}
#line 1363 "../src/Utility/Device.vala"
	result = FALSE;
#line 1363 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1363 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1363 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 1363 "../src/Utility/Device.vala"
	if (loop_device) {
#line 1363 "../src/Utility/Device.vala"
		*loop_device = _vala_loop_device;
#line 8696 "Device.c"
	} else {
#line 1363 "../src/Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 8700 "Device.c"
	}
#line 1363 "../src/Utility/Device.vala"
	return result;
#line 8704 "Device.c"
}

gboolean
device_unmount_udisks (const gchar* dev_name_or_uuid,
                       GtkWindow* parent_window)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
	gboolean result;
#line 1366 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1368 "../src/Utility/Device.vala"
	_tmp0_ = strlen (dev_name_or_uuid);
#line 1368 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1368 "../src/Utility/Device.vala"
	if (_tmp1_ == 0) {
#line 1369 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1370 "../src/Utility/Device.vala"
		result = FALSE;
#line 1370 "../src/Utility/Device.vala"
		return result;
#line 8733 "Device.c"
	}
#line 1373 "../src/Utility/Device.vala"
	_tmp2_ = g_strdup_printf ("udisksctl unmount -b '%s'", dev_name_or_uuid);
#line 1373 "../src/Utility/Device.vala"
	cmd = _tmp2_;
#line 1374 "../src/Utility/Device.vala"
	_tmp3_ = cmd;
#line 1374 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1375 "../src/Utility/Device.vala"
	_tmp4_ = cmd;
#line 1375 "../src/Utility/Device.vala"
	status = system (_tmp4_);
#line 1377 "../src/Utility/Device.vala"
	if (status != 0) {
#line 1378 "../src/Utility/Device.vala"
		if (parent_window != NULL) {
#line 8751 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 1379 "../src/Utility/Device.vala"
			_tmp5_ = g_strdup_printf ("Failed to unmount: %s", dev_name_or_uuid);
#line 1379 "../src/Utility/Device.vala"
			msg = _tmp5_;
#line 1380 "../src/Utility/Device.vala"
			_tmp6_ = msg;
#line 1380 "../src/Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp6_, parent_window, TRUE);
#line 1378 "../src/Utility/Device.vala"
			_g_free0 (msg);
#line 8765 "Device.c"
		}
	}
#line 1384 "../src/Utility/Device.vala"
	result = status == 0;
#line 1384 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 1384 "../src/Utility/Device.vala"
	return result;
#line 8774 "Device.c"
}

Device*
device_luks_unlock (Device* luks_device,
                    const gchar* mapped_name,
                    const gchar* passphrase,
                    GtkWindow* parent_window,
                    gchar** message,
                    gchar** details)
{
	gchar* _vala_message = NULL;
	gchar* _vala_details = NULL;
	Device* unlocked_device = NULL;
	gchar* std_out = NULL;
	gchar* _tmp0_;
	gchar* std_err = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp7_;
	gchar* luks_pass = NULL;
	gchar* _tmp25_;
	gchar* luks_name = NULL;
	gchar* _tmp26_;
	gboolean _tmp27_ = FALSE;
	const gchar* _tmp28_;
	GeeArrayList* _tmp106_;
	gboolean is_error = FALSE;
	Device* _tmp120_;
	Device* result;
#line 1387 "../src/Utility/Device.vala"
	g_return_val_if_fail (luks_device != NULL, NULL);
#line 1387 "../src/Utility/Device.vala"
	g_return_val_if_fail (mapped_name != NULL, NULL);
#line 1387 "../src/Utility/Device.vala"
	g_return_val_if_fail (passphrase != NULL, NULL);
#line 1397 "../src/Utility/Device.vala"
	unlocked_device = NULL;
#line 1398 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1398 "../src/Utility/Device.vala"
	std_out = _tmp0_;
#line 1398 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1398 "../src/Utility/Device.vala"
	std_err = _tmp1_;
#line 1401 "../src/Utility/Device.vala"
	_tmp3_ = luks_device->fstype;
#line 1401 "../src/Utility/Device.vala"
	if (!string_contains (_tmp3_, "luks")) {
#line 8826 "Device.c"
		const gchar* _tmp4_;
#line 1401 "../src/Utility/Device.vala"
		_tmp4_ = luks_device->fstype;
#line 1401 "../src/Utility/Device.vala"
		_tmp2_ = !string_contains (_tmp4_, "crypt");
#line 8832 "Device.c"
	} else {
#line 1401 "../src/Utility/Device.vala"
		_tmp2_ = FALSE;
#line 8836 "Device.c"
	}
#line 1401 "../src/Utility/Device.vala"
	if (_tmp2_) {
#line 8840 "Device.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1402 "../src/Utility/Device.vala"
		_tmp5_ = g_strdup (_ ("This device is not encrypted"));
#line 1402 "../src/Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1402 "../src/Utility/Device.vala"
		_vala_message = _tmp5_;
#line 1403 "../src/Utility/Device.vala"
		_tmp6_ = g_strdup (_ ("Failed to unlock device"));
#line 1403 "../src/Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1403 "../src/Utility/Device.vala"
		_vala_details = _tmp6_;
#line 1404 "../src/Utility/Device.vala"
		result = NULL;
#line 1404 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1404 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1404 "../src/Utility/Device.vala"
		_g_object_unref0 (unlocked_device);
#line 1404 "../src/Utility/Device.vala"
		if (message) {
#line 1404 "../src/Utility/Device.vala"
			*message = _vala_message;
#line 8867 "Device.c"
		} else {
#line 1404 "../src/Utility/Device.vala"
			_g_free0 (_vala_message);
#line 8871 "Device.c"
		}
#line 1404 "../src/Utility/Device.vala"
		if (details) {
#line 1404 "../src/Utility/Device.vala"
			*details = _vala_details;
#line 8877 "Device.c"
		} else {
#line 1404 "../src/Utility/Device.vala"
			_g_free0 (_vala_details);
#line 8881 "Device.c"
		}
#line 1404 "../src/Utility/Device.vala"
		return result;
#line 8885 "Device.c"
	}
#line 1408 "../src/Utility/Device.vala"
	_tmp7_ = device_get_block_devices_using_lsblk ("");
#line 1408 "../src/Utility/Device.vala"
	list = _tmp7_;
#line 8891 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp8_;
		gint _part_size = 0;
		GeeArrayList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _part_index = 0;
#line 1409 "../src/Utility/Device.vala"
		_tmp8_ = list;
#line 1409 "../src/Utility/Device.vala"
		_part_list = _tmp8_;
#line 1409 "../src/Utility/Device.vala"
		_tmp9_ = _part_list;
#line 1409 "../src/Utility/Device.vala"
		_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 1409 "../src/Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1409 "../src/Utility/Device.vala"
		_part_size = _tmp11_;
#line 1409 "../src/Utility/Device.vala"
		_part_index = -1;
#line 1409 "../src/Utility/Device.vala"
		while (TRUE) {
#line 8916 "Device.c"
			gint _tmp12_;
			gint _tmp13_;
			Device* part = NULL;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			Device* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
#line 1409 "../src/Utility/Device.vala"
			_part_index = _part_index + 1;
#line 1409 "../src/Utility/Device.vala"
			_tmp12_ = _part_index;
#line 1409 "../src/Utility/Device.vala"
			_tmp13_ = _part_size;
#line 1409 "../src/Utility/Device.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 1409 "../src/Utility/Device.vala"
				break;
#line 8935 "Device.c"
			}
#line 1409 "../src/Utility/Device.vala"
			_tmp14_ = _part_list;
#line 1409 "../src/Utility/Device.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _part_index);
#line 1409 "../src/Utility/Device.vala"
			part = (Device*) _tmp15_;
#line 1410 "../src/Utility/Device.vala"
			_tmp16_ = part;
#line 1410 "../src/Utility/Device.vala"
			_tmp17_ = _tmp16_->pkname;
#line 1410 "../src/Utility/Device.vala"
			_tmp18_ = luks_device->kname;
#line 1410 "../src/Utility/Device.vala"
			if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 8951 "Device.c"
				Device* _tmp19_;
				Device* _tmp20_;
				gchar* _tmp21_;
				Device* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 1411 "../src/Utility/Device.vala"
				_tmp19_ = part;
#line 1411 "../src/Utility/Device.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 1411 "../src/Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1411 "../src/Utility/Device.vala"
				unlocked_device = _tmp20_;
#line 1412 "../src/Utility/Device.vala"
				_tmp21_ = g_strdup (_ ("Device is unlocked"));
#line 1412 "../src/Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1412 "../src/Utility/Device.vala"
				_vala_message = _tmp21_;
#line 1413 "../src/Utility/Device.vala"
				_tmp22_ = part;
#line 1413 "../src/Utility/Device.vala"
				_tmp23_ = _tmp22_->mapped_name;
#line 1413 "../src/Utility/Device.vala"
				_tmp24_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp23_);
#line 1413 "../src/Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1413 "../src/Utility/Device.vala"
				_vala_details = _tmp24_;
#line 1414 "../src/Utility/Device.vala"
				result = part;
#line 1414 "../src/Utility/Device.vala"
				_g_object_unref0 (list);
#line 1414 "../src/Utility/Device.vala"
				_g_free0 (std_err);
#line 1414 "../src/Utility/Device.vala"
				_g_free0 (std_out);
#line 1414 "../src/Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1414 "../src/Utility/Device.vala"
				if (message) {
#line 1414 "../src/Utility/Device.vala"
					*message = _vala_message;
#line 8996 "Device.c"
				} else {
#line 1414 "../src/Utility/Device.vala"
					_g_free0 (_vala_message);
#line 9000 "Device.c"
				}
#line 1414 "../src/Utility/Device.vala"
				if (details) {
#line 1414 "../src/Utility/Device.vala"
					*details = _vala_details;
#line 9006 "Device.c"
				} else {
#line 1414 "../src/Utility/Device.vala"
					_g_free0 (_vala_details);
#line 9010 "Device.c"
				}
#line 1414 "../src/Utility/Device.vala"
				return result;
#line 9014 "Device.c"
			}
#line 1409 "../src/Utility/Device.vala"
			_g_object_unref0 (part);
#line 9018 "Device.c"
		}
	}
#line 1418 "../src/Utility/Device.vala"
	_tmp25_ = g_strdup (passphrase);
#line 1418 "../src/Utility/Device.vala"
	luks_pass = _tmp25_;
#line 1419 "../src/Utility/Device.vala"
	_tmp26_ = g_strdup (mapped_name);
#line 1419 "../src/Utility/Device.vala"
	luks_name = _tmp26_;
#line 1421 "../src/Utility/Device.vala"
	_tmp28_ = luks_name;
#line 1421 "../src/Utility/Device.vala"
	if (_tmp28_ == NULL) {
#line 1421 "../src/Utility/Device.vala"
		_tmp27_ = TRUE;
#line 9035 "Device.c"
	} else {
		const gchar* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
#line 1421 "../src/Utility/Device.vala"
		_tmp29_ = luks_name;
#line 1421 "../src/Utility/Device.vala"
		_tmp30_ = strlen (_tmp29_);
#line 1421 "../src/Utility/Device.vala"
		_tmp31_ = _tmp30_;
#line 1421 "../src/Utility/Device.vala"
		_tmp27_ = _tmp31_ == 0;
#line 9048 "Device.c"
	}
#line 1421 "../src/Utility/Device.vala"
	if (_tmp27_) {
#line 9052 "Device.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 1422 "../src/Utility/Device.vala"
		_tmp32_ = luks_device->kname;
#line 1422 "../src/Utility/Device.vala"
		_tmp33_ = g_strdup_printf ("%s_crypt", _tmp32_);
#line 1422 "../src/Utility/Device.vala"
		_g_free0 (luks_name);
#line 1422 "../src/Utility/Device.vala"
		luks_name = _tmp33_;
#line 9063 "Device.c"
	}
#line 1425 "../src/Utility/Device.vala"
	if (parent_window == NULL) {
#line 9067 "Device.c"
		gboolean _tmp34_ = FALSE;
		const gchar* _tmp35_;
#line 1429 "../src/Utility/Device.vala"
		_tmp35_ = luks_pass;
#line 1429 "../src/Utility/Device.vala"
		if (_tmp35_ == NULL) {
#line 1429 "../src/Utility/Device.vala"
			_tmp34_ = TRUE;
#line 9076 "Device.c"
		} else {
			const gchar* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
#line 1429 "../src/Utility/Device.vala"
			_tmp36_ = luks_pass;
#line 1429 "../src/Utility/Device.vala"
			_tmp37_ = strlen (_tmp36_);
#line 1429 "../src/Utility/Device.vala"
			_tmp38_ = _tmp37_;
#line 1429 "../src/Utility/Device.vala"
			_tmp34_ = _tmp38_ == 0;
#line 9089 "Device.c"
		}
#line 1429 "../src/Utility/Device.vala"
		if (_tmp34_) {
#line 9093 "Device.c"
			TimeoutCounter* counter = NULL;
			TimeoutCounter* _tmp39_;
			TimeoutCounter* _tmp40_;
			gchar* cmd = NULL;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			gchar* _tmp43_;
			const gchar* _tmp44_;
			const gchar* _tmp45_;
			TimeoutCounter* _tmp46_;
#line 1433 "../src/Utility/Device.vala"
			_tmp39_ = timeout_counter_new ();
#line 1433 "../src/Utility/Device.vala"
			counter = _tmp39_;
#line 1434 "../src/Utility/Device.vala"
			_tmp40_ = counter;
#line 1434 "../src/Utility/Device.vala"
			timeout_counter_kill_process_on_timeout (_tmp40_, "cryptsetup", 20, TRUE);
#line 1435 "../src/Utility/Device.vala"
			_tmp41_ = luks_device->device;
#line 1435 "../src/Utility/Device.vala"
			_tmp42_ = luks_name;
#line 1435 "../src/Utility/Device.vala"
			_tmp43_ = g_strdup_printf ("cryptsetup luksOpen '%s' '%s'", _tmp41_, _tmp42_);
#line 1435 "../src/Utility/Device.vala"
			cmd = _tmp43_;
#line 1437 "../src/Utility/Device.vala"
			_tmp44_ = cmd;
#line 1437 "../src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp44_);
#line 1438 "../src/Utility/Device.vala"
			_tmp45_ = cmd;
#line 1438 "../src/Utility/Device.vala"
			system (_tmp45_);
#line 1439 "../src/Utility/Device.vala"
			_tmp46_ = counter;
#line 1439 "../src/Utility/Device.vala"
			timeout_counter_stop (_tmp46_);
#line 1440 "../src/Utility/Device.vala"
			tee_jee_logging_log_msg ("", FALSE);
#line 1429 "../src/Utility/Device.vala"
			_g_free0 (cmd);
#line 1429 "../src/Utility/Device.vala"
			_g_object_unref0 (counter);
#line 9138 "Device.c"
		} else {
			gchar* cmd = NULL;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			const gchar* _tmp54_;
			const gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			gint status = 0;
			const gchar* _tmp60_;
			gchar* _tmp61_ = NULL;
			gchar* _tmp62_ = NULL;
			gint _tmp63_;
#line 1447 "../src/Utility/Device.vala"
			_tmp47_ = luks_pass;
#line 1447 "../src/Utility/Device.vala"
			_tmp48_ = tee_jee_file_system_escape_single_quote (_tmp47_);
#line 1447 "../src/Utility/Device.vala"
			_tmp49_ = _tmp48_;
#line 1447 "../src/Utility/Device.vala"
			_tmp50_ = luks_device->device;
#line 1447 "../src/Utility/Device.vala"
			_tmp51_ = luks_name;
#line 1447 "../src/Utility/Device.vala"
			_tmp52_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp49_, _tmp50_, _tmp51_);
#line 1447 "../src/Utility/Device.vala"
			_tmp53_ = _tmp52_;
#line 1447 "../src/Utility/Device.vala"
			_g_free0 (_tmp49_);
#line 1447 "../src/Utility/Device.vala"
			cmd = _tmp53_;
#line 1450 "../src/Utility/Device.vala"
			_tmp54_ = cmd;
#line 1450 "../src/Utility/Device.vala"
			_tmp55_ = luks_pass;
#line 1450 "../src/Utility/Device.vala"
			_tmp56_ = tee_jee_file_system_escape_single_quote (_tmp55_);
#line 1450 "../src/Utility/Device.vala"
			_tmp57_ = _tmp56_;
#line 1450 "../src/Utility/Device.vala"
			_tmp58_ = string_replace (_tmp54_, _tmp57_, "**PASSWORD**");
#line 1450 "../src/Utility/Device.vala"
			_tmp59_ = _tmp58_;
#line 1450 "../src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp59_);
#line 1450 "../src/Utility/Device.vala"
			_g_free0 (_tmp59_);
#line 1450 "../src/Utility/Device.vala"
			_g_free0 (_tmp57_);
#line 1452 "../src/Utility/Device.vala"
			_tmp60_ = cmd;
#line 1452 "../src/Utility/Device.vala"
			_tmp63_ = tee_jee_process_helper_exec_script_sync (_tmp60_, &_tmp61_, &_tmp62_, FALSE, TRUE, TRUE, FALSE);
#line 1452 "../src/Utility/Device.vala"
			_g_free0 (std_out);
#line 1452 "../src/Utility/Device.vala"
			std_out = _tmp61_;
#line 1452 "../src/Utility/Device.vala"
			_g_free0 (std_err);
#line 1452 "../src/Utility/Device.vala"
			std_err = _tmp62_;
#line 1452 "../src/Utility/Device.vala"
			status = _tmp63_;
#line 1454 "../src/Utility/Device.vala"
			switch (status) {
#line 1454 "../src/Utility/Device.vala"
				case 512:
#line 9213 "Device.c"
				{
					gchar* _tmp64_;
					gchar* _tmp65_;
					const gchar* _tmp66_;
					const gchar* _tmp67_;
#line 1456 "../src/Utility/Device.vala"
					_tmp64_ = g_strdup (_ ("Wrong password"));
#line 1456 "../src/Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1456 "../src/Utility/Device.vala"
					_vala_message = _tmp64_;
#line 1457 "../src/Utility/Device.vala"
					_tmp65_ = g_strdup (_ ("Failed to unlock device"));
#line 1457 "../src/Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1457 "../src/Utility/Device.vala"
					_vala_details = _tmp65_;
#line 1458 "../src/Utility/Device.vala"
					_tmp66_ = _vala_message;
#line 1458 "../src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp66_, FALSE, FALSE);
#line 1459 "../src/Utility/Device.vala"
					_tmp67_ = _vala_details;
#line 1459 "../src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp67_, FALSE, FALSE);
#line 1460 "../src/Utility/Device.vala"
					break;
#line 9241 "Device.c"
				}
				default:
#line 1454 "../src/Utility/Device.vala"
				break;
#line 9246 "Device.c"
			}
#line 1429 "../src/Utility/Device.vala"
			_g_free0 (cmd);
#line 9250 "Device.c"
		}
	} else {
		gboolean _tmp68_ = FALSE;
		const gchar* _tmp69_;
		gboolean _tmp80_ = FALSE;
		const gchar* _tmp81_;
#line 1469 "../src/Utility/Device.vala"
		_tmp69_ = luks_pass;
#line 1469 "../src/Utility/Device.vala"
		if (_tmp69_ == NULL) {
#line 1469 "../src/Utility/Device.vala"
			_tmp68_ = TRUE;
#line 9263 "Device.c"
		} else {
			const gchar* _tmp70_;
			gint _tmp71_;
			gint _tmp72_;
#line 1469 "../src/Utility/Device.vala"
			_tmp70_ = luks_pass;
#line 1469 "../src/Utility/Device.vala"
			_tmp71_ = strlen (_tmp70_);
#line 1469 "../src/Utility/Device.vala"
			_tmp72_ = _tmp71_;
#line 1469 "../src/Utility/Device.vala"
			_tmp68_ = _tmp72_ == 0;
#line 9276 "Device.c"
		}
#line 1469 "../src/Utility/Device.vala"
		if (_tmp68_) {
#line 9280 "Device.c"
			const gchar* _tmp73_;
			gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
			const gchar* _tmp77_;
#line 1473 "../src/Utility/Device.vala"
			tee_jee_logging_log_debug ("Prompting user for passphrase..");
#line 1475 "../src/Utility/Device.vala"
			_tmp73_ = luks_device->name;
#line 1475 "../src/Utility/Device.vala"
			_tmp74_ = g_strdup_printf (_ ("Enter passphrase to unlock '%s'"), _tmp73_);
#line 1475 "../src/Utility/Device.vala"
			_tmp75_ = _tmp74_;
#line 1475 "../src/Utility/Device.vala"
			_tmp76_ = tee_jee_gtk_helper_gtk_inputbox (_ ("Encrypted Device"), _tmp75_, parent_window, TRUE);
#line 1475 "../src/Utility/Device.vala"
			_g_free0 (luks_pass);
#line 1475 "../src/Utility/Device.vala"
			luks_pass = _tmp76_;
#line 1475 "../src/Utility/Device.vala"
			_g_free0 (_tmp75_);
#line 1480 "../src/Utility/Device.vala"
			_tmp77_ = luks_pass;
#line 1480 "../src/Utility/Device.vala"
			if (_tmp77_ == NULL) {
#line 9306 "Device.c"
				gchar* _tmp78_;
				gchar* _tmp79_;
#line 1482 "../src/Utility/Device.vala"
				_tmp78_ = g_strdup (_ ("Failed to unlock device"));
#line 1482 "../src/Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1482 "../src/Utility/Device.vala"
				_vala_message = _tmp78_;
#line 1483 "../src/Utility/Device.vala"
				_tmp79_ = g_strdup (_ ("User cancelled the password prompt"));
#line 1483 "../src/Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1483 "../src/Utility/Device.vala"
				_vala_details = _tmp79_;
#line 1484 "../src/Utility/Device.vala"
				tee_jee_logging_log_debug ("User cancelled the password prompt");
#line 1485 "../src/Utility/Device.vala"
				result = NULL;
#line 1485 "../src/Utility/Device.vala"
				_g_free0 (luks_name);
#line 1485 "../src/Utility/Device.vala"
				_g_free0 (luks_pass);
#line 1485 "../src/Utility/Device.vala"
				_g_object_unref0 (list);
#line 1485 "../src/Utility/Device.vala"
				_g_free0 (std_err);
#line 1485 "../src/Utility/Device.vala"
				_g_free0 (std_out);
#line 1485 "../src/Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1485 "../src/Utility/Device.vala"
				if (message) {
#line 1485 "../src/Utility/Device.vala"
					*message = _vala_message;
#line 9341 "Device.c"
				} else {
#line 1485 "../src/Utility/Device.vala"
					_g_free0 (_vala_message);
#line 9345 "Device.c"
				}
#line 1485 "../src/Utility/Device.vala"
				if (details) {
#line 1485 "../src/Utility/Device.vala"
					*details = _vala_details;
#line 9351 "Device.c"
				} else {
#line 1485 "../src/Utility/Device.vala"
					_g_free0 (_vala_details);
#line 9355 "Device.c"
				}
#line 1485 "../src/Utility/Device.vala"
				return result;
#line 9359 "Device.c"
			}
		}
#line 1489 "../src/Utility/Device.vala"
		_tmp81_ = luks_pass;
#line 1489 "../src/Utility/Device.vala"
		if (_tmp81_ != NULL) {
#line 9366 "Device.c"
			const gchar* _tmp82_;
			gint _tmp83_;
			gint _tmp84_;
#line 1489 "../src/Utility/Device.vala"
			_tmp82_ = luks_pass;
#line 1489 "../src/Utility/Device.vala"
			_tmp83_ = strlen (_tmp82_);
#line 1489 "../src/Utility/Device.vala"
			_tmp84_ = _tmp83_;
#line 1489 "../src/Utility/Device.vala"
			_tmp80_ = _tmp84_ > 0;
#line 9378 "Device.c"
		} else {
#line 1489 "../src/Utility/Device.vala"
			_tmp80_ = FALSE;
#line 9382 "Device.c"
		}
#line 1489 "../src/Utility/Device.vala"
		if (_tmp80_) {
#line 9386 "Device.c"
			gchar* cmd = NULL;
			const gchar* _tmp85_;
			gchar* _tmp86_;
			gchar* _tmp87_;
			const gchar* _tmp88_;
			const gchar* _tmp89_;
			gchar* _tmp90_;
			gchar* _tmp91_;
			const gchar* _tmp92_;
			const gchar* _tmp93_;
			gchar* _tmp94_;
			gchar* _tmp95_;
			gchar* _tmp96_;
			gchar* _tmp97_;
			gint status = 0;
			const gchar* _tmp98_;
			gchar* _tmp99_ = NULL;
			gchar* _tmp100_ = NULL;
			gint _tmp101_;
#line 1493 "../src/Utility/Device.vala"
			_tmp85_ = luks_pass;
#line 1493 "../src/Utility/Device.vala"
			_tmp86_ = tee_jee_file_system_escape_single_quote (_tmp85_);
#line 1493 "../src/Utility/Device.vala"
			_tmp87_ = _tmp86_;
#line 1493 "../src/Utility/Device.vala"
			_tmp88_ = luks_device->device;
#line 1493 "../src/Utility/Device.vala"
			_tmp89_ = luks_name;
#line 1493 "../src/Utility/Device.vala"
			_tmp90_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp87_, _tmp88_, _tmp89_);
#line 1493 "../src/Utility/Device.vala"
			_tmp91_ = _tmp90_;
#line 1493 "../src/Utility/Device.vala"
			_g_free0 (_tmp87_);
#line 1493 "../src/Utility/Device.vala"
			cmd = _tmp91_;
#line 1496 "../src/Utility/Device.vala"
			_tmp92_ = cmd;
#line 1496 "../src/Utility/Device.vala"
			_tmp93_ = luks_pass;
#line 1496 "../src/Utility/Device.vala"
			_tmp94_ = tee_jee_file_system_escape_single_quote (_tmp93_);
#line 1496 "../src/Utility/Device.vala"
			_tmp95_ = _tmp94_;
#line 1496 "../src/Utility/Device.vala"
			_tmp96_ = string_replace (_tmp92_, _tmp95_, "**PASSWORD**");
#line 1496 "../src/Utility/Device.vala"
			_tmp97_ = _tmp96_;
#line 1496 "../src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp97_);
#line 1496 "../src/Utility/Device.vala"
			_g_free0 (_tmp97_);
#line 1496 "../src/Utility/Device.vala"
			_g_free0 (_tmp95_);
#line 1498 "../src/Utility/Device.vala"
			_tmp98_ = cmd;
#line 1498 "../src/Utility/Device.vala"
			_tmp101_ = tee_jee_process_helper_exec_script_sync (_tmp98_, &_tmp99_, &_tmp100_, FALSE, TRUE, TRUE, FALSE);
#line 1498 "../src/Utility/Device.vala"
			_g_free0 (std_out);
#line 1498 "../src/Utility/Device.vala"
			std_out = _tmp99_;
#line 1498 "../src/Utility/Device.vala"
			_g_free0 (std_err);
#line 1498 "../src/Utility/Device.vala"
			std_err = _tmp100_;
#line 1498 "../src/Utility/Device.vala"
			status = _tmp101_;
#line 1500 "../src/Utility/Device.vala"
			switch (status) {
#line 1500 "../src/Utility/Device.vala"
				case 512:
#line 9460 "Device.c"
				{
					gchar* _tmp102_;
					gchar* _tmp103_;
					const gchar* _tmp104_;
					const gchar* _tmp105_;
#line 1502 "../src/Utility/Device.vala"
					_tmp102_ = g_strdup (_ ("Wrong password"));
#line 1502 "../src/Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1502 "../src/Utility/Device.vala"
					_vala_message = _tmp102_;
#line 1503 "../src/Utility/Device.vala"
					_tmp103_ = g_strdup (_ ("Failed to unlock device"));
#line 1503 "../src/Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1503 "../src/Utility/Device.vala"
					_vala_details = _tmp103_;
#line 1504 "../src/Utility/Device.vala"
					_tmp104_ = _vala_message;
#line 1504 "../src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp104_, FALSE, FALSE);
#line 1505 "../src/Utility/Device.vala"
					_tmp105_ = _vala_details;
#line 1505 "../src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp105_, FALSE, FALSE);
#line 1506 "../src/Utility/Device.vala"
					break;
#line 9488 "Device.c"
				}
				default:
#line 1500 "../src/Utility/Device.vala"
				break;
#line 9493 "Device.c"
			}
#line 1489 "../src/Utility/Device.vala"
			_g_free0 (cmd);
#line 9497 "Device.c"
		}
	}
#line 1513 "../src/Utility/Device.vala"
	_tmp106_ = device_get_block_devices_using_lsblk ("");
#line 1513 "../src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1513 "../src/Utility/Device.vala"
	list = _tmp106_;
#line 9506 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp107_;
		gint _part_size = 0;
		GeeArrayList* _tmp108_;
		gint _tmp109_;
		gint _tmp110_;
		gint _part_index = 0;
#line 1514 "../src/Utility/Device.vala"
		_tmp107_ = list;
#line 1514 "../src/Utility/Device.vala"
		_part_list = _tmp107_;
#line 1514 "../src/Utility/Device.vala"
		_tmp108_ = _part_list;
#line 1514 "../src/Utility/Device.vala"
		_tmp109_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp108_);
#line 1514 "../src/Utility/Device.vala"
		_tmp110_ = _tmp109_;
#line 1514 "../src/Utility/Device.vala"
		_part_size = _tmp110_;
#line 1514 "../src/Utility/Device.vala"
		_part_index = -1;
#line 1514 "../src/Utility/Device.vala"
		while (TRUE) {
#line 9531 "Device.c"
			gint _tmp111_;
			gint _tmp112_;
			Device* part = NULL;
			GeeArrayList* _tmp113_;
			gpointer _tmp114_;
			Device* _tmp115_;
			const gchar* _tmp116_;
			const gchar* _tmp117_;
#line 1514 "../src/Utility/Device.vala"
			_part_index = _part_index + 1;
#line 1514 "../src/Utility/Device.vala"
			_tmp111_ = _part_index;
#line 1514 "../src/Utility/Device.vala"
			_tmp112_ = _part_size;
#line 1514 "../src/Utility/Device.vala"
			if (!(_tmp111_ < _tmp112_)) {
#line 1514 "../src/Utility/Device.vala"
				break;
#line 9550 "Device.c"
			}
#line 1514 "../src/Utility/Device.vala"
			_tmp113_ = _part_list;
#line 1514 "../src/Utility/Device.vala"
			_tmp114_ = gee_abstract_list_get ((GeeAbstractList*) _tmp113_, _part_index);
#line 1514 "../src/Utility/Device.vala"
			part = (Device*) _tmp114_;
#line 1515 "../src/Utility/Device.vala"
			_tmp115_ = part;
#line 1515 "../src/Utility/Device.vala"
			_tmp116_ = _tmp115_->pkname;
#line 1515 "../src/Utility/Device.vala"
			_tmp117_ = luks_device->kname;
#line 1515 "../src/Utility/Device.vala"
			if (g_strcmp0 (_tmp116_, _tmp117_) == 0) {
#line 9566 "Device.c"
				Device* _tmp118_;
				Device* _tmp119_;
#line 1516 "../src/Utility/Device.vala"
				_tmp118_ = part;
#line 1516 "../src/Utility/Device.vala"
				_tmp119_ = _g_object_ref0 (_tmp118_);
#line 1516 "../src/Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1516 "../src/Utility/Device.vala"
				unlocked_device = _tmp119_;
#line 1517 "../src/Utility/Device.vala"
				_g_object_unref0 (part);
#line 1517 "../src/Utility/Device.vala"
				break;
#line 9581 "Device.c"
			}
#line 1514 "../src/Utility/Device.vala"
			_g_object_unref0 (part);
#line 9585 "Device.c"
		}
	}
#line 1521 "../src/Utility/Device.vala"
	is_error = FALSE;
#line 1522 "../src/Utility/Device.vala"
	_tmp120_ = unlocked_device;
#line 1522 "../src/Utility/Device.vala"
	if (_tmp120_ == NULL) {
#line 9594 "Device.c"
		const gchar* _tmp121_;
		gchar* _tmp122_;
		gchar* _tmp123_;
		gchar* _tmp124_;
		const gchar* _tmp125_;
		gchar* _tmp126_;
#line 1523 "../src/Utility/Device.vala"
		_tmp121_ = luks_device->device;
#line 1523 "../src/Utility/Device.vala"
		_tmp122_ = g_strdup_printf (" '%s'", _tmp121_);
#line 1523 "../src/Utility/Device.vala"
		_tmp123_ = _tmp122_;
#line 1523 "../src/Utility/Device.vala"
		_tmp124_ = g_strconcat (_ ("Failed to unlock device"), _tmp123_, NULL);
#line 1523 "../src/Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1523 "../src/Utility/Device.vala"
		_vala_message = _tmp124_;
#line 1523 "../src/Utility/Device.vala"
		_g_free0 (_tmp123_);
#line 1524 "../src/Utility/Device.vala"
		_tmp125_ = std_err;
#line 1524 "../src/Utility/Device.vala"
		_tmp126_ = g_strdup (_tmp125_);
#line 1524 "../src/Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1524 "../src/Utility/Device.vala"
		_vala_details = _tmp126_;
#line 1525 "../src/Utility/Device.vala"
		is_error = TRUE;
#line 9625 "Device.c"
	} else {
		gchar* _tmp127_;
		Device* _tmp128_;
		const gchar* _tmp129_;
		gchar* _tmp130_;
#line 1528 "../src/Utility/Device.vala"
		_tmp127_ = g_strdup (_ ("Unlocked successfully"));
#line 1528 "../src/Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1528 "../src/Utility/Device.vala"
		_vala_message = _tmp127_;
#line 1529 "../src/Utility/Device.vala"
		_tmp128_ = unlocked_device;
#line 1529 "../src/Utility/Device.vala"
		_tmp129_ = _tmp128_->mapped_name;
#line 1529 "../src/Utility/Device.vala"
		_tmp130_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp129_);
#line 1529 "../src/Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1529 "../src/Utility/Device.vala"
		_vala_details = _tmp130_;
#line 9647 "Device.c"
	}
#line 1532 "../src/Utility/Device.vala"
	if (parent_window != NULL) {
#line 9651 "Device.c"
		const gchar* _tmp131_;
		const gchar* _tmp132_;
#line 1533 "../src/Utility/Device.vala"
		_tmp131_ = _vala_message;
#line 1533 "../src/Utility/Device.vala"
		_tmp132_ = _vala_details;
#line 1533 "../src/Utility/Device.vala"
		tee_jee_gtk_helper_gtk_messagebox (_tmp131_, _tmp132_, parent_window, is_error);
#line 9660 "Device.c"
	}
#line 1536 "../src/Utility/Device.vala"
	result = unlocked_device;
#line 1536 "../src/Utility/Device.vala"
	_g_free0 (luks_name);
#line 1536 "../src/Utility/Device.vala"
	_g_free0 (luks_pass);
#line 1536 "../src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1536 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1536 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1536 "../src/Utility/Device.vala"
	if (message) {
#line 1536 "../src/Utility/Device.vala"
		*message = _vala_message;
#line 9678 "Device.c"
	} else {
#line 1536 "../src/Utility/Device.vala"
		_g_free0 (_vala_message);
#line 9682 "Device.c"
	}
#line 1536 "../src/Utility/Device.vala"
	if (details) {
#line 1536 "../src/Utility/Device.vala"
		*details = _vala_details;
#line 9688 "Device.c"
	} else {
#line 1536 "../src/Utility/Device.vala"
		_g_free0 (_vala_details);
#line 9692 "Device.c"
	}
#line 1536 "../src/Utility/Device.vala"
	return result;
#line 9696 "Device.c"
}

gboolean
device_luks_lock (const gchar* kname,
                  GtkWindow* parent_window)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean result;
#line 1539 "../src/Utility/Device.vala"
	g_return_val_if_fail (kname != NULL, FALSE);
#line 1541 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("cryptsetup luksClose %s", kname);
#line 1541 "../src/Utility/Device.vala"
	cmd = _tmp0_;
#line 1543 "../src/Utility/Device.vala"
	_tmp1_ = cmd;
#line 1543 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 1546 "../src/Utility/Device.vala"
	_tmp2_ = cmd;
#line 1546 "../src/Utility/Device.vala"
	_tmp5_ = tee_jee_process_helper_exec_script_sync (_tmp2_, &_tmp3_, &_tmp4_, FALSE, TRUE, TRUE, FALSE);
#line 1546 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1546 "../src/Utility/Device.vala"
	std_out = _tmp3_;
#line 1546 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1546 "../src/Utility/Device.vala"
	std_err = _tmp4_;
#line 1546 "../src/Utility/Device.vala"
	status = _tmp5_;
#line 1547 "../src/Utility/Device.vala"
	_tmp6_ = std_out;
#line 1547 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp6_, FALSE);
#line 1548 "../src/Utility/Device.vala"
	_tmp7_ = std_err;
#line 1548 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp7_, FALSE);
#line 1550 "../src/Utility/Device.vala"
	if (status != 0) {
#line 1551 "../src/Utility/Device.vala"
		if (parent_window != NULL) {
#line 9752 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp8_;
			const gchar* _tmp9_;
#line 1552 "../src/Utility/Device.vala"
			_tmp8_ = g_strdup_printf ("Failed to lock device: %s", kname);
#line 1552 "../src/Utility/Device.vala"
			msg = _tmp8_;
#line 1553 "../src/Utility/Device.vala"
			_tmp9_ = msg;
#line 1553 "../src/Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp9_, parent_window, TRUE);
#line 1551 "../src/Utility/Device.vala"
			_g_free0 (msg);
#line 9766 "Device.c"
		}
	}
#line 1557 "../src/Utility/Device.vala"
	result = status == 0;
#line 1557 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1557 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1557 "../src/Utility/Device.vala"
	_g_free0 (cmd);
#line 1557 "../src/Utility/Device.vala"
	return result;
#line 9779 "Device.c"
}

gboolean
device_mount (const gchar* dev_name_or_uuid,
              const gchar* mount_point,
              const gchar* mount_options,
              gboolean silent)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* device = NULL;
	gchar* _tmp1_;
	gchar* uuid = NULL;
	gchar* _tmp2_;
	GeeArrayList* mps = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gint _tmp52_;
	gint _tmp53_;
	const gchar* _tmp58_;
	gchar* _tmp59_ = NULL;
	gchar* _tmp60_ = NULL;
	gint _tmp61_;
	gboolean result;
#line 1571 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1571 "../src/Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1571 "../src/Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, FALSE);
#line 1579 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1579 "../src/Utility/Device.vala"
	cmd = _tmp0_;
#line 1584 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1584 "../src/Utility/Device.vala"
	device = _tmp1_;
#line 1585 "../src/Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 1585 "../src/Utility/Device.vala"
	uuid = _tmp2_;
#line 1589 "../src/Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 9829 "Device.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 1590 "../src/Utility/Device.vala"
		_tmp3_ = g_strdup (dev_name_or_uuid);
#line 1590 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1590 "../src/Utility/Device.vala"
		device = _tmp3_;
#line 1591 "../src/Utility/Device.vala"
		_tmp4_ = device_get_device_uuid (dev_name_or_uuid);
#line 1591 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1591 "../src/Utility/Device.vala"
		uuid = _tmp4_;
#line 9844 "Device.c"
	} else {
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 1594 "../src/Utility/Device.vala"
		_tmp5_ = g_strdup (dev_name_or_uuid);
#line 1594 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1594 "../src/Utility/Device.vala"
		uuid = _tmp5_;
#line 1595 "../src/Utility/Device.vala"
		_tmp6_ = uuid;
#line 1595 "../src/Utility/Device.vala"
		_tmp7_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp6_);
#line 1595 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1595 "../src/Utility/Device.vala"
		device = _tmp7_;
#line 1596 "../src/Utility/Device.vala"
		_tmp8_ = device;
#line 1596 "../src/Utility/Device.vala"
		_tmp9_ = device_resolve_device_name (_tmp8_);
#line 1596 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1596 "../src/Utility/Device.vala"
		device = _tmp9_;
#line 9873 "Device.c"
	}
#line 1601 "../src/Utility/Device.vala"
	_tmp10_ = device_get_device_mount_points (dev_name_or_uuid);
#line 1601 "../src/Utility/Device.vala"
	mps = _tmp10_;
#line 1603 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 1604 "../src/Utility/Device.vala"
	_tmp11_ = device;
#line 1604 "../src/Utility/Device.vala"
	_tmp12_ = g_strdup_printf ("arg=%s, device=%s", dev_name_or_uuid, _tmp11_);
#line 1604 "../src/Utility/Device.vala"
	_tmp13_ = _tmp12_;
#line 1604 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp13_);
#line 1604 "../src/Utility/Device.vala"
	_g_free0 (_tmp13_);
#line 9891 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp14_;
		gint _mp_size = 0;
		GeeArrayList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _mp_index = 0;
#line 1605 "../src/Utility/Device.vala"
		_tmp14_ = mps;
#line 1605 "../src/Utility/Device.vala"
		_mp_list = _tmp14_;
#line 1605 "../src/Utility/Device.vala"
		_tmp15_ = _mp_list;
#line 1605 "../src/Utility/Device.vala"
		_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 1605 "../src/Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1605 "../src/Utility/Device.vala"
		_mp_size = _tmp17_;
#line 1605 "../src/Utility/Device.vala"
		_mp_index = -1;
#line 1605 "../src/Utility/Device.vala"
		while (TRUE) {
#line 9916 "Device.c"
			gint _tmp18_;
			gint _tmp19_;
			MountEntry* mp = NULL;
			GeeArrayList* _tmp20_;
			gpointer _tmp21_;
			MountEntry* _tmp22_;
			const gchar* _tmp23_;
#line 1605 "../src/Utility/Device.vala"
			_mp_index = _mp_index + 1;
#line 1605 "../src/Utility/Device.vala"
			_tmp18_ = _mp_index;
#line 1605 "../src/Utility/Device.vala"
			_tmp19_ = _mp_size;
#line 1605 "../src/Utility/Device.vala"
			if (!(_tmp18_ < _tmp19_)) {
#line 1605 "../src/Utility/Device.vala"
				break;
#line 9934 "Device.c"
			}
#line 1605 "../src/Utility/Device.vala"
			_tmp20_ = _mp_list;
#line 1605 "../src/Utility/Device.vala"
			_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _mp_index);
#line 1605 "../src/Utility/Device.vala"
			mp = (MountEntry*) _tmp21_;
#line 1606 "../src/Utility/Device.vala"
			_tmp22_ = mp;
#line 1606 "../src/Utility/Device.vala"
			_tmp23_ = _tmp22_->mount_point;
#line 1606 "../src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp23_);
#line 1605 "../src/Utility/Device.vala"
			_g_object_unref0 (mp);
#line 9950 "Device.c"
		}
	}
#line 1608 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 9955 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp24_;
		gint _mp_size = 0;
		GeeArrayList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _mp_index = 0;
#line 1610 "../src/Utility/Device.vala"
		_tmp24_ = mps;
#line 1610 "../src/Utility/Device.vala"
		_mp_list = _tmp24_;
#line 1610 "../src/Utility/Device.vala"
		_tmp25_ = _mp_list;
#line 1610 "../src/Utility/Device.vala"
		_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 1610 "../src/Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1610 "../src/Utility/Device.vala"
		_mp_size = _tmp27_;
#line 1610 "../src/Utility/Device.vala"
		_mp_index = -1;
#line 1610 "../src/Utility/Device.vala"
		while (TRUE) {
#line 9980 "Device.c"
			gint _tmp28_;
			gint _tmp29_;
			MountEntry* mp = NULL;
			GeeArrayList* _tmp30_;
			gpointer _tmp31_;
			gboolean _tmp32_ = FALSE;
			MountEntry* _tmp33_;
			const gchar* _tmp34_;
#line 1610 "../src/Utility/Device.vala"
			_mp_index = _mp_index + 1;
#line 1610 "../src/Utility/Device.vala"
			_tmp28_ = _mp_index;
#line 1610 "../src/Utility/Device.vala"
			_tmp29_ = _mp_size;
#line 1610 "../src/Utility/Device.vala"
			if (!(_tmp28_ < _tmp29_)) {
#line 1610 "../src/Utility/Device.vala"
				break;
#line 9999 "Device.c"
			}
#line 1610 "../src/Utility/Device.vala"
			_tmp30_ = _mp_list;
#line 1610 "../src/Utility/Device.vala"
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _mp_index);
#line 1610 "../src/Utility/Device.vala"
			mp = (MountEntry*) _tmp31_;
#line 1611 "../src/Utility/Device.vala"
			_tmp33_ = mp;
#line 1611 "../src/Utility/Device.vala"
			_tmp34_ = _tmp33_->mount_point;
#line 1611 "../src/Utility/Device.vala"
			if (g_strcmp0 (_tmp34_, mount_point) == 0) {
#line 10013 "Device.c"
				MountEntry* _tmp35_;
				const gchar* _tmp36_;
#line 1611 "../src/Utility/Device.vala"
				_tmp35_ = mp;
#line 1611 "../src/Utility/Device.vala"
				_tmp36_ = _tmp35_->mount_options;
#line 1611 "../src/Utility/Device.vala"
				_tmp32_ = string_contains (_tmp36_, mount_options);
#line 10022 "Device.c"
			} else {
#line 1611 "../src/Utility/Device.vala"
				_tmp32_ = FALSE;
#line 10026 "Device.c"
			}
#line 1611 "../src/Utility/Device.vala"
			if (_tmp32_) {
#line 1612 "../src/Utility/Device.vala"
				if (!silent) {
#line 10032 "Device.c"
					gchar* msg = NULL;
					const gchar* _tmp37_;
					gchar* _tmp38_;
					MountEntry* _tmp39_;
					const gchar* _tmp40_;
					gint _tmp41_;
					gint _tmp42_;
					const gchar* _tmp49_;
					gchar* _tmp50_;
					gchar* _tmp51_;
#line 1613 "../src/Utility/Device.vala"
					_tmp37_ = device;
#line 1613 "../src/Utility/Device.vala"
					_tmp38_ = g_strdup_printf ("%s is mounted at: %s", _tmp37_, mount_point);
#line 1613 "../src/Utility/Device.vala"
					msg = _tmp38_;
#line 1614 "../src/Utility/Device.vala"
					_tmp39_ = mp;
#line 1614 "../src/Utility/Device.vala"
					_tmp40_ = _tmp39_->mount_options;
#line 1614 "../src/Utility/Device.vala"
					_tmp41_ = strlen (_tmp40_);
#line 1614 "../src/Utility/Device.vala"
					_tmp42_ = _tmp41_;
#line 1614 "../src/Utility/Device.vala"
					if (_tmp42_ > 0) {
#line 10059 "Device.c"
						const gchar* _tmp43_;
						MountEntry* _tmp44_;
						const gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						gchar* _tmp48_;
#line 1615 "../src/Utility/Device.vala"
						_tmp43_ = msg;
#line 1615 "../src/Utility/Device.vala"
						_tmp44_ = mp;
#line 1615 "../src/Utility/Device.vala"
						_tmp45_ = _tmp44_->mount_options;
#line 1615 "../src/Utility/Device.vala"
						_tmp46_ = g_strdup_printf (", options: %s", _tmp45_);
#line 1615 "../src/Utility/Device.vala"
						_tmp47_ = _tmp46_;
#line 1615 "../src/Utility/Device.vala"
						_tmp48_ = g_strconcat (_tmp43_, _tmp47_, NULL);
#line 1615 "../src/Utility/Device.vala"
						_g_free0 (msg);
#line 1615 "../src/Utility/Device.vala"
						msg = _tmp48_;
#line 1615 "../src/Utility/Device.vala"
						_g_free0 (_tmp47_);
#line 10084 "Device.c"
					}
#line 1617 "../src/Utility/Device.vala"
					_tmp49_ = msg;
#line 1617 "../src/Utility/Device.vala"
					_tmp50_ = g_strdup_printf ("\n%s\n", _tmp49_);
#line 1617 "../src/Utility/Device.vala"
					_tmp51_ = _tmp50_;
#line 1617 "../src/Utility/Device.vala"
					tee_jee_logging_log_msg (_tmp51_, FALSE);
#line 1617 "../src/Utility/Device.vala"
					_g_free0 (_tmp51_);
#line 1612 "../src/Utility/Device.vala"
					_g_free0 (msg);
#line 10098 "Device.c"
				}
#line 1619 "../src/Utility/Device.vala"
				result = TRUE;
#line 1619 "../src/Utility/Device.vala"
				_g_object_unref0 (mp);
#line 1619 "../src/Utility/Device.vala"
				_g_object_unref0 (mps);
#line 1619 "../src/Utility/Device.vala"
				_g_free0 (uuid);
#line 1619 "../src/Utility/Device.vala"
				_g_free0 (device);
#line 1619 "../src/Utility/Device.vala"
				_g_free0 (std_err);
#line 1619 "../src/Utility/Device.vala"
				_g_free0 (std_out);
#line 1619 "../src/Utility/Device.vala"
				_g_free0 (cmd);
#line 1619 "../src/Utility/Device.vala"
				return result;
#line 10118 "Device.c"
			}
#line 1610 "../src/Utility/Device.vala"
			_g_object_unref0 (mp);
#line 10122 "Device.c"
		}
	}
#line 1623 "../src/Utility/Device.vala"
	tee_jee_file_system_dir_create (mount_point, FALSE);
#line 1627 "../src/Utility/Device.vala"
	device_unmount (mount_point);
#line 1631 "../src/Utility/Device.vala"
	_tmp52_ = strlen (mount_options);
#line 1631 "../src/Utility/Device.vala"
	_tmp53_ = _tmp52_;
#line 1631 "../src/Utility/Device.vala"
	if (_tmp53_ > 0) {
#line 10135 "Device.c"
		const gchar* _tmp54_;
		gchar* _tmp55_;
#line 1632 "../src/Utility/Device.vala"
		_tmp54_ = device;
#line 1632 "../src/Utility/Device.vala"
		_tmp55_ = g_strdup_printf ("mount -o %s \"%s\" \"%s\"", mount_options, _tmp54_, mount_point);
#line 1632 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1632 "../src/Utility/Device.vala"
		cmd = _tmp55_;
#line 10146 "Device.c"
	} else {
		const gchar* _tmp56_;
		gchar* _tmp57_;
#line 1635 "../src/Utility/Device.vala"
		_tmp56_ = device;
#line 1635 "../src/Utility/Device.vala"
		_tmp57_ = g_strdup_printf ("mount \"%s\" \"%s\"", _tmp56_, mount_point);
#line 1635 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1635 "../src/Utility/Device.vala"
		cmd = _tmp57_;
#line 10158 "Device.c"
	}
#line 1638 "../src/Utility/Device.vala"
	_tmp58_ = cmd;
#line 1638 "../src/Utility/Device.vala"
	_tmp61_ = tee_jee_process_helper_exec_sync (_tmp58_, &_tmp59_, &_tmp60_);
#line 1638 "../src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1638 "../src/Utility/Device.vala"
	std_out = _tmp59_;
#line 1638 "../src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1638 "../src/Utility/Device.vala"
	std_err = _tmp60_;
#line 1638 "../src/Utility/Device.vala"
	ret_val = _tmp61_;
#line 1640 "../src/Utility/Device.vala"
	if (ret_val != 0) {
#line 10176 "Device.c"
		const gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		const gchar* _tmp65_;
#line 1641 "../src/Utility/Device.vala"
		_tmp62_ = device;
#line 1641 "../src/Utility/Device.vala"
		_tmp63_ = g_strdup_printf ("Failed to mount device '%s' at mount point '%s'", _tmp62_, mount_point);
#line 1641 "../src/Utility/Device.vala"
		_tmp64_ = _tmp63_;
#line 1641 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp64_, FALSE, FALSE);
#line 1641 "../src/Utility/Device.vala"
		_g_free0 (_tmp64_);
#line 1642 "../src/Utility/Device.vala"
		_tmp65_ = std_err;
#line 1642 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp65_, FALSE, FALSE);
#line 1643 "../src/Utility/Device.vala"
		result = FALSE;
#line 1643 "../src/Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1643 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1643 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1643 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1643 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1643 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1643 "../src/Utility/Device.vala"
		return result;
#line 10211 "Device.c"
	} else {
#line 1646 "../src/Utility/Device.vala"
		if (!silent) {
#line 10215 "Device.c"
			Device* dev = NULL;
			const gchar* _tmp66_;
			Device* _tmp67_;
			gchar* _tmp68_ = NULL;
			Device* _tmp69_;
			gchar* _tmp75_ = NULL;
			gint _tmp76_;
			gint _tmp77_;
			gchar* _tmp80_;
			gchar* _tmp81_;
#line 1647 "../src/Utility/Device.vala"
			_tmp66_ = device;
#line 1647 "../src/Utility/Device.vala"
			_tmp67_ = device_get_device_by_name (_tmp66_);
#line 1647 "../src/Utility/Device.vala"
			dev = _tmp67_;
#line 1649 "../src/Utility/Device.vala"
			_tmp69_ = dev;
#line 1649 "../src/Utility/Device.vala"
			if (_tmp69_ == NULL) {
#line 10236 "Device.c"
				const gchar* _tmp70_;
				gchar* _tmp71_;
#line 1649 "../src/Utility/Device.vala"
				_tmp70_ = device;
#line 1649 "../src/Utility/Device.vala"
				_tmp71_ = g_strdup (_tmp70_);
#line 1649 "../src/Utility/Device.vala"
				_g_free0 (_tmp68_);
#line 1649 "../src/Utility/Device.vala"
				_tmp68_ = _tmp71_;
#line 10247 "Device.c"
			} else {
				Device* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
#line 1649 "../src/Utility/Device.vala"
				_tmp72_ = dev;
#line 1649 "../src/Utility/Device.vala"
				_tmp73_ = device_get_device_name_with_parent (_tmp72_);
#line 1649 "../src/Utility/Device.vala"
				_tmp74_ = _tmp73_;
#line 1649 "../src/Utility/Device.vala"
				_g_free0 (_tmp68_);
#line 1649 "../src/Utility/Device.vala"
				_tmp68_ = _tmp74_;
#line 10262 "Device.c"
			}
#line 1650 "../src/Utility/Device.vala"
			_tmp76_ = strlen (mount_options);
#line 1650 "../src/Utility/Device.vala"
			_tmp77_ = _tmp76_;
#line 1650 "../src/Utility/Device.vala"
			if (_tmp77_ > 0) {
#line 10270 "Device.c"
				gchar* _tmp78_;
#line 1650 "../src/Utility/Device.vala"
				_tmp78_ = g_strdup_printf (" (%s)", mount_options);
#line 1650 "../src/Utility/Device.vala"
				_g_free0 (_tmp75_);
#line 1650 "../src/Utility/Device.vala"
				_tmp75_ = _tmp78_;
#line 10278 "Device.c"
			} else {
				gchar* _tmp79_;
#line 1650 "../src/Utility/Device.vala"
				_tmp79_ = g_strdup ("");
#line 1650 "../src/Utility/Device.vala"
				_g_free0 (_tmp75_);
#line 1650 "../src/Utility/Device.vala"
				_tmp75_ = _tmp79_;
#line 10287 "Device.c"
			}
#line 1648 "../src/Utility/Device.vala"
			_tmp80_ = g_strdup_printf ("Mounted '%s'%s at '%s'", _tmp68_, _tmp75_, mount_point);
#line 1648 "../src/Utility/Device.vala"
			_tmp81_ = _tmp80_;
#line 1648 "../src/Utility/Device.vala"
			tee_jee_logging_log_msg (_tmp81_, FALSE);
#line 1648 "../src/Utility/Device.vala"
			_g_free0 (_tmp81_);
#line 1646 "../src/Utility/Device.vala"
			_g_free0 (_tmp75_);
#line 1646 "../src/Utility/Device.vala"
			_g_free0 (_tmp68_);
#line 1646 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 10303 "Device.c"
		}
#line 1653 "../src/Utility/Device.vala"
		result = TRUE;
#line 1653 "../src/Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1653 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1653 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1653 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1653 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1653 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1653 "../src/Utility/Device.vala"
		return result;
#line 10321 "Device.c"
	}
}

gchar*
device_automount (const gchar* dev_name_or_uuid,
                  const gchar* mount_options,
                  const gchar* mount_prefix)
{
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp9_;
	Device* dev = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	Device* _tmp12_;
	Device* _tmp13_;
	gchar* mount_point = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1668 "../src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 1668 "../src/Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, NULL);
#line 1668 "../src/Utility/Device.vala"
	g_return_val_if_fail (mount_prefix != NULL, NULL);
#line 1675 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1675 "../src/Utility/Device.vala"
	device = _tmp0_;
#line 1676 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1676 "../src/Utility/Device.vala"
	uuid = _tmp1_;
#line 1680 "../src/Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 10364 "Device.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1681 "../src/Utility/Device.vala"
		_tmp2_ = g_strdup (dev_name_or_uuid);
#line 1681 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1681 "../src/Utility/Device.vala"
		device = _tmp2_;
#line 1682 "../src/Utility/Device.vala"
		_tmp3_ = device_get_device_uuid (dev_name_or_uuid);
#line 1682 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1682 "../src/Utility/Device.vala"
		uuid = _tmp3_;
#line 10379 "Device.c"
	} else {
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1685 "../src/Utility/Device.vala"
		_tmp4_ = g_strdup (dev_name_or_uuid);
#line 1685 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1685 "../src/Utility/Device.vala"
		uuid = _tmp4_;
#line 1686 "../src/Utility/Device.vala"
		_tmp5_ = uuid;
#line 1686 "../src/Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp5_);
#line 1686 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1686 "../src/Utility/Device.vala"
		device = _tmp6_;
#line 1687 "../src/Utility/Device.vala"
		_tmp7_ = device;
#line 1687 "../src/Utility/Device.vala"
		_tmp8_ = device_resolve_device_name (_tmp7_);
#line 1687 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1687 "../src/Utility/Device.vala"
		device = _tmp8_;
#line 10408 "Device.c"
	}
#line 1692 "../src/Utility/Device.vala"
	_tmp9_ = device_get_block_devices_using_lsblk ("");
#line 1692 "../src/Utility/Device.vala"
	list = _tmp9_;
#line 1693 "../src/Utility/Device.vala"
	_tmp10_ = list;
#line 1693 "../src/Utility/Device.vala"
	_tmp11_ = uuid;
#line 1693 "../src/Utility/Device.vala"
	_tmp12_ = device_find_device_in_list (_tmp10_, _tmp11_);
#line 1693 "../src/Utility/Device.vala"
	dev = _tmp12_;
#line 1694 "../src/Utility/Device.vala"
	_tmp13_ = dev;
#line 1694 "../src/Utility/Device.vala"
	if (_tmp13_ != NULL) {
#line 10426 "Device.c"
		Device* _tmp14_;
		GeeArrayList* _tmp15_;
		gpointer _tmp16_;
		MountEntry* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 1695 "../src/Utility/Device.vala"
		_tmp14_ = dev;
#line 1695 "../src/Utility/Device.vala"
		_tmp15_ = _tmp14_->mount_points;
#line 1695 "../src/Utility/Device.vala"
		_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, 0);
#line 1695 "../src/Utility/Device.vala"
		_tmp17_ = (MountEntry*) _tmp16_;
#line 1695 "../src/Utility/Device.vala"
		_tmp18_ = _tmp17_->mount_point;
#line 1695 "../src/Utility/Device.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 1695 "../src/Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1695 "../src/Utility/Device.vala"
		_g_object_unref0 (_tmp17_);
#line 1695 "../src/Utility/Device.vala"
		result = _tmp20_;
#line 1695 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1695 "../src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1695 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1695 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1695 "../src/Utility/Device.vala"
		return result;
#line 10462 "Device.c"
	}
#line 1700 "../src/Utility/Device.vala"
	_tmp21_ = uuid;
#line 1700 "../src/Utility/Device.vala"
	_tmp22_ = g_strdup_printf ("%s/%s", mount_prefix, _tmp21_);
#line 1700 "../src/Utility/Device.vala"
	mount_point = _tmp22_;
#line 10470 "Device.c"
	{
		GFile* file = NULL;
		const gchar* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
#line 1703 "../src/Utility/Device.vala"
		_tmp23_ = mount_point;
#line 1703 "../src/Utility/Device.vala"
		_tmp24_ = g_file_new_for_path (_tmp23_);
#line 1703 "../src/Utility/Device.vala"
		file = _tmp24_;
#line 1704 "../src/Utility/Device.vala"
		_tmp25_ = file;
#line 1704 "../src/Utility/Device.vala"
		if (!g_file_query_exists (_tmp25_, NULL)) {
#line 10486 "Device.c"
			GFile* _tmp26_;
#line 1705 "../src/Utility/Device.vala"
			_tmp26_ = file;
#line 1705 "../src/Utility/Device.vala"
			g_file_make_directory_with_parents (_tmp26_, NULL, &_inner_error0_);
#line 1705 "../src/Utility/Device.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1705 "../src/Utility/Device.vala"
				_g_object_unref0 (file);
#line 10496 "Device.c"
				goto __catch0_g_error;
			}
		}
#line 1702 "../src/Utility/Device.vala"
		_g_object_unref0 (file);
#line 10502 "Device.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1702 "../src/Utility/Device.vala"
		e = _inner_error0_;
#line 1702 "../src/Utility/Device.vala"
		_inner_error0_ = NULL;
#line 1709 "../src/Utility/Device.vala"
		_tmp27_ = e;
#line 1709 "../src/Utility/Device.vala"
		_tmp28_ = _tmp27_->message;
#line 1709 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp28_, FALSE, FALSE);
#line 1710 "../src/Utility/Device.vala"
		_tmp29_ = g_strdup ("");
#line 1710 "../src/Utility/Device.vala"
		result = _tmp29_;
#line 1710 "../src/Utility/Device.vala"
		_g_error_free0 (e);
#line 1710 "../src/Utility/Device.vala"
		_g_free0 (mount_point);
#line 1710 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1710 "../src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1710 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1710 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1710 "../src/Utility/Device.vala"
		return result;
#line 10539 "Device.c"
	}
	__finally0:
#line 1702 "../src/Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1702 "../src/Utility/Device.vala"
		_g_free0 (mount_point);
#line 1702 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1702 "../src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1702 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1702 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1702 "../src/Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1702 "../src/Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1702 "../src/Utility/Device.vala"
		return NULL;
#line 10560 "Device.c"
	}
#line 1715 "../src/Utility/Device.vala"
	_tmp30_ = uuid;
#line 1715 "../src/Utility/Device.vala"
	_tmp31_ = mount_point;
#line 1715 "../src/Utility/Device.vala"
	if (device_mount (_tmp30_, _tmp31_, mount_options, FALSE)) {
#line 1716 "../src/Utility/Device.vala"
		result = mount_point;
#line 1716 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1716 "../src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1716 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1716 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1716 "../src/Utility/Device.vala"
		return result;
#line 10580 "Device.c"
	} else {
		gchar* _tmp32_;
#line 1719 "../src/Utility/Device.vala"
		_tmp32_ = g_strdup ("");
#line 1719 "../src/Utility/Device.vala"
		result = _tmp32_;
#line 1719 "../src/Utility/Device.vala"
		_g_free0 (mount_point);
#line 1719 "../src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1719 "../src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1719 "../src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1719 "../src/Utility/Device.vala"
		_g_free0 (device);
#line 1719 "../src/Utility/Device.vala"
		return result;
#line 10599 "Device.c"
	}
}

gboolean
device_unmount (const gchar* mount_point)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1723 "../src/Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1728 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1728 "../src/Utility/Device.vala"
	cmd = _tmp0_;
#line 1734 "../src/Utility/Device.vala"
	if (!device_mount_point_in_use (mount_point)) {
#line 1735 "../src/Utility/Device.vala"
		result = TRUE;
#line 1735 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1735 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1735 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1735 "../src/Utility/Device.vala"
		return result;
#line 10631 "Device.c"
	}
	{
		gchar* cmd_unmount = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gint _tmp14_;
#line 1742 "../src/Utility/Device.vala"
		_tmp1_ = g_strdup_printf ("cat /proc/mounts | awk '{print $2}' | grep '%s' | sort -r | xargs umou" \
"nt", mount_point);
#line 1742 "../src/Utility/Device.vala"
		cmd_unmount = _tmp1_;
#line 1744 "../src/Utility/Device.vala"
		_tmp2_ = g_strdup_printf (": '%s'", mount_point);
#line 1744 "../src/Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1744 "../src/Utility/Device.vala"
		_tmp4_ = g_strconcat (_ ("Unmounting from"), _tmp3_, NULL);
#line 1744 "../src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1744 "../src/Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp5_);
#line 1744 "../src/Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1744 "../src/Utility/Device.vala"
		_g_free0 (_tmp3_);
#line 1747 "../src/Utility/Device.vala"
		_tmp6_ = g_strdup ("sync");
#line 1747 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1747 "../src/Utility/Device.vala"
		cmd = _tmp6_;
#line 1748 "../src/Utility/Device.vala"
		_tmp7_ = cmd;
#line 1748 "../src/Utility/Device.vala"
		g_spawn_command_line_sync (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_inner_error0_);
#line 1748 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1748 "../src/Utility/Device.vala"
		std_out = _tmp8_;
#line 1748 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1748 "../src/Utility/Device.vala"
		std_err = _tmp9_;
#line 1748 "../src/Utility/Device.vala"
		ret_val = _tmp10_;
#line 1748 "../src/Utility/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1748 "../src/Utility/Device.vala"
			_g_free0 (cmd_unmount);
#line 10691 "Device.c"
			goto __catch0_g_error;
		}
#line 1752 "../src/Utility/Device.vala"
		_tmp11_ = cmd_unmount;
#line 1752 "../src/Utility/Device.vala"
		_tmp14_ = tee_jee_process_helper_exec_script_sync (_tmp11_, &_tmp12_, &_tmp13_, FALSE, FALSE, TRUE, FALSE);
#line 1752 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1752 "../src/Utility/Device.vala"
		std_out = _tmp12_;
#line 1752 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1752 "../src/Utility/Device.vala"
		std_err = _tmp13_;
#line 1752 "../src/Utility/Device.vala"
		ret_val = _tmp14_;
#line 1754 "../src/Utility/Device.vala"
		if (ret_val != 0) {
#line 10710 "Device.c"
			const gchar* _tmp15_;
#line 1755 "../src/Utility/Device.vala"
			tee_jee_logging_log_error (_ ("Failed to unmount"), FALSE, FALSE);
#line 1756 "../src/Utility/Device.vala"
			_tmp15_ = std_err;
#line 1756 "../src/Utility/Device.vala"
			tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 10718 "Device.c"
		}
#line 1740 "../src/Utility/Device.vala"
		_g_free0 (cmd_unmount);
#line 10722 "Device.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 1740 "../src/Utility/Device.vala"
		e = _inner_error0_;
#line 1740 "../src/Utility/Device.vala"
		_inner_error0_ = NULL;
#line 1760 "../src/Utility/Device.vala"
		_tmp16_ = e;
#line 1760 "../src/Utility/Device.vala"
		_tmp17_ = _tmp16_->message;
#line 1760 "../src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 1761 "../src/Utility/Device.vala"
		result = FALSE;
#line 1761 "../src/Utility/Device.vala"
		_g_error_free0 (e);
#line 1761 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1761 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1761 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1761 "../src/Utility/Device.vala"
		return result;
#line 10752 "Device.c"
	}
	__finally0:
#line 1740 "../src/Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10757 "Device.c"
		gboolean _tmp18_ = FALSE;
#line 1740 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1740 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1740 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1740 "../src/Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1740 "../src/Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1740 "../src/Utility/Device.vala"
		return _tmp18_;
#line 10771 "Device.c"
	}
#line 1765 "../src/Utility/Device.vala"
	if (!device_mount_point_in_use (mount_point)) {
#line 1766 "../src/Utility/Device.vala"
		result = TRUE;
#line 1766 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1766 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1766 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1766 "../src/Utility/Device.vala"
		return result;
#line 10785 "Device.c"
	} else {
#line 1769 "../src/Utility/Device.vala"
		result = FALSE;
#line 1769 "../src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1769 "../src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1769 "../src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1769 "../src/Utility/Device.vala"
		return result;
#line 10797 "Device.c"
	}
}

gchar*
device_description (Device* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 1825 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1826 "../src/Utility/Device.vala"
	_tmp0_ = device_description_formatted (self);
#line 1826 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1826 "../src/Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1826 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1826 "../src/Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1826 "../src/Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1826 "../src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1826 "../src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1826 "../src/Utility/Device.vala"
	result = _tmp5_;
#line 1826 "../src/Utility/Device.vala"
	return result;
#line 10833 "Device.c"
}

gchar*
device_description_formatted (Device* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* result;
#line 1829 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1830 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1830 "../src/Utility/Device.vala"
	s = _tmp0_;
#line 1832 "../src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 1832 "../src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 10855 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
#line 1833 "../src/Utility/Device.vala"
		_tmp2_ = s;
#line 1833 "../src/Utility/Device.vala"
		_tmp3_ = self->kname;
#line 1833 "../src/Utility/Device.vala"
		_tmp4_ = g_strconcat ("<b>", _tmp3_, NULL);
#line 1833 "../src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1833 "../src/Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp5_, "</b> ~", NULL);
#line 1833 "../src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1833 "../src/Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp2_, _tmp7_, NULL);
#line 1833 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1833 "../src/Utility/Device.vala"
		s = _tmp8_;
#line 1833 "../src/Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 1833 "../src/Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1834 "../src/Utility/Device.vala"
		_tmp9_ = self->vendor;
#line 1834 "../src/Utility/Device.vala"
		_tmp10_ = strlen (_tmp9_);
#line 1834 "../src/Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1834 "../src/Utility/Device.vala"
		if (_tmp11_ > 0) {
#line 10899 "Device.c"
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 1835 "../src/Utility/Device.vala"
			_tmp12_ = s;
#line 1835 "../src/Utility/Device.vala"
			_tmp13_ = self->vendor;
#line 1835 "../src/Utility/Device.vala"
			_tmp14_ = g_strconcat (" ", _tmp13_, NULL);
#line 1835 "../src/Utility/Device.vala"
			_tmp15_ = _tmp14_;
#line 1835 "../src/Utility/Device.vala"
			_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1835 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1835 "../src/Utility/Device.vala"
			s = _tmp16_;
#line 1835 "../src/Utility/Device.vala"
			_g_free0 (_tmp15_);
#line 10921 "Device.c"
		}
#line 1837 "../src/Utility/Device.vala"
		_tmp17_ = self->model;
#line 1837 "../src/Utility/Device.vala"
		_tmp18_ = strlen (_tmp17_);
#line 1837 "../src/Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1837 "../src/Utility/Device.vala"
		if (_tmp19_ > 0) {
#line 10931 "Device.c"
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 1838 "../src/Utility/Device.vala"
			_tmp20_ = s;
#line 1838 "../src/Utility/Device.vala"
			_tmp21_ = self->model;
#line 1838 "../src/Utility/Device.vala"
			_tmp22_ = g_strconcat (" ", _tmp21_, NULL);
#line 1838 "../src/Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 1838 "../src/Utility/Device.vala"
			_tmp24_ = g_strconcat (_tmp20_, _tmp23_, NULL);
#line 1838 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1838 "../src/Utility/Device.vala"
			s = _tmp24_;
#line 1838 "../src/Utility/Device.vala"
			_g_free0 (_tmp23_);
#line 10953 "Device.c"
		}
#line 1840 "../src/Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 10957 "Device.c"
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 1841 "../src/Utility/Device.vala"
			_tmp25_ = s;
#line 1841 "../src/Utility/Device.vala"
			_tmp26_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1841 "../src/Utility/Device.vala"
			_tmp27_ = _tmp26_;
#line 1841 "../src/Utility/Device.vala"
			_tmp28_ = g_strdup_printf (" (%s)", _tmp27_);
#line 1841 "../src/Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 1841 "../src/Utility/Device.vala"
			_tmp30_ = g_strconcat (_tmp25_, _tmp29_, NULL);
#line 1841 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1841 "../src/Utility/Device.vala"
			s = _tmp30_;
#line 1841 "../src/Utility/Device.vala"
			_g_free0 (_tmp29_);
#line 1841 "../src/Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 10984 "Device.c"
		}
	} else {
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_ = NULL;
		const gchar* _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_ = NULL;
		const gchar* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
#line 1845 "../src/Utility/Device.vala"
		_tmp31_ = s;
#line 1845 "../src/Utility/Device.vala"
		_tmp32_ = device_get_short_name_with_parent (self);
#line 1845 "../src/Utility/Device.vala"
		_tmp33_ = _tmp32_;
#line 1845 "../src/Utility/Device.vala"
		_tmp34_ = _tmp33_;
#line 1845 "../src/Utility/Device.vala"
		_tmp35_ = g_strconcat ("<b>", _tmp34_, NULL);
#line 1845 "../src/Utility/Device.vala"
		_tmp36_ = _tmp35_;
#line 1845 "../src/Utility/Device.vala"
		_tmp37_ = g_strconcat (_tmp36_, "</b>", NULL);
#line 1845 "../src/Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1845 "../src/Utility/Device.vala"
		_tmp39_ = g_strconcat (_tmp31_, _tmp38_, NULL);
#line 1845 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1845 "../src/Utility/Device.vala"
		s = _tmp39_;
#line 1845 "../src/Utility/Device.vala"
		_g_free0 (_tmp38_);
#line 1845 "../src/Utility/Device.vala"
		_g_free0 (_tmp36_);
#line 1845 "../src/Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 1846 "../src/Utility/Device.vala"
		_tmp41_ = self->label;
#line 1846 "../src/Utility/Device.vala"
		_tmp42_ = strlen (_tmp41_);
#line 1846 "../src/Utility/Device.vala"
		_tmp43_ = _tmp42_;
#line 1846 "../src/Utility/Device.vala"
		if (_tmp43_ > 0) {
#line 11044 "Device.c"
			const gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
#line 1846 "../src/Utility/Device.vala"
			_tmp44_ = self->label;
#line 1846 "../src/Utility/Device.vala"
			_tmp45_ = g_strconcat (" (", _tmp44_, NULL);
#line 1846 "../src/Utility/Device.vala"
			_tmp46_ = _tmp45_;
#line 1846 "../src/Utility/Device.vala"
			_tmp47_ = g_strconcat (_tmp46_, ")", NULL);
#line 1846 "../src/Utility/Device.vala"
			_g_free0 (_tmp40_);
#line 1846 "../src/Utility/Device.vala"
			_tmp40_ = _tmp47_;
#line 1846 "../src/Utility/Device.vala"
			_g_free0 (_tmp46_);
#line 11063 "Device.c"
		} else {
			gchar* _tmp48_;
#line 1846 "../src/Utility/Device.vala"
			_tmp48_ = g_strdup ("");
#line 1846 "../src/Utility/Device.vala"
			_g_free0 (_tmp40_);
#line 1846 "../src/Utility/Device.vala"
			_tmp40_ = _tmp48_;
#line 11072 "Device.c"
		}
#line 1846 "../src/Utility/Device.vala"
		_tmp49_ = s;
#line 1846 "../src/Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp49_, _tmp40_, NULL);
#line 1846 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1846 "../src/Utility/Device.vala"
		s = _tmp50_;
#line 1847 "../src/Utility/Device.vala"
		_tmp52_ = self->fstype;
#line 1847 "../src/Utility/Device.vala"
		_tmp53_ = strlen (_tmp52_);
#line 1847 "../src/Utility/Device.vala"
		_tmp54_ = _tmp53_;
#line 1847 "../src/Utility/Device.vala"
		if (_tmp54_ > 0) {
#line 11090 "Device.c"
			const gchar* _tmp55_;
			gchar* _tmp56_;
#line 1847 "../src/Utility/Device.vala"
			_tmp55_ = self->fstype;
#line 1847 "../src/Utility/Device.vala"
			_tmp56_ = g_strconcat (" ~ ", _tmp55_, NULL);
#line 1847 "../src/Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 1847 "../src/Utility/Device.vala"
			_tmp51_ = _tmp56_;
#line 11101 "Device.c"
		} else {
			gchar* _tmp57_;
#line 1847 "../src/Utility/Device.vala"
			_tmp57_ = g_strdup ("");
#line 1847 "../src/Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 1847 "../src/Utility/Device.vala"
			_tmp51_ = _tmp57_;
#line 11110 "Device.c"
		}
#line 1847 "../src/Utility/Device.vala"
		_tmp58_ = s;
#line 1847 "../src/Utility/Device.vala"
		_tmp59_ = g_strconcat (_tmp58_, _tmp51_, NULL);
#line 1847 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1847 "../src/Utility/Device.vala"
		s = _tmp59_;
#line 1848 "../src/Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11122 "Device.c"
			const gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
#line 1849 "../src/Utility/Device.vala"
			_tmp60_ = s;
#line 1849 "../src/Utility/Device.vala"
			_tmp61_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1849 "../src/Utility/Device.vala"
			_tmp62_ = _tmp61_;
#line 1849 "../src/Utility/Device.vala"
			_tmp63_ = g_strdup_printf (" (%s)", _tmp62_);
#line 1849 "../src/Utility/Device.vala"
			_tmp64_ = _tmp63_;
#line 1849 "../src/Utility/Device.vala"
			_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 1849 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1849 "../src/Utility/Device.vala"
			s = _tmp65_;
#line 1849 "../src/Utility/Device.vala"
			_g_free0 (_tmp64_);
#line 1849 "../src/Utility/Device.vala"
			_g_free0 (_tmp62_);
#line 11149 "Device.c"
		}
#line 1832 "../src/Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1832 "../src/Utility/Device.vala"
		_g_free0 (_tmp40_);
#line 11155 "Device.c"
	}
#line 1853 "../src/Utility/Device.vala"
	_tmp66_ = s;
#line 1853 "../src/Utility/Device.vala"
	_tmp67_ = string_strip (_tmp66_);
#line 1853 "../src/Utility/Device.vala"
	result = _tmp67_;
#line 1853 "../src/Utility/Device.vala"
	_g_free0 (s);
#line 1853 "../src/Utility/Device.vala"
	return result;
#line 11167 "Device.c"
}

gchar*
device_description_simple (Device* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 1856 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1857 "../src/Utility/Device.vala"
	_tmp0_ = device_description_simple_formatted (self);
#line 1857 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1857 "../src/Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1857 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1857 "../src/Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1857 "../src/Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1857 "../src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1857 "../src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1857 "../src/Utility/Device.vala"
	result = _tmp5_;
#line 1857 "../src/Utility/Device.vala"
	return result;
#line 11202 "Device.c"
}

gchar*
device_description_simple_formatted (Device* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* result;
#line 1860 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1862 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1862 "../src/Utility/Device.vala"
	s = _tmp0_;
#line 1864 "../src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 1864 "../src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11224 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1865 "../src/Utility/Device.vala"
		_tmp2_ = self->vendor;
#line 1865 "../src/Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 1865 "../src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 1865 "../src/Utility/Device.vala"
		if (_tmp4_ > 0) {
#line 11239 "Device.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 1866 "../src/Utility/Device.vala"
			_tmp5_ = s;
#line 1866 "../src/Utility/Device.vala"
			_tmp6_ = self->vendor;
#line 1866 "../src/Utility/Device.vala"
			_tmp7_ = g_strconcat (" ", _tmp6_, NULL);
#line 1866 "../src/Utility/Device.vala"
			_tmp8_ = _tmp7_;
#line 1866 "../src/Utility/Device.vala"
			_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1866 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1866 "../src/Utility/Device.vala"
			s = _tmp9_;
#line 1866 "../src/Utility/Device.vala"
			_g_free0 (_tmp8_);
#line 11261 "Device.c"
		}
#line 1868 "../src/Utility/Device.vala"
		_tmp10_ = self->model;
#line 1868 "../src/Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1868 "../src/Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1868 "../src/Utility/Device.vala"
		if (_tmp12_ > 0) {
#line 11271 "Device.c"
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 1869 "../src/Utility/Device.vala"
			_tmp13_ = s;
#line 1869 "../src/Utility/Device.vala"
			_tmp14_ = self->model;
#line 1869 "../src/Utility/Device.vala"
			_tmp15_ = g_strconcat (" ", _tmp14_, NULL);
#line 1869 "../src/Utility/Device.vala"
			_tmp16_ = _tmp15_;
#line 1869 "../src/Utility/Device.vala"
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
#line 1869 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1869 "../src/Utility/Device.vala"
			s = _tmp17_;
#line 1869 "../src/Utility/Device.vala"
			_g_free0 (_tmp16_);
#line 11293 "Device.c"
		}
#line 1871 "../src/Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11297 "Device.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gboolean _tmp23_;
#line 1872 "../src/Utility/Device.vala"
			_tmp18_ = s;
#line 1872 "../src/Utility/Device.vala"
			_tmp19_ = string_strip (_tmp18_);
#line 1872 "../src/Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1872 "../src/Utility/Device.vala"
			_tmp21_ = strlen (_tmp20_);
#line 1872 "../src/Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1872 "../src/Utility/Device.vala"
			_tmp23_ = _tmp22_ == 0;
#line 1872 "../src/Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1872 "../src/Utility/Device.vala"
			if (_tmp23_) {
#line 11320 "Device.c"
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 1873 "../src/Utility/Device.vala"
				_tmp24_ = s;
#line 1873 "../src/Utility/Device.vala"
				_tmp25_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1873 "../src/Utility/Device.vala"
				_tmp26_ = _tmp25_;
#line 1873 "../src/Utility/Device.vala"
				_tmp27_ = g_strdup_printf ("%s Device", _tmp26_);
#line 1873 "../src/Utility/Device.vala"
				_tmp28_ = _tmp27_;
#line 1873 "../src/Utility/Device.vala"
				_tmp29_ = g_strconcat (_tmp24_, _tmp28_, NULL);
#line 1873 "../src/Utility/Device.vala"
				_g_free0 (s);
#line 1873 "../src/Utility/Device.vala"
				s = _tmp29_;
#line 1873 "../src/Utility/Device.vala"
				_g_free0 (_tmp28_);
#line 1873 "../src/Utility/Device.vala"
				_g_free0 (_tmp26_);
#line 11347 "Device.c"
			} else {
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 1876 "../src/Utility/Device.vala"
				_tmp30_ = s;
#line 1876 "../src/Utility/Device.vala"
				_tmp31_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1876 "../src/Utility/Device.vala"
				_tmp32_ = _tmp31_;
#line 1876 "../src/Utility/Device.vala"
				_tmp33_ = g_strdup_printf (" (%s)", _tmp32_);
#line 1876 "../src/Utility/Device.vala"
				_tmp34_ = _tmp33_;
#line 1876 "../src/Utility/Device.vala"
				_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
#line 1876 "../src/Utility/Device.vala"
				_g_free0 (s);
#line 1876 "../src/Utility/Device.vala"
				s = _tmp35_;
#line 1876 "../src/Utility/Device.vala"
				_g_free0 (_tmp34_);
#line 1876 "../src/Utility/Device.vala"
				_g_free0 (_tmp32_);
#line 11375 "Device.c"
			}
		}
	} else {
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_ = NULL;
		const gchar* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_ = NULL;
		const gchar* _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		const gchar* _tmp63_;
		gchar* _tmp64_;
#line 1881 "../src/Utility/Device.vala"
		_tmp36_ = s;
#line 1881 "../src/Utility/Device.vala"
		_tmp37_ = device_get_short_name_with_parent (self);
#line 1881 "../src/Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1881 "../src/Utility/Device.vala"
		_tmp39_ = _tmp38_;
#line 1881 "../src/Utility/Device.vala"
		_tmp40_ = g_strconcat ("<b>", _tmp39_, NULL);
#line 1881 "../src/Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1881 "../src/Utility/Device.vala"
		_tmp42_ = g_strconcat (_tmp41_, "</b>", NULL);
#line 1881 "../src/Utility/Device.vala"
		_tmp43_ = _tmp42_;
#line 1881 "../src/Utility/Device.vala"
		_tmp44_ = g_strconcat (_tmp36_, _tmp43_, NULL);
#line 1881 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1881 "../src/Utility/Device.vala"
		s = _tmp44_;
#line 1881 "../src/Utility/Device.vala"
		_g_free0 (_tmp43_);
#line 1881 "../src/Utility/Device.vala"
		_g_free0 (_tmp41_);
#line 1881 "../src/Utility/Device.vala"
		_g_free0 (_tmp39_);
#line 1882 "../src/Utility/Device.vala"
		_tmp46_ = self->label;
#line 1882 "../src/Utility/Device.vala"
		_tmp47_ = strlen (_tmp46_);
#line 1882 "../src/Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1882 "../src/Utility/Device.vala"
		if (_tmp48_ > 0) {
#line 11436 "Device.c"
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
#line 1882 "../src/Utility/Device.vala"
			_tmp49_ = self->label;
#line 1882 "../src/Utility/Device.vala"
			_tmp50_ = g_strconcat (" (", _tmp49_, NULL);
#line 1882 "../src/Utility/Device.vala"
			_tmp51_ = _tmp50_;
#line 1882 "../src/Utility/Device.vala"
			_tmp52_ = g_strconcat (_tmp51_, ")", NULL);
#line 1882 "../src/Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 1882 "../src/Utility/Device.vala"
			_tmp45_ = _tmp52_;
#line 1882 "../src/Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 11455 "Device.c"
		} else {
			gchar* _tmp53_;
#line 1882 "../src/Utility/Device.vala"
			_tmp53_ = g_strdup ("");
#line 1882 "../src/Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 1882 "../src/Utility/Device.vala"
			_tmp45_ = _tmp53_;
#line 11464 "Device.c"
		}
#line 1882 "../src/Utility/Device.vala"
		_tmp54_ = s;
#line 1882 "../src/Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp54_, _tmp45_, NULL);
#line 1882 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1882 "../src/Utility/Device.vala"
		s = _tmp55_;
#line 1883 "../src/Utility/Device.vala"
		_tmp57_ = self->fstype;
#line 1883 "../src/Utility/Device.vala"
		_tmp58_ = strlen (_tmp57_);
#line 1883 "../src/Utility/Device.vala"
		_tmp59_ = _tmp58_;
#line 1883 "../src/Utility/Device.vala"
		if (_tmp59_ > 0) {
#line 11482 "Device.c"
			const gchar* _tmp60_;
			gchar* _tmp61_;
#line 1883 "../src/Utility/Device.vala"
			_tmp60_ = self->fstype;
#line 1883 "../src/Utility/Device.vala"
			_tmp61_ = g_strconcat (" ~ ", _tmp60_, NULL);
#line 1883 "../src/Utility/Device.vala"
			_g_free0 (_tmp56_);
#line 1883 "../src/Utility/Device.vala"
			_tmp56_ = _tmp61_;
#line 11493 "Device.c"
		} else {
			gchar* _tmp62_;
#line 1883 "../src/Utility/Device.vala"
			_tmp62_ = g_strdup ("");
#line 1883 "../src/Utility/Device.vala"
			_g_free0 (_tmp56_);
#line 1883 "../src/Utility/Device.vala"
			_tmp56_ = _tmp62_;
#line 11502 "Device.c"
		}
#line 1883 "../src/Utility/Device.vala"
		_tmp63_ = s;
#line 1883 "../src/Utility/Device.vala"
		_tmp64_ = g_strconcat (_tmp63_, _tmp56_, NULL);
#line 1883 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1883 "../src/Utility/Device.vala"
		s = _tmp64_;
#line 1884 "../src/Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11514 "Device.c"
			const gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
#line 1885 "../src/Utility/Device.vala"
			_tmp65_ = s;
#line 1885 "../src/Utility/Device.vala"
			_tmp66_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1885 "../src/Utility/Device.vala"
			_tmp67_ = _tmp66_;
#line 1885 "../src/Utility/Device.vala"
			_tmp68_ = g_strdup_printf (" (%s)", _tmp67_);
#line 1885 "../src/Utility/Device.vala"
			_tmp69_ = _tmp68_;
#line 1885 "../src/Utility/Device.vala"
			_tmp70_ = g_strconcat (_tmp65_, _tmp69_, NULL);
#line 1885 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1885 "../src/Utility/Device.vala"
			s = _tmp70_;
#line 1885 "../src/Utility/Device.vala"
			_g_free0 (_tmp69_);
#line 1885 "../src/Utility/Device.vala"
			_g_free0 (_tmp67_);
#line 11541 "Device.c"
		}
#line 1864 "../src/Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1864 "../src/Utility/Device.vala"
		_g_free0 (_tmp45_);
#line 11547 "Device.c"
	}
#line 1889 "../src/Utility/Device.vala"
	_tmp71_ = s;
#line 1889 "../src/Utility/Device.vala"
	_tmp72_ = string_strip (_tmp71_);
#line 1889 "../src/Utility/Device.vala"
	result = _tmp72_;
#line 1889 "../src/Utility/Device.vala"
	_g_free0 (s);
#line 1889 "../src/Utility/Device.vala"
	return result;
#line 11559 "Device.c"
}

gchar*
device_description_full_free (Device* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* result;
#line 1892 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1893 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1893 "../src/Utility/Device.vala"
	s = _tmp0_;
#line 1895 "../src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 1895 "../src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11579 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1896 "../src/Utility/Device.vala"
		_tmp2_ = s;
#line 1896 "../src/Utility/Device.vala"
		_tmp3_ = self->model;
#line 1896 "../src/Utility/Device.vala"
		_tmp4_ = self->vendor;
#line 1896 "../src/Utility/Device.vala"
		_tmp5_ = g_strdup_printf ("%s %s", _tmp3_, _tmp4_);
#line 1896 "../src/Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 1896 "../src/Utility/Device.vala"
		_tmp7_ = string_strip (_tmp6_);
#line 1896 "../src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1896 "../src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp2_, _tmp8_, NULL);
#line 1896 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1896 "../src/Utility/Device.vala"
		s = _tmp9_;
#line 1896 "../src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1896 "../src/Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 1897 "../src/Utility/Device.vala"
		_tmp10_ = s;
#line 1897 "../src/Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1897 "../src/Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1897 "../src/Utility/Device.vala"
		if (_tmp12_ == 0) {
#line 11623 "Device.c"
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 1898 "../src/Utility/Device.vala"
			_tmp13_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1898 "../src/Utility/Device.vala"
			_tmp14_ = _tmp13_;
#line 1898 "../src/Utility/Device.vala"
			_tmp15_ = g_strdup_printf ("%s Disk", _tmp14_);
#line 1898 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1898 "../src/Utility/Device.vala"
			s = _tmp15_;
#line 1898 "../src/Utility/Device.vala"
			_g_free0 (_tmp14_);
#line 11639 "Device.c"
		} else {
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 1901 "../src/Utility/Device.vala"
			_tmp16_ = s;
#line 1901 "../src/Utility/Device.vala"
			_tmp17_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1901 "../src/Utility/Device.vala"
			_tmp18_ = _tmp17_;
#line 1901 "../src/Utility/Device.vala"
			_tmp19_ = g_strdup_printf (" (%s Disk)", _tmp18_);
#line 1901 "../src/Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1901 "../src/Utility/Device.vala"
			_tmp21_ = g_strconcat (_tmp16_, _tmp20_, NULL);
#line 1901 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1901 "../src/Utility/Device.vala"
			s = _tmp21_;
#line 1901 "../src/Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1901 "../src/Utility/Device.vala"
			_g_free0 (_tmp18_);
#line 11667 "Device.c"
		}
	} else {
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		guint64 _tmp41_;
		guint64 _tmp42_;
#line 1905 "../src/Utility/Device.vala"
		_tmp22_ = s;
#line 1905 "../src/Utility/Device.vala"
		_tmp23_ = self->kname;
#line 1905 "../src/Utility/Device.vala"
		_tmp24_ = g_strconcat (_tmp22_, _tmp23_, NULL);
#line 1905 "../src/Utility/Device.vala"
		_g_free0 (s);
#line 1905 "../src/Utility/Device.vala"
		s = _tmp24_;
#line 1906 "../src/Utility/Device.vala"
		_tmp25_ = self->label;
#line 1906 "../src/Utility/Device.vala"
		_tmp26_ = strlen (_tmp25_);
#line 1906 "../src/Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1906 "../src/Utility/Device.vala"
		if (_tmp27_ > 0) {
#line 11699 "Device.c"
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 1907 "../src/Utility/Device.vala"
			_tmp28_ = s;
#line 1907 "../src/Utility/Device.vala"
			_tmp29_ = self->label;
#line 1907 "../src/Utility/Device.vala"
			_tmp30_ = g_strdup_printf (" (%s)", _tmp29_);
#line 1907 "../src/Utility/Device.vala"
			_tmp31_ = _tmp30_;
#line 1907 "../src/Utility/Device.vala"
			_tmp32_ = g_strconcat (_tmp28_, _tmp31_, NULL);
#line 1907 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1907 "../src/Utility/Device.vala"
			s = _tmp32_;
#line 1907 "../src/Utility/Device.vala"
			_g_free0 (_tmp31_);
#line 11721 "Device.c"
		}
#line 1909 "../src/Utility/Device.vala"
		_tmp33_ = self->fstype;
#line 1909 "../src/Utility/Device.vala"
		_tmp34_ = strlen (_tmp33_);
#line 1909 "../src/Utility/Device.vala"
		_tmp35_ = _tmp34_;
#line 1909 "../src/Utility/Device.vala"
		if (_tmp35_ > 0) {
#line 11731 "Device.c"
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 1910 "../src/Utility/Device.vala"
			_tmp36_ = s;
#line 1910 "../src/Utility/Device.vala"
			_tmp37_ = self->fstype;
#line 1910 "../src/Utility/Device.vala"
			_tmp38_ = g_strdup_printf (" ~ %s", _tmp37_);
#line 1910 "../src/Utility/Device.vala"
			_tmp39_ = _tmp38_;
#line 1910 "../src/Utility/Device.vala"
			_tmp40_ = g_strconcat (_tmp36_, _tmp39_, NULL);
#line 1910 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1910 "../src/Utility/Device.vala"
			s = _tmp40_;
#line 1910 "../src/Utility/Device.vala"
			_g_free0 (_tmp39_);
#line 11753 "Device.c"
		}
#line 1912 "../src/Utility/Device.vala"
		_tmp41_ = device_get_free_bytes (self);
#line 1912 "../src/Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1912 "../src/Utility/Device.vala"
		if (_tmp42_ > ((guint64) 0)) {
#line 11761 "Device.c"
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
#line 1913 "../src/Utility/Device.vala"
			_tmp43_ = s;
#line 1913 "../src/Utility/Device.vala"
			_tmp44_ = device_description_free (self);
#line 1913 "../src/Utility/Device.vala"
			_tmp45_ = _tmp44_;
#line 1913 "../src/Utility/Device.vala"
			_tmp46_ = g_strdup_printf (" ~ %s", _tmp45_);
#line 1913 "../src/Utility/Device.vala"
			_tmp47_ = _tmp46_;
#line 1913 "../src/Utility/Device.vala"
			_tmp48_ = g_strconcat (_tmp43_, _tmp47_, NULL);
#line 1913 "../src/Utility/Device.vala"
			_g_free0 (s);
#line 1913 "../src/Utility/Device.vala"
			s = _tmp48_;
#line 1913 "../src/Utility/Device.vala"
			_g_free0 (_tmp47_);
#line 1913 "../src/Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 11788 "Device.c"
		}
	}
#line 1917 "../src/Utility/Device.vala"
	result = s;
#line 1917 "../src/Utility/Device.vala"
	return result;
#line 11795 "Device.c"
}

gchar*
device_description_full (Device* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp39_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* result;
#line 1920 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1921 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1921 "../src/Utility/Device.vala"
	s = _tmp0_;
#line 1922 "../src/Utility/Device.vala"
	_tmp1_ = s;
#line 1922 "../src/Utility/Device.vala"
	_tmp2_ = self->device;
#line 1922 "../src/Utility/Device.vala"
	_tmp3_ = g_strconcat (_tmp1_, _tmp2_, NULL);
#line 1922 "../src/Utility/Device.vala"
	_g_free0 (s);
#line 1922 "../src/Utility/Device.vala"
	s = _tmp3_;
#line 1923 "../src/Utility/Device.vala"
	_tmp5_ = self->label;
#line 1923 "../src/Utility/Device.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1923 "../src/Utility/Device.vala"
	_tmp7_ = _tmp6_;
#line 1923 "../src/Utility/Device.vala"
	if (_tmp7_ > 0) {
#line 11858 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1923 "../src/Utility/Device.vala"
		_tmp8_ = self->label;
#line 1923 "../src/Utility/Device.vala"
		_tmp9_ = g_strconcat (" (", _tmp8_, NULL);
#line 1923 "../src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1923 "../src/Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp10_, ")", NULL);
#line 1923 "../src/Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1923 "../src/Utility/Device.vala"
		_tmp4_ = _tmp11_;
#line 1923 "../src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 11877 "Device.c"
	} else {
		gchar* _tmp12_;
#line 1923 "../src/Utility/Device.vala"
		_tmp12_ = g_strdup ("");
#line 1923 "../src/Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1923 "../src/Utility/Device.vala"
		_tmp4_ = _tmp12_;
#line 11886 "Device.c"
	}
#line 1923 "../src/Utility/Device.vala"
	_tmp13_ = s;
#line 1923 "../src/Utility/Device.vala"
	_tmp14_ = g_strconcat (_tmp13_, _tmp4_, NULL);
#line 1923 "../src/Utility/Device.vala"
	_g_free0 (s);
#line 1923 "../src/Utility/Device.vala"
	s = _tmp14_;
#line 1924 "../src/Utility/Device.vala"
	_tmp16_ = self->uuid;
#line 1924 "../src/Utility/Device.vala"
	_tmp17_ = strlen (_tmp16_);
#line 1924 "../src/Utility/Device.vala"
	_tmp18_ = _tmp17_;
#line 1924 "../src/Utility/Device.vala"
	if (_tmp18_ > 0) {
#line 11904 "Device.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 1924 "../src/Utility/Device.vala"
		_tmp19_ = self->uuid;
#line 1924 "../src/Utility/Device.vala"
		_tmp20_ = g_strconcat (" ~ ", _tmp19_, NULL);
#line 1924 "../src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1924 "../src/Utility/Device.vala"
		_tmp15_ = _tmp20_;
#line 11915 "Device.c"
	} else {
		gchar* _tmp21_;
#line 1924 "../src/Utility/Device.vala"
		_tmp21_ = g_strdup ("");
#line 1924 "../src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1924 "../src/Utility/Device.vala"
		_tmp15_ = _tmp21_;
#line 11924 "Device.c"
	}
#line 1924 "../src/Utility/Device.vala"
	_tmp22_ = s;
#line 1924 "../src/Utility/Device.vala"
	_tmp23_ = g_strconcat (_tmp22_, _tmp15_, NULL);
#line 1924 "../src/Utility/Device.vala"
	_g_free0 (s);
#line 1924 "../src/Utility/Device.vala"
	s = _tmp23_;
#line 1925 "../src/Utility/Device.vala"
	_tmp25_ = self->fstype;
#line 1925 "../src/Utility/Device.vala"
	_tmp26_ = strlen (_tmp25_);
#line 1925 "../src/Utility/Device.vala"
	_tmp27_ = _tmp26_;
#line 1925 "../src/Utility/Device.vala"
	if (_tmp27_ > 0) {
#line 11942 "Device.c"
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1925 "../src/Utility/Device.vala"
		_tmp28_ = self->fstype;
#line 1925 "../src/Utility/Device.vala"
		_tmp29_ = g_strconcat (" ~ ", _tmp28_, NULL);
#line 1925 "../src/Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1925 "../src/Utility/Device.vala"
		_tmp24_ = _tmp29_;
#line 11953 "Device.c"
	} else {
		gchar* _tmp30_;
#line 1925 "../src/Utility/Device.vala"
		_tmp30_ = g_strdup ("");
#line 1925 "../src/Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1925 "../src/Utility/Device.vala"
		_tmp24_ = _tmp30_;
#line 11962 "Device.c"
	}
#line 1925 "../src/Utility/Device.vala"
	_tmp31_ = s;
#line 1925 "../src/Utility/Device.vala"
	_tmp32_ = g_strconcat (_tmp31_, _tmp24_, NULL);
#line 1925 "../src/Utility/Device.vala"
	_g_free0 (s);
#line 1925 "../src/Utility/Device.vala"
	s = _tmp32_;
#line 1926 "../src/Utility/Device.vala"
	_tmp34_ = device_get_used (self);
#line 1926 "../src/Utility/Device.vala"
	_tmp35_ = _tmp34_;
#line 1926 "../src/Utility/Device.vala"
	_tmp36_ = _tmp35_;
#line 1926 "../src/Utility/Device.vala"
	_tmp37_ = strlen (_tmp36_);
#line 1926 "../src/Utility/Device.vala"
	_tmp38_ = _tmp37_;
#line 1926 "../src/Utility/Device.vala"
	_tmp39_ = _tmp38_ > 0;
#line 1926 "../src/Utility/Device.vala"
	_g_free0 (_tmp36_);
#line 1926 "../src/Utility/Device.vala"
	if (_tmp39_) {
#line 11988 "Device.c"
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 1926 "../src/Utility/Device.vala"
		_tmp40_ = device_get_used (self);
#line 1926 "../src/Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1926 "../src/Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1926 "../src/Utility/Device.vala"
		_tmp43_ = g_strconcat (" ~ ", _tmp42_, NULL);
#line 1926 "../src/Utility/Device.vala"
		_tmp44_ = _tmp43_;
#line 1926 "../src/Utility/Device.vala"
		_tmp45_ = g_strconcat (_tmp44_, " / ", NULL);
#line 1926 "../src/Utility/Device.vala"
		_tmp46_ = _tmp45_;
#line 1926 "../src/Utility/Device.vala"
		_tmp47_ = device_get_size (self);
#line 1926 "../src/Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1926 "../src/Utility/Device.vala"
		_tmp49_ = _tmp48_;
#line 1926 "../src/Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 1926 "../src/Utility/Device.vala"
		_tmp51_ = _tmp50_;
#line 1926 "../src/Utility/Device.vala"
		_tmp52_ = g_strconcat (_tmp51_, " GB used (", NULL);
#line 1926 "../src/Utility/Device.vala"
		_tmp53_ = _tmp52_;
#line 1926 "../src/Utility/Device.vala"
		_tmp54_ = self->used_percent;
#line 1926 "../src/Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp53_, _tmp54_, NULL);
#line 1926 "../src/Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1926 "../src/Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp56_, ")", NULL);
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1926 "../src/Utility/Device.vala"
		_tmp33_ = _tmp57_;
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp53_);
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp49_);
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp46_);
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp44_);
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp42_);
#line 12061 "Device.c"
	} else {
		gchar* _tmp58_;
#line 1926 "../src/Utility/Device.vala"
		_tmp58_ = g_strdup ("");
#line 1926 "../src/Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1926 "../src/Utility/Device.vala"
		_tmp33_ = _tmp58_;
#line 12070 "Device.c"
	}
#line 1926 "../src/Utility/Device.vala"
	_tmp59_ = s;
#line 1926 "../src/Utility/Device.vala"
	_tmp60_ = g_strconcat (_tmp59_, _tmp33_, NULL);
#line 1926 "../src/Utility/Device.vala"
	_g_free0 (s);
#line 1926 "../src/Utility/Device.vala"
	s = _tmp60_;
#line 1928 "../src/Utility/Device.vala"
	result = s;
#line 1928 "../src/Utility/Device.vala"
	_g_free0 (_tmp33_);
#line 1928 "../src/Utility/Device.vala"
	_g_free0 (_tmp24_);
#line 1928 "../src/Utility/Device.vala"
	_g_free0 (_tmp15_);
#line 1928 "../src/Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1928 "../src/Utility/Device.vala"
	return result;
#line 12092 "Device.c"
}

gchar*
device_description_usage (Device* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gchar* result;
#line 1931 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1932 "../src/Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1932 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1932 "../src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1932 "../src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1932 "../src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1932 "../src/Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1932 "../src/Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1932 "../src/Utility/Device.vala"
	if (_tmp5_) {
#line 12123 "Device.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 1933 "../src/Utility/Device.vala"
		_tmp6_ = device_get_used (self);
#line 1933 "../src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1933 "../src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1933 "../src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp8_, " / ", NULL);
#line 1933 "../src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1933 "../src/Utility/Device.vala"
		_tmp11_ = device_get_size (self);
#line 1933 "../src/Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1933 "../src/Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1933 "../src/Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 1933 "../src/Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1933 "../src/Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " used (", NULL);
#line 1933 "../src/Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1933 "../src/Utility/Device.vala"
		_tmp18_ = self->used_percent;
#line 1933 "../src/Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp17_, _tmp18_, NULL);
#line 1933 "../src/Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1933 "../src/Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp20_, ")", NULL);
#line 1933 "../src/Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1933 "../src/Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1933 "../src/Utility/Device.vala"
		_g_free0 (_tmp17_);
#line 1933 "../src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1933 "../src/Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1933 "../src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1933 "../src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1933 "../src/Utility/Device.vala"
		result = _tmp22_;
#line 1933 "../src/Utility/Device.vala"
		return result;
#line 12191 "Device.c"
	} else {
		gchar* _tmp23_;
#line 1936 "../src/Utility/Device.vala"
		_tmp23_ = g_strdup ("");
#line 1936 "../src/Utility/Device.vala"
		result = _tmp23_;
#line 1936 "../src/Utility/Device.vala"
		return result;
#line 12200 "Device.c"
	}
}

gchar*
device_description_free (Device* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gchar* result;
#line 1940 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1941 "../src/Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1941 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1941 "../src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1941 "../src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1941 "../src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1941 "../src/Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1941 "../src/Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1941 "../src/Utility/Device.vala"
	if (_tmp5_) {
#line 12232 "Device.c"
		guint64 _tmp6_;
		guint64 _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 1942 "../src/Utility/Device.vala"
		_tmp6_ = device_get_free_bytes (self);
#line 1942 "../src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1942 "../src/Utility/Device.vala"
		_tmp8_ = tee_jee_file_system_format_file_size (_tmp7_, FALSE, "g", FALSE, 1);
#line 1942 "../src/Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1942 "../src/Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp9_, " / ", NULL);
#line 1942 "../src/Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1942 "../src/Utility/Device.vala"
		_tmp12_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "g", TRUE, 1);
#line 1942 "../src/Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1942 "../src/Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
#line 1942 "../src/Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1942 "../src/Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " free", NULL);
#line 1942 "../src/Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1942 "../src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1942 "../src/Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1942 "../src/Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1942 "../src/Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 1942 "../src/Utility/Device.vala"
		result = _tmp17_;
#line 1942 "../src/Utility/Device.vala"
		return result;
#line 12281 "Device.c"
	} else {
		gchar* _tmp18_;
#line 1946 "../src/Utility/Device.vala"
		_tmp18_ = g_strdup ("");
#line 1946 "../src/Utility/Device.vala"
		result = _tmp18_;
#line 1946 "../src/Utility/Device.vala"
		return result;
#line 12290 "Device.c"
	}
}

gchar*
device_tooltip_text (Device* self)
{
	gchar* tt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp92_;
	gchar* _tmp93_;
	gchar* result;
#line 1950 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1951 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1951 "../src/Utility/Device.vala"
	tt = _tmp0_;
#line 1953 "../src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 1953 "../src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 12313 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_ = NULL;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 1954 "../src/Utility/Device.vala"
		_tmp2_ = tt;
#line 1954 "../src/Utility/Device.vala"
		_tmp3_ = self->device;
#line 1954 "../src/Utility/Device.vala"
		_tmp4_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp3_);
#line 1954 "../src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1954 "../src/Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 1954 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1954 "../src/Utility/Device.vala"
		tt = _tmp6_;
#line 1954 "../src/Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1955 "../src/Utility/Device.vala"
		_tmp7_ = tt;
#line 1955 "../src/Utility/Device.vala"
		_tmp8_ = self->vendor;
#line 1955 "../src/Utility/Device.vala"
		_tmp9_ = g_strdup_printf ("%-15s: %s\n", _ ("Vendor"), _tmp8_);
#line 1955 "../src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1955 "../src/Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
#line 1955 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1955 "../src/Utility/Device.vala"
		tt = _tmp11_;
#line 1955 "../src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1956 "../src/Utility/Device.vala"
		_tmp12_ = tt;
#line 1956 "../src/Utility/Device.vala"
		_tmp13_ = self->model;
#line 1956 "../src/Utility/Device.vala"
		_tmp14_ = g_strdup_printf ("%-15s: %s\n", _ ("Model"), _tmp13_);
#line 1956 "../src/Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1956 "../src/Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1956 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1956 "../src/Utility/Device.vala"
		tt = _tmp16_;
#line 1956 "../src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1957 "../src/Utility/Device.vala"
		_tmp17_ = tt;
#line 1957 "../src/Utility/Device.vala"
		_tmp18_ = self->serial;
#line 1957 "../src/Utility/Device.vala"
		_tmp19_ = g_strdup_printf ("%-15s: %s\n", _ ("Serial"), _tmp18_);
#line 1957 "../src/Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1957 "../src/Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp17_, _tmp20_, NULL);
#line 1957 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1957 "../src/Utility/Device.vala"
		tt = _tmp21_;
#line 1957 "../src/Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1958 "../src/Utility/Device.vala"
		_tmp22_ = tt;
#line 1958 "../src/Utility/Device.vala"
		_tmp23_ = self->revision;
#line 1958 "../src/Utility/Device.vala"
		_tmp24_ = g_strdup_printf ("%-15s: %s\n", _ ("Revision"), _tmp23_);
#line 1958 "../src/Utility/Device.vala"
		_tmp25_ = _tmp24_;
#line 1958 "../src/Utility/Device.vala"
		_tmp26_ = g_strconcat (_tmp22_, _tmp25_, NULL);
#line 1958 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1958 "../src/Utility/Device.vala"
		tt = _tmp26_;
#line 1958 "../src/Utility/Device.vala"
		_g_free0 (_tmp25_);
#line 1961 "../src/Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12426 "Device.c"
			gchar* _tmp28_;
#line 1961 "../src/Utility/Device.vala"
			_tmp28_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1961 "../src/Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1961 "../src/Utility/Device.vala"
			_tmp27_ = _tmp28_;
#line 12434 "Device.c"
		} else {
			gchar* _tmp29_;
#line 1961 "../src/Utility/Device.vala"
			_tmp29_ = g_strdup ("N/A");
#line 1961 "../src/Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1961 "../src/Utility/Device.vala"
			_tmp27_ = _tmp29_;
#line 12443 "Device.c"
		}
#line 1960 "../src/Utility/Device.vala"
		_tmp30_ = tt;
#line 1960 "../src/Utility/Device.vala"
		_tmp31_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp27_);
#line 1960 "../src/Utility/Device.vala"
		_tmp32_ = _tmp31_;
#line 1960 "../src/Utility/Device.vala"
		_tmp33_ = g_strconcat (_tmp30_, _tmp32_, NULL);
#line 1960 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1960 "../src/Utility/Device.vala"
		tt = _tmp33_;
#line 1960 "../src/Utility/Device.vala"
		_g_free0 (_tmp32_);
#line 1953 "../src/Utility/Device.vala"
		_g_free0 (_tmp27_);
#line 12461 "Device.c"
	} else {
		gchar* _tmp34_ = NULL;
		const gchar* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		const gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		const gchar* _tmp63_;
		const gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_ = NULL;
		const gchar* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		gchar* _tmp79_;
		gchar* _tmp80_ = NULL;
		const gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		gchar* _tmp86_;
		const gchar* _tmp87_;
		const gchar* _tmp88_;
		gchar* _tmp89_;
		gchar* _tmp90_;
		gchar* _tmp91_;
#line 1965 "../src/Utility/Device.vala"
		_tmp35_ = self->mapped_name;
#line 1965 "../src/Utility/Device.vala"
		_tmp36_ = strlen (_tmp35_);
#line 1965 "../src/Utility/Device.vala"
		_tmp37_ = _tmp36_;
#line 1965 "../src/Utility/Device.vala"
		if (_tmp37_ > 0) {
#line 12514 "Device.c"
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
#line 1965 "../src/Utility/Device.vala"
			_tmp38_ = self->device;
#line 1965 "../src/Utility/Device.vala"
			_tmp39_ = self->mapped_name;
#line 1965 "../src/Utility/Device.vala"
			_tmp40_ = g_strdup_printf ("%s → %s", _tmp38_, _tmp39_);
#line 1965 "../src/Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 1965 "../src/Utility/Device.vala"
			_tmp34_ = _tmp40_;
#line 12528 "Device.c"
		} else {
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 1965 "../src/Utility/Device.vala"
			_tmp41_ = self->device;
#line 1965 "../src/Utility/Device.vala"
			_tmp42_ = g_strdup (_tmp41_);
#line 1965 "../src/Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 1965 "../src/Utility/Device.vala"
			_tmp34_ = _tmp42_;
#line 12540 "Device.c"
		}
#line 1964 "../src/Utility/Device.vala"
		_tmp43_ = tt;
#line 1964 "../src/Utility/Device.vala"
		_tmp44_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp34_);
#line 1964 "../src/Utility/Device.vala"
		_tmp45_ = _tmp44_;
#line 1964 "../src/Utility/Device.vala"
		_tmp46_ = g_strconcat (_tmp43_, _tmp45_, NULL);
#line 1964 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1964 "../src/Utility/Device.vala"
		tt = _tmp46_;
#line 1964 "../src/Utility/Device.vala"
		_g_free0 (_tmp45_);
#line 1967 "../src/Utility/Device.vala"
		if (device_has_parent (self)) {
#line 12558 "Device.c"
			const gchar* _tmp47_;
			Device* _tmp48_;
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
#line 1968 "../src/Utility/Device.vala"
			_tmp47_ = tt;
#line 1968 "../src/Utility/Device.vala"
			_tmp48_ = self->parent;
#line 1968 "../src/Utility/Device.vala"
			_tmp49_ = _tmp48_->device;
#line 1968 "../src/Utility/Device.vala"
			_tmp50_ = g_strdup_printf ("%-15s: %s\n", _ ("Parent Device"), _tmp49_);
#line 1968 "../src/Utility/Device.vala"
			_tmp51_ = _tmp50_;
#line 1968 "../src/Utility/Device.vala"
			_tmp52_ = g_strconcat (_tmp47_, _tmp51_, NULL);
#line 1968 "../src/Utility/Device.vala"
			_g_free0 (tt);
#line 1968 "../src/Utility/Device.vala"
			tt = _tmp52_;
#line 1968 "../src/Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 12583 "Device.c"
		}
#line 1970 "../src/Utility/Device.vala"
		_tmp53_ = tt;
#line 1970 "../src/Utility/Device.vala"
		_tmp54_ = self->uuid;
#line 1970 "../src/Utility/Device.vala"
		_tmp55_ = g_strdup_printf ("%-15s: %s\n", _ ("UUID"), _tmp54_);
#line 1970 "../src/Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1970 "../src/Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp53_, _tmp56_, NULL);
#line 1970 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1970 "../src/Utility/Device.vala"
		tt = _tmp57_;
#line 1970 "../src/Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1971 "../src/Utility/Device.vala"
		_tmp58_ = tt;
#line 1971 "../src/Utility/Device.vala"
		_tmp59_ = self->type;
#line 1971 "../src/Utility/Device.vala"
		_tmp60_ = g_strdup_printf ("%-15s: %s\n", _ ("Type"), _tmp59_);
#line 1971 "../src/Utility/Device.vala"
		_tmp61_ = _tmp60_;
#line 1971 "../src/Utility/Device.vala"
		_tmp62_ = g_strconcat (_tmp58_, _tmp61_, NULL);
#line 1971 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1971 "../src/Utility/Device.vala"
		tt = _tmp62_;
#line 1971 "../src/Utility/Device.vala"
		_g_free0 (_tmp61_);
#line 1972 "../src/Utility/Device.vala"
		_tmp63_ = tt;
#line 1972 "../src/Utility/Device.vala"
		_tmp64_ = self->fstype;
#line 1972 "../src/Utility/Device.vala"
		_tmp65_ = g_strdup_printf ("%-15s: %s\n", _ ("Filesystem"), _tmp64_);
#line 1972 "../src/Utility/Device.vala"
		_tmp66_ = _tmp65_;
#line 1972 "../src/Utility/Device.vala"
		_tmp67_ = g_strconcat (_tmp63_, _tmp66_, NULL);
#line 1972 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1972 "../src/Utility/Device.vala"
		tt = _tmp67_;
#line 1972 "../src/Utility/Device.vala"
		_g_free0 (_tmp66_);
#line 1973 "../src/Utility/Device.vala"
		_tmp68_ = tt;
#line 1973 "../src/Utility/Device.vala"
		_tmp69_ = self->label;
#line 1973 "../src/Utility/Device.vala"
		_tmp70_ = g_strdup_printf ("%-15s: %s\n", _ ("Label"), _tmp69_);
#line 1973 "../src/Utility/Device.vala"
		_tmp71_ = _tmp70_;
#line 1973 "../src/Utility/Device.vala"
		_tmp72_ = g_strconcat (_tmp68_, _tmp71_, NULL);
#line 1973 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1973 "../src/Utility/Device.vala"
		tt = _tmp72_;
#line 1973 "../src/Utility/Device.vala"
		_g_free0 (_tmp71_);
#line 1976 "../src/Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12651 "Device.c"
			gchar* _tmp74_;
#line 1976 "../src/Utility/Device.vala"
			_tmp74_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1976 "../src/Utility/Device.vala"
			_g_free0 (_tmp73_);
#line 1976 "../src/Utility/Device.vala"
			_tmp73_ = _tmp74_;
#line 12659 "Device.c"
		} else {
			gchar* _tmp75_;
#line 1976 "../src/Utility/Device.vala"
			_tmp75_ = g_strdup ("N/A");
#line 1976 "../src/Utility/Device.vala"
			_g_free0 (_tmp73_);
#line 1976 "../src/Utility/Device.vala"
			_tmp73_ = _tmp75_;
#line 12668 "Device.c"
		}
#line 1975 "../src/Utility/Device.vala"
		_tmp76_ = tt;
#line 1975 "../src/Utility/Device.vala"
		_tmp77_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp73_);
#line 1975 "../src/Utility/Device.vala"
		_tmp78_ = _tmp77_;
#line 1975 "../src/Utility/Device.vala"
		_tmp79_ = g_strconcat (_tmp76_, _tmp78_, NULL);
#line 1975 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1975 "../src/Utility/Device.vala"
		tt = _tmp79_;
#line 1975 "../src/Utility/Device.vala"
		_g_free0 (_tmp78_);
#line 1979 "../src/Utility/Device.vala"
		if (self->used_bytes > ((guint64) 0)) {
#line 12686 "Device.c"
			gchar* _tmp81_;
#line 1979 "../src/Utility/Device.vala"
			_tmp81_ = tee_jee_file_system_format_file_size (self->used_bytes, FALSE, "", TRUE, 1);
#line 1979 "../src/Utility/Device.vala"
			_g_free0 (_tmp80_);
#line 1979 "../src/Utility/Device.vala"
			_tmp80_ = _tmp81_;
#line 12694 "Device.c"
		} else {
			gchar* _tmp82_;
#line 1979 "../src/Utility/Device.vala"
			_tmp82_ = g_strdup ("N/A");
#line 1979 "../src/Utility/Device.vala"
			_g_free0 (_tmp80_);
#line 1979 "../src/Utility/Device.vala"
			_tmp80_ = _tmp82_;
#line 12703 "Device.c"
		}
#line 1978 "../src/Utility/Device.vala"
		_tmp83_ = tt;
#line 1978 "../src/Utility/Device.vala"
		_tmp84_ = g_strdup_printf ("%-15s: %s\n", _ ("Used"), _tmp80_);
#line 1978 "../src/Utility/Device.vala"
		_tmp85_ = _tmp84_;
#line 1978 "../src/Utility/Device.vala"
		_tmp86_ = g_strconcat (_tmp83_, _tmp85_, NULL);
#line 1978 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1978 "../src/Utility/Device.vala"
		tt = _tmp86_;
#line 1978 "../src/Utility/Device.vala"
		_g_free0 (_tmp85_);
#line 1981 "../src/Utility/Device.vala"
		_tmp87_ = tt;
#line 1981 "../src/Utility/Device.vala"
		_tmp88_ = self->dist_info;
#line 1981 "../src/Utility/Device.vala"
		_tmp89_ = g_strdup_printf ("%-15s: %s\n", _ ("System"), _tmp88_);
#line 1981 "../src/Utility/Device.vala"
		_tmp90_ = _tmp89_;
#line 1981 "../src/Utility/Device.vala"
		_tmp91_ = g_strconcat (_tmp87_, _tmp90_, NULL);
#line 1981 "../src/Utility/Device.vala"
		_g_free0 (tt);
#line 1981 "../src/Utility/Device.vala"
		tt = _tmp91_;
#line 1981 "../src/Utility/Device.vala"
		_g_free0 (_tmp90_);
#line 1953 "../src/Utility/Device.vala"
		_g_free0 (_tmp80_);
#line 1953 "../src/Utility/Device.vala"
		_g_free0 (_tmp73_);
#line 1953 "../src/Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 12741 "Device.c"
	}
#line 1984 "../src/Utility/Device.vala"
	_tmp92_ = tt;
#line 1984 "../src/Utility/Device.vala"
	_tmp93_ = g_strdup_printf ("<tt>%s</tt>", _tmp92_);
#line 1984 "../src/Utility/Device.vala"
	result = _tmp93_;
#line 1984 "../src/Utility/Device.vala"
	_g_free0 (tt);
#line 1984 "../src/Utility/Device.vala"
	return result;
#line 12753 "Device.c"
}

void
device_test_all (void)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
#line 1991 "../src/Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 1991 "../src/Utility/Device.vala"
	list = _tmp0_;
#line 1992 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_block_devices_using_lsblk()", FALSE);
#line 1993 "../src/Utility/Device.vala"
	_tmp1_ = list;
#line 1993 "../src/Utility/Device.vala"
	device_print_device_list (_tmp1_);
#line 1995 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2001 "../src/Utility/Device.vala"
	_tmp2_ = device_get_mounted_filesystems_using_mtab ();
#line 2001 "../src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 2001 "../src/Utility/Device.vala"
	list = _tmp2_;
#line 2002 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_mounted_filesystems_using_mtab()", FALSE);
#line 2003 "../src/Utility/Device.vala"
	_tmp3_ = list;
#line 2003 "../src/Utility/Device.vala"
	device_print_device_mounts (_tmp3_);
#line 2005 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2007 "../src/Utility/Device.vala"
	_tmp4_ = device_get_disk_space_using_df ("");
#line 2007 "../src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 2007 "../src/Utility/Device.vala"
	list = _tmp4_;
#line 2008 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_disk_space_using_df()", FALSE);
#line 2009 "../src/Utility/Device.vala"
	_tmp5_ = list;
#line 2009 "../src/Utility/Device.vala"
	device_print_device_disk_space (_tmp5_);
#line 2011 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2013 "../src/Utility/Device.vala"
	_tmp6_ = device_get_filesystems (TRUE, TRUE);
#line 2013 "../src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 2013 "../src/Utility/Device.vala"
	list = _tmp6_;
#line 2014 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_filesystems()", FALSE);
#line 2015 "../src/Utility/Device.vala"
	_tmp7_ = list;
#line 2015 "../src/Utility/Device.vala"
	device_print_device_list (_tmp7_);
#line 2016 "../src/Utility/Device.vala"
	_tmp8_ = list;
#line 2016 "../src/Utility/Device.vala"
	device_print_device_mounts (_tmp8_);
#line 2017 "../src/Utility/Device.vala"
	_tmp9_ = list;
#line 2017 "../src/Utility/Device.vala"
	device_print_device_disk_space (_tmp9_);
#line 2019 "../src/Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1989 "../src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 12834 "Device.c"
}

void
device_print_device_list (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2022 "../src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2024 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2026 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", "device", "pkname", "kname", "uuid", "mapped_name");
#line 2026 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2026 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2026 "../src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2033 "../src/Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2033 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2033 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2033 "../src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 12864 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 2035 "../src/Utility/Device.vala"
		_dev_list = list;
#line 2035 "../src/Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 2035 "../src/Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 2035 "../src/Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 2035 "../src/Utility/Device.vala"
		_dev_size = _tmp6_;
#line 2035 "../src/Utility/Device.vala"
		_dev_index = -1;
#line 2035 "../src/Utility/Device.vala"
		while (TRUE) {
#line 12886 "Device.c"
			gint _tmp7_;
			gint _tmp8_;
			Device* dev = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			Device* _tmp11_;
			const gchar* _tmp12_;
			Device* _tmp13_;
			const gchar* _tmp14_;
			Device* _tmp15_;
			const gchar* _tmp16_;
			Device* _tmp17_;
			const gchar* _tmp18_;
			Device* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
#line 2035 "../src/Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2035 "../src/Utility/Device.vala"
			_tmp7_ = _dev_index;
#line 2035 "../src/Utility/Device.vala"
			_tmp8_ = _dev_size;
#line 2035 "../src/Utility/Device.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 2035 "../src/Utility/Device.vala"
				break;
#line 12914 "Device.c"
			}
#line 2035 "../src/Utility/Device.vala"
			_tmp9_ = _dev_list;
#line 2035 "../src/Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _dev_index);
#line 2035 "../src/Utility/Device.vala"
			dev = (Device*) _tmp10_;
#line 2036 "../src/Utility/Device.vala"
			_tmp11_ = dev;
#line 2036 "../src/Utility/Device.vala"
			_tmp12_ = _tmp11_->device;
#line 2036 "../src/Utility/Device.vala"
			_tmp13_ = dev;
#line 2036 "../src/Utility/Device.vala"
			_tmp14_ = _tmp13_->pkname;
#line 2036 "../src/Utility/Device.vala"
			_tmp15_ = dev;
#line 2036 "../src/Utility/Device.vala"
			_tmp16_ = _tmp15_->kname;
#line 2036 "../src/Utility/Device.vala"
			_tmp17_ = dev;
#line 2036 "../src/Utility/Device.vala"
			_tmp18_ = _tmp17_->uuid;
#line 2036 "../src/Utility/Device.vala"
			_tmp19_ = dev;
#line 2036 "../src/Utility/Device.vala"
			_tmp20_ = _tmp19_->mapped_name;
#line 2036 "../src/Utility/Device.vala"
			_tmp21_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", _tmp12_, _tmp14_, _tmp16_, _tmp18_, _tmp20_);
#line 2036 "../src/Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 2036 "../src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp22_);
#line 2036 "../src/Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 2035 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 12952 "Device.c"
		}
	}
#line 2045 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 12957 "Device.c"
}

void
device_print_device_mounts (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2098 "../src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2100 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2102 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %s", "device", "> mount_points (mount_options)");
#line 2102 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2102 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2102 "../src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2108 "../src/Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2108 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2108 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2108 "../src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 12987 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 2110 "../src/Utility/Device.vala"
		_dev_list = list;
#line 2110 "../src/Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 2110 "../src/Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 2110 "../src/Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 2110 "../src/Utility/Device.vala"
		_dev_size = _tmp6_;
#line 2110 "../src/Utility/Device.vala"
		_dev_index = -1;
#line 2110 "../src/Utility/Device.vala"
		while (TRUE) {
#line 13009 "Device.c"
			gint _tmp7_;
			gint _tmp8_;
			Device* dev = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			gchar* mps = NULL;
			gchar* _tmp11_;
			Device* _tmp37_;
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
#line 2110 "../src/Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2110 "../src/Utility/Device.vala"
			_tmp7_ = _dev_index;
#line 2110 "../src/Utility/Device.vala"
			_tmp8_ = _dev_size;
#line 2110 "../src/Utility/Device.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 2110 "../src/Utility/Device.vala"
				break;
#line 13032 "Device.c"
			}
#line 2110 "../src/Utility/Device.vala"
			_tmp9_ = _dev_list;
#line 2110 "../src/Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _dev_index);
#line 2110 "../src/Utility/Device.vala"
			dev = (Device*) _tmp10_;
#line 2112 "../src/Utility/Device.vala"
			_tmp11_ = g_strdup ("");
#line 2112 "../src/Utility/Device.vala"
			mps = _tmp11_;
#line 13044 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp12_;
				GeeArrayList* _tmp13_;
				gint _mp_size = 0;
				GeeArrayList* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _mp_index = 0;
#line 2113 "../src/Utility/Device.vala"
				_tmp12_ = dev;
#line 2113 "../src/Utility/Device.vala"
				_tmp13_ = _tmp12_->mount_points;
#line 2113 "../src/Utility/Device.vala"
				_mp_list = _tmp13_;
#line 2113 "../src/Utility/Device.vala"
				_tmp14_ = _mp_list;
#line 2113 "../src/Utility/Device.vala"
				_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 2113 "../src/Utility/Device.vala"
				_tmp16_ = _tmp15_;
#line 2113 "../src/Utility/Device.vala"
				_mp_size = _tmp16_;
#line 2113 "../src/Utility/Device.vala"
				_mp_index = -1;
#line 2113 "../src/Utility/Device.vala"
				while (TRUE) {
#line 13072 "Device.c"
					gint _tmp17_;
					gint _tmp18_;
					MountEntry* mp = NULL;
					GeeArrayList* _tmp19_;
					gpointer _tmp20_;
					const gchar* _tmp21_;
					MountEntry* _tmp22_;
					const gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					MountEntry* _tmp27_;
					const gchar* _tmp28_;
					gint _tmp29_;
					gint _tmp30_;
#line 2113 "../src/Utility/Device.vala"
					_mp_index = _mp_index + 1;
#line 2113 "../src/Utility/Device.vala"
					_tmp17_ = _mp_index;
#line 2113 "../src/Utility/Device.vala"
					_tmp18_ = _mp_size;
#line 2113 "../src/Utility/Device.vala"
					if (!(_tmp17_ < _tmp18_)) {
#line 2113 "../src/Utility/Device.vala"
						break;
#line 13098 "Device.c"
					}
#line 2113 "../src/Utility/Device.vala"
					_tmp19_ = _mp_list;
#line 2113 "../src/Utility/Device.vala"
					_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _mp_index);
#line 2113 "../src/Utility/Device.vala"
					mp = (MountEntry*) _tmp20_;
#line 2114 "../src/Utility/Device.vala"
					_tmp21_ = mps;
#line 2114 "../src/Utility/Device.vala"
					_tmp22_ = mp;
#line 2114 "../src/Utility/Device.vala"
					_tmp23_ = _tmp22_->mount_point;
#line 2114 "../src/Utility/Device.vala"
					_tmp24_ = g_strdup_printf ("\n    %s -> ", _tmp23_);
#line 2114 "../src/Utility/Device.vala"
					_tmp25_ = _tmp24_;
#line 2114 "../src/Utility/Device.vala"
					_tmp26_ = g_strconcat (_tmp21_, _tmp25_, NULL);
#line 2114 "../src/Utility/Device.vala"
					_g_free0 (mps);
#line 2114 "../src/Utility/Device.vala"
					mps = _tmp26_;
#line 2114 "../src/Utility/Device.vala"
					_g_free0 (_tmp25_);
#line 2115 "../src/Utility/Device.vala"
					_tmp27_ = mp;
#line 2115 "../src/Utility/Device.vala"
					_tmp28_ = _tmp27_->mount_options;
#line 2115 "../src/Utility/Device.vala"
					_tmp29_ = strlen (_tmp28_);
#line 2115 "../src/Utility/Device.vala"
					_tmp30_ = _tmp29_;
#line 2115 "../src/Utility/Device.vala"
					if (_tmp30_ > 0) {
#line 13134 "Device.c"
						const gchar* _tmp31_;
						MountEntry* _tmp32_;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
#line 2116 "../src/Utility/Device.vala"
						_tmp31_ = mps;
#line 2116 "../src/Utility/Device.vala"
						_tmp32_ = mp;
#line 2116 "../src/Utility/Device.vala"
						_tmp33_ = _tmp32_->mount_options;
#line 2116 "../src/Utility/Device.vala"
						_tmp34_ = g_strdup_printf (" %s", _tmp33_);
#line 2116 "../src/Utility/Device.vala"
						_tmp35_ = _tmp34_;
#line 2116 "../src/Utility/Device.vala"
						_tmp36_ = g_strconcat (_tmp31_, _tmp35_, NULL);
#line 2116 "../src/Utility/Device.vala"
						_g_free0 (mps);
#line 2116 "../src/Utility/Device.vala"
						mps = _tmp36_;
#line 2116 "../src/Utility/Device.vala"
						_g_free0 (_tmp35_);
#line 13159 "Device.c"
					}
#line 2113 "../src/Utility/Device.vala"
					_g_object_unref0 (mp);
#line 13163 "Device.c"
				}
			}
#line 2120 "../src/Utility/Device.vala"
			_tmp37_ = dev;
#line 2120 "../src/Utility/Device.vala"
			_tmp38_ = _tmp37_->device;
#line 2120 "../src/Utility/Device.vala"
			_tmp39_ = mps;
#line 2120 "../src/Utility/Device.vala"
			_tmp40_ = g_strdup_printf ("%-15s %s", _tmp38_, _tmp39_);
#line 2120 "../src/Utility/Device.vala"
			_tmp41_ = _tmp40_;
#line 2120 "../src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp41_);
#line 2120 "../src/Utility/Device.vala"
			_g_free0 (_tmp41_);
#line 2110 "../src/Utility/Device.vala"
			_g_free0 (mps);
#line 2110 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13184 "Device.c"
		}
	}
#line 2128 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13189 "Device.c"
}

void
device_print_device_disk_space (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2131 "../src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2132 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2134 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", "device", "fstype", "size", "used", "available", "used_percent");
#line 2134 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2134 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2134 "../src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2143 "../src/Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2143 "../src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2143 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2143 "../src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13219 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 2145 "../src/Utility/Device.vala"
		_dev_list = list;
#line 2145 "../src/Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 2145 "../src/Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 2145 "../src/Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 2145 "../src/Utility/Device.vala"
		_dev_size = _tmp6_;
#line 2145 "../src/Utility/Device.vala"
		_dev_index = -1;
#line 2145 "../src/Utility/Device.vala"
		while (TRUE) {
#line 13241 "Device.c"
			gint _tmp7_;
			gint _tmp8_;
			Device* dev = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			Device* _tmp11_;
			const gchar* _tmp12_;
			Device* _tmp13_;
			const gchar* _tmp14_;
			Device* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			Device* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			Device* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			Device* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
#line 2145 "../src/Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2145 "../src/Utility/Device.vala"
			_tmp7_ = _dev_index;
#line 2145 "../src/Utility/Device.vala"
			_tmp8_ = _dev_size;
#line 2145 "../src/Utility/Device.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 2145 "../src/Utility/Device.vala"
				break;
#line 13274 "Device.c"
			}
#line 2145 "../src/Utility/Device.vala"
			_tmp9_ = _dev_list;
#line 2145 "../src/Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _dev_index);
#line 2145 "../src/Utility/Device.vala"
			dev = (Device*) _tmp10_;
#line 2146 "../src/Utility/Device.vala"
			_tmp11_ = dev;
#line 2146 "../src/Utility/Device.vala"
			_tmp12_ = _tmp11_->device;
#line 2146 "../src/Utility/Device.vala"
			_tmp13_ = dev;
#line 2146 "../src/Utility/Device.vala"
			_tmp14_ = _tmp13_->fstype;
#line 2146 "../src/Utility/Device.vala"
			_tmp15_ = dev;
#line 2146 "../src/Utility/Device.vala"
			_tmp16_ = tee_jee_file_system_format_file_size (_tmp15_->size_bytes, TRUE, "", TRUE, 1);
#line 2146 "../src/Utility/Device.vala"
			_tmp17_ = _tmp16_;
#line 2146 "../src/Utility/Device.vala"
			_tmp18_ = dev;
#line 2146 "../src/Utility/Device.vala"
			_tmp19_ = tee_jee_file_system_format_file_size (_tmp18_->used_bytes, TRUE, "", TRUE, 1);
#line 2146 "../src/Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 2146 "../src/Utility/Device.vala"
			_tmp21_ = dev;
#line 2146 "../src/Utility/Device.vala"
			_tmp22_ = tee_jee_file_system_format_file_size (_tmp21_->available_bytes, TRUE, "", TRUE, 1);
#line 2146 "../src/Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 2146 "../src/Utility/Device.vala"
			_tmp24_ = dev;
#line 2146 "../src/Utility/Device.vala"
			_tmp25_ = _tmp24_->used_percent;
#line 2146 "../src/Utility/Device.vala"
			_tmp26_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", _tmp12_, _tmp14_, _tmp17_, _tmp20_, _tmp23_, _tmp25_);
#line 2146 "../src/Utility/Device.vala"
			_tmp27_ = _tmp26_;
#line 2146 "../src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp27_);
#line 2146 "../src/Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 2146 "../src/Utility/Device.vala"
			_g_free0 (_tmp23_);
#line 2146 "../src/Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 2146 "../src/Utility/Device.vala"
			_g_free0 (_tmp17_);
#line 2145 "../src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13328 "Device.c"
		}
	}
#line 2156 "../src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13333 "Device.c"
}

guint64
device_get_free_bytes (Device* self)
{
	guint64 result;
	guint64 _tmp0_ = 0ULL;
#line 121 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 122 "../src/Utility/Device.vala"
	if (self->used_bytes == ((guint64) 0)) {
#line 122 "../src/Utility/Device.vala"
		_tmp0_ = (guint64) 0;
#line 13347 "Device.c"
	} else {
#line 122 "../src/Utility/Device.vala"
		_tmp0_ = self->available_bytes;
#line 13351 "Device.c"
	}
#line 122 "../src/Utility/Device.vala"
	result = _tmp0_;
#line 122 "../src/Utility/Device.vala"
	return result;
#line 13357 "Device.c"
}

gchar*
device_get_size (Device* self)
{
	gchar* result;
#line 127 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "../src/Utility/Device.vala"
	if (((gdouble) self->size_bytes) < device_GB) {
#line 13368 "Device.c"
		gchar* _tmp0_;
#line 129 "../src/Utility/Device.vala"
		_tmp0_ = g_strdup_printf ("%.1f MB", self->size_bytes / device_MB);
#line 129 "../src/Utility/Device.vala"
		result = _tmp0_;
#line 129 "../src/Utility/Device.vala"
		return result;
#line 13376 "Device.c"
	} else {
#line 131 "../src/Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 13380 "Device.c"
			gchar* _tmp1_;
#line 132 "../src/Utility/Device.vala"
			_tmp1_ = g_strdup_printf ("%.1f GB", self->size_bytes / device_GB);
#line 132 "../src/Utility/Device.vala"
			result = _tmp1_;
#line 132 "../src/Utility/Device.vala"
			return result;
#line 13388 "Device.c"
		} else {
			gchar* _tmp2_;
#line 135 "../src/Utility/Device.vala"
			_tmp2_ = g_strdup ("");
#line 135 "../src/Utility/Device.vala"
			result = _tmp2_;
#line 135 "../src/Utility/Device.vala"
			return result;
#line 13397 "Device.c"
		}
	}
}

gchar*
device_get_used (Device* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 141 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../src/Utility/Device.vala"
	if (self->used_bytes == ((guint64) 0)) {
#line 13411 "Device.c"
		gchar* _tmp1_;
#line 142 "../src/Utility/Device.vala"
		_tmp1_ = g_strdup ("");
#line 142 "../src/Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "../src/Utility/Device.vala"
		_tmp0_ = _tmp1_;
#line 13419 "Device.c"
	} else {
		gchar* _tmp2_;
#line 142 "../src/Utility/Device.vala"
		_tmp2_ = g_strdup_printf ("%.1f GB", self->used_bytes / device_GB);
#line 142 "../src/Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "../src/Utility/Device.vala"
		_tmp0_ = _tmp2_;
#line 13428 "Device.c"
	}
#line 142 "../src/Utility/Device.vala"
	result = _tmp0_;
#line 142 "../src/Utility/Device.vala"
	return result;
#line 13434 "Device.c"
}

gchar*
device_get_free (Device* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	guint64 _tmp2_;
#line 147 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "../src/Utility/Device.vala"
	_tmp1_ = device_get_free_bytes (self);
#line 148 "../src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 148 "../src/Utility/Device.vala"
	if (_tmp2_ == ((guint64) 0)) {
#line 13452 "Device.c"
		gchar* _tmp3_;
#line 148 "../src/Utility/Device.vala"
		_tmp3_ = g_strdup ("");
#line 148 "../src/Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "../src/Utility/Device.vala"
		_tmp0_ = _tmp3_;
#line 13460 "Device.c"
	} else {
		guint64 _tmp4_;
		guint64 _tmp5_;
		gchar* _tmp6_;
#line 148 "../src/Utility/Device.vala"
		_tmp4_ = device_get_free_bytes (self);
#line 148 "../src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 148 "../src/Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("%.1f GB", _tmp5_ / device_GB);
#line 148 "../src/Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "../src/Utility/Device.vala"
		_tmp0_ = _tmp6_;
#line 13475 "Device.c"
	}
#line 148 "../src/Utility/Device.vala"
	result = _tmp0_;
#line 148 "../src/Utility/Device.vala"
	return result;
#line 13481 "Device.c"
}

gboolean
device_get_is_mounted (Device* self)
{
	gboolean result;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 153 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "../src/Utility/Device.vala"
	_tmp0_ = self->mount_points;
#line 154 "../src/Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 154 "../src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/Utility/Device.vala"
	result = _tmp2_ > 0;
#line 154 "../src/Utility/Device.vala"
	return result;
#line 13503 "Device.c"
}

gchar*
device_get_full_name_with_alias (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1776 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1777 "../src/Utility/Device.vala"
	_tmp0_ = self->device;
#line 1777 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1777 "../src/Utility/Device.vala"
	text = _tmp1_;
#line 1778 "../src/Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1778 "../src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1778 "../src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1778 "../src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 13532 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1779 "../src/Utility/Device.vala"
		_tmp5_ = text;
#line 1779 "../src/Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1779 "../src/Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1779 "../src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1779 "../src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1779 "../src/Utility/Device.vala"
		_g_free0 (text);
#line 1779 "../src/Utility/Device.vala"
		text = _tmp9_;
#line 1779 "../src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13554 "Device.c"
	}
#line 1781 "../src/Utility/Device.vala"
	result = text;
#line 1781 "../src/Utility/Device.vala"
	return result;
#line 13560 "Device.c"
}

gchar*
device_get_full_name_with_parent (Device* self)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1786 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1787 "../src/Utility/Device.vala"
	_tmp0_ = device_get_device_name_with_parent (self);
#line 1787 "../src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1787 "../src/Utility/Device.vala"
	result = _tmp1_;
#line 1787 "../src/Utility/Device.vala"
	return result;
#line 13579 "Device.c"
}

gchar*
device_get_short_name_with_alias (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1792 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1793 "../src/Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1793 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1793 "../src/Utility/Device.vala"
	text = _tmp1_;
#line 1794 "../src/Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1794 "../src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1794 "../src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1794 "../src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 13608 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1795 "../src/Utility/Device.vala"
		_tmp5_ = text;
#line 1795 "../src/Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1795 "../src/Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1795 "../src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1795 "../src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1795 "../src/Utility/Device.vala"
		_g_free0 (text);
#line 1795 "../src/Utility/Device.vala"
		text = _tmp9_;
#line 1795 "../src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13630 "Device.c"
	}
#line 1797 "../src/Utility/Device.vala"
	result = text;
#line 1797 "../src/Utility/Device.vala"
	return result;
#line 13636 "Device.c"
}

gchar*
device_get_short_name_with_parent (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1802 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1803 "../src/Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1803 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1803 "../src/Utility/Device.vala"
	text = _tmp1_;
#line 1805 "../src/Utility/Device.vala"
	if (device_has_parent (self)) {
#line 13657 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
#line 1805 "../src/Utility/Device.vala"
		_tmp3_ = self->parent;
#line 1805 "../src/Utility/Device.vala"
		_tmp4_ = _tmp3_->type;
#line 1805 "../src/Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "part") == 0;
#line 13666 "Device.c"
	} else {
#line 1805 "../src/Utility/Device.vala"
		_tmp2_ = FALSE;
#line 13670 "Device.c"
	}
#line 1805 "../src/Utility/Device.vala"
	if (_tmp2_) {
#line 13674 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1806 "../src/Utility/Device.vala"
		_tmp5_ = text;
#line 1806 "../src/Utility/Device.vala"
		_tmp6_ = self->pkname;
#line 1806 "../src/Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1806 "../src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1806 "../src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1806 "../src/Utility/Device.vala"
		_g_free0 (text);
#line 1806 "../src/Utility/Device.vala"
		text = _tmp9_;
#line 1806 "../src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13696 "Device.c"
	}
#line 1809 "../src/Utility/Device.vala"
	result = text;
#line 1809 "../src/Utility/Device.vala"
	return result;
#line 13702 "Device.c"
}

gchar*
device_get_device_name_with_parent (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1814 "../src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1815 "../src/Utility/Device.vala"
	_tmp0_ = self->device;
#line 1815 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1815 "../src/Utility/Device.vala"
	text = _tmp1_;
#line 1817 "../src/Utility/Device.vala"
	if (device_has_parent (self)) {
#line 13723 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
#line 1817 "../src/Utility/Device.vala"
		_tmp3_ = self->parent;
#line 1817 "../src/Utility/Device.vala"
		_tmp4_ = _tmp3_->type;
#line 1817 "../src/Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "part") == 0;
#line 13732 "Device.c"
	} else {
#line 1817 "../src/Utility/Device.vala"
		_tmp2_ = FALSE;
#line 13736 "Device.c"
	}
#line 1817 "../src/Utility/Device.vala"
	if (_tmp2_) {
#line 13740 "Device.c"
		const gchar* _tmp5_;
		Device* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1818 "../src/Utility/Device.vala"
		_tmp5_ = text;
#line 1818 "../src/Utility/Device.vala"
		_tmp6_ = self->parent;
#line 1818 "../src/Utility/Device.vala"
		_tmp7_ = _tmp6_->kname;
#line 1818 "../src/Utility/Device.vala"
		_tmp8_ = g_strdup_printf (" (%s)", _tmp7_);
#line 1818 "../src/Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1818 "../src/Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp5_, _tmp9_, NULL);
#line 1818 "../src/Utility/Device.vala"
		_g_free0 (text);
#line 1818 "../src/Utility/Device.vala"
		text = _tmp10_;
#line 1818 "../src/Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 13765 "Device.c"
	}
#line 1821 "../src/Utility/Device.vala"
	result = text;
#line 1821 "../src/Utility/Device.vala"
	return result;
#line 13771 "Device.c"
}

static void
device_class_init (DeviceClass * klass,
                   gpointer klass_data)
{
	gchar* _tmp0_;
#line 32 "../src/Utility/Device.vala"
	device_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/Utility/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_device_get_property;
#line 32 "../src/Utility/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = device_finalize;
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_BYTES_PROPERTY, device_properties[DEVICE_FREE_BYTES_PROPERTY] = g_param_spec_uint64 ("free-bytes", "free-bytes", "free-bytes", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SIZE_PROPERTY, device_properties[DEVICE_SIZE_PROPERTY] = g_param_spec_string ("size", "size", "size", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_USED_PROPERTY, device_properties[DEVICE_USED_PROPERTY] = g_param_spec_string ("used", "used", "used", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_PROPERTY, device_properties[DEVICE_FREE_PROPERTY] = g_param_spec_string ("free", "free", "free", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_IS_MOUNTED_PROPERTY, device_properties[DEVICE_IS_MOUNTED_PROPERTY] = g_param_spec_boolean ("is-mounted", "is-mounted", "is-mounted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("full-name-with-alias", "full-name-with-alias", "full-name-with-alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("full-name-with-parent", "full-name-with-parent", "full-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("short-name-with-alias", "short-name-with-alias", "short-name-with-alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("short-name-with-parent", "short-name-with-parent", "short-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("device-name-with-parent", "device-name-with-parent", "device-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "../src/Utility/Device.vala"
	device_MB = 1000 * device_KB;
#line 38 "../src/Utility/Device.vala"
	device_GB = 1000 * device_MB;
#line 41 "../src/Utility/Device.vala"
	device_MiB = 1024 * device_KiB;
#line 42 "../src/Utility/Device.vala"
	device_GiB = 1024 * device_MiB;
#line 89 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 89 "../src/Utility/Device.vala"
	device_lsblk_version = _tmp0_;
#line 13817 "Device.c"
}

static void
device_instance_init (Device * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 44 "../src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 44 "../src/Utility/Device.vala"
	self->device = _tmp0_;
#line 45 "../src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 45 "../src/Utility/Device.vala"
	self->name = _tmp1_;
#line 46 "../src/Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 46 "../src/Utility/Device.vala"
	self->kname = _tmp2_;
#line 47 "../src/Utility/Device.vala"
	_tmp3_ = g_strdup ("");
#line 47 "../src/Utility/Device.vala"
	self->pkname = _tmp3_;
#line 48 "../src/Utility/Device.vala"
	_tmp4_ = g_strdup ("");
#line 48 "../src/Utility/Device.vala"
	self->pkname_toplevel = _tmp4_;
#line 49 "../src/Utility/Device.vala"
	_tmp5_ = g_strdup ("");
#line 49 "../src/Utility/Device.vala"
	self->mapped_name = _tmp5_;
#line 50 "../src/Utility/Device.vala"
	_tmp6_ = g_strdup ("");
#line 50 "../src/Utility/Device.vala"
	self->uuid = _tmp6_;
#line 51 "../src/Utility/Device.vala"
	_tmp7_ = g_strdup ("");
#line 51 "../src/Utility/Device.vala"
	self->label = _tmp7_;
#line 52 "../src/Utility/Device.vala"
	_tmp8_ = g_strdup ("");
#line 52 "../src/Utility/Device.vala"
	self->partuuid = _tmp8_;
#line 53 "../src/Utility/Device.vala"
	_tmp9_ = g_strdup ("");
#line 53 "../src/Utility/Device.vala"
	self->partlabel = _tmp9_;
#line 55 "../src/Utility/Device.vala"
	self->major = -1;
#line 56 "../src/Utility/Device.vala"
	self->minor = -1;
#line 58 "../src/Utility/Device.vala"
	_tmp10_ = g_strdup ("");
#line 58 "../src/Utility/Device.vala"
	self->device_mapper = _tmp10_;
#line 59 "../src/Utility/Device.vala"
	_tmp11_ = g_strdup ("");
#line 59 "../src/Utility/Device.vala"
	self->device_by_uuid = _tmp11_;
#line 60 "../src/Utility/Device.vala"
	_tmp12_ = g_strdup ("");
#line 60 "../src/Utility/Device.vala"
	self->device_by_label = _tmp12_;
#line 61 "../src/Utility/Device.vala"
	_tmp13_ = g_strdup ("");
#line 61 "../src/Utility/Device.vala"
	self->device_by_partuuid = _tmp13_;
#line 62 "../src/Utility/Device.vala"
	_tmp14_ = g_strdup ("");
#line 62 "../src/Utility/Device.vala"
	self->device_by_partlabel = _tmp14_;
#line 64 "../src/Utility/Device.vala"
	_tmp15_ = g_strdup ("");
#line 64 "../src/Utility/Device.vala"
	self->type = _tmp15_;
#line 65 "../src/Utility/Device.vala"
	_tmp16_ = g_strdup ("");
#line 65 "../src/Utility/Device.vala"
	self->fstype = _tmp16_;
#line 67 "../src/Utility/Device.vala"
	self->order = -1;
#line 69 "../src/Utility/Device.vala"
	_tmp17_ = g_strdup ("");
#line 69 "../src/Utility/Device.vala"
	self->vendor = _tmp17_;
#line 70 "../src/Utility/Device.vala"
	_tmp18_ = g_strdup ("");
#line 70 "../src/Utility/Device.vala"
	self->model = _tmp18_;
#line 71 "../src/Utility/Device.vala"
	_tmp19_ = g_strdup ("");
#line 71 "../src/Utility/Device.vala"
	self->serial = _tmp19_;
#line 72 "../src/Utility/Device.vala"
	_tmp20_ = g_strdup ("");
#line 72 "../src/Utility/Device.vala"
	self->revision = _tmp20_;
#line 74 "../src/Utility/Device.vala"
	self->removable = FALSE;
#line 75 "../src/Utility/Device.vala"
	self->read_only = FALSE;
#line 77 "../src/Utility/Device.vala"
	self->size_bytes = (guint64) 0;
#line 78 "../src/Utility/Device.vala"
	self->used_bytes = (guint64) 0;
#line 79 "../src/Utility/Device.vala"
	self->available_bytes = (guint64) 0;
#line 81 "../src/Utility/Device.vala"
	_tmp21_ = g_strdup ("");
#line 81 "../src/Utility/Device.vala"
	self->used_percent = _tmp21_;
#line 82 "../src/Utility/Device.vala"
	_tmp22_ = g_strdup ("");
#line 82 "../src/Utility/Device.vala"
	self->dist_info = _tmp22_;
#line 86 "../src/Utility/Device.vala"
	self->parent = NULL;
#line 87 "../src/Utility/Device.vala"
	self->children = NULL;
#line 13959 "Device.c"
}

static void
device_finalize (GObject * obj)
{
	Device * self;
#line 32 "../src/Utility/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE, Device);
#line 44 "../src/Utility/Device.vala"
	_g_free0 (self->device);
#line 45 "../src/Utility/Device.vala"
	_g_free0 (self->name);
#line 46 "../src/Utility/Device.vala"
	_g_free0 (self->kname);
#line 47 "../src/Utility/Device.vala"
	_g_free0 (self->pkname);
#line 48 "../src/Utility/Device.vala"
	_g_free0 (self->pkname_toplevel);
#line 49 "../src/Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 50 "../src/Utility/Device.vala"
	_g_free0 (self->uuid);
#line 51 "../src/Utility/Device.vala"
	_g_free0 (self->label);
#line 52 "../src/Utility/Device.vala"
	_g_free0 (self->partuuid);
#line 53 "../src/Utility/Device.vala"
	_g_free0 (self->partlabel);
#line 58 "../src/Utility/Device.vala"
	_g_free0 (self->device_mapper);
#line 59 "../src/Utility/Device.vala"
	_g_free0 (self->device_by_uuid);
#line 60 "../src/Utility/Device.vala"
	_g_free0 (self->device_by_label);
#line 61 "../src/Utility/Device.vala"
	_g_free0 (self->device_by_partuuid);
#line 62 "../src/Utility/Device.vala"
	_g_free0 (self->device_by_partlabel);
#line 64 "../src/Utility/Device.vala"
	_g_free0 (self->type);
#line 65 "../src/Utility/Device.vala"
	_g_free0 (self->fstype);
#line 69 "../src/Utility/Device.vala"
	_g_free0 (self->vendor);
#line 70 "../src/Utility/Device.vala"
	_g_free0 (self->model);
#line 71 "../src/Utility/Device.vala"
	_g_free0 (self->serial);
#line 72 "../src/Utility/Device.vala"
	_g_free0 (self->revision);
#line 81 "../src/Utility/Device.vala"
	_g_free0 (self->used_percent);
#line 82 "../src/Utility/Device.vala"
	_g_free0 (self->dist_info);
#line 83 "../src/Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 84 "../src/Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 86 "../src/Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 87 "../src/Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 32 "../src/Utility/Device.vala"
	G_OBJECT_CLASS (device_parent_class)->finalize (obj);
#line 14024 "Device.c"
}

static GType
device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Device), 0, (GInstanceInitFunc) device_instance_init, NULL };
	GType device_type_id;
	device_type_id = g_type_register_static (G_TYPE_OBJECT, "Device", &g_define_type_info, 0);
	return device_type_id;
}

GType
device_get_type (void)
{
	static volatile gsize device_type_id__once = 0;
	if (g_once_init_enter (&device_type_id__once)) {
		GType device_type_id;
		device_type_id = device_get_type_once ();
		g_once_init_leave (&device_type_id__once, device_type_id);
	}
	return device_type_id__once;
}

static void
_vala_device_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Device * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE, Device);
#line 32 "../src/Utility/Device.vala"
	switch (property_id) {
#line 32 "../src/Utility/Device.vala"
		case DEVICE_FREE_BYTES_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_set_uint64 (value, device_get_free_bytes (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_SIZE_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_take_string (value, device_get_size (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_USED_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_take_string (value, device_get_used (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_FREE_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_take_string (value, device_get_free (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_IS_MOUNTED_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_set_boolean (value, device_get_is_mounted (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_alias (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_PARENT_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_parent (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_alias (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_parent (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 32 "../src/Utility/Device.vala"
		case DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY:
#line 32 "../src/Utility/Device.vala"
		g_value_take_string (value, device_get_device_name_with_parent (self));
#line 32 "../src/Utility/Device.vala"
		break;
#line 14118 "Device.c"
		default:
#line 32 "../src/Utility/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/Utility/Device.vala"
		break;
#line 14124 "Device.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

